include("global/cl_noxiousdb.lua")

if not MySelf then
	MySelf = NULL
end
hook.Add("Think", "GetLocal", function()
	MySelf = LocalPlayer()
	if MySelf:IsValid() then
		gamemode.Call("HookGetLocal", MySelf)
		MySelf.Money = MySelf.Money or 0
		MySelf.MemberLevel = MySelf.MemberLevel or MEMBER_NONE or 0
		RunConsoleCommand("PostPlayerInitialSpawn")
		hook.Remove("Think", "GetLocal")
	end
end)

PowerupDrawModels = {}
PowerupDrawScales = {}
CustomDrawFunctions = {}

include("shared.lua")

include("vgui/praceboard.lua")

function GM:Initialize()
	surface.CreateFont("coolvetica", 48, 500, true, false, "ScoreboardHead")
	surface.CreateFont("coolvetica", 24, 500, true, false, "ScoreboardSub")
	surface.CreateFont("Tahoma", 16, 1000, true, false, "ScoreboardText")
end

function GM:HookGetLocal(pl)
end

function GM:PlayerBindPress(pl, bind, down)
	if bind == "+duck" and down and pl:GetHoverGear():IsValid() then
		if GetConVarNumber("gmod_vehicle_viewmode") == 1 then
			RunConsoleCommand("gmod_vehicle_viewmode", 0)
		else
			RunConsoleCommand("gmod_vehicle_viewmode", 1)
		end

		return true
	end
end

function GM:DrawDebugInfo()
	surface.SetFont("DefaultSmall")
	local texw, texh = surface.GetTextSize("TEXT")
	texh = texh + 1

	local x, y = w - 64, h * 0.5

	draw.DrawText("CurTime(): "..tostring(CurTime()), "DefaultSmall", x, y, COLOR_RED, TEXT_ALIGN_RIGHT)
	y = y + texh

	draw.DrawText("Racing: "..tostring(self.Racing), "DefaultSmall", x, y, COLOR_RED, TEXT_ALIGN_RIGHT)
	y = y + texh

	draw.DrawText("StartRaceTime: "..tostring(self.StartRaceTime), "DefaultSmall", x, y, COLOR_RED, TEXT_ALIGN_RIGHT)
	y = y + texh

	draw.DrawText("EndRaceTime: "..tostring(self.EndRaceTime), "DefaultSmall", x, y, COLOR_RED, TEXT_ALIGN_RIGHT)
	y = y + texh
end

--[[function GM:HUDPaint()
	GAMEMODE:HUDDrawTargetID()
	GAMEMODE:DrawDeathNotice(0.85, 0.04)

	self:DrawDebugInfo()
end]]

function GM:RenderScreenspaceEffects()
end

function GM:PostProcessPermitted(str)
	return false
end

function GM:CalcView(pl, origin, angles, fov)
	local hovergear = pl:GetHoverGear()
	if hovergear:IsValid() then
		--angles = angles + hovergear:GetAngles()

		if GetConVarNumber("gmod_vehicle_viewmode") == 1 then
			local tr = util.TraceLine({start = origin, endpos = origin - 128 * SCALE * angles:Forward(), mask = MASK_SOLID_BRUSHONLY})
			origin = tr.HitPos + tr.HitNormal * 8
		else
			origin = hovergear:GetPilotEyePos()
		end
	end

	return self.BaseClass.CalcView(self, pl, origin, angles, fov)
end

local DrawScale = VECSCALE
function GM:PrePlayerDraw(pl)
	pl:SetModelScale(DrawScale)
end

function GM:PlayerSpawn(pl)
	pl:SetHull(PLAYER_HULL_MIN, PLAYER_HULL_MAX)
	pl:SetHullDuck(PLAYER_HULL_MIN, PLAYER_HULL_MAX)
	pl:SetCollisionBounds(PLAYER_HULL_MIN, PLAYER_HULL_MAX)
	pl:SetViewOffset(PLAYER_VIEWOFFSET)
	pl:SetViewOffsetDucked(PLAYER_VIEWOFFSET_DUCKED)
	pl:SetStepSize(PLAYER_STEPSIZE)
	pl:SetJumpPower(PLAYER_JUMPPOWER)

	--pl:PhysicsInitBox(PLAYER_HULL_MIN, PLAYER_HULL_MAX)
	--pl:SetSolid(SOLID_BBOX)
	--pl:SetMoveType(MOVETYPE_WALK)
end

function GM:QueueUpdated()
end

function GM:GameStateUpdated()
end

usermessage.Hook("PlayerSpawn", function(um)
	local pl = um:ReadEntity()
	if pl:IsValid() then
		gamemode.Call("PlayerSpawn", pl)
	end
end)

usermessage.Hook("updateracingqueue", function(um)
	GAMEMODE.Queue = {}

	for i, id in ipairs(string.Explode(",", um:ReadString())) do
		GAMEMODE.Queue[i] = Entity(id)
	end

	gamemode.Call("QueueUpdated")
end)

usermessage.Hook("updgmstate", function(um)
	GAMEMODE.Racing = um:ReadBool()
	local startracetime = um:ReadFloat()
	if startracetime == 0 then
		GAMEMODE.StartRaceTime = nil
	else
		GAMEMODE.StartRaceTime = startracetime
	end
	local endracetime = um:ReadFloat()
	if endracetime == 0 then
		GAMEMODE.EndRaceTime = nil
	else
		GAMEMODE.EndRaceTime = endracetime
	end

	gamemode.Call("GameStateUpdated")
end)