include("sh_micro.lua")

include("obj_entity_extend.lua")
include("sh_obj_player_extend.lua")

include("sh_animations.lua")

GM.Name = "Hover Gear"
GM.Author = "William \"JetBoom\" Moodhe"
GM.Email = "williammoodhe@gmail.com"
GM.Website = "www.noxiousnet.com"

GM.MinimumRacers = 2
GM.MaximumRacers = 8
GM.PreRaceCountdown = 10
GM.RaceTime = 600
GM.LapsToWin = 2
GM.MaxCheckpoint = GM.MaxCheckpoint or 0
GM.VehicleClass = "vehicle__base_hover"

if NDB.MemberNames then
	GM.HatsDisabled = true
	GM.BloodDyesDisabled = true
	GM.BodysDisabled = true
	GM.AccsDisabled = true
end

TEAM_NOTRACING = 1
TEAM_CROWD = TEAM_NOTRACING
TEAM_RED = TEAM_NOTRACING
TEAM_RACING = 2
TEAM_BLUE = TEAM_RACING
TEAM_RACERS = TEAM_RACING

team.SetUp(TEAM_CROWD, "The Crowd", Color(255, 50, 50, 255), true)
team.SetSpawnPoint(TEAM_CROWD, "info_player_crowd")

team.SetUp(TEAM_RACING, "Racers", Color(30, 255, 30, 255))
team.SetSpawnPoint(TEAM_RACING, "info_player_racer", true)

SOUNDBARRIER = 13500 * SCALE

PickupTranslates = {
	["default"] = ". . .",
	["weapon_tier1"] = "Random Weapon Tier 1",
	["weapon_tier2"] = "Random Weapon Tier 2",
	["weapon_tier3"] = "Random Weapon Tier 3",
	["weapon_tier4"] = "Random Weapon Tier 4",
	["weapon_tier5"] = "Random Weapon Tier 5",
	["weapon_def_tier1"] = "Random Defense Tier 1",
	["weapon_def_tier2"] = "Random Defense Tier 2",
	["weapon_def_tier3"] = "Random Defense Tier 3",
	["powerup_tier1"] = "Random Powerup Tier 1",
	["powerup_tier2"] = "Random Powerup Tier 2",
	["powerup_tier3"] = "Random Powerup Tier 3",
	["powerup_tier4"] = "Random Powerup Tier 4",
	["powerup_tier5"] = "Random Powerup Tier 5"
}

PICKUP_GROUPS = {
	["weapon_tier1"] = {},
	["weapon_tier2"] = {},
	["weapon_tier3"] = {},
	["weapon_tier4"] = {},
	["weapon_tier5"] = {},
	["weapon_tier6"] = {},
	["weapon_def_tier1"] = {},
	["weapon_def_tier2"] = {},
	["weapon_def_tier3"] = {},
	["weapon_def_tier4"] = {},
	["weapon_def_tier5"] = {},
	["weapon_def_tier6"] = {},
	["powerup_tier1"] = {},
	["powerup_tier2"] = {},
	["powerup_tier3"] = {},
	["powerup_tier4"] = {},
	["powerup_tier5"] = {},
	["powerup_tier6"] = {}
}

GM.Queue = GM.Queue or {}

function GM:GravGunPickupAllowed(pl, ent)
	return false
end

function GM:AddPickup(class, name, model, scale, customdraw)
	if class then
		PickupTranslates[class] = name
		if CLIENT then
			PowerupDrawScales[class] = scale
			PowerupDrawModels[class] = model
			CustomDrawFunctions[class] = customdraw
		end
	else
		ErrorNoHalt("Attempt to add a nil pickup class!")
	end
end

function GM:AddPickupToTier(class, tiername)
	if class then
		if not PICKUP_GROUPS[tiername] then
			PICKUP_GROUPS[tiername] = {}
		end
		table.insert(PICKUP_GROUPS[tiername], class)
	else
		ErrorNoHalt("Attempt to add a nil pickup to a tier!")
	end
end

function GM:KeyPress(pl, key)
	local vehicle = pl:GetHoverGear()
	if vehicle:IsValid() then
		vehicle:KeyPress(pl, key)
	end
end

function GM:KeyRelease(pl, key)
	local vehicle = pl:GetHoverGear()
	if vehicle:IsValid() then
		vehicle:KeyRelease(pl, key)
	end
end

function GM:PhysgunPickup(pl, ent)
	return true
end

function GM:GetGameDescription()
	return self.Name
end

function GM:PlayerStepSoundTime(pl, iType, bWalking)
	return self.BaseClass.PlayerStepSoundTime(self, pl, iType, bWalking) * SCALE
end

function TrueVisible(posa, posb)
	local filt = ents.FindByClass("projectile_*")
	filt = table.Add(filt, ents.FindByClass("npc_*"))
	filt = table.Add(filt, ents.FindByClass("prop_physics*"))
	filt = table.Add(filt, ents.FindByClass("prop_vehicle*"))
	filt = table.Add(filt, ents.FindByClass("vehicle*"))
	if GAMEMODE.FlagEntity then
		filt = table.Add(filt, ents.FindByClass(GAMEMODE.FlagEntity))
	end
	filt = table.Add(filt, player.GetAll())

	return not util.TraceLine({start = posa, endpos = posb, filter = filt, mask = MASK_SHOT}).Hit
end
