local meta = FindMetaTable("Player")
if not meta then return end

function meta:RemoveHoverGear()
	for _, ent in pairs(ents.FindByClass("vehicle*")) do
		if ent:GetVehicleOwner() == self then
			ent:Remove()
			self:UnSpectate()
		end
	end
end

function meta:SpawnHoverGear(pos, ang)
	self:RemoveHoverGear()

	pos = pos or (self:GetPos() + Vector(0, 0, 16))
	if not ang then
		ang = self:GetAngles()
		ang:RotateAroundAxis(Vector(0, 0, 1), 270)
	end

	local vehicle = ents.Create(GAMEMODE.VehicleClass)
	if vehicle:IsValid() then
		vehicle:SetPos(pos)
		vehicle:Spawn()
		vehicle:SetAngles(ang)
		vehicle:SetVehicleOwner(self)

		self:SetHoverGear(vehicle)
		self:Spectate(OBS_MODE_CHASE)
		self:SpectateEntity(vehicle)
	end

	return vehicle
end

function meta:UpdateGameState()
	GAMEMODE:UpdateGameState(self)
end

function meta:EnterQueue(silent)
	if not self:IsInQueue() then
		table.insert(GAMEMODE.Queue, self)
		if not silent then
			self:PrintMessage(HUD_PRINTTALK, "You have been entered in to the racing queue!")
		end

		GAMEMODE:UpdateQueue()
	end
end

function meta:ExitQueue(silent)
	local slot = self:IsInQueue()
	if slot then
		table.remove(GAMEMODE.Queue, slot)
		if not silent then
			self:PrintMessage(HUD_PRINTTALK, "You have been removed from the racing queue!")
		end

		GAMEMODE:UpdateQueue()

		return slot
	end
end
