function MakepRaceBoard()
	if not self.Racing then return end

	local frame = vgui.Create("DRaceBoard")
	pRaceBoard = frame

	return frame
end

local PANEL = {}

function PANEL:Init()
	DPanel.Init(self)

	self:SetWide(300)
	self.Racers = {}
	self.RacersPanels = {}
end

function PANEL:GetRacer(pl)
	for i, racer in pairs(self.Racers) do
		if racer == pl then return i end
	end
end

function PANEL:AddRacer(pl, noanim)
	local id = self:GetRacer(pl)
	if id then return end

	local racers = self:SortedRacers()

	local racerpan = vgui.Create("DPanel", self)
	self.RacersPanels[pl] = racerpan
	if noanim then
		racerpan:SetSize(self:GetWide() - 16, 24)
	else
		racerpan:SetSize(24, 24)
		racerpan:SizeTo(self:GetWide() - 16, 24, 0.5, 0.4)
	end

	self:SetPos(8, 64 + #racers * 24)

	self:ReorderRacers(noanim)

	return true
end

function PANEL:RemoveRacer(pl, noanim)
	local id = self:GetRacer(pl)
	if not id then return end

	if self.RacersPanels[pl] then
		self.RacersPanels[pl]:Remove()
		self.RacersPanels[pl] = nil
		table.remove(self.Racers, id)
	end

	self:ReorderRacers(noanim)

	return false
end

function PANEL:SwapRacer(pl, pl2, noanim)
	local id = self:GetRacer(pl)
	if not id then return end
	local id2 = self:GetRacer(pl2)
	if not id2 then return end

	local temp = self.Racers[id]
	self.Racers[id] = self.Racers[id2]
	self.Racers[id2] = temp

	self:ReorderRacers(noanim)
end

local function SortRacers(a, b)
	local alap, blap = a:GetLap(), b:GetLap()
	if alap == blap then return a:GetCheckpoint() > b:GetCheckpoint() end
	return alap > blap
end

function PANEL:SortedRacers()
	local racers = team.GetPlayers(TEAM_RACING)
	table.sort(racers, SortRacers)
	return racers
end

function PANEL:ReorderRacers(noanim)
	
end

vgui.Register("DRaceBoard", PANEL, "DPanel")
