function EFFECT:Init(data)
	local TargetEntity = data:GetEntity()
	if not (TargetEntity and TargetEntity:IsValid()) then return end

	local Low, High = TargetEntity:WorldSpaceAABB()
	local r,g,b,a = TargetEntity:GetColor()

	local emitter = ParticleEmitter(TargetEntity:GetPos())
	for i=1, math.Clamp(TargetEntity:BoundingRadius() * 4, 32, 256) do
		local particle = emitter:Add("sprites/light_glow02_add", Vector(math.Rand(Low.x,High.x), math.Rand(Low.y,High.y), math.Rand(Low.z,High.z)))
		particle:SetDieTime(math.Rand(1.4, 2.0))
		particle:SetStartAlpha(a)
		particle:SetEndAlpha(50)
		particle:SetStartSize(8)
		particle:SetEndSize(1)
		particle:SetRoll(math.Rand(0, 360))
		particle:SetRollDelta(math.Rand(-30, 30))
		particle:SetColor(r,g,b)
		particle:SetAirResistance(20)
		particle:SetGravity(Vector(0, 0, math.Rand(20, 200)))
		particle:SetCollide(true)
		particle:SetBounce(0.3)
	end
	emitter:Finish()
end

function EFFECT:Think()
	return false
end

function EFFECT:Render()
end
