function EFFECT:Init(data)
	local dir = data:GetNormal() * -1
	self.Dir = dir
	local pos = data:GetOrigin() + dir * 0.5
	self.EndPos = pos
	self.TeamID = math.Round(data:GetMagnitude())
	local col = team.GetColor(self.TeamID) or color_white
	self.Col = col
	self.DieTime = CurTime() + 0.5
	self.SpriteSize = math.Rand(14, 20)

	util.Decal("Impact.Concrete", pos + dir, pos - dir)
	WorldSound("weapons/fx/rics/ric"..math.random(1,5)..".wav", pos, 74, math.Rand(130, 170))
	WorldSound("vehicles/Airboat/pontoon_impact_hard"..math.random(1,2)..".wav", pos, 74, math.Rand(105, 125))

	self.Entity:SetModel("models/Weapons/w_bullet.mdl")
	self.Entity:SetMaterial("models/shiny")
	self.Entity:SetColor(col.r, col.g, col.b, 255)
	self.Entity:SetModelScale(Vector(3,3,3))
	self.Entity:SetAngles(self.Dir:Angle())
end

function EFFECT:Think()
	return CurTime() <= self.DieTime
end

--local matRing = Material("effects/select_ring")
local matRefraction	= Material("refract_ring")
local matGlow = Material("sprites/glow04_noz")
function EFFECT:Render()
	local ct = CurTime()
	local col = self.Col
	local r,g,b = col.r, col.g, col.b
	if not self.EndParticles then
		self.EndParticles = true
		local emitter = ParticleEmitter(self.EndPos)
		for i=1, math.max(8, EFFECT_QUALITY * 6.5) do
			local particle = emitter:Add("noxctf/sprite_nova", self.EndPos)
			particle:SetDieTime(math.Rand(0.5, 0.75))
			particle:SetStartAlpha(255)
			particle:SetEndAlpha(0)
			particle:SetStartSize(1)
			particle:SetEndSize(16)
			particle:SetVelocity((VectorRand():Normalize() + self.Dir):Normalize() * math.Rand(500, 1500))
			particle:SetAirResistance(1000)
			particle:SetColor(r, g, b)
		end
	end

	local delta = math.max(0, self.DieTime - ct)
	local rdelta = 0.5 - delta
	local siz = delta * 512
	render.SetMaterial(matGlow)
	render.DrawSprite(self.EndPos, siz, siz, col)
	render.SetMaterial(matGlow)
	render.DrawQuadEasy(self.EndPos + self.Dir * 0.1, self.Dir, siz, siz, col)

	--[[render.SetMaterial(matRing)
	local quadsiz = rdelta * 750
	local colquad = Color(r, g, b, delta * 500)
	render.DrawQuadEasy(self.EndPos, self.Dir, quadsiz, quadsiz, colquad, 0)
	render.DrawQuadEasy(self.EndPos, self.Dir * -1, quadsiz, quadsiz, colquad, 0)]]

	matRefraction:SetMaterialFloat("$refractamount", math.sin(delta * math.pi) * 0.2)
	render.SetMaterial(matRefraction)
	render.UpdateRefractTexture()
	local qsiz = rdelta * 1500 + math.cos(delta * 12) * 100
	render.DrawQuadEasy(self.EndPos, self.Dir, qsiz, qsiz, color_white, 0)
	render.DrawQuadEasy(self.EndPos, self.Dir * -1, qsiz, qsiz, color_white, 0)

	self.Entity:SetColor(r, g, b, math.min(255, siz))
	self.Entity:SetPos(self.EndPos)
	self.Entity:DrawModel()
end
