local matBolt = Material("Effects/laser1")
local cBeam = Color(255, 200, 30)

function EFFECT:Init(data)
	self.DieTime = RealTime() + 1
	self.EndPos = data:GetOrigin()
	self.BeamPos = {}

	local startpos = data:GetStart()
	local endpos = self.EndPos

	local pos = nil
	for i=1, math.ceil(startpos:Distance(endpos) / 32) do
		if pos then
			pos = pos + (endpos - pos):Normalize() * 32 + VectorRand() * 16
		else
			pos = startpos
		end
		table.insert(self.BeamPos, pos)
	end

	WorldSound("nox/sunburst_explode.wav", endpos, 90, math.Rand(95, 105))
	self.Entity:SetRenderBoundsWS(startpos, endpos, Vector(32, 32, 32))
end

function EFFECT:Think()
	if RealTime() >= self.DieTime then
		local effectdata = EffectData()
			effectdata:SetOrigin(self.EndPos)
		util.Effect("sunbeamexplosion", effectdata)

		return false
	end

	return true
end

function EFFECT:Render()
	if self.DieTime - RealTime() > 0.5 then
		render.SetMaterial(matBolt)
		for i, pos in ipairs(self.BeamPos) do
			if self.BeamPos[i+1] then
				render.DrawBeam(pos, self.BeamPos[i+1], 24, 28, 28, cBeam)
			end
		end
	end
end
