function EFFECT:Init(data)
	local vOffset = data:GetOrigin()
	local startpos = data:GetStart()
	local dir = vOffset - startpos
	local normal = dir:Normalize()

	WorldSound("nox/meleehit_blunt01.wav", vOffset, 76, math.Rand(100, 110))

	local emitter = ParticleEmitter(vOffset)
	emitter:SetNearClip(24, 32)
	for i=0, 5 do
		local particle = emitter:Add("effects/spark", vOffset + dir * math.Rand(-0.1, 0.1))
		particle:SetVelocity(VectorRand() * 150 + normal * math.Rand(100,500))
		particle:SetDieTime(math.Rand(0.01, 0.25))             
		particle:SetStartAlpha(255)
		particle:SetStartSize(10)
		particle:SetRoll(math.Rand(0, 360))
		particle:SetRollDelta(math.Rand(-5, 5))
		particle:SetAirResistance(100)             
	end
	
	local x1 = normal:Angle()
	x1:RotateAroundAxis(x1:Up(), 90)
	x1 = x1:Forward()
	for i=0, 5 do
		local particle = emitter:Add("effects/spark", vOffset + dir * math.Rand(-0.1, 0.1) + 20 * i * x1)
		particle:SetVelocity(150000 * (6-i) * normal * x1)
		particle:SetDieTime(math.Rand(0.5, 1))             
		particle:SetStartAlpha(255)
		particle:SetStartSize(30 + (6-i) * 10)
		particle:SetRoll(math.Rand(0, 360))
		particle:SetRollDelta(math.Rand(-5, 5))
		particle:SetAirResistance(100)
	end

	x1 = normal:Angle()
	x1:RotateAroundAxis(x1:Up(), -90)
	x1 = x1:Forward()
	for i=0, 5 do
		local particle = emitter:Add("effects/spark", vOffset + dir * math.Rand(-0.1, 0.1) + 20 * i * x1)
		particle:SetVelocity(150000 * (6-i) * normal * x1)
		particle:SetDieTime(math.Rand(0.5, 1))             
		particle:SetStartAlpha(255)
		particle:SetStartSize(30 + (6-i) * 10)
		particle:SetRoll(math.Rand(0, 360))
		particle:SetRollDelta(math.Rand(-5, 5))
		particle:SetAirResistance(100)
	end

	for i=0, 6 do     
		local particle = emitter:Add("effects/yellowflare", vOffset)
		particle:SetVelocity(VectorRand() * 150 + normal * math.Rand(-500,500))
		particle:SetDieTime(math.Rand(0.1, 0.3) + i * 0.1666666)             
		particle:SetStartAlpha(255)
		particle:SetStartSize(130-i*20)
		particle:SetEndSize(50-i*6)
		particle:SetRoll(math.Rand(0, 360))
		particle:SetRollDelta(math.Rand(-15, 15))
		particle:SetAirResistance(400)             
	end

	local particle = emitter:Add("effects/select_ring", vOffset)
	particle:SetVelocity(normal * math.Rand(5,10))
	particle:SetDieTime(math.Rand(1, 1))             
	particle:SetStartAlpha(105)
	particle:SetEndAlpha(0)
	particle:SetStartSize(50)
	particle:SetEndSize(650)
	particle:SetRoll(math.Rand(0, 360))
	particle:SetRollDelta(math.Rand(-15, 15))
	particle:SetAirResistance(50)             
	emitter:Finish()

	ExplosiveEffect(vOffset, 64, 64, DMGTYPE_PHYSICAL)
end

function EFFECT:Think()
	return false
end

function EFFECT:Render()
end
