function EFFECT:Init(data)
	self.DieTime = CurTime() + 0.5

	local pos = data:GetOrigin()
	self.Pos = pos
	local normal = data:GetNormal()
	self.Normal = normal

	util.Decal("Scorch", pos + normal, pos - normal)

	WorldSound("weapons/physcannon/energy_sing_explosion2.wav", pos, 84, math.Rand(100, 108))
	WorldSound("ambient/materials/clang1.wav", pos, 84, math.Rand(90, 100))

	local emitter = ParticleEmitter(pos)
	emitter:SetNearClip(32, 48)

	for i=1, math.max(48, EFFECT_QUALITY * 48) do
		local particle = emitter:Add("effects/tesla_glow_noz", pos)
		particle:SetDieTime(math.Rand(0.64, 1.25))
		particle:SetStartAlpha(255)
		particle:SetEndAlpha(0)
		particle:SetStartSize(5)
		particle:SetEndSize(0)
		particle:SetRoll(math.Rand(0, 360))
		particle:SetRollDelta(math.Rand(-20, 20))
		particle:SetVelocity((normal + VectorRand()):Normalize() * math.Rand(1400, 1700))
		particle:SetAirResistance(500)
	end

	emitter:Finish()

	ExplosiveEffect(pos, 200, 300, DMGTYPE_PHYSICAL)
end

function EFFECT:Think()
	return CurTime() <= self.DieTime
end

local matRefraction	= Material("refract_ring")
function EFFECT:Render()
	local normal = self.Normal
	local pos = self.Pos + normal * 2

	local ct = CurTime()

	local delta = math.max(0, self.DieTime - ct)
	local rdelta = 0.5 - delta

	matRefraction:SetMaterialFloat("$refractamount", delta * math.sin(rdelta * math.pi) * 0.5)
	render.SetMaterial(matRefraction)
	render.UpdateRefractTexture()
	local qsiz = rdelta * 1500
	render.DrawQuadEasy(pos, normal, qsiz, qsiz, color_white, 0)
	render.DrawQuadEasy(pos, normal * -1, qsiz, qsiz, color_white, 0)
end
