function EFFECT:Init(data)
	local ent = data:GetEntity()
	self.DieTime = CurTime() + 0.5
	if not ent:IsValid() then return end

	local pos = ent:GetShootPos()
	WorldSound("ambient/machines/thumper_top.wav", pos, 86, math.Rand(95, 105))
	self.Pos = pos
	self.Dir = ent:GetAngles()

	--[[local dir = ent:GetUp():Angle()
	dir:RotateAroundAxis(ent:GetRight(), -15)
	dir = dir:Forward()
	local force = dir * 1.75
	local vecGrav = Vector(0,0,-800)

	local emitter = ParticleEmitter(pos)
	emitter:SetNearClip(24, 32)
	for i=1, math.max(1, EFFECT_QUALITY) * math.Rand(70, 80) do
		local vel = (VectorRand() + force):Normalize()

		local particle = emitter:Add("effects/fire_cloud"..math.random(1,2), pos + vel * 16)
		particle:SetStartSize(math.Rand(16, 32))
		particle:SetEndSize(0)
		particle:SetStartAlpha(255)
		particle:SetEndAlpha(255)
		particle:SetAirResistance(math.Rand(128, 512))
		particle:SetVelocity(vel * math.Rand(256, 2048))
		particle:SetDieTime(math.Rand(0.45, 1))
		particle:SetRoll(math.Rand(0, 360))
		particle:SetRollDelta(math.Rand(-20, 20))
		particle:SetGravity(vecGrav)
		particle:SetCollide(true)
		particle:SetBounce(0.5)
	end
	emitter:Finish()]]
end

function EFFECT:Think()
	return CurTime() < self.DieTime
end

local matBeam = Material("Effects/laser1")
function EFFECT:Render()
	local pos = self.Pos
	if not pos then return end

	local delta = math.max(0, self.DieTime - CurTime())

	local oang = self.Dir
	local ang = Angle(oang.pitch, oang.yaw, oang.roll)
	local up = ang:Up()
	ang:RotateAroundAxis(up, -90)

	local col = Color(255, 190, 40, math.min(255, delta * 710))

	local siz = delta * 128
	local amount = 140 - delta * 256

	render.SetMaterial(matBeam)
	render.StartBeam(45)
	for i=1, 45 do
		render.AddBeam(pos + amount * ang:Forward(), siz, i, col)

		ang:RotateAroundAxis(up, 4)
	end
	render.EndBeam()
end
