function EFFECT:Init(data)
	local normal = data:GetNormal() * -1
	local pos = data:GetOrigin()

	WorldSound("nox/managain.wav", pos, 70, math.Rand(98, 102))
	WorldSound("weapons/physcannon/energy_sing_flyby2.wav", pos, 70, 70)

	local emitter = ParticleEmitter(pos)
	emitter:SetNearClip(35, 40)
	local oldang = normal:Angle():Right():Angle()
	local numparts = 360 / math.max(24, math.Rand(EFFECT_QUALITY * 12, EFFECT_QUALITY * 15))
	for i=1, 360, numparts do
		local ang = oldang
		ang:RotateAroundAxis(normal, i)
		local heading = normal * 32 + ang:Forward() * 128
		local particle = emitter:Add("sprites/light_glow02_add", pos + heading)
		particle:SetVelocity(heading * -1)
		particle:SetDieTime(math.Rand(0.9, 0.98))
		particle:SetStartAlpha(255)
		particle:SetEndAlpha(255)
		particle:SetStartSize(32)
		particle:SetEndSize(0)
		particle:SetRoll(math.Rand(0, 360))
		particle:SetRollDelta(math.Rand(-10, 10))
		particle:SetAirResistance(16)
		particle:SetColor(92, 128, 255)
	end

	local particle = emitter:Add("sprites/light_glow02_add", pos + normal * 16)
	particle:SetDieTime(1.35)
	particle:SetStartAlpha(255)
	particle:SetEndAlpha(255)
	particle:SetStartSize(75)
	particle:SetEndSize(0)
	particle:SetRoll(math.Rand(0, 360))
	particle:SetRollDelta(math.Rand(-10, 10))
	particle:SetColor(255, 255, 255)

	emitter:Finish()

	ExplosiveEffect(pos, 64, 20, DMGTYPE_LIGHTNING)
end

function EFFECT:Think()
	return false
end

function EFFECT:Render()
end
