function EFFECT:Init(data)
	local pos = data:GetOrigin()
	self.Die = CurTime() + 0.4

	WorldSound("nox/plasma_explode.wav", pos, 85, math.Rand(98, 102))

	self.Emitter = ParticleEmitter(pos)
	self.Emitter:SetNearClip(24, 32)
	self.Pos = pos

	for i=1, math.max(1, EFFECT_QUALITY) do
		local particle = self.Emitter:Add("sprites/glow04_noz", pos)
		particle:SetDieTime(2)
		particle:SetStartAlpha(255)
		particle:SetEndAlpha(0)
		particle:SetStartSize(1)
		particle:SetEndSize(140)

		local particle = self.Emitter:Add("sprites/glow04_noz", pos)
		particle:SetDieTime(1.25)
		particle:SetStartAlpha(255)
		particle:SetEndAlpha(0)
		particle:SetStartSize(32)
		particle:SetEndSize(170)
		particle:SetColor(180, 200, 255)
	end

	ExplosiveEffect(pos, 100, 50, DMGTYPE_FIRE)
end

function EFFECT:Think()
	if CurTime() > self.Die then
		local vOffset = self.Pos
		local emitter = self.Emitter
		for i=1, EFFECT_QUALITY * math.Rand(3, 4) + 1 do
			local particle = emitter:Add("sprites/glow04_noz", vOffset)
			particle:SetVelocity(VectorRand():Normalize() * math.Rand(64, 200))
			particle:SetDieTime(2)
			particle:SetStartAlpha(254)
			particle:SetEndAlpha(0)
			particle:SetStartSize(50)
			particle:SetEndSize(1)
			particle:SetColor(180, 240, 255)
			particle:SetRoll(math.Rand(0, 360))
			particle:SetRollDelta(math.Rand(-30, 30))
			particle:SetAirResistance(45)

			local particle = emitter:Add("sprites/glow04_noz", vOffset + VectorRand():Normalize() * 10)
			particle:SetVelocity(VectorRand() * 90)
			particle:SetDieTime(1.5)
			particle:SetStartAlpha(200)
			particle:SetEndAlpha(20)
			particle:SetStartSize(math.Rand(82, 126))
			particle:SetEndSize(16)
			particle:SetColor(55, 200, 255)
			particle:SetRoll(math.Rand(0, 360))
			//particle:SetGravity(Vector(0,0,-700))
		end

		emitter:Finish()
		return false
	end

	return true
end

function EFFECT:Render()
end
