include("shared.lua")

function ENT:Initialize()
	self.LastThink = CurTime()
	self.NextEmit = 0

	self.Emitter = ParticleEmitter(self:GetPos())
	self.Emitter:SetNearClip(24, 32)

	self:SetRenderBounds(Vector(-128, -128, -64), Vector(128, 128, 64))
end

ENT.MaxTraceHUDPaintLength = 256

function ENT:Think()
	local owner = self:GetOwner()
	if owner == MySelf and owner:IsValid() then
		if not self.InitLastThink then
			self.InitLastThink = true
			self.LastThink = CurTime()
		end
		local delta = CurTime() - self.LastThink
		self.LastThink = CurTime()

		--if not owner.Sprinting and not owner.WallRunning then
			owner:SetStamina(math.max(0, owner:GetStamina() - (owner.StaminaRegenerate + STAMINA_HOLDING_BALL) * delta))
		--end

		owner.Carrying = self
	elseif self.InitLastThink then
		for _, pl in pairs(player.GetAll()) do
			if pl.Carrying == self then
				pl.Carrying = nil
			end
		end
		self.InitLastThink = nil
	end

	self.Emitter:SetPos(self:GetPos())
end

local matGlow = Material("sprites/light_glow02_add")
local matBeam = Material("effects/laser1")
function ENT:Draw()
	self:DrawModel()

	local ct = CurTime()
	local rsin = math.sin(ct * 3) * 16
	local rcon = math.cos(ct * 3) * 16

	local pos = self:GetPos()
	local vOffset = pos + Vector(rsin, rcon, 0)
	local vOffset2 = pos + Vector(0, rcon, rsin)
	local vOffset3 = pos + Vector(rcon, 0, rsin)

	local r,g,b,a = self:GetColor()

	local colDraw = Color(r, g, b, 200)
	local size =  math.sin(RealTime() * 5) * 24 + 40

	render.SetMaterial(matGlow)
	render.DrawSprite(pos, 92, 92, colDraw)
	render.DrawSprite(vOffset, size, size, colDraw)
	render.DrawSprite(vOffset2, size, size, colDraw)
	render.DrawSprite(vOffset3, size, size, colDraw)

	if 0 < self:GetSkin() then
		if self.NextEmit <= ct then
			self.NextEmit = ct + 0.05

			local vecGravity = Vector(0, 0, -48)
			for i=1, 3 do
			local vecVel = self:GetVelocity() * 0.25 + VectorRand():Normalize() * math.Rand(8, 48)

			local emitter = self.Emitter
			local particle = emitter:Add("sprites/light_glow02_add", vOffset)
			particle:SetColor(r, g, b)
			particle:SetStartAlpha(255)
			particle:SetEndAlpha(255)
			particle:SetDieTime(2)
			particle:SetGravity(vecGravity)
			particle:SetVelocity(vecVel)
			particle:SetAirResistance(32)
			particle:SetStartSize(8)
			particle:SetBounce(0.8)
			particle:SetCollide(true)
			particle:SetEndSize(0)
			particle:SetRoll(math.Rand(0, 360))
			particle:SetRollDelta(math.Rand(-15, 15))

			local particle = emitter:Add("sprites/light_glow02_add", vOffset2)
			particle:SetColor(r, g, b)
			particle:SetStartAlpha(255)
			particle:SetEndAlpha(255)
			particle:SetDieTime(2)
			particle:SetGravity(vecGravity)
			particle:SetVelocity(vecVel)
			particle:SetAirResistance(32)
			particle:SetStartSize(8)
			particle:SetBounce(0.8)
			particle:SetCollide(true)
			particle:SetEndSize(0)
			particle:SetRoll(math.Rand(0, 360))
			particle:SetRollDelta(math.Rand(-15, 15))

			local particle = emitter:Add("sprites/light_glow02_add", vOffset3)
			particle:SetColor(r, g, b)
			particle:SetStartAlpha(255)
			particle:SetEndAlpha(255)
			particle:SetDieTime(2)
			particle:SetGravity(vecGravity)
			particle:SetVelocity(vecVel)
			particle:SetAirResistance(32)
			particle:SetStartSize(8)
			particle:SetBounce(0.8)
			particle:SetCollide(true)
			particle:SetEndSize(0)
			particle:SetRoll(math.Rand(0, 360))
			particle:SetRollDelta(math.Rand(-15, 15))
			end
		end
	else
		local ct2 = ct * -8
		render.DrawSprite(pos + Vector(math.sin(ct2) * 64, math.cos(ct2) * 64, 0), 12, 9, colDraw)

		render.SetMaterial(matBeam)
		render.StartBeam(16)
		for i=1, 32 do
			render.AddBeam(pos + Vector(math.sin(ct2 + i * 0.08) * 64, math.cos(ct2 + i * 0.08) * 64, 0), 8 - i * 0.2475, 0.0625 * i, colDraw)
		end
		render.EndBeam()
	end
end
