AddCSLuaFile("cl_init.lua")
AddCSLuaFile("shared.lua")

include("shared.lua")

function ENT:Initialize()
	self:SetModel("models/Roller_Spikes.mdl")
	--self:SetModel("models/Samuel/samzanemesis/noxious_flag.mdl")
	self:PhysicsInit(SOLID_VPHYSICS)
	self:SetMoveType(MOVETYPE_VPHYSICS)
	self:SetSolid(SOLID_VPHYSICS)
	self.Carrier = self
	self.NextCantTakeMsg = 0
	self.LastDrop = 0
	self.Phys = self:GetPhysicsObject()
	self:SetCollisionGroup(COLLISION_GROUP_WEAPON)
	self:SetTrigger(true)
	if self.Phys:IsValid() then
		self.Phys:SetMass(500)
		--self.Phys:SetMaterial("metal_bouncy")
		self.Phys:EnableMotion(false)
		self.Phys:Wake()
	end

	self.LastThink = CurTime()

	local teamid = self:GetTeamID()
	local col = team.TeamInfo[teamid].Color
	self:SetColor(col.r, col.g, col.b, 255)
	--self:SetSkin(teamid)
	self.Carriers = {}

	self:SetName(teamid)
end

function ENT:Dropped(pl)
	local byplayer = "itself"
	if pl and pl:IsValid() then
		self:SetPos(pl:GetPos() + Vector(0,0,16))
		pl.Carrying = nil
		byplayer = pl:Name()
		pl:SetStamina(pl:GetStamina(), true)
	end
	self:SetSolid(SOLID_VPHYSICS)
	self.Phys:EnableGravity(true)
	self.Carrier = self
	self:SetOwner(NULL)
	self.Phys:EnableMotion(GAMESTATE == GAMESTATE_PLAY)
	self.Phys:Wake()
	if pl and pl:IsValid() then
		--self.Phys:SetVelocityInstantaneous(pl:GetAngles():Forward() * 400 + Vector(0,0,100))
		self.Phys:SetVelocityInstantaneous(pl:GetVelocity() * 0.75 + Vector(0,0,300))
	end
	self.LastDrop = CurTime()
	local teamid = self:GetTeamID()
	--if self:GetPos():Distance(team.TeamInfo[teamid].FlagPoint) > 80 then
		self.AutoReturnTimer = CurTime() + 30
	--end
	self:SetSkin(2)
	GAMEMODE:FlagDropped(teamid, byplayer)
end

function ENT:Returned(pl, far)
	local myteam = self:GetTeamID()
	local flagpoint = team.TeamInfo[myteam].FlagPoint
	if far then
		umsg.Start("FlagReturnEffect")
			umsg.Vector(self:GetPos())
			umsg.Vector(flagpoint)
			umsg.Short(myteam)
		umsg.End()
	end
	self:SetSolid(SOLID_VPHYSICS)
	self:SetPos(flagpoint)
	self.Carrier = self
	self:SetOwner(NULL)
	self.Phys:EnableGravity(true)
	self.Phys:EnableMotion(false)
	self.Phys:Wake()
	self.AutoReturnTimer = nil
	self.AutoReturnPlayer = nil
	self:SetSkin(0)
	for _, e in pairs(player.GetAll()) do
		if e.Carrying == self then
			e.Carrying = nil
		end
	end
	if pl and pl:IsValid() then
		gamemode.Call("FlagReturned", pl, myteam, far)
	else
		gamemode.Call("FlagReturned", nil, myteam, far)
	end
end

function ENT:SetToHome()
	local teamid = self:GetTeamID()
	local newpos = team.TeamInfo[teamid].FlagPoint

	if 256 <= newpos:Distance(self:GetPos()) then
		umsg.Start("FlagReturnEffect")
			umsg.Vector(self:GetPos())
			umsg.Vector(newpos)
			umsg.Short(teamid)
		umsg.End()
	end

	for _, pl in pairs(player.GetAll()) do
		if pl.Carrying == self then pl.Carrying = nil end
	end

	self.Carrier = self
	self:SetOwner(NULL)
	self:SetSolid(SOLID_VPHYSICS)

	self:SetPos(newpos)
	self:SetSkin(0)

	self.AutoReturnPlayer = nil
	self.AutoReturnTimer = nil

	local phys = self:GetPhysicsObject()
	if phys:IsValid() then
		phys:EnableMotion(false)
	end
end

function ENT:Reset(silent)
	self:SetToHome()
end

function ENT:Touch(hitent)
	if ENDGAME or GAMEMODE.Intermission then return end

	if GAMESTATE == GAMESTATE_VERIFY then
		if hitent:IsPlayer() and hitent:Team() == self:GetTeamID() and hitent.Verified and hitent.Verified == 1 then
			hitent.Verified = 2
			hitent:PrintMessage(HUD_PRINTTALK, "Now go to the center of the map again.")
		end

		return
	end

	if GAMESTATE == GAMESTATE_PLAY and hitent:IsPlayer() and self.Carrier == self and not hitent:InVehicle() then
		local myteam = self:GetTeamID()
		if hitent:IsCarrying() then
			if hitent:Team() == myteam then
				local dist = self:GetPos():Distance(team.TeamInfo[myteam].FlagPoint)
				if dist > 256 then
					if not self.AutoReturnPlayer then
						--self:Returned(hitent, true)
						self.AutoReturnTimer = CurTime() + CTF_FLAG_RETURNTIME
						self.AutoReturnPlayer = hitent
						umsg.Start("FRetTimer")
							umsg.String(hitent:Name())
							umsg.Short(myteam)
						umsg.End()
					end
					return
				elseif dist > 16 then
					self:Returned(hitent, false)
					return
				end
				local carrier = hitent
				hitent = hitent.Carrying
				local otherteam = hitent:GetTeamID()
				if self:GetPos():Distance(team.TeamInfo[myteam].FlagPoint) <= 16 then
					if carrier:IsPlayer() then
						local dist = hitent:GetPos():Distance(team.TeamInfo[myteam].FlagPoint)
						self:SetSolid(SOLID_VPHYSICS)
						self:SetPos(team.TeamInfo[myteam].FlagPoint)
						self.Carrier = self
						self:SetOwner(NULL)
						self.Phys:EnableGravity(true)
						self.Phys:EnableMotion(false)
						self.Phys:Wake()
						self.AutoReturnTimer = nil
						self.AutoReturnPlayer = nil
						self:SetSkin(0)

						hitent:SetSolid(SOLID_VPHYSICS)
						hitent:SetPos(team.TeamInfo[otherteam].FlagPoint)
						hitent.Carrier = hitent
						hitent:SetOwner(NULL)
						hitent.Phys:EnableGravity(true)
						hitent.Phys:EnableMotion(false)
						hitent.Phys:Wake()
						hitent.AutoReturnTimer = nil
						hitent.AutoReturnPlayer = nil
						hitent:SetSkin(0)
						carrier.Carrying = nil
						carrier:SetStamina(carrier:GetStamina(), true)
						if dist < 200 then
							GAMEMODE:FlagCaptured(carrier, myteam, otherteam)
						end
						self.Carriers = {}
					end
				end
			end
		elseif hitent:Team() ~= myteam and not hitent:IsCarrying() and CurTime() > hitent.LastDeath + 0.25 then
			if team.NumPlayers(myteam) > 0 then
				if CurTime() > self.LastDrop + 0.5 then
					self:SetSolid(SOLID_NONE)
					self.Carrier = hitent
					self.LastThink = CurTime()
					self:SetOwner(hitent)
					self.Phys:EnableGravity(false)
					self.Phys:EnableMotion(GAMESTATE == GAMESTATE_PLAY)
					self.Phys:Wake()
					hitent.Carrying = self
					self:SetSkin(1)
					GAMEMODE:FlagTaken(myteam, hitent)
					self.AutoReturnTimer = nil
					self.AutoReturnPlayer = nil
				end
			elseif self.NextCantTakeMsg < CurTime() then
				hitent:PrintMessage(HUD_PRINTCENTER, "You can't take the flag of an unrepresented team!")
				self.NextCantTakeMsg = CurTime() + 1
			end
		elseif hitent:Team() == myteam then
			local dist = self:GetPos():Distance(team.TeamInfo[myteam].FlagPoint)
			if dist >= 256 then
				if not self.AutoReturnPlayer then
					self.AutoReturnTimer = CurTime() + CTF_FLAG_RETURNTIME
					self.AutoReturnPlayer = hitent
					umsg.Start("FRetTimer")
						umsg.String(hitent:Name())
						umsg.Short(myteam)
					umsg.End()
				end
			elseif dist >= 16 then
				self:Returned(hitent, false)
			end
		end
	end
end

function ENT:Think()
	if self.AutoReturnTimer and self.AutoReturnTimer < CurTime() then
		self:Returned(self.AutoReturnPlayer, true)
		return
	end

	local carrier = self.Carrier

	if carrier == self then
		return
	end

	local delta = CurTime() - self.LastThink
	self.LastThink = CurTime()

	if carrier:IsValid() and carrier:Alive() then
		self:SetPos(carrier:GetPos() + Vector(0, 0, 90))
		self.Carriers[carrier] = (self.Carriers[carrier] or 0) + delta
		self.Phys:SetVelocityInstantaneous(Vector(0, 0, 0))

		--if not carrier.Sprinting and not carrier.WallRunning then
			carrier:SetStamina(math.max(carrier:GetStamina() - (carrier.StaminaRegenerate + STAMINA_HOLDING_BALL) * delta, 0))
		--end

		self:NextThink(CurTime())
		return true
	elseif carrier:IsValid() then
		self:Dropped(carrier)
	else
		self:Dropped()
	end
end

function ENT:PhysicsCollide(data, phys)
	if 50 < data.Speed and 0.3 < data.DeltaTime then
		self:EmitSound("npc/turret_floor/click1.wav")
	end
end

function ENT:UpdateTransmitState()
	return TRANSMIT_ALWAYS
end
