AddCSLuaFile("cl_init.lua")
AddCSLuaFile("shared.lua")

include("shared.lua")

function ENT:GetMana()
	return self.Mana
end

function ENT:SetMana(iMana)
	self.Mana = math.max(0, math.min(self.MaxMana, iMana))
end

local rockmodels = {"models/props_wasteland/rockcliff01b.mdl",
"models/props_wasteland/rockcliff01c.mdl",
"models/props_wasteland/rockcliff01e.mdl",
"models/props_wasteland/rockcliff01g.mdl"}

function ENT:Initialize()
	--local ang = self:GetAngles()
	--ang:RotateAroundAxis(ang:Up(), math.Rand(0, 360))
	--self:SetAngles(ang)
	self:SetModel(rockmodels[math.random(1, #rockmodels)])
	self:SetUseType(SIMPLE_USE)
	--self:PhysicsInit(SOLID_VPHYSICS)
	self:PhysicsInitBox(Vector(-14, -14, -48), Vector(14, 14, 48))
	self:SetCollisionBounds(Vector(-14, -14, -48), Vector(14, 14, 48))
	--self:SetSolid(SOLID_VPHYSICS)
	self:SetColor(0, 127, 255, 255)
	self.Mana = 100
	self.MaxMana = 100
	--self.LastDrain = -10
	self.NextSound = -10
	self.LastBrightness = 255
	self.Sappers = 0
	self.LstThnk = CurTime()
	local phys = self:GetPhysicsObject()
	if phys:IsValid() then
		phys:SetMaterial("metal")
		phys:EnableMotion(false)
		phys:Sleep()
	end
end

function ENT:Team()
	return 0
end

function ENT:UniqueID()
	return self.EntIndex()
end

function ENT:Alive()
	return self.Mana > 0
end

function ENT:Think()
	local ct = CurTime()
	if self.Mana < self.MaxMana then --and self.LastDrain + 1 < ct then
		local ft = ct - self.LstThnk
		self.LstThnk = ct
		self.Mana = math.min(self.MaxMana, self.Mana + ft * math.max(1.25, 6 - self.Sappers * 1.75))
		local brightness = math.ceil(math.max(self.Mana * 2.55, 30))
		if self.LastBrightness ~= math.ceil(brightness * 0.1) then
			self:SetColor(0, brightness * 0.5, brightness, 255)
			self.LastBrightness = brightness
		end
	end
end

function ENT:Touch(ent, drain)
	if drain then
		local amount = math.min(self.Mana, FrameTime() * 120)
		ent:SetMana(math.min(ent:GetMana() + amount * (ent.ObeliskManaRetainer or 1), ent.MaxMana), true)
		self.Mana = self.Mana - amount
		local brightness = math.max(self.Mana * 2.55, 30)
		if self.LastBrightness ~= math.ceil(brightness*0.1) then
			self:SetColor(0, brightness * 0.5, brightness, 255)
			self.LastBrightness = brightness
		end
		--self.LastDrain = CurTime()
		self.LstThnk = CurTime()
	elseif ent:IsPlayer() and 1 < self.Mana and 0 < ent.MaxMana then
		local wep = ent:GetActiveWeapon()
		if wep:IsValid() and wep.MaxMana and ent:GetAmmoCount(wep.ChargeAmmo) < wep.MaxMana then
			local amount = math.min(self.Mana, FrameTime() * 66)
			ent:SetMana(math.min(ent:GetMana() + amount * (ent.ObeliskManaRetainer or 1), ent.MaxMana), true)
			ent:GiveAmmo(1, wep.ChargeAmmo)
			self.Mana = self.Mana - amount
			local brightness = math.max(self.Mana * 2.55, 30)
			if self.LastBrightness ~= math.ceil(brightness*0.1) then
				self:SetColor(0, brightness * 0.5, brightness, 255)
				self.LastBrightness = brightness
			end
			--self.LastDrain = CurTime()
			self.LstThnk = CurTime()
			if CurTime() >= self.NextSound then
				self:EmitSound("nox/managain.wav")
				self.NextSound = CurTime() + 0.75
			end
		elseif ent:GetMana() < ent.MaxMana then
			local amount = math.min(self.Mana, FrameTime() * 66)
			ent:SetMana(math.min(ent:GetMana() + amount * (ent.ObeliskManaRetainer or 1), ent.MaxMana), true)
			self.Mana = self.Mana - amount
			local brightness = math.max(self.Mana * 2.55, 30)
			if self.LastBrightness ~= math.ceil(brightness*0.1) then
				self:SetColor(0, brightness * 0.5, brightness, 255)
				self.LastBrightness = brightness
			end
			--self.LastDrain = CurTime()
			self.LstThnk = CurTime()
			if CurTime() >= self.NextSound then
				self:EmitSound("nox/managain.wav")
				self.NextSound = CurTime() + 0.75
			end
		end
	end
end
