AddCSLuaFile("cl_init.lua")
AddCSLuaFile("shared.lua")

include("shared.lua")

function ENT:Initialize()
	self:DrawShadow(false)
	self:SetModel("models/weapons/w_missile_closed.mdl")
	self:PhysicsInitSphere(7)
	self:SetMoveType(MOVETYPE_VPHYSICS)
	self:SetSolid(SOLID_VPHYSICS)
	self:SetCollisionGroup(COLLISION_GROUP_WEAPON)
	local phys = self:GetPhysicsObject()
	if phys:IsValid() then
		phys:EnableDrag(false)
		phys:EnableGravity(false)
		phys:Wake()
	end

	self.DeathTime = CurTime() + 15
	self.SpawnTime = CurTime() + 0.1
	self.Target = NULL
end

function ENT:Think()
	if self.Exploded or self.DeathTime <= CurTime() then
		self:Remove()
		return
	end

	if 0 < self:WaterLevel() then
		self:Explode()
		return
	end

	if self.PhysicsData then
		self:Explode(self.PhysicsData.HitPos, self.PhysicsData.HitNormal)
		return
	end

	local teamid = self:GetTeamID()
	local mypos = self:GetPos()
	local target = self.Target
	if target:IsValid() and target:Alive() and IsVisible(self:GetPos(), target:EyePos()) then
		local phys = self:GetPhysicsObject()
		if phys:IsValid() then
			local targetpos = target:GetPos()
			if targetpos:Distance(mypos) < 256 then
				phys:SetVelocityInstantaneous(((targetpos - mypos):Normalize() + self:GetVelocity():Normalize()):Normalize() * 950)
			else
				phys:SetVelocityInstantaneous(((targetpos - mypos):Normalize() + self:GetVelocity():Normalize() * 3.6):Normalize() * 950)
			end
		end
		self.DeathTime = CurTime() + 10
	else
		for _, ent in pairs(ents.FindInSphere(mypos, 390)) do
			if ent.SendLua and ent:Alive() and ent:Team() ~= teamid and IsVisible(mypos, ent:EyePos()) then
				if ent:InVehicle() then
					ent:SendLua("RLO()")
					self.Target = ent
				elseif ent.Invisible then
					local vel = ent:GetVelocity():Length()
					if 160 <= vel then
						self.Target = ent
						break
					end
				else
					self.Target = ent
					break
				end
			end
		end
		self:NextThink(CurTime() + 0.25)
		return true
	end
end

function ENT:PhysicsCollide(data, physobj)
	if TRS(self, data.HitEntity, data.OurOldVelocity) then return end

	if self.SpawnTime <= CurTime() then
		self.PhysicsData = data
		self:NextThink(CurTime())
	end
end

function ENT:Explode(hitpos, hitnormal)
	if self.Exploded then return end
	self.Exploded = true
	self.DeathTime = -10

	local owner = self:GetOwner()
	if not owner:IsValid() then owner = self end
	hitpos = hitpos or self:GetPos()

	ExplosiveDamage(owner, self, hitpos, 130, 72, 0.6, 1, 8)

	local effectdata = EffectData()
		effectdata:SetOrigin(hitpos)
		effectdata:SetNormal(hitnormal or Vector(0,0,1))
		effectdata:SetScale(1)
		effectdata:SetMagnitude(1)
		effectdata:SetRadius(1)
	util.Effect("Explosion", effectdata)

	self:NextThink(CurTime())
end

function ENT:UpdateTransmitState()
	return TRANSMIT_PVS
end
