include("shared.lua")

local matGlow = Material("sprites/light_glow02_add")

function ENT:Draw()
	local vel = self:GetVelocity()
	if 10 < vel:Length() then
		self:SetAngles(vel:Angle())
	end
	self:SetModelScale(Vector(2,2,3))
	self:DrawModel()

	local vOffset = self:GetPos()

	render.SetMaterial(matGlow)
	local size = 105 + math.sin(RealTime() * 40) * 38
	render.DrawSprite(vOffset, size, size, color_white)

	local particle = self.Emitter:Add("effects/fire_embers"..math.random(1, 3), vOffset)
	particle:SetDieTime(0.5)
	particle:SetStartAlpha(190)
	particle:SetEndAlpha(20)
	particle:SetStartSize(math.Rand(18, 26))
	particle:SetEndSize(4)
	particle:SetRoll(math.random(0, 360))
	for i=0, EFFECT_QUALITY do
		local particle = self.Emitter:Add("particles/smokey", vOffset)
		particle:SetVelocity(VectorRand() * 8)
		particle:SetDieTime(2.0)
		particle:SetStartAlpha(220)
		particle:SetEndAlpha(0)
		particle:SetStartSize(math.Rand(10, 14))
		particle:SetEndSize(6)
		particle:SetRoll(math.Rand(0, 360))
		particle:SetRollDelta(math.Rand(-1, 1))
	end
end

function ENT:Initialize()
	self.Emitter = ParticleEmitter(self:GetPos())
	self.Emitter:SetNearClip(120, 140)

	self:DrawShadow(false)
	self.FireSound = CreateSound(self, "Missile.Ignite")
end

function ENT:Think()
	self.Emitter:SetPos(self:GetPos())
	self.FireSound:Play()
end

function ENT:OnRemove()
	self.Emitter:Finish()
	self.FireSound:Stop()
	ExplosiveEffect(self:GetPos(), 170, 80, DMGTYPE_FIRE)
end
