AddCSLuaFile("cl_init.lua")
AddCSLuaFile("shared.lua")

include("shared.lua")

ENT.Damage = 10
ENT.DamageType = DMGTYPE_BULLET
ENT.Heading = Vector(0,0,1)
ENT.BulletSpeed = 3500

function ENT:Initialize()
	self:SetModel("models/Weapons/w_bullet.mdl")
	self:DrawShadow(false)
	self:PhysicsInitSphere(1)
	self:SetMoveType(MOVETYPE_VPHYSICS)
	self:SetSolid(SOLID_VPHYSICS)
	local phys = self:GetPhysicsObject()
	phys:EnableDrag(false)
	phys:EnableGravity(false)
	phys:SetBuoyancyRatio(0.00001)
	phys:Wake()

	self.DeathTime = CurTime() + 30
end

function ENT:Think()
	if self.PhysicsData then
		local data = self.PhysicsData
		self.PhysicsData = nil

		if not (self.Callback and self.Callback(self, data)) then
			local start = self:GetPos()
			local hitentity = data.HitEntity
			if hitentity:IsValid() then
				hitentity:TakeSpecialDamage(self.Damage, self.DamageType, self:GetOwner(), self.Inflictor or self)
			end

			local effectdata = EffectData()
				effectdata:SetOrigin(data.HitPos)
				effectdata:SetNormal(data.HitNormal)
				effectdata:SetMagnitude(self:GetTeamID())
			util.Effect("bullethit_basic", effectdata)
		end

		self:Remove()
	elseif self.DeathTime <= CurTime() then	
		self:Remove()
	end
end

function ENT:PhysicsCollide(data, phys)
	if TRS(self, data.HitEntity, data.OurOldVelocity) then return end

	self.DeathTime = 0
	self.PhysicsData = data

	self:NextThink(CurTime())
end
