include("shared.lua")

function ENT:Initialize()
	self:DrawShadow(false)
	self:SetRenderBounds(Vector(-60, -60, -60), Vector(60, 60, 60))
	self.Col = Color(self:GetColor())
	self.Created = CurTime()
	self.Beams = {}
	self.BeamDieTimes = {}
end

local vec0 = Vector(0,0,0)
local matTBeam = Material("sprites/tp_beam001")
local matGlow = Material("effects/stunstick")
function ENT:Draw()
	local vel = self:GetVelocity()
	local ang = vel:Angle()
	if vec0 ~= vel then
		self:SetAngles(ang)
	end
	self:SetModelScale(Vector(3,3,3))
	self:SetMaterial("models/shiny")
	local pos = self:GetPos()
	render.SetMaterial(matGlow)
	local siz = math.Rand(32, 64)
	local col = self.Col
	render.DrawSprite(pos, siz, siz, col)
	render.SetMaterial(matTBeam)
	--render.DrawBeam(pos, pos + math.min(0.25, CurTime() - self.Created) * -1024 * vel:Normalize(), 24, 1, 0, col)

	local tot = #self.Beams
	render.StartBeam(tot + 1)
		render.AddBeam(pos, 24, 0, col)
		for i, bpos in ipairs(self.Beams) do
			render.AddBeam(bpos, 25 - i / tot, i, col)
		end
	render.EndBeam()

	local endbeam = self.BeamDieTimes[tot]
	if endbeam and endbeam <= CurTime() then
		table.remove(self.Beams, tot)
		table.remove(self.BeamDieTimes, tot)
	end

	ang:RotateAroundAxis(ang:Forward(), RealTime() * 1200)
	table.insert(self.Beams, 1, pos + ang:Up() * 12)
	table.insert(self.BeamDieTimes, 1, CurTime() + 0.4)

	self:DrawModel()
end
