include("shared.lua")

function ENT:Initialize()
	self:DrawShadow(false)

	self.Emitter = ParticleEmitter(self:GetPos())
	self.Emitter:SetNearClip(28, 36)

	self:SetColor(255, 125, 75, 255)
	self:SetMaterial("models/props_wasteland/rockcliff04a")

	self.AmbientSound = CreateSound(self, "ambient/fire/fire_big_loop1.wav")
end

function ENT:Think()
	self.AmbientSound:Play()

	self.Emitter:SetPos(self:GetPos())

	if not self.PlayedSound then
		self.PlayedSound = true
		self:EmitSound("nox/fireballwhoosh.wav", 80, math.Rand(95, 105))
	end
end

function ENT:OnRemove()
	self.Emitter:Finish()
	self.AmbientSound:Stop()
end

local matFire = Material("sprites/light_glow02_add")
function ENT:Draw()
	self:SetModelScale(Vector(0.35, 0.35, 0.35))
	self:DrawModel()
	render.SetMaterial(matFire)
	render.DrawSprite(self:GetPos(), math.Rand(32, 48), math.Rand(32, 48), color_white)

	local vPos = self:GetPos()

	local emitter = self.Emitter
	local particle = emitter:Add("effects/fire_embers"..math.random(1,3), vPos)
	particle:SetDieTime(0.3)
	particle:SetStartAlpha(150)
	particle:SetEndAlpha(60)
	particle:SetStartSize(math.Rand(14, 20))
	particle:SetEndSize(2)
	particle:SetRoll(math.Rand(0, 360))
	particle:SetRollDelta(math.Rand(-64, 64))

	local vel = self:GetVelocity()

	for i=1, math.max(1, EFFECT_QUALITY) do
		local particle = emitter:Add("effects/fire_embers"..math.random(1,3), vPos)
		particle:SetVelocity(vel * -0.7 + VectorRand() * 100)
		particle:SetDieTime(0.5)
		particle:SetStartAlpha(200)
		particle:SetEndAlpha(100)
		particle:SetStartSize(math.Rand(10, 14))
		particle:SetEndSize(2)
		particle:SetRoll(math.Rand(0, 360))
		particle:SetRollDelta(math.Rand(-64, 64))

		local particle = emitter:Add("sprites/light_glow02_add", vPos + VectorRand():Normalize() * 10)
		particle:SetVelocity(vel * -0.1 + VectorRand() * 8)
		particle:SetDieTime(1.25)
		particle:SetStartAlpha(200)
		particle:SetEndAlpha(20)
		particle:SetStartSize(math.Rand(12, 16))
		particle:SetEndSize(2)
		particle:SetColor(255, 200, 50)
		particle:SetRoll(math.Rand(0, 360))
		particle:SetRollDelta(math.Rand(-64, 64))
	end
end
