AddCSLuaFile("cl_init.lua")
AddCSLuaFile("shared.lua")

include("shared.lua")

function ENT:Initialize()
	self:SetModel("models/Combine_Helicopter/helicopter_bomb01.mdl")
	self:PhysicsInit(SOLID_VPHYSICS)
	self:SetMoveType(MOVETYPE_VPHYSICS)
	self:SetSolid(SOLID_VPHYSICS)
	self:SetCollisionGroup(COLLISION_GROUP_WEAPON)
	--self:SetTrigger(true)
	local phys = self:GetPhysicsObject()
	if phys:IsValid() then
		phys:EnableDrag(false)
		phys:SetMass(5)
		phys:Wake()
	end

	self.DeathTime = CurTime() + 20
	self:SetMaterial("models/shiny")
end

function ENT:Think()
	if CurTime() >= self.DeathTime then
		self:Remove()
		return
	end

	if 0 < self:WaterLevel() or self.BounceTime and self.BounceTime <= CurTime() then
		self:Explode()
	end
end

function ENT:PhysicsCollide(data, physobj)
	if TRS(self, data.HitEntity, data.OurOldVelocity) then return end

	if 20 < data.Speed and 0.2 < data.DeltaTime then
		self:EmitSound("physics/metal/metal_canister_impact_hard"..math.random(1,3)..".wav", 80, math.random(137, 143))
	end

	local normal = data.OurOldVelocity:Normalize()
	local DotProduct = data.HitNormal:Dot(normal * -1)

	physobj:SetVelocityInstantaneous((2 * DotProduct * data.HitNormal + normal) * data.Speed * 0.75)

	if not self.BounceTime then
		self.BounceTime = CurTime() + 1.25
	end
end

function ENT:Explode()
	if self.Exploded then return end
	self.Exploded = true

	local owner = self:GetOwner()
	if not owner:IsValid() then owner = self end

	local mypos = self:GetPos()
	local myteam = owner:GetTeamID()
	for ent, damagetaken in pairs(ExplosiveDamage(owner, self, mypos, 300, 300, 0.9, 0.35, 8)) do
		if ent.KnockDown and 25 <= damagetaken and (ent:GetTeamID() ~= myteam or ent == owner) then
			ent:SetGroundEntity(NULL)
			ent:SetLocalVelocity(damagetaken * 9 * (ent:LocalToWorld(ent:OBBCenter()) - mypos):Normalize() + Vector(0,0,damagetaken * 8))
			ent:KnockDown()
		end
	end

	local effectdata = EffectData()
		effectdata:SetOrigin(self:GetPos())
	util.Effect("FireBombExplosion", effectdata)

	self.DeathTime = -10
end

function ENT:UpdateTransmitState()
	return TRANSMIT_ALWAYS
end
