AddCSLuaFile("cl_init.lua")
AddCSLuaFile("shared.lua")

include("shared.lua")

function ENT:Initialize()
	self:DrawShadow(false)
	self.DeathTime = CurTime() + 10
	self:PhysicsInitSphere(16)
	self:SetSolid(SOLID_VPHYSICS)
	local phys = self:GetPhysicsObject()
	if phys:IsValid() then
		phys:EnableMotion(true)
		phys:EnableGravity(false)
		phys:EnableDrag(false)
		phys:Wake()
	end

	self.CounterSpell = COUNTERSPELL_DESTROY
	self.Inversion = INVERSION_SETOWNER_REVERSE_TARGET
	self.Target = NULL
end

function ENT:Think()
	local ct = CurTime()
	if self.DeathTime <= ct then
		self:Remove()
		return
	elseif 0 < self:WaterLevel() then
		self:Explode(self:GetPos(), Vector(0,0,1))
		return
	elseif self.PhysicsData then
		self:Explode(self.PhysicsData.HitPos, self.PhysicsData.HitNormal)
		return
	end

	local mypos = self:GetPos()
	local owner = self:GetOwner()

	if self.EndHoming then return end

	local myteam = self:GetTeamID()
	local target = self.Target
	if target:IsValid() and target:Alive() then
		self.DeathTime = ct + 15

		local nearest = target:NearestPoint(mypos)
		local vHeading = (nearest - mypos):Normalize()
		local aOldHeading = self:GetVelocity():Angle()

		self:SetAngles(aOldHeading)
		local diffang = self:WorldToLocalAngles(vHeading:Angle())

		local ft = FrameTime() * math.max(1.4, math.min(5.2, 6 - nearest:Distance(mypos) * 1.2))
		aOldHeading:RotateAroundAxis(aOldHeading:Up(), diffang.yaw * ft)
		aOldHeading:RotateAroundAxis(aOldHeading:Right(), diffang.pitch * -ft)

		local vNewHeading = aOldHeading:Forward()
		self:GetPhysicsObject():SetVelocityInstantaneous(vNewHeading * 1300)

		if nearest:Distance(mypos) < 89 then
			self:GetPhysicsObject():SetVelocityInstantaneous(vHeading * 1300)
			self.EndHoming = true
		else
			self:NextThink(ct)
			return true
		end
	else
		self.Target = NULL
		for _, ent in pairs(ents.FindInSphere(self:GetPos(), 400)) do
			if ent:IsPlayer() and ent:Alive() and ent:Team() ~= myteam and IsVisible(mypos, ent:NearestPoint(mypos)) then
				if not (ent:GetVisibility() <= 1 and not owner.Infravision) then
					self.Target = ent
					break
				end
			end
		end
	end
end

function ENT:PhysicsCollide(data, physobj)
	if TRS(self, data.HitEntity, data.OurOldVelocity) then return end

	if not (data.HitEntity and data.HitEntity:IsValid() and data.HitEntity:GetClass() == "projectile_firesprite") then
		self.PhysicsData = data
		self:NextThink(CurTime())
	end
end

function ENT:Explode(hitpos, hitnormal)
	if self.Exploded then return end
	self.Exploded = true
	self.DeathTime = -10

	local owner = self:GetOwner()
	if not owner:IsValid() then owner = self end
	hitpos = hitpos or self:GetPos()

	ExplosiveDamage(owner, self, hitpos, 72, 72, 1, 0.5, 2)

	local effectdata = EffectData()
		effectdata:SetOrigin(hitpos)
		effectdata:SetNormal(hitnormal or Vector(0, 0, 1))
	util.Effect("firespriteexplosion", effectdata)

	self:NextThink(CurTime())
end

function ENT:UpdateTransmitState()
	return TRANSMIT_PVS
end
