AddCSLuaFile("cl_init.lua")
AddCSLuaFile("shared.lua")

include("shared.lua")

function ENT:Initialize()
	self:SetModel("models/Combine_Helicopter/helicopter_bomb01.mdl")
	self:DrawShadow(false)
	self.CounterSpell = COUNTERSPELL_EXPLODE
	self:PhysicsInitSphere(6)
	self:SetMoveType(MOVETYPE_VPHYSICS)
	self:SetSolid(SOLID_VPHYSICS)
	local phys = self:GetPhysicsObject()
	if phys:IsValid() then
		phys:EnableDrag(false)
		phys:EnableGravity(false)
		phys:Wake()
	end
	self.DeathTime = CurTime() + 10.0
	self.Created = CurTime() - 0.25

	self:SetColor(255, 125, 75, 255)
	self:SetMaterial("models/props_wasteland/rockcliff04a")
end

function ENT:Think()
	if self.DeathTime <= CurTime() then
		self:Remove()
	elseif 0 < self:WaterLevel() then
		self:Explode()
	elseif self.PhysicsData then
		self:Explode(self.PhysicsData.HitPos, self.PhysicsData.HitNormal)
	end
end

function ENT:PhysicsCollide(data, physobj)
	if TRS(self, data.HitEntity, data.OurOldVelocity) then return end

	self.PhysicsData = data
	self:NextThink(CurTime())
end

function ENT:PhysicsUpdate(phys)
	phys:SetVelocityInstantaneous(math.max(250, math.min((CurTime() - self.Created) * 400, 800)) * self.Heading)
end

function ENT:Explode(hitpos, hitnormal)
	if self.Exploded then return end
	self.Exploded = true
	self.DeathTime = -10

	local owner = self:GetOwner()
	if not owner:IsValid() then owner = self end

	hitpos = hitpos or self:GetPos()
	
	local myteam = owner:GetTeamID()
	for ent, damagetaken in pairs(ExplosiveDamage(owner, self, hitpos, 132, 132, 1, 0.45, 1)) do
		if ent.KnockDown and 25 <= damagetaken and (ent:GetTeamID() ~= myteam or ent == owner) then
			ent:SetGroundEntity(NULL)
			ent:SetLocalVelocity(damagetaken * 8 * (ent:LocalToWorld(ent:OBBCenter()) - hitpos):Normalize() + Vector(0, 0, damagetaken * 8))
			ent:KnockDown()
		end
	end

	local effectdata = EffectData()
		effectdata:SetOrigin(hitpos)
		effectdata:SetNormal(hitnormal or Vector(0, 0, 1))
	util.Effect("rovercannonexplosion", effectdata)

	self:NextThink(CurTime())
end
