include("shared.lua")

function ENT:Initialize()
	self:DrawShadow(false)

	self.NextRing = 0

	self.Emitter = ParticleEmitter(self:GetPos())
	self.Emitter:SetNearClip(28, 36)

	self.AmbientSound = CreateSound(self, "ambient/fire/firebig.wav")
end

function ENT:Think()
	self.AmbientSound:Play()

	self.Emitter:SetPos(self:GetPos())

	if not self.PlayedSound then
		self.PlayedSound = true
		self:EmitSound("nox/meteorfall.wav", 82, math.Rand(95, 105))
	end
end

function ENT:OnRemove()
	self.Emitter:Finish()
	self.AmbientSound:Stop()
end

local matFire = Material("sprites/light_glow02_add")
local matRing = Material("effects/select_ring")
function ENT:Draw()
	render.SetMaterial(matFire)
	local vPos = self:GetPos()
	render.DrawSprite(vPos, math.Rand(32, 48), math.Rand(32, 48), color_white)
	render.SetMaterial(matRing)
	render.DrawSprite(vPos, 24, 24, COLOR_YELLOW)

	local emitter = self.Emitter
	local particle = emitter:Add("effects/fire_embers"..math.random(1,3), vPos)
	particle:SetDieTime(0.3)
	particle:SetStartAlpha(150)
	particle:SetEndAlpha(0)
	particle:SetStartSize(math.Rand(24, 30))
	particle:SetEndSize(0)
	particle:SetRoll(math.Rand(0, 360))
	particle:SetRollDelta(math.Rand(-64, 64))

	local vel = self:GetVelocity()
	for i=1, math.max(1, EFFECT_QUALITY) do
		local particle = emitter:Add("effects/fire_embers"..math.random(1,3), vPos)
		particle:SetVelocity(vel * -1 + VectorRand() * 140)
		particle:SetDieTime(0.5)
		particle:SetStartAlpha(200)
		particle:SetEndAlpha(0)
		particle:SetStartSize(math.Rand(15, 20))
		particle:SetEndSize(2)
		particle:SetRoll(math.Rand(0, 360))
		particle:SetRollDelta(math.Rand(-64, 64))
	end

	local particle = emitter:Add("noxctf/sprite_smoke", vPos + VectorRand():Normalize() * 10)
	particle:SetVelocity(vel * -0.1 + VectorRand() * 8)
	particle:SetDieTime(1.25)
	particle:SetStartAlpha(200)
	particle:SetEndAlpha(20)
	particle:SetStartSize(4)
	particle:SetEndSize(math.Rand(16, 40))
	particle:SetColor(20, 20, 20)
	particle:SetRoll(math.Rand(0, 360))
	particle:SetRollDelta(math.Rand(-64, 64))

	if self.NextRing <= RealTime() then
		self.NextRing = RealTime() + 0.05

		local particle = emitter:Add("effects/select_ring", vPos)
		particle:SetAngles(vel:Angle())
		particle:SetStartSize(8)
		particle:SetEndSize(48)
		particle:SetLifeTime(0.1)
		particle:SetDieTime(0.5)
		particle:SetColor(255, 200, 50)
		particle:SetStartAlpha(255)
		particle:SetEndAlpha(0)
	end
end
