include("shared.lua")

function ENT:Initialize()
	self.Emitter = ParticleEmitter(self:GetPos())
	self.Emitter:SetNearClip(32, 36)

	self.FireSound = CreateSound(self, "ambient/fire/fire_med_loop1.wav")

	self.Col = Color(self:GetColor())
end

function ENT:Think()
	self.FireSound:PlayEx(0.85, 135 + math.sin(CurTime()*5))
	self.Emitter:SetPos(self:GetPos())
end

function ENT:OnRemove()
	self.FireSound:Stop()
	self.Emitter:Finish()
	ExplosiveEffect(self:GetPos(), 92, 80, DMGTYPE_FIRE)
end

local matGlow = Material("sprites/light_glow02_add")
function ENT:Draw()
	local vOffset = self:GetPos()

	local pos1 = self:GetPos()
	render.SetMaterial(matGlow)
	local r,g,b = self:GetColor()
	local col = self.Col
	col.r = r
	col.g = g
	col.b = b
	render.DrawSprite(pos1, 290, 48, self.Col)
	render.DrawSprite(pos1, 64, 64, color_white)
	render.DrawSprite(pos1 + Vector(0,0,math.sin(RealTime() * 32) * 9), 330, 48, self.Col)

	local emitter = self.Emitter
	particle = emitter:Add("sprites/light_glow02_add", pos1 + VectorRand():Normalize() * math.Rand(12, 16))
	particle:SetDieTime(math.Rand(0.6, 1))
	particle:SetStartAlpha(230)
	particle:SetEndAlpha(50)
	particle:SetStartSize(math.Rand(32, 48))
	particle:SetEndSize(0)
	particle:SetRoll(math.Rand(0, 360))
	particle:SetRollDelta(math.Rand(-8, 8))
	particle:SetColor(r, g, b)

	particle = emitter:Add("effects/muzzleflash2", pos1)
	particle:SetVelocity(VectorRand():Normalize() * math.Rand(32, 48))
	particle:SetDieTime(math.Rand(1, 1.2))
	particle:SetStartAlpha(230)
	particle:SetEndAlpha(0)
	particle:SetStartSize(math.Rand(20, 28))
	particle:SetEndSize(16)
	particle:SetRoll(math.Rand(0, 360))
	particle:SetRollDelta(math.Rand(-9, 9))
end
