include("shared.lua")

function ENT:Initialize()
	self:DrawShadow(false)
	self.Col = Color(self:GetColor())
	self.Created = CurTime()
	self.Emitter = ParticleEmitter(self:GetPos())
	self.Emitter:SetNearClip(25, 35)
	self:EmitSound("npc/roller/blade_out.wav", 73, math.Rand(80, 100))
end

function ENT:Think()
	self.Emitter:SetPos(self:GetPos())
end

function ENT:OnRemove()
	self.Emitter:Finish()
end

--local matBeam = Material("Effects/laser1")
--local matGlow = Material("sprites/glow04_noz")
function ENT:Draw()
	self:SetMaterial("models/shiny")
	self:DrawModel()

	local Low, High = self:WorldSpaceAABB()
	local r,g,b,a = self:GetColor()

	local emitter = self.Emitter
	for i=0, math.min(32, math.ceil(FrameTime() * 300)) do
		local particle
		if math.random(1, 4) == 1 then
			particle = emitter:Add("sprites/heatwave", Vector(math.Rand(Low.x, High.x), math.Rand(Low.y, High.y), math.Rand(Low.z, High.z)))
		else
			particle = emitter:Add("sprites/light_glow02_add", Vector(math.Rand(Low.x, High.x), math.Rand(Low.y, High.y), math.Rand(Low.z, High.z)))
			particle:SetColor(r * math.Rand(0.85, 1), g * math.Rand(0.85, 1), b * math.Rand(0.85, 1))
		end
		particle:SetDieTime(math.Rand(1.4, 2.0))
		particle:SetStartAlpha(255)
		particle:SetEndAlpha(0)
		particle:SetStartSize(math.Rand(8, 48))
		particle:SetEndSize(1)
		particle:SetRoll(math.Rand(0, 360))
		particle:SetRollDelta(math.Rand(-40, 40))
	end
end
