AddCSLuaFile("cl_init.lua")
AddCSLuaFile("shared.lua")

include("shared.lua")

function ENT:Initialize()
	self:DrawShadow(false)
	self.CounterSpell = COUNTERSPELL_EXPLODE
	self.Inversion = INVERSION_SETOWNER_REVERSE_TARGET_VELOCITY
	self:PhysicsInitSphere(4)
	self:SetMoveType(MOVETYPE_VPHYSICS)
	self:SetSolid(SOLID_VPHYSICS)
	local phys = self:GetPhysicsObject()
	if phys:IsValid() then
		phys:EnableDrag(false)
		phys:EnableGravity(false)
		phys:Wake()
	end

	self.DeathTime = CurTime() + 7
	self.SpawnTime = CurTime() + 0.3
	self.Target = NULL
end

function ENT:Think()
	if self.DeathTime < CurTime() or self.Exploded then
		self:Remove()
	elseif 0 < self:WaterLevel() then
		self:Explode()
	elseif self.PhysicsData then
		self:Explode(self.PhysicsData.HitPos, self.PhysicsData.HitNormal)
	else
		if not self.Trailed then
			self.Trailed = true
			util.SpriteTrail(self, 0, Color(255, 255, 120, 160), false, 22, 16, 1, one42, "trails/smoke.vmt")
		end

		local target = self.Target
		local mypos = self:GetPos()
		if target:IsValid() and 0 < target:Health() and TrueVisible(mypos, target:EyePos()) then
			self:GetPhysicsObject():ApplyForceCenter((target:EyePos() - self:GetPos()):Normalize() * 400 + VectorRand() * 70)
		else
			--self:GetPhysicsObject():ApplyForceCenter(VectorRand() * 50)
			local myteam = self:GetTeamID()
			local mypos = self:GetPos()
			for _, ent in pairs(ents.FindInSphere(mypos, 400)) do
				if ent:IsPlayer() and ent:Team() ~= myteam and ent:Alive() and ent:EyePos():Distance(mypos) < 400 and IsVisible(mypos, ent:EyePos()) then
					if not (ent:GetVisibility() <= 1 and not self:GetOwner().Infravision) then
						self.Target = ent
						break
					end
				end
			end
			self:NextThink(CurTime() + 0.3)
			return true
		end
	end
end

function ENT:PhysicsCollide(data, physobj)
	if TRS(self, data.HitEntity, data.OurOldVelocity) then return end

	if self.SpawnTime <= CurTime() and not (data.HitEntity and data.HitEntity:IsValid() and data.HitEntity:GetClass() == "projectile_magicmissile") then
		self.PhysicsData = data
		self:NextThink(CurTime())
	end
end

function ENT:Explode(hitpos, hitnormal)
	if self.Exploded then return end
	self.Exploded = true
	self.DeathTime = -10

	local owner = self:GetOwner()
	if not owner:IsValid() then owner = self end
	hitpos = hitpos or self:GetPos()

	ExplosiveDamage(owner, self, hitpos, 50, 50, 0.5, 0.25, 1)

	local effectdata = EffectData()
		effectdata:SetOrigin(hitpos)
		effectdata:SetNormal(hitnormal or Vector(0,0,1))
	util.Effect("magicmissileexplosion", effectdata)

	self:NextThink(CurTime())
end

function ENT:UpdateTransmitState()
	return TRANSMIT_PVS
end
