AddCSLuaFile("cl_init.lua")
AddCSLuaFile("shared.lua")

include("shared.lua")

function ENT:Initialize()
	self:DrawShadow(false)
	self.DeathTime = CurTime() + 25
	self:PhysicsInitSphere(5)
	self:SetMoveType(MOVETYPE_VPHYSICS)
	self:SetSolid(SOLID_VPHYSICS)
	self:SetTrigger(true)
	self:SetCollisionGroup(COLLISION_GROUP_WEAPON)
	local phys = self:GetPhysicsObject()
	if phys:IsValid() then
		phys:EnableDrag(false)
		phys:EnableGravity(false)
		phys:SetBuoyancyRatio(0.000001)
		phys:SetMass(5)
		phys:Wake()
	end

	self.ManaAmount = self.ManaAmount or 50
end

function ENT:Think()
	if self.DeathTime <= CurTime() then
		self:Remove()
	end
end

function ENT:StartTouch(ent)
	if ent:IsValid() and not (ent:IsPlayer() and ent:Team() == self:GetTeamID()) then
		self:Explode(ent:NearestPoint(self:GetPos()), self:GetVelocity():Normalize() * -1, ent)
	end
end

function ENT:Think()
	if self.DeathTime <= CurTime() then
		self:Remove()
	elseif self.PhysicsData then
		self:Explode(self.PhysicsData.HitPos, self.PhysicsData.HitNormal, self.PhysicsData.HitEntity)
	end
end

function ENT:PhysicsCollide(data, physobj)
	if TRS(self, data.HitEntity, data.OurOldVelocity) then return end

	self.PhysicsData = data
	self:NextThink(CurTime())
end

function ENT:Explode(hitpos, hitnormal, hitent)
	if self.Exploded then return end
	self.Exploded = true
	self.DeathTime = -10

	local owner = self:GetOwner()
	if not owner:IsValid() then owner = self end
	hitpos = hitpos or self:GetPos()

	local effectdata = EffectData()
		effectdata:SetOrigin(hitpos)
		effectdata:SetNormal(hitnormal or Vector(0,0,1))
	if hitent and hitent:IsValid() and hitent.ManaStorage then
		util.Effect("manatranslocatorrec", effectdata)
		hitent.ManaStorage = math.min(hitent.MaxManaStorage, hitent.ManaStorage + self.ManaAmount)
		if hitent.ManaReceived then
			hitent:ManaReceived(self, self.ManaAmount)
		end
	else
		util.Effect("ebexplode", effectdata)
		ExplosiveDamage(hitent or self, self, hitpos, 100, 100, 0, 0.4, 1, DMGTYPE_ELECTRIC)
	end

	self:NextThink(CurTime())
end
