include("shared.lua")

util.PrecacheSound("physics/glass/glass_largesheet_break1.wav")
util.PrecacheSound("physics/glass/glass_largesheet_break2.wav")
util.PrecacheSound("physics/glass/glass_largesheet_break3.wav")

function ENT:Draw()
	local delta = math.max(0, self.DieTime - CurTime())
	local size = math.min(1, (0.75 - delta) * 3)

	local icea
	if size == 1 then
		self:SetColor(30, 150, 255, delta * 480)
		icea = delta * 240
	else
		icea = 120
		self:SetColor(30, 150, 255, 240)
		self.Rotation = self.Rotation + FrameTime() * 520
	end
	self:SetAngles(Angle(0, self.Rotation, 0))
	self:SetModelScale(Vector(size, size, size * 2))
	self:SetMaterial("models/shadertest/shader2")
	self:DrawModel()
	self:SetMaterial("models/spawn_effect2")
	self:SetModelScale(Vector(size + 0.02, size + 0.02, size * 2 + 0.02))
	self:SetColor(255, 255, 255, icea)
	self:DrawModel()
end

function ENT:Initialize()
	self.DieTime = CurTime() + 0.75
	self.Rotation = math.Rand(0, 360)
	--self:SetMaterial("models/shadertest/shader2")
	ExplosiveEffect(self:GetPos(), 48, 100, DMGTYPE_ICE)

	self:EmitSound("physics/glass/glass_largesheet_break"..math.random(1, 3)..".wav", 75, math.random(160, 180))
	self:EmitSound("physics/glass/glass_largesheet_break"..math.random(1, 3)..".wav", 75, math.random(160, 180))
	self:EmitSound("physics/glass/glass_largesheet_break"..math.random(1, 3)..".wav", 75, math.random(160, 180))

	local emitter = ParticleEmitter(self:GetPos())
	emitter:SetNearClip(40, 48)

	local ang = Angle(0,0,0)
	local up = Vector(0,0,1)
	local pos = self:GetPos()
	for i=1, 180 do
		ang:RotateAroundAxis(up, 2)
		local fwd = ang:Forward()
		local particle = emitter:Add("particle/snow", pos + fwd * 8)
		particle:SetVelocity(fwd * 64)
		particle:SetAirResistance(-64)
		particle:SetDieTime(2)
		particle:SetLifeTime(1)
		particle:SetStartAlpha(255)
		particle:SetEndAlpha(0)
		particle:SetStartSize(10)
		particle:SetEndSize(10)
		particle:SetRoll(math.Rand(0, 360))
		particle:SetRollDelta(math.Rand(-2, 2))

		local particle = emitter:Add("particle/snow", pos)
		particle:SetVelocity(fwd * 64 + Vector(0,0,32))
		particle:SetAirResistance(-128)
		particle:SetDieTime(2)
		particle:SetLifeTime(1)
		particle:SetStartAlpha(255)
		particle:SetEndAlpha(0)
		particle:SetStartSize(16)
		particle:SetEndSize(16)
		particle:SetRoll(math.Rand(0, 360))
		particle:SetRollDelta(math.Rand(-2, 2))
	end
end

function ENT:Think()
	--[[if not self.Played then
		self.Played = true
		self:EmitSound("physics/glass/glass_largesheet_break"..math.random(1, 3)..".wav", 75, math.random(160, 180))
		self:EmitSound("physics/glass/glass_largesheet_break"..math.random(1, 3)..".wav", 75, math.random(160, 180))
		self:EmitSound("physics/glass/glass_largesheet_break"..math.random(1, 3)..".wav", 75, math.random(160, 180))
	end]]
end

function ENT:OnRemove()
end
