AddCSLuaFile("cl_init.lua")
AddCSLuaFile("shared.lua")

include("shared.lua")

function ENT:Initialize()
	self:SetModel("models/weapons/w_missile_closed.mdl")
	self:PhysicsInitSphere(4)
	self:SetMoveType(MOVETYPE_VPHYSICS)
	self:SetSolid(SOLID_VPHYSICS)
	local phys = self:GetPhysicsObject()
	if phys:IsValid() then
		phys:EnableDrag(false)
		phys:EnableGravity(false)
		phys:Wake()
	end

	self.DeathTime = CurTime() + 30
	self.Target = self.Target or NULL
end

function ENT:Think()
	local ct = CurTime()

	if self.DeathTime < ct then
		self:Remove()
	elseif 0 < self:WaterLevel() then
		self:Explode()
	elseif self.PhysicsData then
		self:Explode(self.PhysicsData.HitPos, self.PhysicsData.HitNormal)
	elseif self.Target:IsValid() then
		self.DeathTime = ct + 30

		local target = self.Target
		local mypos = self:GetPos()
		local nearest = (target:NearestPoint(mypos) + target:GetPos() * 0.6) / 1.6
		local vHeading = (nearest - mypos):Normalize()
		local aOldHeading = self:GetVelocity():Angle()

		self:SetAngles(aOldHeading)
		local diffang = self:WorldToLocalAngles(vHeading:Angle())

		local ft = FrameTime() * math.max(2.75, math.min(6, 6 - nearest:Distance(mypos) * 0.975))
		aOldHeading:RotateAroundAxis(aOldHeading:Up(), diffang.yaw * ft)
		aOldHeading:RotateAroundAxis(aOldHeading:Right(), diffang.pitch * -ft)

		local vNewHeading = aOldHeading:Forward()
		self:GetPhysicsObject():SetVelocityInstantaneous(vNewHeading * 2800)

		if 1.4 < vNewHeading:Distance(vHeading) then
			self.Target = NULL
			if target.SendLua then
				target:SendLua("surface.PlaySound(\"buttons/button14.wav\")")
			else
				local enemydriver = target.PilotSeat:GetDriver()
				if enemydriver:IsValid() then
					enemydriver:SendLua("surface.PlaySound(\"buttons/button14.wav\")")
				end
			end
		else
			self:NextThink(ct)
			return true
		end
	end
end

function ENT:PhysicsCollide(data, physobj)
	if TRS(self, data.HitEntity, data.OurOldVelocity) then return end

	self.PhysicsData = data
	self:NextThink(CurTime())
end

function ENT:Explode(hitpos, hitnormal)
	if self.Exploded then return end
	self.Exploded = true
	self.DeathTime = -10

	local owner = self:GetOwner()
	if not owner:IsValid() then owner = self end
	hitpos = hitpos or self:GetPos()

	ExplosiveDamage(owner, self, hitpos, 200, 200, 1, 0.4, 8)

	local effectdata = EffectData()
		effectdata:SetOrigin(hitpos)
		effectdata:SetNormal(hitnormal or Vector(0,0,1))
	util.Effect("rovercannonexplosion", effectdata)
end
