AddCSLuaFile("cl_init.lua")
AddCSLuaFile("shared.lua")

include("shared.lua")

function ENT:Initialize()
	self:DrawShadow(false)
	self.DeathTime = CurTime() + 10
	self:PhysicsInitSphere(4)
	self:SetSolid(SOLID_VPHYSICS)
	local phys = self:GetPhysicsObject()
	if phys:IsValid() then
		phys:EnableMotion(true)
		phys:EnableDrag(false)
		phys:EnableGravity(false)
		phys:Wake()
	end

	self.CounterSpell = COUNTERSPELL_DESTROY
	self.Inversion = INVERSION_SETOWNER_REVERSE_TARGET_VELOCITY
	self.Target = NULL
end

function ENT:Think()
	if self.DeathTime <= CurTime() then
		self:Remove()
	elseif self.PhysicsData then
		self:Explode(self.PhysicsData.HitPos, self.PhysicsData.HitNormal)
	end
end

function ENT:PhysicsCollide(data, physobj)
	if TRS(self, data.HitEntity, data.OurOldVelocity) then return end

	self.PhysicsData = data
	self:NextThink(CurTime())
end

function ENT:Explode(hitpos, hitnormal)
	if self.Exploded then return end
	self.Exploded = true
	self.DeathTime = -10

	local owner = self:GetOwner()
	if not owner:IsValid() then owner = self end
	hitpos = hitpos or self:GetPos()

	local myteam = owner:GetTeamID()
	for ent, damagetaken in pairs(ExplosiveDamage(owner, self, hitpos, 50, 32, 0, 1, 32, DMGTYPE_SHOCK)) do
		if ent.KnockDown and (ent:GetTeamID() ~= myteam or ent == owner) then
			ent:SetGroundEntity(NULL)
			ent:SetLocalVelocity(400 * (ent:LocalToWorld(ent:OBBCenter()) - hitpos):Normalize() + Vector(0, 0, 300))
			ent:KnockDown()
		end
	end

	local effectdata = EffectData()
		effectdata:SetOrigin(hitpos)
		effectdata:SetNormal(hitnormal or Vector(0,0,1))
		effectdata:SetScale(2)
	util.Effect("sparklerexplode", effectdata)

	self:NextThink(CurTime())
end

function ENT:UpdateTransmitState()
	return TRANSMIT_PVS
end
