AddCSLuaFile("cl_init.lua")
AddCSLuaFile("shared.lua")

include("shared.lua")

function ENT:Initialize()
	self:DrawShadow(false)
	self:SetModel("models/Combine_Helicopter/helicopter_bomb01.mdl")
	self:PhysicsInit(SOLID_VPHYSICS)
	self:SetMoveType(MOVETYPE_VPHYSICS)
	self:SetSolid(SOLID_VPHYSICS)
	self:SetCollisionGroup(COLLISION_GROUP_WEAPON)
	local phys = self:GetPhysicsObject()
	if phys:IsValid() then
		phys:SetMass(100)
		phys:EnableDrag(false)
		phys:Wake()
	end

	self.DeathTime = CurTime() + 15
	self.SpawnTime = CurTime() + 0.6
end

function ENT:Think()
	if self.DeathTime <= CurTime() then
		self:Remove()
	elseif 0 < self:WaterLevel() then
		self:Explode()
	elseif self.PhysicsData then
		self:Explode(self.PhysicsData.HitPos, self.PhysicsData.HitNormal)
	end
end

function ENT:PhysicsCollide(data, physobj)
	if TRS(self, data.HitEntity, data.OurOldVelocity) then return end

	if self.SpawnTime <= CurTime() then
		self.PhysicsData = data
		self:NextThink(CurTime())
	end
end

function ENT:Explode(hitpos, hitnormal)
	if self.Exploded then return end
	self.Exploded = true
	self.DeathTime = -10

	local owner = self:GetOwner()
	if not owner:IsValid() then owner = self end
	hitpos = hitpos or self:GetPos()

	local myteam = owner:GetTeamID()
	for ent, damagetaken in pairs(ExplosiveDamage(owner, self, hitpos, 400, 400, 1, 0.75, 1)) do
		if ent.KnockDown and 25 <= damagetaken and (ent:GetTeamID() ~= myteam or ent == owner) then
			ent:SetGroundEntity(NULL)
			ent:SetLocalVelocity(damagetaken * 14 * (ent:GetPos() - hitpos):Normalize() + Vector(0,0,damagetaken * 8))
			ent:KnockDown()
		end
	end

	local effectdata = EffectData()
		effectdata:SetOrigin(hitpos or self:GetPos())
		effectdata:SetNormal(hitnormal or Vector(0,0,1))
	util.Effect("vbexplosion", effectdata)
end

function ENT:UpdateTransmitState()
	return TRANSMIT_PVS
end
