include("shared.lua")

util.PrecacheSound("ambient/machines/electric_machine.wav")

function ENT:Initialize()
	self.NextRequest = 0
	self.AmbientSound = CreateSound(self, "ambient/machines/electric_machine.wav")
	self.SoundPlaying = false
end

function ENT:Think()
	local r,g,b,a = self:GetColor()
	if a == 255 then
		self.AmbientSound:PlayEx(0.7, 100 + math.sin(CurTime()))
	end
end

function ENT:OnRemove()
	self.AmbientSound:Stop()
end

function ENT:Info(um)
	local str = um:ReadString()
	if str == "deny" then
		self.DeniedAccess = true
		return
	end

	local stuff = string.Explode(",", str)
	self.PHealth = tonumber(stuff[1])
	self.MaxPHealth = tonumber(stuff[2])
	--self.Powered = stuff[3] == "true"
end

ENT.MaxTraceHUDPaintLength = 256

function ENT:TraceHUDPaint()
	if self.PHealth then
		local toscreen = self:GetPos():ToScreen()
		local x, y = toscreen.x, toscreen.y
		draw.DrawTextShadow("Anti-Projectile Tower", "noxnetnormal", x, y, COLOR_CYAN, color_black, TEXT_ALIGN_CENTER)
		local _, hhh = surface.GetTextSize("A")
		y = y + hhh * 1.2
		surface.SetDrawColor(0, 0, 0, 255)
		surface.DrawRect(x - 100, y, 200, hhh)
		surface.SetDrawColor(255, 0, 0, 255)
		local health = self.PHealth
		local maxhealth = self.MaxPHealth
		surface.DrawRect(x - 100, y, (health / maxhealth) * 200, hhh)
		surface.SetDrawColor(255, 255, 255, 255)
		surface.DrawOutlinedRect(x - 100, y, 200, hhh)
		draw.SimpleTextShadow(health.." / "..maxhealth, "TargetIDSmall", x, y, COLOR_CYAN, COLOR_BLUE, TEXT_ALIGN_CENTER)
	end

	if not self.DeniedAccess and CurTime() > self.NextRequest then
		MySelf:ConCommand("reqinfo "..self:EntIndex())
		self.NextRequest = CurTime() + 0.75
	end
end

local matBolt = Material("Effects/laser1")
local matGlow = Material("sprites/glow04_noz")
function ENT:Draw()
	self:DrawModel()

	local r,g,b,a = self:GetColor()
	if a < 255 then return end

	render.SetMaterial(matBolt)

	local rt = RealTime()
	local orbpos = self:GetPos() + self:GetUp() * 100
	local right = self:GetRight()
	local leftpos = orbpos + right * -85
	local rightpos = orbpos + right * 85

	local BeamPos = {}
	local pos
	local dir = (rightpos - leftpos):Normalize()
	for i=1, math.ceil(leftpos:Distance(orbpos) / 20) do
		if pos then
			pos = pos + dir * 20 + VectorRand() * 5
		else
			pos = leftpos
		end
		BeamPos[#BeamPos + 1] = pos
	end

	local scroll = rt * 20
	--render.StartBeam(#BeamPos + 1)
	render.StartBeam(#BeamPos)
	for i, pos in ipairs(BeamPos) do
		render.AddBeam(pos, math.sin((rt + i * 0.2) * 5) * 48 + 92, scroll, color_white)
	end
	--render.AddBeam(orbpos, 100, scroll, COLOR_CYAN)
	render.EndBeam()

	local BeamPos = {}
	local pos
	dir = dir * -1
	for i=1, math.ceil(rightpos:Distance(orbpos) / 20) do
		if pos then
			pos = pos + dir * 20 + VectorRand() * 5
		else
			pos = rightpos
		end
		BeamPos[#BeamPos + 1] = pos
	end

	local scroll = rt * 20
	--render.StartBeam(#BeamPos + 1)
	render.StartBeam(#BeamPos)
	for i, pos in ipairs(BeamPos) do
		render.AddBeam(pos, math.sin((rt + i * 0.2) * 5) * 48 + 92, scroll, color_white)
	end
	--render.AddBeam(orbpos, 100, scroll, COLOR_CYAN)
	render.EndBeam()

	render.SetMaterial(matGlow)
	local spritesize = 180 + math.cos(rt * 10) * 48
	render.DrawSprite(orbpos, spritesize, spritesize, color_white)
	render.DrawSprite(orbpos, 128, 128, COLOR_CYAN)
end
