AddCSLuaFile("cl_init.lua")
AddCSLuaFile("shared.lua")

include("shared.lua")

function ENT:Initialize()
	self:PhysicsInit(SOLID_VPHYSICS)
	self:SetMoveType(MOVETYPE_VPHYSICS)
	self:SetSolid(SOLID_VPHYSICS)
	self:SetUseType(SIMPLE_USE)
	local phys = self:GetPhysicsObject()
	if phys:IsValid() then phys:EnableMotion(false) end
	--self:Fire("evaluate", "", 0.1)

	local effect2 = ents.Create("point_tesla")
	if effect2:IsValid() then
		effect2:SetKeyValue("m_flRadius", "150")
		effect2:SetKeyValue("m_SoundName", "DoSpark")
		effect2:SetKeyValue("m_Color", "220 220 255")
		effect2:SetKeyValue("texture", "effects/laser1.vmt")
		effect2:SetKeyValue("beamcount_min", "6")
		effect2:SetKeyValue("beamcount_max", "9")
		effect2:SetKeyValue("thick_min", "15")
		effect2:SetKeyValue("thick_max", "35")
		effect2:SetKeyValue("lifetime_min", "0.5")
		effect2:SetKeyValue("lifetime_max", "1")
		effect2:SetKeyValue("interval_min", "0.1")
		effect2:SetKeyValue("interval_max", "0.25")
		effect2:SetPos(self:GetPos() + self:GetUp() * 100)
		effect2:Spawn()
		effect2:SetParent(self)
		self.Tesla = effect2
	end
end

function ENT:Info(pl)
	if pl:Team() == self:GetTeamID() then
		return self.PHealth..","..self.MaxPHealth--..","..tostring(self.Powered)
	end

	return "deny"
end

ENT.DestructionEffect = PROPGENERICDESTRUCTIONEFFECT2
ENT.MoneyBonus = 30
ENT.OffenseBonus = 3
ENT.FragsBonus = 3
ENT.ProcessDamage = PROPGENERICPROCESSDAMAGE
ENT.OverrideTakeDamage = PROPGENERICOVERRIDETAKEDAMAGE
ENT.ProcessSpecialDamage = PROPGENERICPROCESSSPECIALDAMAGE

local function Invert(self, ent, phys, vel)
	if self:IsValid() and ent:IsValid() and phys:IsValid() then
		phys:SetVelocityInstantaneous(vel)
		if ent.Heading then
			ent.Heading = vel:Normalize()
		end
		local teamid = self:GetTeamID()
		ent:SetTeamID(teamid)
		if ent.Target and ent.Target:IsValid() then
			if ent.Target:IsValid() then
				ent.Target = ent:GetOwner()
			end
		end

		local ownersteam = self.Owner
		local attacker = self
		for _, pl in pairs(player.GetAll()) do
			if pl:SteamID() == ownersteam and pl:Team() == teamid then
				attacker = pl
			end
		end
		ent:SetOwner(attacker)
		if ent.Attacker then
			ent.Attacker = attacker
		end
	end
end

function ENT:Think()
	if not self.Destroyed then
		local pos = self:GetPos() + self:GetUp() * 100
		local attacked
		local myteam = self:GetTeamID()
		for _, ent in pairs(ents.FindInSphere(pos, 768)) do
			if string.sub(ent:GetClass(), 1, 11) == "projectile_" and ent:GetClass() ~= "projectile_protrusionspike" and ent.LastReflectiveShield ~= self and ent:GetTeamID() ~= myteam and ent:GetMoveType() == MOVETYPE_VPHYSICS then
				local vel = ent:GetVelocity()
				local entpos = ent:GetPos()
				local dir = (pos - entpos):Normalize()

				if TrueVisible(entpos, pos) and vel:GetNormalized():Distance(dir) <= 1.4 and GAMEMODE:DrainPower(self, ent.APTowerMana or 10) then
					attacked = true
					ent.LastReflectiveShield = self

					local effectdata = EffectData()
						effectdata:SetOrigin(entpos)
						effectdata:SetStart(pos)
					util.Effect("aptowerbeam", effectdata)

					timer.Simple(0, Invert, self, ent, ent:GetPhysicsObject(), dir * -vel:Length())
				end
			end
		end

		if attacked then
			self.Tesla:Fire("DoSpark", "", 0)
			self.Tesla:Fire("DoSpark", "", 0.15)
		end
	end

	self:NextThink(CurTime() + 0.3)
	return true
end
