AddCSLuaFile("cl_init.lua")
AddCSLuaFile("shared.lua")

include("shared.lua")

function ENT:Initialize()
	self:PhysicsInit(SOLID_VPHYSICS)
	self:SetMoveType(MOVETYPE_VPHYSICS)
	self:SetSolid(SOLID_VPHYSICS)
	self:SetUseType(SIMPLE_USE)
	self:SetTrigger(true)

	local phys = self:GetPhysicsObject()
	if phys:IsValid() then
		phys:EnableMotion(false)
	end
end

function ENT:RemoveThink()
	self:Remove()
end

function ENT:DoExplode()
	if self.Exploded then return end
	self.Exploded = true
	self.Removing = true
	self.Think = self.RemoveThink

	self:EmitSound("nox/explosion02.wav", 88, 100)

	local effectdata = EffectData()
		effectdata:SetRadius(1)
		effectdata:SetMagnitude(1)
		effectdata:SetScale(1)
		effectdata:SetOrigin(self:GetPos() + Vector(0, 0, 16))
	util.Effect("HelicopterMegaBomb", effectdata, true, true)

	local teamid = self:GetTeamID()
	if team.TeamInfo[teamid] then
		team.AddProps(teamid, -1)
	end

	local ownersteam = self.Owner
	local attacker = self
	for _, pl in pairs(player.GetAll()) do
		if pl:SteamID() == ownersteam and pl:Team() == teamid then
			attacker = pl
		end
	end

	local myteam = self:GetTeamID()
	for ent, damage in pairs(ExplosiveDamage(attacker, self, mypos, 100, 100, 1, 0.1, 40)) do
		if ent:IsValid() and ent.KnockDown and (ent:GetTeamID() ~= myteam or ent == attacker) then
			ent:SetGroundEntity(NULL)
			ent:SetLocalVelocity((ent:GetPos() - mypos):Normalize() * 600 + Vector(0, 0, 450))
			if 1 <= ent:Health() then
				ent:KnockDown()
			end
		end
	end
end

function ENT:StartTouch(ent)
	if ent:IsPlayer() and ent:Team() ~= self:GetTeamID() and not self.Destroyed and GAMESTATE == GAMESTATE_PLAY then
		self.ArmedBy = ent
		self:EmitSound("HL1/fvox/activated.wav")
	end
end

function ENT:Touch(ent)
end

function ENT:EndTouch(ent)
	if self.ArmedBy and ent == self.ArmedBy then
		self:DoExplode()
	end
end

function ENT:DestructionEffect()
	if self.Destroyed then
		local effectdata = EffectData()
			effectdata:SetRadius(1)
			effectdata:SetMagnitude(1)
			effectdata:SetScale(1)
			effectdata:SetOrigin(self:GetPos())
		util.Effect("Explosion", effectdata, true, true)
	else
		self:DoExplode()
	end
end

function ENT:Info(pl)
	if pl:Team() == self:GetTeamID() then
		return self.PHealth..","..self.MaxPHealth
	end

	return "deny"
end

ENT.MoneyBonus = 0
ENT.ProcessDamage = PROPGENERICPROCESSDAMAGE
ENT.OverrideTakeDamage = PROPGENERICOVERRIDETAKEDAMAGE
function ENT:ProcessSpecialDamage(damage, dmgtype, attacker, inflictor)
	return 100, dmgtype, attacker, inflictor
end
