AddCSLuaFile("cl_init.lua")
AddCSLuaFile("shared.lua")

include("shared.lua")

function ENT:Initialize()
	self:PhysicsInit(SOLID_VPHYSICS)
	self:SetMoveType(MOVETYPE_VPHYSICS)
	self:SetSolid(SOLID_VPHYSICS)
	local phys = self:GetPhysicsObject()
	if phys:IsValid() then phys:EnableMotion(false) end

	self.NextEvaluate = 0
	self.Powering = false
	self.LastObelisk = NULL
	self.LastSkin = 0
end

function ENT:Think()
	if self.Destroyed then return end
	if self.NextEvaluate <= CurTime() then
		self.NextEvaluate = CurTime() + 2

		local startpos = self:GetPos() + self:GetUp() * 34

		local tr = util.TraceLine({start = startpos, endpos = startpos + self:GetForward() * -48, filter = self})
		local ent = tr.Entity
		local extracting
		if ent:IsValid() and ent:GetClass() == "obelisk" then
			local lastobelisk = self.LastObelisk
			if lastobelisk == ent then
				extracting = true
			else
				if lastobelisk:IsValid() then
					lastobelisk.Sappers = lastobelisk.Sappers - 1
				end
				if ent.Sappers < 1 then
					self.LastObelisk = ent
					ent.Sappers = ent.Sappers + 1
					extracting = true
				else
					self.LastObelisk = NULL
					extracting = false
				end
			end
		end

		--[[local tr = util.TraceLine({start = startpos, endpos = startpos + self:GetForward() * 42, filter = self})
		local ent = tr.Entity
		if ent:IsValid() and ent.ManaStorage and not ent.Destroyed then
			if extracting then
				local newmana = math.min(ent.MaxManaStorage, ent.ManaStorage + 7)
				if newmana ~= ent.ManaStorage then
					ent.ManaStorage = newmana
					ent:SetSkin(newmana)
				end
			end
			self.Powering = true
		else
			self.Powering = false
		end]]

		local myteam = self:GetTeamID()
		local ent = util.TraceLine({start = startpos, endpos = startpos + self:GetForward() * 32000, filter = self}).Entity
		if ent:IsValid() and ent.ManaStorage and ent:GetTeamID() == myteam and not ent.Destroyed then
			self.Powering = true
			if extracting and ent.ManaStorage < ent.MaxManaStorage then
				self:EmitSound("weapons/physcannon/energy_sing_flyby1.wav", 70, 70)
				local proj = ents.Create("projectile_manatranslocator")
				if proj:IsValid() then
					proj:SetPos(startpos)
					proj:SetTeamID(myteam)
					local col = team.GetColor(myteam)
					proj:SetColor(col.r, col.g, col.b, 255)
					proj:Spawn()
					proj.ManaAmount = 14
					local phys = proj:GetPhysicsObject()
					if phys:IsValid() then
						phys:SetVelocityInstantaneous(self:GetForward() * 2800)
					end
				end
			end
		else
			self.Powering = false
		end

		if extracting and self.LastSkin == 0 then
			self.LastSkin = 1
			self:SetSkin(1)
		elseif not extracting and self.LastSkin == 1 then
			self:SetSkin(0)
			self.LastSkin = 0
		end
	end
end

function ENT:OnRemove()
	local lastobelisk = self.LastObelisk
	if lastobelisk:IsValid() then
		lastobelisk.Sappers = lastobelisk.Sappers - 1
	end
end

function ENT:Info(pl)
	if pl:Team() == self:GetTeamID() then
		return self.PHealth..","..self.MaxPHealth..","..tostring(self.Powering)
	end

	return "deny"
end

ENT.DestructionEffect = PROPGENERICDESTRUCTIONEFFECT
ENT.MoneyBonus = 20
ENT.OffenseBonus = 2
ENT.FragsBonus = 2
ENT.ProcessDamage = PROPGENERICPROCESSDAMAGE
ENT.OverrideTakeDamage = PROPGENERICOVERRIDETAKEDAMAGE
ENT.ProcessSpecialDamage = PROPGENERICPROCESSSPECIALDAMAGE

local obpos
local function sortbydist(a, b)
	return obpos:Distance(a) < obpos:Distance(b)
end

function ENT:AcceptInput(name, activator, caller, args)
	if name == "precreated" then
		local ob = self.BasedOn
		if ob and ob:IsValid() and ob:GetClass() == "obelisk" then
			local myteam = self:GetTeamID()
			obpos = ob:GetPos()

			local up = ob:GetUp()
			local dir = ob:GetAngles()

			local tab = {mask = MASK_SOLID, start = obpos + up * 34, filter = {ob, self}}

			for i=1, 359 do
				local fwd = dir:Forward()

				tab.endpos = tab.start + fwd * 10240

				local hitent = util.TraceLine(tab).Entity
				if hitent.CanTakeMana and hitent:IsValid() and not hitent.Destroyed and hitent:GetTeamID() == myteam and hitent:NearestPoint(obpos):Distance(obpos) > 48 then
					self:SetPos(obpos + fwd * 32)
					self:SetAngles(dir)
					break
				end

				dir:RotateAroundAxis(up, 1)
			end

			--[[local capacitors = {}
			for _, ent in pairs(ents.GetAll()) do
				if ent:IsValid() and ent.CanTakeMana and not ent.Destroyed and ent:GetTeamID() == myteam then
					capacitors[#capacitors + 1] = ent
				end
			end

			if 0 == #capacitors then return true end

			if 1 < #capacitors then
				table.sort(capacitors, sortbydist)
			end

			local filt = player.GetAll()
			filt[#filt + 1] = self
			filt[#filt + 1] = ob

			for i, ent in ipairs(capacitors) do
				filt[#filt + 1] = ent

				local entpos = ent:GetPos()
				local nearest = ent:NearestPoint(obpos)
				local obnearest = ob:NearestPoint(nearest)
				if 48 < nearest:Distance(obnearest) and MeleeVisible(nearest, obnearest, filt) then
					local newpos = obnearest + (nearest - obnearest):Normalize() * 16

					if MeleeVisible(newpos, nearest, filt) then
						self:SetPos(newpos)
						self:SetAngles(dir:Angle())
						break
					end
				end

				filt[#filt] = nil
			end]]
		end

		return true
	end
end
