include("shared.lua")

function ENT:Draw()
	self:DrawModel()

	--[[if EYETRACE_ENTITY == self and self.PHealth then
		self:DrawBasicPropInfo(nil, nil, self.PropName, COLOR_CYAN, "Health", self.PHealth, self.MaxPHealth, COLOR_RED)
	end]]
end

function ENT:Initialize()
	self.NextRequest = 0
	self.PropName = "Prop"
	local mdl = string.lower(self:GetModel())
	for _, typ in pairs(PROPTYPES) do
		if string.lower(typ.Model) == mdl then
			self.PropName = typ.Name
		end
	end
end

function ENT:Info(um)
	local str = um:ReadString()
	if str == "deny" then
		self.DeniedAccess = true
		return
	end

	local stuff = string.Explode(",", str)
	self.PHealth = tonumber(stuff[1])
	self.MaxPHealth = tonumber(stuff[2])
end

ENT.MaxTraceHUDPaintLength = 256

function ENT:TraceHUDPaint()
	local toscreen = self:GetPos():ToScreen()
	local x, y = toscreen.x, toscreen.y
	surface.SetFont("noxnetnormal")
	local _, hhh = surface.GetTextSize("A")
	if self.PHealth and 0 < self.MaxPHealth then
		draw.DrawTextShadow(self.PropName or "Prop", "noxnetnormal", x, y, COLOR_CYAN, color_black, TEXT_ALIGN_CENTER)
		y = y + hhh * 1.2
		surface.SetDrawColor(0, 0, 0, 255)
		surface.DrawRect(x - 100, y, 200, hhh)
		surface.SetDrawColor(255, 0, 0, 255)
		local health = self.PHealth
		local maxhealth = self.MaxPHealth
		surface.DrawRect(x - 100, y, (health / maxhealth) * 200, hhh)
		surface.SetDrawColor(255, 255, 255, 255)
		surface.DrawOutlinedRect(x - 100, y, 200, hhh)
		if 50000 < health then
			draw.SimpleTextShadow("Indestructable", "TargetIDSmall", x, y, COLOR_CYAN, COLOR_BLUE, TEXT_ALIGN_CENTER)
		else
			draw.SimpleTextShadow(health.." / "..maxhealth, "TargetIDSmall", x, y, COLOR_CYAN, COLOR_BLUE, TEXT_ALIGN_CENTER)
		end
	end

	if self.FirstCaptureAttempt and 0 < self.FirstCaptureAttempt then
		local amount = math.Clamp((self.CaptureAmount - 8 * (CurTime() - self.FirstCaptureAttempt)) / self.MaxPHealth, 0, 1)
		if 0 < amount then
			y = y + hhh
			surface.SetDrawColor(0, 255, 0, 255)
			surface.DrawRect(x - 100, y, amount * 200, hhh * 0.75)
			surface.SetDrawColor(255, 255, 255, 255)
			surface.DrawOutlinedRect(x - 100, y, 200, hhh * 0.75)
		end
	end

	if not self.DeniedAccess and CurTime() > self.NextRequest then
		MySelf:ConCommand("reqinfo "..self:EntIndex())
		self.NextRequest = CurTime() + 0.75
	end
end
