include("shared.lua")

ENT.MaxTraceHUDPaintLength = 256

function ENT:TraceHUDPaint()
	if self.PHealth then
		local toscreen = self:GetPos():ToScreen()
		local x, y = toscreen.x, toscreen.y
		draw.DrawTextShadow("Small Mana Capacitor", "noxnetnormal", x, y, COLOR_CYAN, color_black, TEXT_ALIGN_CENTER)
		local _, hhh = surface.GetTextSize("A")
		y = y + hhh * 1.2
		local boxy = y
		surface.SetDrawColor(0, 0, 0, 255)
		surface.DrawRect(x - 100, y, 200, hhh * 1.75)
		surface.SetDrawColor(255, 0, 0, 255)
		local health = self.PHealth
		local maxhealth = self.MaxPHealth
		surface.DrawRect(x - 100, y, (health / maxhealth) * 200, hhh)
		surface.SetDrawColor(255, 255, 255, 255)
		surface.DrawOutlinedRect(x - 100, y, 200, hhh)
		draw.SimpleTextShadow(health.." / "..maxhealth, "TargetIDSmall", x, y, COLOR_CYAN, COLOR_BLUE, TEXT_ALIGN_CENTER)

		y = y + hhh

		local mana = self:GetSkin()
		local maxmana = self.MaxManaStorage
		surface.SetDrawColor(30, 30, 255, 255)
		surface.DrawRect(x - 100, y, (mana / maxmana) * 200, hhh * 0.75)
		draw.DrawText(mana.." / "..maxmana, "Default", x, y, color_white, TEXT_ALIGN_CENTER)
		surface.SetDrawColor(255, 255, 255, 255)
		surface.DrawOutlinedRect(x - 100, boxy, 200, hhh * 1.75)
		surface.DrawLine(x - 100, boxy + hhh, x + 100, boxy + hhh)

		y = y + hhh

		if self:GetSkin() == 0 then
			draw.SimpleTextShadow("(NO MANA)", "TargetIDSmall", x, y, COLOR_RED, color_black, TEXT_ALIGN_CENTER)
		elseif self:GetSkin() <= 25 then
			draw.SimpleTextShadow("(LOW MANA)", "TargetIDSmall", x, y, COLOR_RED, color_black, TEXT_ALIGN_CENTER)
		end
	end

	if not self.DeniedAccess and CurTime() > self.NextRequest then
		MySelf:ConCommand("reqinfo "..self:EntIndex())
		self.NextRequest = CurTime() + 0.75
	end
end

local matGlow = Material("sprites/light_glow02_add")
local matRing = Material("effects/select_ring")
local colDumby = Color(255, 255, 255, 255)
function ENT:Draw()
	self:DrawModel()

	local ct = CurTime() + self.Seed
	local pos = self:GetPos()
	local up = self:GetUp()

	local r,g,b,a = self:GetColor()
	if a == 255 then
		render.SetMaterial(matGlow)
		if self:GetSkin() == 0 then
			local size = math.sin(ct * 16) * 32 + 64
			render.DrawSprite(pos + up * 48, size, size, COLOR_RED)
		elseif self:GetSkin() <= 50 then
			local size = math.sin(ct * 16) * 32 + 64
			render.DrawSprite(pos + up * 48, size, size, COLOR_YELLOW)
		else
			local size = math.sin(ct * 4) * 8 + 64
			render.DrawSprite(pos + up * 48, size, size, COLOR_CYAN)
		end
	end

	--if EYETRACE_ENTITY == self then
		local siz = math.cos(ct * 3.5)
		if 0 < siz then
			local radius = math.max(siz * CAPACITOR_RANGE * 2.4, self.LastSize)
			self.LastSize = radius

			colDumby.r = r
			colDumby.g = g
			colDumby.b = b
			colDumby.a = siz * 255

			render.SetMaterial(matRing)
			pos = pos + up * 2
			render.DrawQuadEasy(pos, up, radius, radius, colDumby, siz)
			render.DrawQuadEasy(pos, up * -1, radius, radius, colDumby, siz)
		elseif 0 < self.LastSize then
			self.LastSize = 0
		end
	--end
end
