AddCSLuaFile("cl_init.lua")
AddCSLuaFile("shared.lua")

include("shared.lua")

function ENT:Initialize()
	self:PhysicsInit(SOLID_VPHYSICS)
	self:SetMoveType(MOVETYPE_VPHYSICS)
	self:SetSolid(SOLID_VPHYSICS)
	self:SetUseType(SIMPLE_USE)
	local phys = self:GetPhysicsObject()
	if phys:IsValid() then phys:EnableMotion(false) end

	self.AmmoType = self.AmmoType or "NONE"
	self:Fire("attack", "", 0.015)
	self.AntiPulseSpam = 0
end

function ENT:Attach(turretconnecting, activator)
	if self.AmmoType == turretconnecting.AmmoType then
		if activator then
			activator:PrintMessage(HUD_PRINTCENTER, "Turret already loaded with that type of barrel.")
			activator:SendLua([[surface.PlaySound("buttons/button16.wav")]])
		end
		return
	end

	if 200 < turretconnecting:GetPos():Distance(self:GetPos()) then
		if activator then
			activator:PrintMessage(HUD_PRINTCENTER, "Barrel is too far from the turret to load.")
			activator:SendLua([[surface.PlaySound("buttons/button16.wav")]])
		end
		return
	end

	if self.Barrel and self.Barrel:IsValid() then
		self.Barrel:Remove()
		self.Barrel = nil
	end

	local ent = ents.Create("turretbarrel")
	if ent:IsValid() then
		self.AmmoType = turretconnecting.AmmoType
		ent:SetModel(turretconnecting:GetTurretModel(self))
		ent:SetPos(self:GetPos() + self:GetUp() * 55)
		ent:SetOwner(self)
		ent:SetParent(self)
		local col = team.GetColor(self:GetTeamID())
		ent:SetColor(col.r, col.g, col.b, 255)
		ent:SetSkin(turretconnecting.SkinType)
		ent:Spawn()
		self.Barrel = ent
		turretconnecting:BarrelChanged(self, ent)
		if activator then
			activator:PrintMessage(HUD_PRINTCENTER, "Turret barrel changed!")
			activator.TurretConnecting = nil
		end

		turretconnecting.NoValue = true
		GAMEMODE:RemoveProp(NULL, turretconnecting)
	elseif activator then
		activator:PrintMessage(HUD_PRINTCENTER, "Failed to attach barrel (engine error).")
	end
end

function ENT:Use(activator, caller)
	if self.Destroyed then return end
	if not activator:IsPlayer() then return end

	if activator:Team() == self:GetTeamID() then
		local turretconnecting = activator.TurretConnecting
		if turretconnecting and turretconnecting:IsValid() then
			self:Attach(turretconnecting, activator)
		end
	end
end

function ENT:Attack_Slow()
	self:Fire("attack", "", 2)

	if not self.Destroyed and GAMESTATE == GAMESTATE_PLAY then
		local mypos = self:GetPos() + self:GetUp() * 64

		local myteam = self:GetTeamID()
		for _, ent in pairs(ents.FindInCone(mypos, self:GetForward(), 800, 20)) do
			if ent:IsPlayer() and ent:Alive() and ent:Team() ~= myteam and TrueVisible2(ent:NearestPoint(mypos), mypos, ent) and 30 <= ent:GetVisibility() and not ent:InVehicle() then
				if GAMEMODE:DrainPower(self, 20) then
					local proj = ents.Create("projectile_slow")
					if proj:IsValid() then
						proj:SetPos(mypos)
						proj:SetTeamID(myteam)
						proj:Spawn()
						for _, pl in pairs(player.GetAll()) do
							if pl:SteamID() == self.Owner and pl:Team() == myteam then
								proj:SetOwner(pl)
								break
							end
						end
						local phys = proj:GetPhysicsObject()
						if phys:IsValid() then
							phys:SetVelocityInstantaneous(ent:GetVelocity() * 0.875 + (ent:LocalToWorld(ent:OBBCenter()) - mypos):Normalize() * 900)
						end
					end
				else
					self:EmitSound("npc/turret_floor/die.wav")
				end

				umsg.Start("recturrettarget")
					umsg.Entity(ent)
					umsg.Short(self:EntIndex())
				umsg.End()

				break
			end
		end
	end
end

function ENT:Attack_Plasma()
	self:Fire("attack", "", 1.5)

	if not self.Destroyed and GAMESTATE == GAMESTATE_PLAY then
		local mypos = self:GetPos() + self:GetUp() * 64

		local myteam = self:GetTeamID()
		for _, ent in pairs(ents.FindInCone(mypos, self:GetForward(), 800, 20)) do
			if ent:IsPlayer() and ent:Alive() and ent:GetTeamID() ~= myteam and TrueVisible(ent:NearestPoint(mypos), mypos) and (not ent.Invisible or 180 < ent:GetVelocity():Length()) then
				if GAMEMODE:DrainPower(self, 20) then
					local proj = ents.Create("projectile_plasmabolt")
					if proj:IsValid() then
						proj:SetPos(mypos)
						local col = team.GetColor(self:GetTeamID())
						proj:SetColor(col.r,col.g,col.b,127)
						proj:Spawn()
						proj:SetTeamID(myteam)
						for _, pl in pairs(player.GetAll()) do
							if pl:SteamID() == self.Owner and pl:Team() == myteam then
								proj:SetOwner(pl)
								break
							end
						end
						local phys = proj:GetPhysicsObject()
						if phys:IsValid() then
							if ent:InVehicle() then
								phys:ApplyForceCenter(ent:GetVehicle():GetVelocity() * 4.15 + (ent:GetPos() + Vector(0,0,-16) - mypos):Normalize() * 4000)
							else
								phys:ApplyForceCenter(ent:GetVelocity() * 4.15 + (ent:GetPos() + Vector(0,0,-16) - mypos):Normalize() * 4000)
							end
						end
					end
				else
					self:EmitSound("npc/turret_floor/die.wav")
				end

				umsg.Start("recturrettarget")
					umsg.Entity(ent)
					umsg.Short(self:EntIndex())
				umsg.End()

				break
			end
		end
	end
end

function ENT:Attack_Antivehicle()
	self:Fire("attack", "", 2.5)

	if not self.Destroyed and GAMESTATE == GAMESTATE_PLAY then
		local mypos = self:GetPos() + self:GetUp() * 64
		local searchpos = mypos + self:GetForward() * 2000 + self:GetUp() * 1500

		local myteam = self:GetTeamID()
		for _, ent in pairs(ents.FindInCone(mypos, self:GetForward(), 4096, 30)) do
			if ent.ScriptVehicle and ent:GetTeamID() ~= myteam and TrueVisible(ent:NearestPoint(mypos), mypos) and ent:GetPos():Distance(searchpos) < 2000 then
				if GAMEMODE:DrainPower(self, 20) then
					self:EmitSound("weapons/stinger_fire1.wav")
					local proj = ents.Create("projectile_antivehiclemissile")
					if proj:IsValid() then
						proj:SetPos(mypos)
						proj:SetTeamID(myteam)
						proj:Spawn()
						proj.Target = ent
						for _, pl in pairs(player.GetAll()) do
							if pl:SteamID() == self.Owner and pl:Team() == myteam then
								proj:SetOwner(pl)
								break
							end
						end
						local phys = proj:GetPhysicsObject()
						if phys:IsValid() then
							phys:SetVelocityInstantaneous((ent:GetPos() - mypos):Normalize() * 1300)
						end
					end
				else
					self:EmitSound("npc/turret_floor/die.wav")
				end

				umsg.Start("recturrettarget")
					umsg.Entity(ent)
					umsg.Short(self:EntIndex())
				umsg.End()

				break
			end
		end
	end
end

util.PrecacheSound("nox/missilesofmagic.wav")
util.PrecacheSound("npc/turret_floor/die.wav")
ENT["Attack_Magic Missiles"] = function(self)
	self:Fire("attack", "", 1.5)

	if not self.Destroyed and GAMESTATE == GAMESTATE_PLAY then
		local mypos = self:GetPos() + self:GetUp() * 64

		local myteam = self:GetTeamID()
		for _, ent in pairs(ents.FindInCone(mypos, self:GetForward(), 600, 20)) do
			if ent:IsPlayer() and ent:Alive() and ent:GetTeamID() ~= myteam and TrueVisible(ent:NearestPoint(mypos), mypos) and (not ent.Invisible or 180 < ent:GetVelocity():Length()) then
				if GAMEMODE:DrainPower(self, 20) then
					self:EmitSound("nox/missilesofmagic.wav")

					for i=1, 2 do
						local proj = ents.Create("projectile_magicmissile")
						if proj:IsValid() then
							proj:SetPos(mypos)
							proj.DontCount = true
							proj:Spawn()
							proj:SetTeamID(myteam)
							for _, pl in pairs(player.GetAll()) do
								if pl:SteamID() == self.Owner and pl:Team() == myteam then
									proj:SetOwner(pl)
									break
								end
							end
							local phys = proj:GetPhysicsObject()
							if phys:IsValid() then
								phys:ApplyForceCenter((ent:GetPos() + Vector(math.Rand(-180, 180), math.Rand(-180, 180), 0) - mypos):Normalize() * 500)
							end
						end
					end
				else
					self:EmitSound("npc/turret_floor/die.wav")
				end

				umsg.Start("recturrettarget")
					umsg.Entity(ent)
					umsg.Short(self:EntIndex())
				umsg.End()

				break
			end
		end
	end
end

ENT["Attack_Pulse Cannon"] = function(self)
	if not self.Destroyed and GAMESTATE == GAMESTATE_PLAY then
		local mypos = self:GetPos() + self:GetUp() * 64 + self:GetForward() * 4

		local myteam = self:GetTeamID()
		for _, ent in pairs(ents.FindInCone(mypos, self:GetForward(), 1300, 20)) do
			if ent:IsPlayer() and ent:Alive() and ent:GetTeamID() ~= myteam and TrueVisible(ent:NearestPoint(mypos), mypos) and (not ent.Invisible or 180 < ent:GetVelocity():Length()) then
				if GAMEMODE:DrainPower(self, 1) then
					self:Fire("attack", "", 0.15)
					self:EmitSound("Weapon_AR2.Single")

					local proj = ents.Create("projectile_pulsecannon")
					if proj:IsValid() then
						proj:SetPos(mypos)
						proj.DontCount = true
						local r,g,b,a = self:GetColor()
						proj:SetColor(r,g,b,255)
						proj:Spawn()
						proj:SetTeamID(myteam)
						for _, pl in pairs(player.GetAll()) do
							if pl:SteamID() == self.Owner and pl:Team() == myteam then
								proj:SetOwner(pl)
								break
							end
						end
						local phys = proj:GetPhysicsObject()
						if phys:IsValid() then
							local dir
							if ent:InVehicle() then
								dir = (ent:LocalToWorld(ent:OBBCenter()) + ent:GetVehicle():GetVelocity() * 0.35 - mypos):Normalize()
							else
								dir = (ent:LocalToWorld(ent:OBBCenter()) + ent:GetVelocity() * 0.35 - mypos):Normalize()
							end
							dir:Rotate(Angle(math.Rand(-2, 2), math.Rand(-2, 2), 0))
							phys:SetVelocityInstantaneous(dir * 1100)
						end
					end
				else
					self:Fire("attack", "", 0.5)
					self:EmitSound("npc/turret_floor/die.wav")
				end

				if self.AntiPulseSpam <= CurTime() then
					self.AntiPulseSpam = CurTime() + 0.4
					umsg.Start("recturrettarget")
						umsg.Entity(ent)
						umsg.Short(self:EntIndex())
					umsg.End()
				end

				return
			end
		end
		self:Fire("attack", "", 0.5)
	end
end

function ENT:Attack_NONE()
	self:Fire("attack", "", 1)
end

function ENT:AcceptInput(name, activator, caller)
	if name == "attack" then
		self["Attack_"..self.AmmoType](self)

		return true
	end
end

function ENT:Info(pl)
	if pl:Team() == self:GetTeamID() then
		return self.PHealth..","..self.MaxPHealth..","..tostring(self.AmmoType)
	end

	return "deny"
end

ENT.DestructionEffect = PROPGENERICDESTRUCTIONEFFECT
ENT.MoneyBonus = 20
ENT.OffenseBonus = 2
ENT.FragsBonus = 2
ENT.ProcessDamage = PROPGENERICPROCESSDAMAGE
ENT.OverrideTakeDamage = PROPGENERICOVERRIDETAKEDAMAGE
ENT.ProcessSpecialDamage = PROPGENERICPROCESSSPECIALDAMAGE
