include("shared.lua")

function ENT:Initialize()
	self:DrawShadow(false)
	self:SetRenderBounds(Vector(-128, -128, -128), Vector(128, 128, 128))

	self.Emitter = ParticleEmitter(self:GetPos())
	self.Emitter:SetNearClip(14, 24)

	self:GetOwner().DashDodging = self
	self:GetOwner().DashDodgingLeft = self

	self:EmitSound("npc/advisor/advisor_blast6.wav", 70, 210)

	self.DieTime = CurTime() + 0.2

	--self.NextGhost = 0
end

function ENT:OnRemove()
	local owner = self:GetOwner()
	if owner:IsValid() then
		owner.DashDodging = nil
		owner.DashDodgingLeft = nil
	end

	self.Emitter:Finish()
end

function ENT:Think()
	local owner = self:GetOwner()
	if owner:IsValid() then self:SetPos(owner:EyePos()) end
	self.Emitter:SetPos(self:GetPos())
end

function ENT:Draw()
	local owner = self:GetOwner()
	if not owner:IsValid() then return end

	--[[if self.NextGhost <= CurTime() then
		self.NextGhost = CurTime() + 0.04

		local effectdata = EffectData()
			effectdata:SetOrigin(owner:GetPos())
			effectdata:SetEntity(owner)
		util.Effect("dodgeghost", effectdata)
	end]]

	local aa, bb = owner:WorldSpaceAABB()

	for i=1, 3 do
		--local particle = self.Emitter:Add("effects/fire_cloud1", Vector(math.Rand(aa.x, bb.x), math.Rand(aa.y, bb.y), math.Rand(aa.z, bb.z)))
		local particle = self.Emitter:Add("sprites/heatwave", Vector(math.Rand(aa.x, bb.x), math.Rand(aa.y, bb.y), math.Rand(aa.z, bb.z)))
		particle:SetDieTime(math.Rand(0.3, 0.4))
		particle:SetStartAlpha(255)
		particle:SetEndAlpha(255)
		--particle:SetStartSize(math.Rand(4, 8))
		particle:SetStartSize(math.Rand(14, 28))
		particle:SetEndSize(0)
		particle:SetRoll(math.Rand(0, 360))
		particle:SetRollDelta(math.Rand(40, 120))
	end
end
