include("shared.lua")

function ENT:Initialize()
	self:DrawShadow(false)
	self:SetRenderBounds(Vector(-128, -128, -128), Vector(128, 128, 128))

	self:GetOwner().EnergyBolt = self

	self:EmitSound("nox/energyboltstart.wav", 72, math.Rand(95, 105))

	self.AmbientSound = CreateSound(self, "ambient/machines/electric_machine.wav")
	self.AmbientSound:PlayEx(0.72, 125)

	self.Emitter = ParticleEmitter(self:GetPos())
	self.Emitter:SetNearClip(20, 32)

	self.LastThink = CurTime()
end

function ENT:Think()
	local owner = self:GetOwner()
	if owner:IsValid() then self:SetPos(owner:EyePos()) end
	if MySelf == self:GetOwner() then
		MySelf:SetMana(MySelf:GetMana() - (CurTime() - self.LastThink) * 17)
		self.LastThink = CurTime()
	end
end

function ENT:OnRemove()
	self.AmbientSound:Stop()
	self.Emitter:Finish()
	self:GetOwner().EnergyBolt = nil
end

local matBolt = Material("Effects/laser1")
local matGlow = Material("sprites/glow04_noz")
function ENT:DrawTranslucent()
	local owner = self:GetOwner()
	if not owner:IsValid() then return end

	local tr = owner:TraceLine(1024, MASK_SHOT)
	local hitpos = tr.HitPos
	local ent = tr.Entity

	local startpos
	local wep = owner:GetActiveWeapon()
	if wep:IsValid() then
		local attach
		if owner == MySelf and not NOX_VIEW then
			attach = owner:GetViewModel():GetAttachment(1)
		else
			attach = wep:GetAttachment(1)
		end
		if attach then
			startpos = attach.Pos
		end
	end

	startpos = startpos or owner:GetShootPos()
	self:SetRenderBoundsWS(startpos, hitpos, Vector(128, 128, 128))

	local col = team.GetColor(owner:Team()) or color_white

	local rt = RealTime()

	render.SetMaterial(matGlow)
	local spritesize = 52 + math.cos(rt * 10) * 14
	render.DrawSprite(startpos, spritesize, spritesize, color_white)
	render.DrawSprite(startpos, 52, 52, COLOR_YELLOW)

	render.SetMaterial(matBolt)

	local BeamPos = {}
	local pos
	local dir = owner:GetAimVector()
	for i=1, math.ceil(startpos:Distance(hitpos) / 40) do
		if pos then
			pos = pos + dir * 40 + VectorRand() * 4
		else
			pos = startpos
		end
		BeamPos[#BeamPos + 1] = pos
	end

	local scroll = rt * 20
	--render.StartBeam(#BeamPos + 1)
	render.StartBeam(#BeamPos)
	for i, pos in ipairs(BeamPos) do
		render.AddBeam(pos, math.sin((rt + i * 0.2) * 5) * 48 + 92, scroll, COLOR_YELLOW)
	end
	--render.AddBeam(hitpos, 100, scroll, COLOR_YELLOW)
	render.EndBeam()

	if EFFECT_QUALITY < 1 then return end

	local emitter = self.Emitter

	local particle = emitter:Add("sprites/glow04_noz", hitpos)
	particle:SetVelocity(Vector(0,0,0))
	particle:SetDieTime(0.22)
	particle:SetStartAlpha(255)
	particle:SetEndAlpha(127.5)
	particle:SetStartSize(math.Rand(28, 32))
	particle:SetEndSize(0)
	particle:SetRoll(math.Rand(0, 359))
	particle:SetRollDelta(math.Rand(-16, 16))

	for i=1, math.random(2, 4) do
		local particle = emitter:Add("effects/spark", hitpos)
		particle:SetVelocity(VectorRand():Normalize() * math.Rand(64, 128))
		particle:SetDieTime(0.8)
		particle:SetStartAlpha(255)
		particle:SetEndAlpha(0)
		particle:SetStartSize(math.Rand(6, 8))
		particle:SetEndSize(0)
		particle:SetRoll(math.Rand(0, 359))
		particle:SetRollDelta(math.Rand(-75, 75))
		particle:SetAirResistance(50)
	end
end
