include("shared.lua")

function ENT:Initialize()
	self:DrawShadow(false)
	self:SetRenderBounds(Vector(-40, -40, -18), Vector(40, 40, 48))

	self.Emitter = ParticleEmitter(self:GetPos())
	self.Emitter:SetNearClip(28, 32)

	self.EndTime = CurTime() + 0.75
	self:EmitSound("nox/healringbegin.wav", 70, 175)

	local owner = self:GetOwner()
	owner.LesserHeal = self
	owner.HealCharge = self

	if MySelf == owner then
		owner:DI(NameToSpell["Lesser Heal"], 0.75)
	end
end

function ENT:OnRemove()
	local owner = self:GetOwner()
	owner.LesserHeal = nil
	owner.HealCharge = nil

	self.Emitter:Finish()

	if MySelf == owner then
		owner:DI(NameToSpell["Lesser Heal"], 0)
	end
end

function ENT:Think()
	local owner = self:GetOwner()
	if owner:IsValid() then self:SetPos(owner:EyePos()) end
	self.Emitter:SetPos(self:GetPos())
end

local matGlow = Material("sprites/light_glow02_add")
function ENT:DrawTranslucent()
	local owner = self:GetOwner()
	if not owner:IsValid() then return end

	local r,g,b,a = owner:GetColor()
	if a < 230 then return end

	local delta = self.EndTime - CurTime()
	local pos = owner:LocalToWorld(owner:OBBCenter()) + Vector(math.sin(RealTime() * 10) * delta * 48, math.cos(RealTime() * 10) * delta * 48, 0)

	render.SetMaterial(matGlow)
	render.DrawSprite(pos, 32, 32, COLOR_LIMEGREEN)

	local emitter = self.Emitter
	for i=1, 2 do
		particle = emitter:Add("sprites/light_glow02_add", pos + delta * 4 * VectorRand():Normalize())
		particle:SetVelocity(delta * 48 * VectorRand():Normalize())
		particle:SetDieTime(0.5)
		particle:SetStartAlpha(255)
		particle:SetEndAlpha(255)
		particle:SetStartSize(math.max(1, delta * 11))
		particle:SetEndSize(0)
		particle:SetRoll(math.Rand(0, 360))
		particle:SetRollDelta(math.Rand(0, 360))
		particle:SetColor(math.Rand(20, 40), math.Rand(230, 255), math.Rand(20, 40))
		particle:SetGravity(Vector(0, 0, -600))
		particle:SetBounce(0.8)
		particle:SetCollide(true)
	end
end
