include("shared.lua")

function ENT:Initialize()
	self:DrawShadow(false)
	self:SetRenderBounds(Vector(-40, -40, -18), Vector(40, 40, 80))

	local owner = self:GetOwner()
	if owner:IsPlayer() then
		owner.KnockedDown = self
		owner.VelocityRecovery = true
		owner:SetNoDraw(true)
	end
end

function ENT:OnRemove()
	local owner = self:GetOwner()
	if owner:IsValid() then
		owner.KnockedDown = nil
		owner:SetNoDraw(false)
	end
end

function ENT:Think()
	local ct = CurTime()
	local owner = self:GetOwner()
	if owner:IsValid() and 0 < owner:Health() then
		local rag = owner:GetRagdollEntity()
		if rag and rag:IsValid() then
			self:SetPos(rag:EyePos())

			local ft = FrameTime()
			rag:SetColor(owner:GetColor())
			local endtime = self:GetNetworkedFloat("endtime", 0)
			if self:GetSkin() == 1 then
				local hitnormal = self.WallFreezeHitNormal
				if hitnormal then
					local hitpos = owner:GetPos() + hitnormal * -8
					local hitang = hitnormal:Angle()

					local up = hitang:Up()
					local right = hitang:Right()
					local forward = hitang:Forward()

					local rightfootpos = hitpos + right * 24 + up * 8

					local leftfootpos = hitpos + right * -24 + up * 8

					local headpos = hitpos + up * 58

					local torsopos = hitpos + up * 48

					local lefthandpos = torsopos + right * -35

					local righthandpos = torsopos + right * 35

					local timtoarriv = ft * 20

					local phys = rag:GetPhysicsObjectNum(1)
					if phys and phys:IsValid() then
						local ownerangles = Angle(hitang.pitch, hitang.yaw, hitang.roll)
						ownerangles:RotateAroundAxis(ownerangles:Right(), 90)
						ownerangles:RotateAroundAxis(ownerangles:Forward(), 270)
						phys:Wake()
						phys:ComputeShadowControl({secondstoarrive = timtoarriv, pos = torsopos, angle = ownerangles, maxangular = 3000, maxangulardamp = 100, maxspeed = 1000, maxspeeddamp = 500, dampfactor = 0.85, teleportdistance = 40, deltatime = ft})
					end

					phys = rag:GetPhysicsObjectNum(14)
					if phys and phys:IsValid() then
						phys:Wake()
						phys:ComputeShadowControl({secondstoarrive = timtoarriv, pos = rightfootpos, angle = phys:GetAngle(), maxangular = 1000, maxangulardamp = 500, maxspeed = 1000, maxspeeddamp = 500, dampfactor = 0.85, teleportdistance = 40, deltatime = ft})
					end

					phys = rag:GetPhysicsObjectNum(13)
					if phys and phys:IsValid() then
						phys:Wake()
						phys:ComputeShadowControl({secondstoarrive = timtoarriv, pos = leftfootpos, angle = phys:GetAngle(), maxangular = 1000, maxangulardamp = 500, maxspeed = 1000, maxspeeddamp = 500, dampfactor = 0.85, teleportdistance = 40, deltatime = ft})
						--phys:SetPos(leftfootpos)
					end

					phys = rag:GetPhysicsObjectNum(10)
					if phys and phys:IsValid() then
						phys:Wake()
						phys:ComputeShadowControl({secondstoarrive = timtoarriv, pos = headpos, angle = phys:GetAngle(), maxangular = 1000, maxangulardamp = 500, maxspeed = 1000, maxspeeddamp = 500, dampfactor = 0.85, teleportdistance = 40, deltatime = ft})
					end

					phys = rag:GetPhysicsObjectNum(7)
					if phys and phys:IsValid() then
						phys:Wake()
						phys:ComputeShadowControl({secondstoarrive = timtoarriv, pos = righthandpos, angle = phys:GetAngle(), maxangular = 1000, maxangulardamp = 500, maxspeed = 1000, maxspeeddamp = 500, dampfactor = 0.85, teleportdistance = 40, deltatime = ft})
					end

					phys = rag:GetPhysicsObjectNum(5)
					if phys and phys:IsValid() then
						phys:Wake()
						phys:ComputeShadowControl({secondstoarrive = timtoarriv, pos = lefthandpos, angle = phys:GetAngle(), maxangular = 1000, maxangulardamp = 500, maxspeed = 1000, maxspeeddamp = 500, dampfactor = 0.85, teleportdistance = 40, deltatime = ft})
					end

					self:NextThink(ct)
					return true
				end
			end

			if endtime - 0.65 <= ct then
				local playerpos = owner:GetPos()
				local delta = math.max(0.01, endtime - ct)
				for i = 0, rag:GetPhysicsObjectCount() do
					local translate = owner:TranslatePhysBoneToBone(i)
					if 0 < translate then
						local pos, ang = owner:GetBonePosition(translate)
						if pos and ang then
							local phys = rag:GetPhysicsObjectNum(i)
							if phys and phys:IsValid() then
								phys:Wake()
								phys:ComputeShadowControl({secondstoarrive = delta * pos:Distance(playerpos) * 0.1, pos = pos, angle = ang, maxangular = 1000, maxangulardamp = 10000, maxspeed = 5000, maxspeeddamp = 1000, dampfactor = 0.85, teleportdistance = 200, deltatime = ft})
							end
						end
					end
				end
			else
				local phys = rag:GetPhysicsObject()
				if phys:IsValid() then
					phys:Wake()
					phys:ComputeShadowControl({secondstoarrive = ft * 5, pos = owner:GetPos() + Vector(0,0,16), angle = rag:GetPhysicsObject():GetAngle(), maxangular = 2000, maxangulardamp = 10000, maxspeed = 5000, maxspeeddamp = 1000, dampfactor = 0.85, teleportdistance = 200, deltatime = ft})
				end
			end
		else
			self:SetPos(owner:EyePos())
		end
	end

	self:NextThink(ct)
	return true
end

function ENT:Draw()
end
