AddCSLuaFile("cl_init.lua")
AddCSLuaFile("shared.lua")

include("shared.lua")

--ENT.LastFastVelocity = Vector(0,0,0)

function ENT:PlayerSet(pPlayer, bExists)
	pPlayer.KnockedDown = self
	pPlayer:SetVelocityRecovery(true, true)

	self.LastFastVelocity = pPlayer:GetVelocity()

	if self.OldDieTime then
		self.DieTime = math.max(self.DieTime, self.OldDieTime)
	end
	self.OldDieTime = self.DieTime

	self.LastThink = CurTime()

	if bExists then
		self.AppliedWallDamage = nil
		self:SetSkin(0)
	else
		pPlayer:Freeze(true)
		--pPlayer:SetNoDraw(true)

		if pPlayer:GetDrawWorldModel() then
			self.ResetWorldModel = true
			pPlayer:DrawWorldModel(false)
		end

		if pPlayer:GetDrawViewModel() then
			self.ResetViewModel = true
			pPlayer:DrawViewModel(false)
		end

		if 1 <= pPlayer:Health() then
			pPlayer:CreateRagdoll()
		end
	end

	self:SetNetworkedFloat("endtime", self.DieTime)
end

function ENT:Think()
	local ct = CurTime()
	local delta = ct - self.LastThink
	self.LastThink = ct

	local owner = self:GetOwner()
	if owner.WallFreeze then
		if owner.WallFreeze <= ct then
			owner.WallFreeze = nil
		else
			owner:SetLocalVelocity(Vector(0,0,0))
		end
	end

	if self.AppliedWallDamage then
		if owner:IsOnGround() then
			self:SetSkin(0)
			self.DieTime = ct + 4
			self:SetNetworkedFloat("endtime", self.DieTime)
			self.AppliedWallDamage = false
			self.GettingUp = true
		end
	elseif not self.GettingUp or ct + 0.2 <= self.DieTime then
		local heading = owner:GetVelocity()
		local speed = heading:Length()
		if speed < 375 and self.LastFastVelocity then
			heading = self.LastFastVelocity
			speed = heading:Length()
		end
		if 375 <= speed then
			self.LastFastVelocity = heading
			heading = heading:Normalize()
			--local nearest = owner:NearestPoint(owner:LocalToWorld(owner:OBBCenter()) + heading * 2048)
			--local nearest = owner:LocalToWorld(owner:OBBCenter())
			local nearest = owner:GetPos()
			local tr = util.TraceHull({start = nearest, endpos = nearest + speed * FrameTime() * 2 * heading, mask = MASK_PLAYERSOLID, filter = owner, mins=Vector(-16,-16,0), maxs=Vector(16,16,72)})
			if tr.Hit and tr.HitNormal.z < 0.65 and 0 < tr.HitNormal:Length() and not (tr.Entity:IsValid() and tr.Entity:IsPlayer()) then
				local hitang = tr.HitNormal:Angle()
				local eyeangs = owner:EyeAngles()
				owner:SetEyeAngles(Angle(eyeangs.pitch, hitang.yaw, eyeangs.roll))
				self:SetSkin(1)
				self.AppliedWallDamage = true
				owner.WallFreeze = ct + 0.5
				local effectdata = EffectData()
					effectdata:SetNormal(tr.HitNormal)
					effectdata:SetEntity(owner)
					effectdata:SetOrigin(tr.HitPos)
				util.Effect("wallslam", effectdata)
				self.DieTime = ct + 9999
				self:SetNetworkedFloat("endtime", self.DieTime)
				owner:SetLocalVelocity(Vector(0,0,0))
				--owner:TakeSpecialDamage(math.max(10, math.ceil(speed * 0.02)), DGMTYPE_PHYSICAL, GetWorldEntity())
				owner:TakeSpecialDamage(10, DGMTYPE_PHYSICAL, GetWorldEntity())
				util.ScreenShake(tr.HitPos, 20, 0.5, 1, 128)
			end
		end
	end

	if self.DieTime <= ct then
		self:Remove()
	else
		self:NextThink(ct)
		return true
	end
end

function ENT:OnRemove()
	local parent = self:GetParent()
	if parent:IsValid() then
		parent:Freeze(false)
		--parent:SetNoDraw(false)
		parent.KnockedDown = nil
		parent.WallFreeze = nil

		if parent:Alive() then
			if self.ResetViewModel then
				parent:DrawViewModel(true)
			end

			if self.ResetWorldModel then
				parent:DrawWorldModel(true)
			end

			local rag = parent:GetRagdollEntity()
			if rag and rag:IsValid() then
				rag:Remove()
			end
		end
	end
end
