include("shared.lua")

function ENT:Initialize()
	self:DrawShadow(false)
	self:SetRenderBounds(Vector(-40, -40, -18), Vector(40, 40, 80))

	self.Emitter = ParticleEmitter(self:GetPos())
	self.Emitter:SetNearClip(28, 32)

	if MySelf == self:GetOwner() then
		MySelf:DI(NameToSpell["Mana Burn"], 5)
	end
	self:GetOwner().ManaBurn = self
end

function ENT:OnRemove()
	self.Emitter:Finish()

	if MySelf == self:GetOwner() then
		MySelf:DI(NameToSpell["Mana Burn"], 0)
	end
	self:GetOwner().ManaBurn = nil
end

function ENT:Think()
	local owner = self:GetOwner()
	if owner:IsValid() then self:SetPos(owner:EyePos()) end
	self.Emitter:SetPos(self:GetPos())

	if owner == MySelf then
		owner:SetMana(math.max(0, owner:GetMana() - owner.ManaRegenerate * 6 * FrameTime()))
	end

	self:NextThink(CurTime())
	return true
end

function ENT:Draw()
	local ent = self:GetOwner()
	if not ent:IsValid() then return end

	local r,g,b,a = ent:GetColor()
	if a <= 180 then return end

	local pos = ent:GetPos() + Vector(0, 0, ent:OBBMaxs().z)

	local emitter = self.Emitter
	for i=1, 9 do
		local particle = emitter:Add("sprites/light_glow02_add", pos)
		particle:SetVelocity(VectorRand() * 40 + Vector(0,0,90))
		particle:SetDieTime(0.3)
		particle:SetStartAlpha(230)
		particle:SetEndAlpha(50)
		particle:SetStartSize(8)
		particle:SetEndSize(0)
		particle:SetRoll(math.Rand(-0.8, 0.8))
		particle:SetColor(20, 20, 255)
		particle:SetAirResistance(50)
	end
end
