include("shared.lua")

function ENT:Initialize()
	self:DrawShadow(false)
	self:SetRenderBounds(Vector(-40, -40, -18), Vector(40, 40, 80))

	self.Emitter = ParticleEmitter(self:GetPos())
	self.Emitter:SetNearClip(28, 32)
end

function ENT:OnRemove()
	self.Emitter:Finish()

	--[[if MySelf == self:GetOwner() then
		MySelf:DI(NameToSpell.Stun, 0)
	end]]
end

function ENT:Think()
	local owner = self:GetOwner()
	if owner:IsValid() then self:SetPos(owner:EyePos()) end
	self.Emitter:SetPos(self:GetPos())
end

function ENT:Draw()
	local ent = self:GetOwner()
	if not ent:IsValid() then return end

	local r,g,b,a = ent:GetColor()
	if a < 230 then return end

	local pos

	if ent == MySelf then
		pos = ent:GetPos() + Vector(0,0,72)
	else
		local attach = ent:GetAttachment(ent:LookupAttachment("eyes"))
		if not attach then return end
		pos = attach.Pos + Vector(0,0,16)
	end

	local emitter = self.Emitter
	for i=1, 9 do
		local particle = emitter:Add("sprites/light_glow02_add", pos)
		particle:SetVelocity(VectorRand() * 40 + Vector(0,0,90))
		particle:SetDieTime(0.3)
		particle:SetStartAlpha(230)
		particle:SetEndAlpha(50)
		particle:SetStartSize(8)
		particle:SetEndSize(0)
		particle:SetRoll(math.Rand(-0.8, 0.8))
		particle:SetColor(20, 20, 255)
		particle:SetAirResistance(50)
	end
end
