include("shared.lua")

function ENT:Initialize()
	self:DrawShadow(false)
	self:SetRenderBounds(Vector(-128, -128, -128), Vector(128, 128, 128))

	self:GetOwner().NailerCharge = self

	self:EmitSound("Weapon_SMG1.Special1")

	self.AmbientSound = CreateSound(self, "Weapon_CombineGuard.Special1")
	self.DieTime = CurTime() + 1.25

	self.Seed = math.Rand(0, 10)
	self.NextEmit = 0

	self.Emitter = ParticleEmitter(self:GetPos())
	self.Emitter:SetNearClip(20, 32)
end

function ENT:Think()
	local owner = self:GetOwner()
	if owner:IsValid() then self:SetPos(owner:EyePos()) end

	self.AmbientSound:PlayEx(0.62, math.min(255, 70 + (self.DieTime - CurTime()) * 50))
	self.Emitter:SetPos(self:GetPos())
end

function ENT:OnRemove()
	self.AmbientSound:Stop()
	self.Emitter:Finish()
	local parent = self:GetOwner()
	if parent:IsValid() then
		parent.NailerCharge = nil
		if parent == MySelf and parent:Alive() and self.DieTime <= CurTime() then
			local wep = parent:GetActiveWeapon()
			if wep:IsValid() and wep:GetClass() == "weapon_nailer" then
				wep:ShootNailer()
			end
		end
	end
end

local matGlow = Material("effects/rollerglow")
function ENT:DrawTranslucent()
	local owner = self:GetOwner()
	if not owner:IsValid() then return end

	local startpos
	local wep = owner:GetActiveWeapon()
	if wep:IsValid() then
		local attach
		if owner == MySelf and not NOX_VIEW then
			attach = owner:GetViewModel():GetAttachment(1)
		else
			attach = wep:GetAttachment(1)
		end
		if attach then
			startpos = attach.Pos
		end
	end

	startpos = startpos or owner:GetShootPos()

	--local col = team.GetColor(owner:Team()) or color_white

	local eyeangles = owner:EyeAngles()
	eyeangles:RotateAroundAxis(eyeangles:Forward(), self.Rotation)

	local mul = 4
	if owner == MySelf and not NOX_VIEW then mul = 9 end

	local ct = CurTime()
	local delta = math.max(0, self.DieTime - ct)
	local rdelta = 1.25 - delta

	render.SetMaterial(matGlow)
	local sprisiz = math.sin(RealTime() * 10) * 12 + rdelta * 48
	render.DrawSprite(startpos, sprisiz, sprisiz, color_white)

	self.Emitter:SetPos(startpos)
	if self.NextEmit <= ct then
		self.NextEmit = ct + 0.075

		local pos = startpos

		local curvel = owner:GetVelocity()
		eyeangles:RotateAroundAxis(eyeangles:Forward(), (ct + self.Seed) * 180)
		for i=1, 4 do
			eyeangles:RotateAroundAxis(eyeangles:Forward(), 90)
			local headingang = Angle(eyeangles.pitch, eyeangles.yaw, eyeangles.roll)
			headingang:RotateAroundAxis(headingang:Right(), delta * 130)

			local dir = headingang:Forward()

			local particle = self.Emitter:Add("effects/rollerglow", startpos + rdelta * 80 * dir)
			particle:SetVelocity(rdelta * -160 * dir + curvel)
			particle:SetDieTime(0.5)
			particle:SetStartSize(rdelta * 20)
			particle:SetEndSize(0)
			particle:SetStartAlpha(0)
			particle:SetEndAlpha(200)
			particle:SetAirResistance(16)
			--particle:SetColor(col.r, col.g, col.b)
			particle:SetRoll(math.Rand(0, 360))
			particle:SetRollDelta(math.Rand(-100 * rdelta, 100 * rdelta))
		end
	end
end
