AddCSLuaFile("cl_init.lua")
AddCSLuaFile("shared.lua")

include("shared.lua")

function ENT:PlayerSet(pPlayer, bExists)
	self:SetParent(NULL)
	self:SetTeamID(pPlayer:Team())
	if bExists then
		pPlayer:DI(NameToSpell["Reflective Shield"], 3)
	end
end

function ENT:OnRemove()
	self:EmitSound("nox/reflectoff.wav", 72, math.Rand(95, 105))
end

function ENT:Think()
	local owner = self:GetOwner()
	if self.DieTime <= CurTime() or owner:IsMoving() then
		self:Remove()
	else
		local dir = owner:GetForward()
		self:SetPos(owner:LocalToWorld(owner:OBBCenter()) + dir * 38)
		self:SetAngles(dir:Angle())

		self:NextThink(CurTime())
		return true
	end
end

function ENT:ShouldNotCollide(ent)
	return not (ent:IsValid() and string.sub(ent:GetClass(), 1, 11) == "projectile_" and self:GetOwner():IsValid() and 1.4 < ent:GetVelocity():Normalize():Distance(self:GetOwner():GetAimVector()))
end

local mins = Vector(-16, -16, -36)
local maxs = Vector(16, 16, 36)
function ENT:Initialize()
	self:DrawShadow(false)
	self:PhysicsInitBox(mins, maxs)
	self:SetCollisionBounds(mins, maxs)
	self:SetSolid(SOLID_VPHYSICS)
	self:SetSolidMask(MASK_VISIBLE | MASK_NPCSOLID | MASK_SOLID | MASK_PLAYERSOLID)
	local phys = self:GetPhysicsObject()
	phys:SetMass(2)
	phys:EnableGravity(false)
	phys:Wake()
end

local function Invert(self, owner, ent, phys, vel)
	if self:IsValid() and owner:IsValid() and ent:IsValid() and phys:IsValid() then
		phys:SetVelocityInstantaneous(vel * -1)
		if ent.Heading then
			ent.Heading = ent.Heading * -1
		end
		ent:SetTeamID(owner:Team())
		if ent.Target and ent.Target:IsValid() then
			if ent.Target == owner then
				ent.Target = ent:GetOwner()
			else
				ent.Target = NULL
			end
		end
		ent:SetOwner(owner)
		if ent.Attacker then
			ent.Attacker = owner
		end
		self:EmitSound("nox/inversion.wav", 70, math.Rand(95, 105))
	end
end

function TouchReflectiveShield(self, shield, vel)
	if shield:IsValid() and shield:GetClass() == "status_reflectiveshield" and not self.NoReflectiveShield and self:GetTeamID() ~= shield:GetTeamID() and self.LastReflectiveShield ~= shield then
		self.LastReflectiveShield = shield
		timer.Simple(0, Invert, shield, shield:GetOwner(), self, self:GetPhysicsObject(), vel)
		return true
	end
end
TRS = TouchReflectiveShield
