include("shared.lua")

function ENT:Initialize()
	self:DrawShadow(false)
	self:SetRenderBounds(Vector(-60, -60, -18), Vector(60, 60, 80))

	self.Emitter = ParticleEmitter(self:GetPos())
	self.Emitter:SetNearClip(16, 24)

	self.Created = CurTime()

	local owner = self:GetOwner()
	owner.WallRunning = self
	owner.WallRunningUp = self
	owner.WallRunningUpStart = CurTime() + 0.3
	owner.WallRunningRightInterp = nil
	owner.WallRunningLeftInterp = nil

	self:EmitSound("sprint2.wav", 65, 100)

	self.LastThink = CurTime()
end

function ENT:OnRemove()
	local owner = self:GetOwner()
	owner.WallRunning = nil
	owner.WallRunningUp = nil
	owner.WallRunningUpStart = nil
	owner.WallRunningUpInterp = CurTime() + math.min(CurTime() - self.Created, 0.5)

	self.Emitter:Finish()
end

local STAMINA_WALLVERTING = STAMINA_WALLVERTING
function ENT:Think()
	local owner = self:GetOwner()
	if owner:IsValid() then self:SetPos(owner:EyePos()) end

	self.Emitter:SetPos(self:GetPos())

	if owner == MySelf then
		local delta = CurTime() - self.LastThink
		self.LastThink = CurTime()
		owner:SetStamina(owner:GetStamina() - (owner.StaminaRegenerate + STAMINA_WALLVERTING) * delta)
	end

	self:NextThink(CurTime())
	return true
end

local matSprite = Material("sprites/glow04_noz")
function ENT:DrawTranslucent()
	local owner = self:GetOwner()
	if not owner:IsValid() then return end

	render.SetMaterial(matSprite)
	local ct = CurTime()

	local boneindex = owner:LookupBone("valvebiped.bip01_l_foot")
	if boneindex then
		local pos, ang = owner:GetBonePosition(boneindex)
		if pos then
			local sinm = math.sin(ct * 30) * 8 + 16
			render.DrawSprite(pos, sinm, sinm, color_white)
			local particle = self.Emitter:Add("effects/fire_cloud1", pos)
			particle:SetDieTime(math.Rand(0.4, 0.5))
			particle:SetStartAlpha(255)
			particle:SetEndAlpha(255)
			particle:SetStartSize(math.Rand(4, 8))
			particle:SetEndSize(0)
			particle:SetRoll(math.Rand(0, 360))
			particle:SetRollDelta(math.Rand(-5, 5))
		end
	end

	local boneindex2 = owner:LookupBone("valvebiped.bip01_r_foot")
	if boneindex2 then
		local pos, ang = owner:GetBonePosition(boneindex2)
		if pos then
			local cosm = math.cos(ct * 30) * 8 + 16
			render.DrawSprite(pos, cosm, cosm, color_white)
			local particle = self.Emitter:Add("effects/fire_cloud1", pos)
			particle:SetDieTime(math.Rand(0.4, 0.5))
			particle:SetStartAlpha(255)
			particle:SetEndAlpha(255)
			particle:SetStartSize(math.Rand(4, 8))
			particle:SetEndSize(0)
			particle:SetRoll(math.Rand(0, 360))
			particle:SetRollDelta(math.Rand(-5, 5))
		end
	end
end
