AddCSLuaFile("cl_init.lua")
AddCSLuaFile("shared.lua")

include("shared.lua")

function ENT:PlayerSet(pPlayer, bExists)
	pPlayer.WallRunning = self
	pPlayer.WallRunningUp = self
	pPlayer.WallRunningUpStart = CurTime() + 0.3
	pPlayer.WallRunningUpInterp = nil
	pPlayer.WallRunningRightInterp = nil
	pPlayer.WallRunningLeftInterp = nil
	pPlayer.CantSprintTime = CurTime()
	self.Created = CurTime()
	pPlayer:SetAnimation(PLAYER_WALK)
	pPlayer:SetFOV(pPlayer:GetInfo("fov_desired") * 1.1, 0.25)

	pPlayer:SetAllowFullRotation(true)

	self.LastThink = CurTime()
end

local function ResetFullRotation(pl)
	if pl:IsValid() and not pl.WallRunningUp then
		pl:SetAllowFullRotation(false)
	end
end

function ENT:OnRemove()
	local parent = self:GetOwner()
	if parent:IsValid() then
		parent:SetFOV(parent:GetInfo("fov_desired"), 0.25)
		parent.WallRunning = nil
		parent.WallRunningUp = nil
		parent.WallRunningUpStart = nil
		local delay = math.min(CurTime() - self.Created, 0.5)
		parent.WallRunningUpInterp = CurTime() + delay
		timer.Simple(delay, ResetFullRotation, parent)
		parent:SetStamina(parent:GetStamina(), true)
	end
end

local STAMINA_WALLVERTING = STAMINA_WALLVERTING
function ENT:Think()
	local owner = self:GetOwner()
	local ct = CurTime()
	local delta = ct - self.LastThink
	self.LastThink = ct

	local getpos = owner:GetPos() + Vector(0,0,4)
	local tr = util.TraceLine({start = getpos, endpos = getpos + owner:GetForward() * 28, mask = MASK_PLAYERSOLID, filter = owner})
	local checkpos = tr.HitPos + tr.HitNormal * 2
	if not owner:KeyDown(IN_FORWARD) or self.Key and not owner:KeyDown(self.Key) or owner:Crouching() or owner:IsFrozen() or owner:GetStamina() <= 0.5 or (owner:IsOnGround() and owner.WallRunningUpStart + 0.25 <= ct) or not tr.Hit or tr.HitSky or 0.19 < math.abs(tr.HitNormal.z) or util.TraceHull({start = getpos, endpos = getpos + Vector(0, 0, 2), mins = owner:OBBMins() * 0.9, maxs = owner:OBBMaxs() * 0.9, mask = MASK_PLAYERSOLID, filter = owner}).Hit then
		self:Remove()
	else
		owner:SetStamina(owner:GetStamina() - (owner.StaminaRegenerate + STAMINA_WALLVERTING) * delta)
		self:NextThink(ct)
		return true
	end
end
