include("shared.lua")

function ENT:Initialize()
	self:DrawShadow(false)
	self:SetModel("models/props_c17/signpole001.mdl")
	self:SetRenderBounds(Vector(-60, -60, -32), Vector(60, 60, 100))
	self.Emitter = ParticleEmitter(self:GetPos())
	self.Emitter:SetNearClip(24, 32)
	self:SetModelScale(Vector(1,1,0.55))
	self.Staff = true
	self:GetOwner().WeaponStatus = self
end

function ENT:OnRemove()
	self.Emitter:Finish()
end

function ENT:Think()
	local owner = self:GetOwner()
	if owner:IsValid() then
		self:SetPos(owner:EyePos())
		if self:GetSkin() == 1 then
			owner:SetLuaAnimation("staffholdspell")
		end
	end
	self.Emitter:SetPos(self:GetPos() + self:OBBMaxs().z * 2 * self:GetUp())
end

RegisterLuaAnimation("staffholdspell", {
	FrameData = {
		{
			BoneInfo = {
				["ValveBiped.Bip01_R_Forearm"] = {
					RU = 40,
					RF = -40
				},
				["ValveBiped.Bip01_R_Upperarm"] = {
					RU = 40
				},
				["ValveBiped.Bip01_R_Hand"] = {
					RU = -40
				},
				["ValveBiped.Bip01_L_Forearm"] = {
					RU = 40
				},
				["ValveBiped.Bip01_L_Hand"] = {
					RU = -40
				}
			},
			FrameRate = 6
		},
		{
			BoneInfo = {
				["ValveBiped.Bip01_R_Forearm"] = {
					RU = 2,
				},
				["ValveBiped.Bip01_R_Upperarm"] = {
					RU = 1
				},
				["ValveBiped.Bip01_R_Hand"] = {
					RU = -10
				},
				["ValveBiped.Bip01_L_Forearm"] = {
					RU = 8
				},
				["ValveBiped.Bip01_L_Hand"] = {
					RU = -12
				}
			},
			FrameRate = 0.4
		},
		{
			BoneInfo = {
				["ValveBiped.Bip01_R_Forearm"] = {
					RU = -2,
				},
				["ValveBiped.Bip01_R_Upperarm"] = {
					RU = -1
				},
				["ValveBiped.Bip01_R_Hand"] = {
					RU = 10
				},
				["ValveBiped.Bip01_L_Forearm"] = {
					RU = -8
				},
				["ValveBiped.Bip01_L_Hand"] = {
					RU = 12
				}
			},
			FrameRate = 0.1
		}
	},
	RestartFrame = 2,
	Type = TYPE_STANCE,
	ShouldPlay = function(pl, sGestureName, tGestureTable, iCurFrame, tFrameData)
		local wepstatus = pl.WeaponStatus
		return wepstatus and wepstatus:IsValid() and wepstatus:GetSkin() == 1 and wepstatus.Staff
	end
})

local matGlow = Material("sprites/light_glow02_add")
function ENT:DrawTranslucent()
	local owner = self:GetOwner()
	if not owner:IsValid() then return end

	local rag = owner:GetRagdollEntity()
	if rag then
		owner = rag
	elseif not owner:Alive() then return end

	local r,g,b,a = owner:GetColor()
	local angpos = owner:GetAttachment(owner:LookupAttachment("anim_attachment_RH"))
	if angpos then
		self:SetAngles(angpos.Ang)
		self:SetPos(angpos.Pos + self:GetUp() * -32)
		self:SetColor(255,255,255,math.max(1,a))
		self:DrawModel()
	end

	if a <= 1 or self:GetSkin() == 0 then return end

	local pos = self:GetPos() + self:OBBMaxs().z * 0.55 * self:GetUp()
	render.SetMaterial(matGlow)
	render.DrawSprite(pos, 32, 32, COLOR_LIMEGREEN)
	render.DrawSprite(pos, 32, 32, COLOR_RED)

	if EFFECT_QUALITY < 2 then return end

	local emitter = self.Emitter
	for i=1, 2 do
		local particle = emitter:Add("sprites/light_glow02_add", pos + VectorRand() * 6)
		particle:SetVelocity(VectorRand() * 16)
		particle:SetDieTime(math.Rand(0.25, 0.35))
		particle:SetStartAlpha(230)
		particle:SetEndAlpha(50)
		particle:SetStartSize(math.Rand(5, 7.5))
		particle:SetEndSize(0)
		particle:SetRoll(math.Rand(0, 360))
		particle:SetRollDelta(math.Rand(-8, 8))
		particle:SetAirResistance(5)

		particle = emitter:Add("effects/spark", pos + VectorRand() * 6)
		particle:SetVelocity(VectorRand():Normalize() * 128)
		particle:SetDieTime(math.Rand(0.25, 0.4))
		particle:SetStartAlpha(230)
		particle:SetEndAlpha(50)
		particle:SetStartSize(math.Rand(0.5, 1))
		particle:SetEndSize(0)
		particle:SetRoll(math.Rand(0, 360))
		particle:SetAirResistance(200)
	end
end
