include("shared.lua")

function ENT:Initialize()
	self:DrawShadow(false)
	--self:SetModel("models/w_nox_short_sword.mdl")
	self:SetModel("models/weapons/w_gladradus/w_gladradus.mdl")
	self:SetRenderBounds(Vector(-80, -80, -32), Vector(80, 80, 120))
	self.LastSkin = 0
	self.ChargeSound = CreateSound(self, "ambient/levels/citadel/zapper_loop1.wav")
	self:GetOwner().WeaponStatus = self
	self.Emitter = ParticleEmitter(self:GetPos())
	self.Emitter:SetNearClip(20, 25)
end

function ENT:Think()
	local owner = self:GetOwner()
	if owner:IsValid() then self:SetPos(owner:EyePos()) end

	self.Emitter:SetPos(self:GetPos())

	local skin = self:GetSkin()
	if skin ~= self.LastSkin then
		self.LastSkin = skin
		if skin == 0 then
			self.StartCharge = nil
		elseif skin < 3 then
			self.StartCharge = CurTime()
		--[[else
			owner:SetLuaAnimation("gladradusslam")]]
		end
	end

	if self.StartCharge then
		self.ChargeSound:PlayEx(0.75, math.max(40, math.min(255, (CurTime() - self.StartCharge) * 160)))
	else
		self.ChargeSound:Stop()
	end
end

function ENT:OnRemove()
	self.ChargeSound:Stop()
	self.Emitter:Finish()
end

function ENT:Draw()
	local owner = self:GetOwner()
	if owner:IsValid() then
		local rag = owner:GetRagdollEntity()
		if rag then
			owner = rag
		elseif not owner:Alive() then return end

		local boneindex = owner:LookupBone("valvebiped.bip01_r_hand")
		if boneindex then
			local pos, ang = owner:GetBonePosition(boneindex)
			if pos then
				local r,g,b,a = owner:GetColor()
				self:SetColor(255, 255, 255, math.max(1, a))
				self:SetPos(pos + ang:Up() * 3 + ang:Forward() * 3 + ang:Right() * 1)
				ang:RotateAroundAxis(ang:Right(), 90)
				ang:RotateAroundAxis(ang:Forward(), 90)
				self:SetAngles(ang)
				self:DrawModel()

				if self.StartCharge then
					local rdelta = math.max(0, CurTime() - self.StartCharge)

					local noang = Angle(0,0,0)
					local curvel = owner:GetVelocity()
					local ownerpos = owner:GetPos()
					local emitter = self.Emitter
					for i=1, math.min(42, math.ceil(FrameTime() * 400)) do
						local vran = VectorRand()
						vran.z = 0
						local particle = emitter:Add("effects/spark", ownerpos + vran:Normalize() * math.Rand(rdelta * -32, rdelta * 32))
						particle:SetVelocity(Vector(0, 0, rdelta * 256 + 128) + curvel)
						particle:SetDieTime(0.4)
						particle:SetStartAlpha(255)
						particle:SetEndAlpha(0)
						particle:SetStartSize(rdelta * 6 + 2)
						particle:SetEndSize(0)
						particle:SetAngles(noang)
						particle:SetAirResistance(rdelta * 64 + 92)
						--particle:SetColor(r,g,b)
					end
				end
			end
		end
	end
end
