include("shared.lua")

function ENT:Initialize()
	self:DrawShadow(false)
	self:SetModel("models/weapons/steel_might/w_steel_might.mdl")
	self:SetRenderBounds(Vector(-80, -80, -32), Vector(80, 80, 120))
	self.LastSkin = 0
	self.ChargeSound = CreateSound(self, "nox/fireballwhoosh.wav")
	self:GetOwner().WeaponStatus = self
	self.Emitter = ParticleEmitter(self:GetPos())
	self.Emitter:SetNearClip(20, 25)
end

function ENT:Think()
	local owner = self:GetOwner()

	if owner:IsValid() then
		self:SetPos(owner:EyePos())

		local wep = owner:GetActiveWeapon()
		if wep:IsValid() then
			local skin = wep:GetSkin()
			if skin ~= self.LastSkin then
				self.LastSkin = skin
				if skin == 0 then
					self.StartCharge = nil
				elseif skin == 3 then
					self.StartCharge = CurTime()
				end
			end
		end
	else
		self.StartCharge = nil
	end

	if self.StartCharge then
		self.ChargeSound:PlayEx(0.74, math.min(255, 50 + (CurTime() - self.StartCharge) * 200))
	else
		self.ChargeSound:Stop()
	end

	self.Emitter:SetPos(self:GetPos())
end

function ENT:OnRemove()
	self.ChargeSound:Stop()
	self.Emitter:Finish()
end

function ENT:DrawTranslucent()
	local owner = self:GetOwner()
	if owner:IsValid() then
		local rag = owner:GetRagdollEntity()
		if rag then
			owner = rag
		elseif not owner:Alive() then return end

		local boneindex = owner:LookupBone("ValveBiped.Bip01_R_Hand")
		if boneindex then
			local pos, ang = owner:GetBonePosition(boneindex)

			self:SetPos(pos + ang:Up() * -13 + ang:Forward() * 2 + ang:Right() * 1)
			ang:RotateAroundAxis(ang:Right(), 270)
			ang:RotateAroundAxis(ang:Up(), 180)
			ang:RotateAroundAxis(ang:Forward(), 90)
			self:SetAngles(ang)

			if self.StartCharge then
				local rdelta = math.min(0.5, CurTime() - self.StartCharge)

				local force = rdelta * 220
				local resist = force * 0.5

				pos = pos + ang:Forward() * -24

				local noang = Angle(0,0,0)
				local curvel = owner:GetVelocity() * 0.5
				local emitter = self.Emitter

				for i=1, math.min(16, math.ceil(FrameTime() * 250)) do
					local particle = emitter:Add("effects/fire_cloud"..math.random(1,2), pos)
					particle:SetVelocity(curvel + VectorRand():Normalize() * force)
					particle:SetDieTime(0.55)
					particle:SetStartAlpha(rdelta * 400 + 55)
					particle:SetEndAlpha(0)
					particle:SetStartSize(1)
					particle:SetEndSize(rdelta * 10 + 7)
					particle:SetAirResistance(resist)
				end
			end
		end

		local r,g,b,a = owner:GetColor()
		self:SetColor(255, 255, 255, math.max(1, a))
		self:DrawModel()
	end
end
