include("shared.lua")

function ENT:Initialize()
	self:DrawShadow(false)
	self:SetModel("models/peanut/conansword.mdl")
	self:SetRenderBounds(Vector(-120, -120, -64), Vector(120, 120, 120))
	self:GetOwner().WeaponStatus = self
	self.NextEmit = 0
	self.EndThrustSound = 0
	self.AmbientSound = CreateSound(self, "weapons/rpg/rocket1.wav")

	self.Emitter = ParticleEmitter(self:GetPos())
	self.Emitter:SetNearClip(24, 32)
end

function ENT:Think()
	local owner = self:GetOwner()
	if owner:IsValid() then self:SetPos(owner:EyePos()) end

	self.Emitter:SetPos(self:GetPos())

	local owner = self:GetOwner()
	if owner:IsValid() then
		local wep = owner:GetActiveWeapon()
		if wep:IsValid() then
			local skin = wep:GetSkin()
			if skin == 2 or skin == 3 or skin == 5 then
				self.EndThrustSound = CurTime() + 0.15
			end
		end

		if CurTime() < self.EndThrustSound then
			self.AmbientSound:PlayEx(0.72, math.max(50, math.min(255, 255 - owner:GetVelocity():Length() * 0.15)))
			return
		end
	end
	
	self.AmbientSound:Stop()
end

function ENT:OnRemove()
	self.Emitter:Finish()
	self.AmbientSound:Stop()
end

function ENT:Draw()
	local owner = self:GetOwner()
	if owner:IsValid() then
		local origowner = owner
		local rag = owner:GetRagdollEntity()
		if rag then
			owner = rag
		elseif not owner:Alive() then return end

		local boneindex = owner:LookupBone("valvebiped.bip01_r_hand")
		if boneindex then
			local pos, ang = owner:GetBonePosition(boneindex)
			if pos then
				local r,g,b,a = owner:GetColor()
				self:SetColor(255, 255, 255, math.max(1, a))
				self:SetPos(pos + ang:Forward() * 3 + ang:Right() * 3)
				ang:RotateAroundAxis(ang:Up(), 90)
				self:SetAngles(ang)
				self:DrawModel()

				if self.NextEmit <= CurTime() then
					local wep = origowner:GetActiveWeapon()
					if wep:IsValid() then
						local skin = wep:GetSkin()
						if skin == 1 then
							self.NextEmit = CurTime() + 0.05

							local emitter = self.Emitter
							local fwd = origowner:GetForward()
							local up = origowner:GetUp()
							local ang = fwd:Angle()
							ang:RotateAroundAxis(ang:Up(), RealTime() * 350)
							for i=1, 4 do
								local particle = emitter:Add("sprites/flamelet"..math.random(1,4), origowner:GetPos())
								particle:SetDieTime(0.75)
								particle:SetGravity(up * 4500 + fwd * -550)
								particle:SetVelocity(ang:Forward() * 500 + VectorRand():Normalize() * math.Rand(150, 250))
								particle:SetAirResistance(500)
								particle:SetStartAlpha(255)
								particle:SetEndAlpha(100)
								particle:SetStartSize(16)
								particle:SetEndSize(4)
								particle:SetRoll(math.Rand(0, 360))
								particle:SetRollDelta(math.Rand(60, 120))
							end

							ang:RotateAroundAxis(ang:Up(), 180)
							for i=1, 4 do
								local particle = emitter:Add("sprites/flamelet"..math.random(1,4), origowner:GetPos())
								particle:SetDieTime(0.75)
								particle:SetGravity(up * 4500 + fwd * -550)
								particle:SetVelocity(ang:Forward() * 500 + VectorRand():Normalize() * math.Rand(150, 250))
								particle:SetAirResistance(500)
								particle:SetStartAlpha(255)
								particle:SetEndAlpha(100)
								particle:SetStartSize(16)
								particle:SetEndSize(4)
								particle:SetRoll(math.Rand(0, 360))
								particle:SetRollDelta(math.Rand(60, 120))
							end
						elseif skin == 2 then
							self.NextEmit = CurTime() + 0.05

							local emitter = self.Emitter
							local aa,bb = origowner:WorldSpaceAABB()
							local right = origowner:GetRight()
							local fwd = origowner:GetForward()
							for i=0, EFFECT_QUALITY * 4 do
								local particle = emitter:Add("effects/fire_cloud"..math.random(1,2), Vector(math.Rand(aa.x, bb.x), math.Rand(aa.y, bb.y), math.Rand(aa.z, bb.z)))
								particle:SetDieTime(math.Rand(0.6, 0.9))
								particle:SetGravity(fwd * -1600)
								if math.random(1, 2) == 1 then
									particle:SetVelocity(right * math.Rand(700, 1000))
								else
									particle:SetVelocity(right * math.Rand(-1000, -700))
								end
								particle:SetAirResistance(500)
								particle:SetStartAlpha(255)
								particle:SetEndAlpha(0)
								particle:SetStartSize(math.Rand(8, 16))
								particle:SetEndSize(8)
								particle:SetRoll(math.Rand(0, 360))
								particle:SetRollDelta(math.Rand(-100, 100))
							end

							local particle = emitter:Add("particle/smokestack", Vector(math.Rand(aa.x, bb.x), math.Rand(aa.y, bb.y), math.Rand(aa.z, bb.z)))
							particle:SetDieTime(math.Rand(3, 4.5))
							particle:SetVelocity(VectorRand():Normalize() * math.Rand(16, 32))
							particle:SetStartAlpha(math.Rand(130, 183))
							particle:SetEndAlpha(0)
							particle:SetStartSize(16)
							particle:SetEndSize(math.Rand(80, 160))
							particle:SetRoll(math.Rand(0, 360))
							particle:SetRollDelta(math.Rand(-4, 4))
							particle:SetColor(math.Rand(30, 40), math.Rand(30, 40), math.Rand(30, 40))

							for i=0, EFFECT_QUALITY * 2.5 do
								local particle = emitter:Add("sprites/glow04_noz", origowner:GetShootPos() + fwd * 24)
								particle:SetDieTime(0.4)
								particle:SetVelocity(VectorRand():Normalize() * 256 + fwd * -256)
								particle:SetStartAlpha(255)
								particle:SetEndAlpha(255)
								particle:SetStartSize(math.Rand(5, 7))
								particle:SetEndSize(0)
								particle:SetRoll(math.Rand(0, 360))
								particle:SetRollDelta(math.Rand(-45, 45))
							end
						end
					end
				end
			end
		end
	end
end
