include("shared.lua")

ENT.MaxTraceHUDPaintLength = 2048
ENT.TraceHUDPaint = GAMEMODE.GenericVehicleTraceHUDPaint
ENT.UseMyAngles = true

function ENT:Draw()
	self:DrawModel()
	if self.NextSmoke < RealTime() then
		self.NextSmoke = RealTime() + 0.04 * math.max(1, EFFECT_IQUALITY)

		if self:GetNetworkedBool("on") then
			local particle = self.Emitter:Add("particles/smokey", self:GetPos() + self:GetForward() * -88 + self:GetRight() * 26)
			particle:SetStartAlpha(200)
			particle:SetEndAlpha(30)
			particle:SetDieTime(math.Rand(1.5, 2))
			particle:SetStartSize(2)
			particle:SetEndSize(math.Rand(28, 42))
			particle:SetGravity(Vector(0, 0, 30))
			particle:SetCollide(true)
			particle:SetBounce(0.1)
			particle:SetVelocity(self:GetForward() * -16)
			if self:GetMaxVHealth() * 0.3 > self:VHealth() then
				particle:SetColor(25, 0, 0)
			else
				particle:SetColor(220, 220, 220)
			end
		end
	end
end

function ENT:Initialize()
	self.Emitter = ParticleEmitter(self:GetPos())
	self.NextSmoke = 0
	self.Pilot = NULL
	self.Gunner = NULL
end

function ENT:Think()
	self.Emitter:SetPos(self:GetPos())
end

function ENT:OnRemove()
	self.Emitter:Finish()
end

function ENT:DrawHUD(seat)
	if seat == self:GetNetworkedEntity("gunnerseat") then
		local cannon = self:GetNetworkedEntity("cannon")
		if cannon != NULL then
			local up = cannon:GetUp()
			up.z = math.Clamp(MySelf:GetAimVector().z, up.z - 0.6, up.z + 0.6)
			up = up:Normalize()
			local startpos = cannon:GetPos() + up * 48
			local pos = util.TraceLine({start=startpos, endpos = startpos + up * 4096, filter = ents.FindByClass("projectile_assaultrovercannon")}).HitPos:ToScreen()
			local x, y = pos.x, pos.y
			local w2 = w * 0.02
			local w22 = w2 * 0.75
			local w222 = w2 * 1.5
			surface.SetDrawColor(40, 255, 40, 200)
			surface.DrawLine(x - w222, y, x + w222, y)
			surface.DrawLine(x, y - w22, x, y + w22)

			surface.SetDrawColor(255, 0, 0, 180)
			surface.DrawOutlinedRect(x - w22, y - w22, w222, w222)
		end
	end

	local x, y = w * 0.5, h * 0.8
	draw.DrawTextShadow(self.Name, "noxnetnormal", x, y, COLOR_CYAN, color_black, TEXT_ALIGN_CENTER)
	local _, hhh = surface.GetTextSize("A")
	y = y + hhh * 1.2
	surface.SetDrawColor(255, 0, 0, 255)
	local health = self:VHealth()
	local maxhealth = self:GetMaxVHealth()
	surface.DrawRect(x - w * 0.1, y, (health / maxhealth) * w * 0.2, h * 0.04)
	surface.SetDrawColor(255, 255, 255, 255)
	surface.DrawOutlinedRect(x - w * 0.1, y, w * 0.2, h * 0.04)
	draw.SimpleTextShadow(health.." / "..maxhealth, "TargetIDSmall", x, y + hhh * 0.5, COLOR_CYAN, COLOR_BLUE, TEXT_ALIGN_CENTER)

	surface.SetFont("DefaultSmall")
	local lw, lh = surface.GetTextSize("Driver: ------------------------------------------")
	local x = w * 0.5
	local y = h * 0.89

	draw.RoundedBox(4, x - lw * 0.5, y - 4, lw, h * 0.11, color_black_alpha90)

	if self.Pilot:IsValid() then
		draw.DrawText("Driver: "..self.Pilot:Name(), "DefaultSmall", x, y, COLOR_RED, TEXT_ALIGN_CENTER)
		y = y + lh
	end
	if self.Gunner:IsValid() then
		draw.DrawText("Gunner: "..self.Gunner:Name(), "DefaultSmall", x, y, COLOR_RED, TEXT_ALIGN_CENTER)
		y = y + lh
	end
end

usermessage.Hook("RecARD", function(um)
	local ent = um:ReadEntity()

	if ent:IsValid() then
		ent.Pilot = um:ReadEntity() or NULL
		ent.Gunner = um:ReadEntity() or NULL
	end
end)

function RecARD(ent, pilot, gunner)
	ent = Entity(ent)
	if ent:IsValid() then
		pilot = Entity(pilot)
		gunner = Entity(gunner)

		if pilot:IsValid() then
			ent.Pilot = pilot
		end
		if gunner:IsValid() then
			ent.Gunner = gunner
		end
	end
end
