include("shared.lua")

ENT.MaxTraceHUDPaintLength = 2048
ENT.TraceHUDPaint = GAMEMODE.GenericVehicleTraceHUDPaint

function ENT:Draw()
	self:DrawModel()
end

function ENT:Initialize()
	self.AmbientSound = CreateSound(self, "ambient/machines/thumper_amb.wav")
end

function ENT:CalcViewFirstFunc(seat, ply, origin, angles, fov)
	return {origin = origin, angles = self:GetAngles()}
end

function ENT:Think()
	if self:GetSkin() ~= 1 then
		self.AmbientSound:Stop()
	elseif self:GetSkin() ~= 0 then
		self.AmbientSound:PlayEx(0.9, math.min(255, self:GetVelocity():Length() * 0.13 + 85))
	end
end

function ENT:OnRemove()
	self.AmbientSound:Stop()
end

function ENT:DrawHUD(seat)
	local x, y = w * 0.5, h * 0.8
	draw.DrawTextShadow(self.Name, "noxnetnormal", x, y, COLOR_CYAN, color_black, TEXT_ALIGN_CENTER)
	local _, hhh = surface.GetTextSize("A")
	y = y + hhh * 1.2
	surface.SetDrawColor(255, 0, 0, 255)
	local health = self:VHealth()
	local maxhealth = self:GetMaxVHealth()
	surface.DrawRect(x - w * 0.1, y, (health / maxhealth) * w * 0.2, h * 0.04)
	surface.SetDrawColor(255, 255, 255, 255)
	surface.DrawOutlinedRect(x - w * 0.1, y, w * 0.2, h * 0.04)
	draw.SimpleTextShadow(health.." / "..maxhealth, "TargetIDSmall", x, y + hhh * 0.5, COLOR_CYAN, COLOR_BLUE, TEXT_ALIGN_CENTER)
	local gun = self:GetNetworkedEntity("gun", NULL)
	if gun:IsValid() then
		local dir = self:GetForward()
		local aimvec = MySelf:GetAimVector()
		dir.z = math.Clamp(aimvec.z, dir.z - 0.25, dir.z + 0.25)
		dir = dir:Normalize()
		local startpos = gun:GetPos()
		local filt = ents.FindByClass("projectile_plasmabolt")
		table.insert(filt, gun)
		local pos = util.TraceLine({start=startpos, endpos = startpos + dir * 4096, filter = filt}).HitPos:ToScreen()
		local x, y = pos.x, pos.y
		surface.SetDrawColor(255, 0, 0, 200)
		surface.DrawLine(x - 48, y, x + 48, y)
		surface.DrawLine(x, y - 48, x, y + 48)
		surface.SetDrawColor(255, 255, 255, 200)
		surface.DrawOutlinedRect(x - 48, y - 48, 96, 96)

		local pos = (startpos + aimvec * 4096):ToScreen()
		local x, y = pos.x, pos.y
		surface.SetDrawColor(255, 230, 0, 200)
		surface.DrawLine(x - 48, y, x + 48, y)
		surface.DrawLine(x, y - 48, x, y + 48)
	end
end
