SWEP.Base = "weapon_magic_base"

SWEP.HoldType = "melee2"

if SERVER then
	AddCSLuaFile("shared.lua")

	function SWEP:Deploy()
		local owner = self.Owner
		owner:DrawViewModel(false)
		owner:RemoveStatus("weapon_*", false, true)
		owner:GiveStatus("weapon_apprenticestaff")
	end

	function SWEP:PreCastedCallback(pl, spellid, spelltab)
		self.PreCastedSpell = spellid
		self.Fizzle = CurTime() + 15

		self:EmitSound("nox/tagon.wav")

		local wepstat = pl.WeaponStatus
		if wepstat and wepstat:IsValid() then
			wepstat:SetSkin(1)
		end
	end

	function SWEP:CastedCallback(pl, spellid, spelltab)
		self.Fizzle = nil
		self.PreCastedSpell = nil

		local wepstat = pl.WeaponStatus
		if wepstat and wepstat:IsValid() then
			wepstat:SetSkin(0)
		end
	end

	function SWEP:Think(name, activator, caller, args)
		if self.Fizzle and self.Fizzle <= CurTime() then
			self.Fizzle = nil
			self.PreCastedSpell = nil

			local pl = self.Owner

			pl:EmitSound("nox/tagoff.wav")

			local wepstat = pl.WeaponStatus
			if wepstat and wepstat:IsValid() then
				wepstat:SetSkin(0)
			end
		end
	end

	function SWEP:Holster()
		if self.Owner:CanSwitchWeapon() then
			self.Owner:RemoveStatus("weapon_apprenticestaff", false, true)
			if self.PreCastedSpell then
				self.Fizzle = nil
				self.PreCastedSpell = nil
			end
			return true
		end

		return false
	end
end

if CLIENT then
	SWEP.PrintName = "Apprentice Staff"
	SWEP.Author = "JetBoom"

	SWEP.DrawWorldModel = function() end
	SWEP.DrawWorldModelTranslucent = SWEP.DrawWorldModel
end

SWEP.PreCast = true

SWEP.ViewModel = "models/weapons/v_stunbaton.mdl"
SWEP.WorldModel = "models/weapons/w_stunbaton.mdl"

RegisterLuaAnimation("staffholdspell", {
	FrameData = {
		{
			BoneInfo = {
				["ValveBiped.Bip01_R_Forearm"] = {
					RU = 40,
					RF = -40
				},
				["ValveBiped.Bip01_R_Upperarm"] = {
					RU = 40
				},
				["ValveBiped.Bip01_R_Hand"] = {
					RU = -40
				},
				["ValveBiped.Bip01_L_Forearm"] = {
					RU = 40
				},
				["ValveBiped.Bip01_L_Hand"] = {
					RU = -40
				}
			},
			FrameRate = 6
		},
		{
			BoneInfo = {
				["ValveBiped.Bip01_R_Forearm"] = {
					RU = 2,
				},
				["ValveBiped.Bip01_R_Upperarm"] = {
					RU = 1
				},
				["ValveBiped.Bip01_R_Hand"] = {
					RU = -10
				},
				["ValveBiped.Bip01_L_Forearm"] = {
					RU = 8
				},
				["ValveBiped.Bip01_L_Hand"] = {
					RU = -12
				}
			},
			FrameRate = 0.4
		},
		{
			BoneInfo = {
				["ValveBiped.Bip01_R_Forearm"] = {
					RU = -2,
				},
				["ValveBiped.Bip01_R_Upperarm"] = {
					RU = -1
				},
				["ValveBiped.Bip01_R_Hand"] = {
					RU = 10
				},
				["ValveBiped.Bip01_L_Forearm"] = {
					RU = -8
				},
				["ValveBiped.Bip01_L_Hand"] = {
					RU = 12
				}
			},
			FrameRate = 0.1
		}
	},
	RestartFrame = 2,
	Type = TYPE_STANCE,
	ShouldPlay = function(pl, sGestureName, tGestureTable, iCurFrame, tFrameData)
		local wepstatus = pl.WeaponStatus
		return wepstatus and wepstatus:IsValid() and wepstatus:GetSkin() == 1 and wepstatus.IsStaff
	end
})
