AddCSLuaFile("cl_init.lua")
AddCSLuaFile("shared.lua")

include("shared.lua")

SWEP.Weight = 5
SWEP.AutoSwitchTo = false
SWEP.AutoSwitchFrom = false
SWEP.NextBuild = 0

function SWEP:Deploy()
	local owner = self.Owner
	owner:DrawViewModel(true)
	owner.BACKTOBUILDERWEP = self:GetClass()
	if not owner:HasWeapon("weapon_physgun") then
		owner:Give("weapon_physgun")
	end

	return true
end

function SWEP:Think()
	local attacker = self.Owner
	local ray = attacker.BuilderRay
	if not (ray and ray:IsValid()) or CurTime() < self.NextBuild then return end
	self.NextBuild = CurTime() + 0.2

	if not attacker:KeyDown(IN_ATTACK) then
		attacker:RemoveStatus("builderray*", false, true)
		return
	end

	local ent = NULL

	local trace = attacker:TraceLine(self.RayLength, MASK_SHOT)

	if trace.HitNonWorld then
		ent = trace.Entity
	end

	if ent:IsValid() and trace.HitPos:Distance(trace.StartPos) <= self.RayLength then
		if ent:GetClass() == "ffdoor" then
			ent = ent:GetParent()
		end

		local myteam = attacker:Team()

		if ent.ScriptVehicle and ent:Team() == myteam then
			GAMEMODE:RepairVehicle(attacker, ent, self.RepairRate * attacker.BuildingRateMultiplier)
		elseif ent.VehicleParent and ent.VehicleParent:IsValid() and ent.VehicleParent.ScriptVehicle and ent.VehicleParent:Team() == myteam then
			GAMEMODE:RepairVehicle(attacker, ent.VehicleParent, self.RepairRate * attacker.BuildingRateMultiplier)
		elseif ent.PHealth and ent:GetTeamID() == myteam then
			if ent.Destroyed then
				if not ent:IsPlayerHolding() and GAMEMODE:RepairProp(attacker, ent, self.BuildRate * attacker.BuildingRateMultiplier) then
					GAMEMODE:StartAutoBuilding()
					ent.NoAutoBuildTime = CurTime() + 0.5
				end
			else
				GAMEMODE:RepairProp(attacker, ent, self.RepairRate * attacker.BuildingRateMultiplier)
			end
		end
	end
end

function SWEP:PrimaryAttack()
	if self:CanPrimaryAttack() then
		self:SetNextPrimaryFire(CurTime() + self.Primary.Delay)

		local owner = self.Owner

		self:SendWeaponAnim(ACT_VM_PRIMARYATTACK)
		owner:DoAttackEvent()

		owner:GiveStatus(self.BuilderRayEntity)

		if owner.Sprinting then
			owner:RemoveStatus("sprint", false, true)
		end
		if owner.DashDodging then
			owner:RemoveStatus("dashdodge*", false, true)
		end
	end
end

function SWEP:Reload()
end

function SWEP:SecondaryAttack()
end
