AddCSLuaFile("cl_init.lua")
AddCSLuaFile("shared.lua")

include("shared.lua")

SWEP.Weight = 5
SWEP.AutoSwitchTo = false
SWEP.AutoSwitchFrom = false

SWEP.HoldType = "melee2"

function SWEP:Deploy()
	local owner = self.Owner
	owner:DrawViewModel(false)
	owner:RemoveStatus("weapon_*", false, true)
	owner:GiveStatus("weapon_frotchet")

	return true
end

function SWEP:Clashed(pl, wep)
	self.FinishSwing = nil
	local owner = self.Owner
	owner.LastAttacked = CurTime()
	owner.LastAttacker = pl
	owner:SetGroundEntity(NULL)
	local norm = owner:GetPos() - pl:GetPos()
	norm.z = 0
	norm = norm:Normalize()
	owner:SetVelocity(norm * 400 + Vector(0,0,210))

	local effectdata = EffectData()
		effectdata:SetOrigin(owner:GetShootPos())
		effectdata:SetEntity(owner)
	util.Effect("meleeclash", effectdata, true, true)
end

function SWEP:Think()
	local ct = CurTime()
	local owner = self.Owner

	if self.FinishSwing and self.FinishSwing <= ct then
		self.FinishSwing = nil
		local eyepos = owner:GetShootPos()
		local aimvec = owner:GetAimVector()
		local ownerteam = owner:Team()
		local chargeattack = self.DoChargeAttack
		self.DoChargeAttack = nil

		if chargeattack then
			self:ActivityToMelee2()
			local wepstat = owner.WeaponStatus
			if wepstat and wepstat:IsValid() then
				wepstat:SetSkin(0)
			end
		end

		local hit
		local effectpos

		local endpos = eyepos + aimvec * 30
		for _, ent in pairs(ents.FindInSphere(endpos, 40)) do
			if ent.PHealth or ent.CoreHealth or ent.ScriptVehicle then
				if MeleeVisible(ent:NearestPoint(eyepos), eyepos, {ent, owner}) then
					effectpos = ent:NearestPoint(eyepos)
					if chargeattack then
						ent:TakeSpecialDamage(45 * owner.MeleeDamageMultiplier, DMGTYPE_ICE, owner, self)
					else
						ent:TakeSpecialDamage(39 * owner.MeleeDamageMultiplier, DMGTYPE_PHYSICAL, owner, self)
					end
					hit = true
				end
			elseif ent ~= owner and ent:IsPlayer() then
				if ent:IsPlayer() then
					local nearest = ent:NearestPoint(eyepos)
					if ent:Alive() and TrueVisible(nearest, eyepos) then
						if ent:Team() ~= owner:Team() then
							hit = true
							local wep = ent:GetActiveWeapon()
							if chargeattack then
								ent:BloodSpray(nearest, math.random(12, 15), owner:GetAimVector(), 290)
								ent:HitByMelee(owner, self)
								effectpos = ent:NearestPoint(eyepos)
								ent:SetGroundEntity(NULL)
								ent:SetLocalVelocity((nearest - eyepos):Normalize() * 400 + Vector(0,0,350))
								ent:KnockDown()
								ent:TakeSpecialDamage(39 * owner.MeleeDamageMultiplier, DMGTYPE_ICE, owner, self)
							elseif wep.CanGuard and wep:CanGuard(owner, self) then
								wep:Guarded(owner, self)
							elseif wep.CanClash and wep:CanClash(owner, self) then
								wep:Clashed(owner, self)
								if self.Clashed then
									self:Clashed(wep.Owner, wep)
								end
							else
								ent:BloodSpray(nearest, math.random(10, 12), owner:GetAimVector(), 290)
								ent:HitByMelee(owner, self)
								effectpos = ent:NearestPoint(eyepos)
								ent:TakeSpecialDamage(39 * owner.MeleeDamageMultiplier, DMGTYPE_PHYSICAL, owner, self)
							end
						end
					end
				elseif TrueVisible(ent:NearestPoint(eyepos), eyepos) then
					hit = true
					if chargeattack then
						ent:TakeSpecialDamage(39 * owner.MeleeDamageMultiplier, DMGTYPE_ICE, owner, self)
					else
						ent:TakeSpecialDamage(39 * owner.MeleeDamageMultiplier, DMGTYPE_PHYSICAL, owner, self)
					end
					effectpos = ent:NearestPoint(eyepos)
				end
			end
		end

		if not hit then
			local tr = util.TraceLine({start = eyepos, endpos = eyepos + aimvec * 75, mask = MASK_PLAYERSOLID, filter = owner})
			if tr.Hit then
				effectpos = tr.HitPos
				if chargeattack then
					local mv = 0
					if tr.Entity and tr.Entity:IsValid() then
						mv = tr.Entity:GetMoveType()
					end
					if (owner.NoJump and CurTime() <= owner.NoJump or not owner:IsOnGround()) and (tr.HitWorld or mv == MOVETYPE_NONE or mv == MOVETYPE_PUSH or mv == MOVETYPE_STEP) and 0.7 < tr.HitNormal.z then
						timer.Simple(0, spells.Protrusion, owner, true)
					end
				end
			end
		end

		if effectpos then
			local effectdata = EffectData()
				effectdata:SetOrigin(effectpos)
				effectdata:SetStart(eyepos)
			util.Effect("meleehit", effectdata, true, true)
			if chargeattack then
				util.Effect("scatterfrostexplode", effectdata, true, true)
				util.ScreenShake(effectpos, 34, 1, 0.75, 100)
			else
				util.ScreenShake(effectpos, 28, 1, 0.75, 72)
			end
		end
	elseif self.Charging then
		local owner = self.Owner
		if self.Charging <= ct then
			self.Charging = nil
			self.FinishSwing = CurTime() + 0.15
			self.DoChargeAttack = true
			owner:SetNextAttack(CurTime() + 0.8)
			owner:DoAttackEvent()
			owner:EmitSound("nox/sword_miss.wav", 78, math.Rand(55, 60))
		elseif not owner:KeyDown(IN_ATTACK2) and not owner:KeyDown(IN_ATTACK) then
			self.Charging = nil

			self:ActivityToMelee2()

			local wepstat = owner.WeaponStatus
			if wepstat and wepstat:IsValid() then
				wepstat:SetSkin(0)
			end
		end
	end

	self:NextThink(ct)
	return true
end

function SWEP:HitByMelee(attacker, attackerweapon)
	self.FinishSwing = nil
	self.JumpAttackStart = nil
	self.JumpAttackEnd = nil
	self.JumpAttackRecovery = nil
	self.Owner:SetNextAttack(CurTime() + 0.8)
	if self.Charging or self.DoChargeAttack then
		self.Charging = nil
		self.DoChargeAttack = nil
		self:ActivityToMelee2()

		local wepstat = self.Owner.WeaponStatus
		if wepstat and wepstat:IsValid() then
			wepstat:SetSkin(0)
		end
	end
end

function SWEP:PrimaryAttack()
	local owner = self.Owner
	if CurTime() <= owner:GetNextAttack() or (owner.Stunned and not self.JumpAttackRecovery) or self.Charging or self.JumpAttackStart or self.JumpAttackEnd then return end

	if owner.Sprinting then
		owner:RemoveStatus("sprint", false, true)
	end

	if owner.DashDodging then
		owner:RemoveStatus("dashdodge*", false, true)
	end

	owner:EmitSound("nox/sword_miss.wav", 77, math.Rand(40, 45))
	owner:DoAttackEvent()

	owner:SetNextAttack(CurTime() + 0.8)
	self.FinishSwing = CurTime() + 0.15
end

function SWEP:Move(move)
	if self.JumpAttackStart then
		move:SetForwardSpeed(0)
		move:SetSideSpeed(0)
		move:SetVelocity(Vector(0,0,0))
		if self.JumpAttackStart <= CurTime() then
			self.JumpAttackStart = nil
			self.JumpAttackEnd = CurTime() + 0.6
		end
	elseif self.JumpAttackEnd then
		move:SetForwardSpeed(0)
		move:SetSideSpeed(0)
		move:SetVelocity(Vector(0,0,-800))
		if self.Owner:IsOnGround() or self.JumpAttackEnd <= CurTime() then
			self.JumpAttackEnd = nil
			self.DoJumpAttack = true
		end
	elseif self.Charging then
		move:SetForwardSpeed(move:GetForwardSpeed() * 0.6)
		move:SetSideSpeed(move:GetSideSpeed() * 0.6)
	end
end

function SWEP:SecondaryAttack()
	local owner = self.Owner
	if CurTime() <= owner:GetNextAttack() or owner.Stunned or owner.Charging or owner.FinishSwing or self.JumpAttackStart or self.JumpAttackEnd then return end
	owner:SetNextAttack(CurTime() + 0.1)
	self.Charging = CurTime() + 0.3

	if owner.Sprinting then
		owner:RemoveStatus("sprint", false, true)
	end

	if owner.DashDodging then
		owner:RemoveStatus("dashdodge*", false, true)
	end

	if owner.WallRunning then
		owner:RemoveStatus("wallrun*", false, true)
	end

	self:ActivityToMelee()

	local wepstat = owner.WeaponStatus
	if wepstat and wepstat:IsValid() then
		wepstat:SetSkin(1)
	end

	if owner.Invisible then
		DeInvisible(owner)
	end
end

function SWEP:Reload()
end
