include("shared.lua")

SWEP.PrintName = "Gladradus"
SWEP.DrawAmmo = false
SWEP.DrawCrosshair = true

killicon.Add("weapon_gladradus", "spellicons/sword", color_white)
killicon.AddAlias("projectile_gladraduscharge", "weapon_gladradus")

function SWEP:DrawWeaponSelection(x, y, wide, tall, alpha)
	draw.SimpleText(self.PrintName, "DefaultBold", x + wide * 0.5, y + tall * 0.5, color_white, TEXT_ALIGN_CENTER, TEXT_ALIGN_CENTER)
end

function SWEP:Think()
	local ct = CurTime()

	if self.FinishSwing and self.FinishSwing <= ct then
		self.FinishSwing = nil
	end

	self:NextThink(ct)
	return true
end

function SWEP:Move(pl, move)
	local wepstat = pl.WeaponStatus
	if wepstat and wepstat:IsValid() then
		local skin = wepstat:GetSkin()
		if skin == 1 then
			move:SetForwardSpeed(move:GetForwardSpeed() * 0.6)
			move:SetSideSpeed(move:GetSideSpeed() * 0.6)
		elseif skin == 2 then
			move:SetForwardSpeed(0)
			move:SetSideSpeed(0)
		elseif skin == 3 then
			move:SetVelocity(Vector(0,0,-1000))
		end
	end
end

function SWEP:PrimaryAttack()
	local owner = self.Owner
	if CurTime() <= owner:GetNextAttack() then return end
	owner:SetNextAttack(CurTime() + 0.5)
	self.FinishSwing = CurTime() + 0.1

	owner:RestartGesture(ACT_HL2MP_GESTURE_RANGE_ATTACK_MELEE)
end

function SWEP:Reload()
end

SWEP.DrawWorldModel = SWEP.Reload
SWEP.DrawWorldModelTranslucent = SWEP.Reload

function SWEP:Deploy()
	return true
end

--[[RegisterLuaAnimation("gladradusslam", {
	TimeToArrive = 0.25,
	FrameData = {
		{
			BoneInfo = {
				["ValveBiped.Bip01_R_Forearm"] = {
					RU = 0
				},
				["ValveBiped.Bip01_R_Upperarm"] = {
					RU = 0
				},
				["ValveBiped.Bip01_L_Forearm"] = {
					RU = 0
				},
				["ValveBiped.Bip01_L_Upperarm"] = {
					RU = 0
				}
			}
		}
	},
	Type = TYPE_POSTURE,
	ShouldPlay = function(pl, sGestureName, tGestureTable, iCurFrame, tFrameData)
		local wep = pl:GetActiveWeapon()
		return wep:IsValid() and wep:GetClass() == "weapon_gladradus" and wep:GetSkin() == 3
	end
})]]
