include("shared.lua")

SWEP.PrintName = "Scripted Weapon"
SWEP.DrawAmmo = true
SWEP.DrawCrosshair = true
SWEP.NextNoMana = 0

SWEP.DisplayAmmo = 16

function SWEP:ShootBullet(damage, num_bullets, mana)
	--local owner = self.Owner
	--owner:SetMana(owner:GetMana() - mana * owner.GunManaUseMultiplier)
end

function SWEP:CanPrimaryAttack()
	local owner = self.Owner
	if owner.Stunned or self.IsReloading then return end

	if self:Clip1() <= 0 then
		if owner:GetNextAttack() <= CurTime() then
			self:EmitSound(self.Primary.EmptySound)
			owner:SetNextAttack(CurTime() + 0.25)
		end
		return false
	end

	return owner:GetNextAttack() <= CurTime()
end

function SWEP:CanSecondaryAttack()
	local owner = self.Owner
	if owner.Stunned or self.IsReloading then return end

	if self:Clip1() <= 0 then
		if owner:GetNextAttack() <= CurTime() then
			self:EmitSound(self.Secondary.EmptySound)
			owner:SetNextAttack(CurTime() + 0.25)
		end
		return false
	end

	return owner:GetNextAttack() <= CurTime()
end

function SWEP:DrawWeaponSelection(x, y, wide, tall, alpha)
	draw.SimpleText(self.PrintName, "DefaultBold", x + wide * 0.5, y + tall * 0.5, color_white, TEXT_ALIGN_CENTER, TEXT_ALIGN_CENTER)
end

function SWEP:PrimaryAttack()
	if self:CanPrimaryAttack() then
		if self.IsReloading then
			self.IsReloading = nil
		end

		local ct = CurTime()
		self:SetLastPrimaryFire(ct)
		self:SetNextPrimaryFire(ct + self.Primary.Delay * self.Owner.RateOfFireMultiplier)
		self:SetNextSecondaryFire(self:GetNextPrimaryFire())
		self:SetNextReload(self:GetNextPrimaryFire())

		self:EmitSound(self.Primary.Sound)
		--[[if self.Primary.Gesture then
			self.Owner:RestartGesture(self.Primary.Gesture)
		end]]
		--self.Owner:DoAttackEvent()
		self:TakePrimaryAmmo(1)
		self:ShootEffects(ACT_VM_PRIMARYATTACK, self.Primary.Gesture)
		self:ShootBullet(self.Primary.Damage, self.Primary.NumShots, self.Primary.Mana)
	end
end

function SWEP:SecondaryAttack()
	if self.HasSecondary and self:CanSecondaryAttack() then
		if self.IsReloading then
			self.IsReloading = nil
		end

		local ct = CurTime()
		self:SetLastPrimaryFire(ct)
		self:SetNextPrimaryFire(ct + self.Secondary.Delay * self.Owner.RateOfFireMultiplier)
		self:SetNextSecondaryFire(self:GetNextPrimaryFire())
		self:SetNextReload(self:GetNextPrimaryFire())

		self:EmitSound(self.Secondary.Sound)
		--[[if self.Secondary.Gesture then
			self.Owner:RestartGesture(self.Secondary.Gesture)
		end]]
		--self:DoAttackEvent()
		self:TakePrimaryAmmo(1)
		self:ShootEffects(ACT_VM_PRIMARYATTACK, self.Secondary.Gesture)
		self:ShootBullet(self.Secondary.Damage, self.Secondary.NumShots, self.Secondary.Mana, true)
	end
end

function SWEP:FreezeMovement()
	return false
end

function SWEP:DrawHUD()
	if not self.Owner:InVehicle() then
		local screenscale = BetterScreenScale() * 0.5 + 0.5
		GAMEMODE:DrawAmmoCount(w * GetConVarNumber("nox_hud_ammo_x"), h * GetConVarNumber("nox_hud_ammo_y"), self:Clip1(), self.Primary.ClipSize, self.DisplayAmmo, screenscale)
	end
end

function SWEP:ViewModelDrawn()
end

function SWEP:OnRestore()
end

function SWEP:CustomAmmoDisplay()
end
