AddCSLuaFile("cl_init.lua")
AddCSLuaFile("shared.lua")

include("shared.lua")

--SWEP.NextSendMana = 0
SWEP.CurrentRecoil = 1
SWEP.CurrentRecoilSecondary = 1

function SWEP:CanPrimaryAttack()
	local owner = self.Owner
	if owner.Stunned or self.IsReloading then return end

	--[[if owner:GetMana() < self.Primary.Mana * owner.GunManaUseMultiplier then
		self:SetNextPrimaryFire(CurTime() + 0.25)
		return false
	end]]

	if self:Clip1() <= 0 then
		if owner:GetNextAttack() <= CurTime() then
			self:EmitSound(self.Primary.EmptySound)
			owner:SetNextAttack(CurTime() + 0.25)
		end
		return false
	end

	return owner:GetNextAttack() <= CurTime()
end

function SWEP:HitByMelee(attacker, attackerweapon)
	local owner = self.Owner
	self:SetNextPrimaryFire(math.max(self:GetNextPrimaryFire(), CurTime() + math.max(self.Primary.Delay * owner.RateOfFireMultiplier, 0.5)))
	self:SetNextSecondaryFire(math.max(self:GetNextSecondaryFire(), CurTime() + math.max(self.Secondary.Delay * owner.RateOfFireMultiplier, 0.5)))
	owner:SetNextAttack(math.max(owner:GetNextAttack(), self:GetNextPrimaryFire()))
	if self.IsReloading then
		self:SendWeaponAnim(ACT_VM_IDLE)
		self.IsReloading = nil
		self:SetNextReload(0)
	end
end

function SWEP:CanSecondaryAttack()
	local owner = self.Owner
	if owner.Stunned or self.IsReloading then return end

	--[[if owner:GetMana() < self.Secondary.Mana * owner.GunManaUseMultiplier then
		self:SetNextPrimaryFire(CurTime() + 0.25)
		return false
	end]]

	if self:Clip1() <= 0 then
		if self:GetNextSecondaryFire() <= CurTime() then
			self:EmitSound(self.Secondary.EmptySound)
			self:SetNextSecondaryFire(CurTime() + 0.25)
		end
		return false
	end

	return owner:GetNextAttack() <= CurTime()
end

function SWEP:TranslateActivity(act)
	return self.ActivityTranslate[act] or -1
end

function SWEP:ShootBullet(damage, num_bullets, mana, issec)
	local owner = self.Owner
	--[[if self.NextSendMana < CurTime() then
		owner:SetMana(owner:GetMana() - mana * owner.GunManaUseMultiplier, true)
		self.NextSendMana = CurTime() + 1
	else
		owner:SetMana(owner:GetMana() - mana * owner.GunManaUseMultiplier)
	end]]

	if owner.Sprinting then
		owner:RemoveStatus("sprint", false, true)
	end

	if owner.DashDodging then
		owner:RemoveStatus("dashdodge*", false, true)
	end

	local r,g,b,a = owner:GetColor()

	local offsetpos = owner:GetShootPos() + owner:GetAimVector() * 2048

	if num_bullets == 1 then
		local bullet
		if issec then
			bullet = ents.Create(self.Secondary.BulletEntity)
		else
			bullet = ents.Create(self.Primary.BulletEntity)
		end
		if bullet:IsValid() then
			bullet:SetPos(owner:GetShootPos())

			local ang = owner:EyeAngles()
			if issec then
				ang:RotateAroundAxis(ang:Up(), self.Secondary.Offsets[self.CurrentRecoilSecondary].x * owner.AccuracyMultiplier)
				ang:RotateAroundAxis(ang:Right(), self.Secondary.Offsets[self.CurrentRecoilSecondary].y * owner.AccuracyMultiplier)
			else
				ang:RotateAroundAxis(ang:Up(), self.Primary.Offsets[self.CurrentRecoil].x * owner.AccuracyMultiplier)
				ang:RotateAroundAxis(ang:Right(), self.Primary.Offsets[self.CurrentRecoil].y * owner.AccuracyMultiplier)
			end
			local fwd = ang:Forward()
			bullet:SetAngles(ang)
			bullet:SetOwner(owner)
			bullet:SetColor(r, g, b, 255)
			bullet:Spawn()
			bullet:SetTeamID(owner:Team())
			bullet.Heading = fwd
			bullet.Attacker = owner
			bullet.Inflictor = self
			bullet.BulletSpeed = self.BulletSpeed
			bullet.Damage = damage
			bullet:GetPhysicsObject():SetVelocityInstantaneous(fwd * self.BulletSpeed)

			if issec then
				self.CurrentRecoilSecondary = self.CurrentRecoilSecondary + 1
				if self.Secondary.NumOffsets < self.CurrentRecoilSecondary then
					self.CurrentRecoilSecondary = 1
				end
			else
				self.CurrentRecoil = self.CurrentRecoil + 1
				if self.Primary.NumOffsets < self.CurrentRecoil then
					self.CurrentRecoil = 1
				end
			end
		end
	else
		local getoffsets = self:GetSpreadOffsets(damage, num_bullets, aimcone, mana, issec)

		local originalang = owner:EyeAngles()
		local pos = owner:GetShootPos()

		local bullettyp
		if issec then
			bullettyp = self.Secondary.BulletEntity
		else
			bullettyp = self.Primary.BulletEntity
		end

		for i=1, num_bullets do
			local bullet = ents.Create(bullettyp)
			if bullet:IsValid() then
				bullet:SetPos(pos)
				local ang = Angle(originalang.p, originalang.y, originalang.r)
				ang:RotateAroundAxis(ang:Up(), getoffsets[i].x * owner.AccuracyMultiplier)
				ang:RotateAroundAxis(ang:Right(), getoffsets[i].y * owner.AccuracyMultiplier)
				local fwd = ang:Forward()
				bullet.Heading = fwd
				bullet:SetAngles(ang)
				bullet:SetOwner(owner)
				bullet:SetColor(r, g, b, 255)
				bullet.Attacker = owner
				bullet.Inflictor = self
				bullet.BulletSpeed = self.BulletSpeed
				bullet:Spawn()
				bullet:SetTeamID(owner:Team())
				bullet.Damage = damage
				bullet:GetPhysicsObject():SetVelocityInstantaneous(fwd * self.BulletSpeed)
			end
		end
	end
end

function SWEP:PrimaryAttack()
	if self:CanPrimaryAttack() then
		if self.IsReloading then
			self.IsReloading = nil
		end

		local ct = CurTime()
		local owner = self.Owner
		self:SetLastPrimaryFire(ct)
		self:SetNextPrimaryFire(ct + self.Primary.Delay * owner.RateOfFireMultiplier)
		self:SetNextSecondaryFire(self:GetNextPrimaryFire())
		self:SetNextReload(self:GetNextPrimaryFire())
		owner:SetNextAttack(self:GetNextPrimaryFire())

		owner.CantDodgeTime = math.max(owner.CantDodgeTime or 0, ct + 0.35)
		owner.CantSprintTime = math.max(owner.CantSprintTime or 0, ct + 0.35)

		self:EmitSound(self.Primary.Sound)
		if self.Primary.Gesture then
			owner:RestartGesture(self.Primary.Gesture)
		end
		self:TakePrimaryAmmo(1)
		self:ShootEffects(ACT_VM_PRIMARYATTACK, self.Primary.Gesture)
		self:ShootBullet(self.Primary.Damage, self.Primary.NumShots, self.Primary.Mana)
	end
end

function SWEP:SecondaryAttack()
	if self.HasSecondary and self:CanSecondaryAttack() then
		if self.IsReloading then
			self.IsReloading = nil
		end

		local ct = CurTime()
		local owner = self.Owner
		self:SetLastPrimaryFire(ct)
		self:SetNextPrimaryFire(ct + self.Secondary.Delay * owner.RateOfFireMultiplier)
		self:SetNextSecondaryFire(ct + self.Secondary.Delay)
		self:SetNextReload(self:GetNextPrimaryFire())
		owner:SetNextAttack(self:GetNextPrimaryFire())
		owner.CantDodgeTime = math.max(owner.CantDodgeTime or 0, ct + 0.35)
		owner.CantSprintTime = math.max(owner.CantSprintTime or 0, ct + 0.35)

		self:EmitSound(self.Secondary.Sound)
		if self.Secondary.Gesture then
			owner:RestartGesture(self.Secondary.Gesture)
		end
		self:TakePrimaryAmmo(1)
		self:ShootEffects(ACT_VM_PRIMARYATTACK, self.Secondary.Gesture)
		self:ShootBullet(self.Secondary.Damage, self.Secondary.NumShots, self.Secondary.Mana, true)
	end
end
