SWEP.ViewModelFOV = 62
SWEP.ViewModel = "models/weapons/v_pistol.mdl"
SWEP.WorldModel = "models/weapons/w_357.mdl"

SWEP.BulletSpeed = 3500

SWEP.Primary.Automatic = true
SWEP.Primary.Mana = 1
SWEP.Primary.Damage = 15
SWEP.Primary.Delay = 0.1
SWEP.Primary.Sound = Sound("Weapon_Pistol.NPC_Single")
SWEP.Primary.NumShots = 1
SWEP.Primary.Offsets = {Vector(0,0,0)}
SWEP.Primary.NumOffsets = #SWEP.Primary.Offsets
SWEP.Primary.BulletEntity = "projectile_bullet"
SWEP.Primary.ClipSize = 16
SWEP.Primary.DefaultClip = SWEP.Primary.ClipSize
SWEP.Primary.EmptySound = "Weapon_Pistol.Empty"

SWEP.Secondary.Automatic = SWEP.Primary.Automatic
SWEP.Secondary.Delay = SWEP.Primary.Delay
SWEP.Secondary.Damage = SWEP.Primary.Damage
SWEP.Secondary.Sound = SWEP.Primary.Sound
SWEP.Secondary.NumShots = SWEP.Primary.NumShots
SWEP.Secondary.Offsets = SWEP.Primary.Offsets
SWEP.Secondary.NumOffsets = #SWEP.Secondary.Offsets
SWEP.Secondary.BulletEntity = SWEP.Primary.BulletEntity
SWEP.Secondary.ClipSize = 1
SWEP.Secondary.DefaultClip = 1
SWEP.Secondary.Automatic = SWEP.Primary.Ammo
SWEP.Secondary.Ammo = SWEP.Primary.Ammo
SWEP.Secondary.EmptySound = SWEP.Primary.EmptySound

SWEP.SpeedWhileShooting = 0.85
SWEP.EndShootingDelay = 0.5

function SWEP:CanSprint(pl)
	return not pl:KeyDown(IN_ATTACK) and not self.IsReloading
end
SWEP.CanWallRun = SWEP.CanSprint
SWEP.CanWallJump = SWEP.CanSprint
SWEP.CanDodge = SWEP.CanSprint

function SWEP:Move(move)
	if CurTime() < self:GetLastPrimaryFire() + self.EndShootingDelay * self.Owner.RateOfFireMultiplier then
		move:SetForwardSpeed(move:GetForwardSpeed() * self.SpeedWhileShooting)
		move:SetSideSpeed(move:GetSideSpeed() * self.SpeedWhileShooting)

		--[[if not pl.VelocityRecovery and not pl:IsOnGround() then
			local vel = move:GetVelocity()
			local z = vel.z
			vel.z = 0
			vel = math.min(pl:GetMaxSpeed() * self.SpeedWhileShooting, vel:Length()) * vel:Normalize()
			vel.z = z
			move:SetVelocity(vel)
		end]]
	end
end

function SWEP:Reload()
	local owner = self.Owner
	if self:GetNextReload() <= CurTime() and self:CanSprint(owner) and self:Clip1() < self.Primary.ClipSize then
		if owner:GetMana() < self.Primary.Mana * owner.GunManaUseMultiplier then
			if CLIENT then
				insma()
			end
			self:SetNextReload(CurTime() + 0.33)
			return
		end

		--self:SendWeaponAnim(ACT_VM_RELOAD)
		owner:DoReloadEvent()
		local endtime = CurTime() + self:SequenceDuration()
		self.IsReloading = endtime
		self:SetNextReload(endtime)
		if self.ReloadSound then
			self:EmitSound(self.ReloadSound)
		end

		if owner.Sprinting then
			owner:RemoveStatus("sprint", false, true)
		end
		if owner.WallRunning then
			owner:RemoveStatus("wallrun*", false, true)
		end
		if owner.DashDodging then
			owner:RemoveStatus("dashdodge*", false, true)
		end
	end
end

function SWEP:TakePrimaryAmmo(num)
	self:SetClip1(math.max(0, self:Clip1() - num))
end

function SWEP:Think()
	if self.IsReloading and self.IsReloading <= CurTime() then
		local curammo = self:Clip1()
		local owner = self.Owner
		local manaperbullet = self.Primary.Mana * owner.GunManaUseMultiplier
		local curmana = owner:GetMana()
		if not self.ReloadSingle then
			local bulletstogive = math.min(self.Primary.ClipSize - curammo, math.floor(curmana / manaperbullet))

			self:SetClip1(curammo + bulletstogive)
			owner:SetMana(curmana - bulletstogive * manaperbullet)
			self:EmitSound("nox/manadraining.wav", 69, math.Rand(100, 110))
			--self:SetClip1(self.Primary.ClipSize)
			--self:SetClip2(self.Secondary.ClipSize)

			self.IsReloading = nil
			self:SendWeaponAnim(ACT_VM_IDLE)
		elseif self.Primary.ClipSize <= curammo or curmana < manaperbullet then
			self.IsReloading = nil
			if self.ReloadFinishAnim then
				self:SendWeaponAnim(self.ReloadFinishAnim)
			end
			if self.ReloadFinishSound then
				self:EmitSound(self.ReloadFinishSound)
			end
			--[[if self.ReloadFinishGesture then
				owner:RestartGesture(self.ReloadFinishGesture)
			end]]
			owner:SetMana(curmana)
		else
			self:SetClip1(curammo + 1)
			owner:SetMana(curmana - manaperbullet)
			self:EmitSound("nox/manadraining.wav", 69, math.Rand(140, 155))
			if self.ReloadAnim then
				self:SendWeaponAnim(self.ReloadAnim)
			end
			self.IsReloading = CurTime() + (self.ReloadDuration or self:SequenceDuration())
			if self.ReloadSound then
				self:EmitSound(self.ReloadSound)
			end
			--[[if self.ReloadGesture then
				owner:RestartGesture(self.ReloadGesture)
			end]]
		end
	end
end

function SWEP:ShootEffects(anim, gest)
	if anim then
		self:SendWeaponAnim(ACT_VM_PRIMARYATTACK)
	end
	if gest then
		self.Owner:DoAttackEvent() --self.Owner:RestartGesture(gest)
	end
end

function SWEP:Ammo1()
	return self.Owner:GetAmmoCount(self:GetPrimaryAmmoType())
end

function SWEP:Ammo2()
	return self.Owner:GetAmmoCount(self:GetSecondaryAmmoType())
end

function SWEP:Holster()
	if self.Owner:CanSwitchWeapon() then
		self.IsReloading = nil
		return true
	end

	return false
end

--[[function SWEP:CanSwitchWeapon()
	return self:GetNextPrimaryFire() <= CurTime()
end]]

function SWEP:Deploy()
	self:SetNextReload(0)
	self:SendWeaponAnim(ACT_VM_IDLE)
	return true
end
