include("shared.lua")

SWEP.PrintName = "Heater"
SWEP.DrawAmmo = false
SWEP.DrawCrosshair = true

--killicon.Add("weapon_heater", "spellicons/heater", color_white)

function SWEP:DrawWeaponSelection(x, y, wide, tall, alpha)
	draw.SimpleText(self.PrintName, "DefaultBold", x + wide * 0.5, y + tall * 0.5, color_white, TEXT_ALIGN_CENTER, TEXT_ALIGN_CENTER)
end

function SWEP:Think()
	local ct = CurTime()

	if self.FinishSwing and self.FinishSwing <= ct then
		self.FinishSwing = nil
	end

	self:NextThink(ct)
	return true
end

function SWEP:Move(pl, move)
	local wepstat = pl.WeaponStatus
	if wepstat and wepstat:IsValid() and wepstat:GetSkin() ~= 0 then
		move:SetForwardSpeed(move:GetForwardSpeed() * 0.6)
		move:SetSideSpeed(move:GetForwardSpeed() * 0.6)
	end
end

function SWEP:PrimaryAttack()
	local owner = self.Owner
	if CurTime() <= self:GetNextPrimaryFire() then return end
	self:SetNextPrimaryFire(CurTime() + 0.8)
	self.FinishSwing = CurTime() + 0.15

	owner:RestartGesture(ACT_HL2MP_GESTURE_RANGE_ATTACK_MELEE)
end

function SWEP:Reload()
end

SWEP.DrawWorldModel = SWEP.Reload
SWEP.DrawWorldModelTranslucent = SWEP.Reload

function SWEP:Deploy()
	return true
end

RegisterLuaAnimation("heatershield", {
	TimeToArrive = 0.5,
	FrameData = {
		{
			BoneInfo = {
				["ValveBiped.Bip01_L_Forearm"] = {
					RU = -30
				},
				["ValveBiped.Bip01_L_Upperarm"] = {
					RU = 30
				},
				["ValveBiped.Bip01_R_Forearm"] = {
					RU = 0
				},
				["ValveBiped.Bip01_R_Upperarm"] = {
					RU = -50
				}
			}
		}
	},
	Type = TYPE_POSTURE
})
