AddCSLuaFile("cl_init.lua")
AddCSLuaFile("shared.lua")

include("shared.lua")

SWEP.Weight = 5

function SWEP:ActivityToMelee()
	self.ActivityTranslate[ACT_HL2MP_IDLE] = ACT_HL2MP_IDLE_MELEE
	self.ActivityTranslate[ACT_HL2MP_WALK] = ACT_HL2MP_WALK_MELEE
	self.ActivityTranslate[ACT_HL2MP_RUN] = ACT_HL2MP_RUN_MELEE
	self.ActivityTranslate[ACT_HL2MP_IDLE_CROUCH] = ACT_HL2MP_IDLE_CROUCH_MELEE
	self.ActivityTranslate[ACT_HL2MP_WALK_CROUCH] = ACT_HL2MP_WALK_CROUCH_MELEE
	self.ActivityTranslate[ACT_HL2MP_GESTURE_RANGE_ATTACK] = ACT_HL2MP_GESTURE_RANGE_ATTACK_MELEE
	self.ActivityTranslate[ACT_HL2MP_GESTURE_RELOAD] = ACT_HL2MP_GESTURE_RELOAD_MELEE
	self.ActivityTranslate[ACT_HL2MP_JUMP] = ACT_HL2MP_JUMP_MELEE
	self.ActivityTranslate[ACT_RANGE_ATTACK1] = ACT_RANGE_ATTACK_MELEE

	if self.Owner:IsValid() and not self.Owner:IsOnGround() then
		self.Owner:SetAnimation(PLAYER_JUMP)
	end
end

function SWEP:ActivityToMelee2()
	self.ActivityTranslate[ACT_HL2MP_IDLE] = ACT_HL2MP_IDLE_MELEE2
	self.ActivityTranslate[ACT_HL2MP_WALK] = ACT_HL2MP_WALK_MELEE2
	self.ActivityTranslate[ACT_HL2MP_RUN] = ACT_HL2MP_RUN_MELEE2
	self.ActivityTranslate[ACT_HL2MP_IDLE_CROUCH] = ACT_HL2MP_IDLE_CROUCH_MELEE2
	self.ActivityTranslate[ACT_HL2MP_WALK_CROUCH] = ACT_HL2MP_WALK_CROUCH_MELEE2
	self.ActivityTranslate[ACT_HL2MP_GESTURE_RANGE_ATTACK] = ACT_HL2MP_GESTURE_RANGE_ATTACK_MELEE2
	self.ActivityTranslate[ACT_HL2MP_GESTURE_RELOAD] = ACT_HL2MP_GESTURE_RELOAD_MELEE2
	self.ActivityTranslate[ACT_HL2MP_JUMP] = ACT_HL2MP_JUMP_MELEE2
	self.ActivityTranslate[ACT_RANGE_ATTACK1] = ACT_RANGE_ATTACK_MELEE2

	if self.Owner:IsValid() and not self.Owner:IsOnGround() then
		self.Owner:SetAnimation(PLAYER_JUMP)
	end
end

function SWEP:ActivityToFist()
	self.ActivityTranslate[ACT_HL2MP_IDLE] = ACT_HL2MP_IDLE_FIST
	self.ActivityTranslate[ACT_HL2MP_WALK] = ACT_HL2MP_WALK_FIST
	self.ActivityTranslate[ACT_HL2MP_RUN] = ACT_HL2MP_RUN_FIST
	self.ActivityTranslate[ACT_HL2MP_IDLE_CROUCH] = ACT_HL2MP_IDLE_CROUCH_FIST
	self.ActivityTranslate[ACT_HL2MP_WALK_CROUCH] = ACT_HL2MP_WALK_CROUCH_FIST
	self.ActivityTranslate[ACT_HL2MP_GESTURE_RANGE_ATTACK] = ACT_HL2MP_GESTURE_RANGE_ATTACK_FIST
	self.ActivityTranslate[ACT_HL2MP_GESTURE_RELOAD] = ACT_HL2MP_GESTURE_RELOAD_FIST
	self.ActivityTranslate[ACT_HL2MP_JUMP] = ACT_HL2MP_JUMP_FIST
	self.ActivityTranslate[ACT_RANGE_ATTACK1] = ACT_RANGE_ATTACK_FIST

	if self.Owner:IsValid() and not self.Owner:IsOnGround() then
		self.Owner:SetAnimation(PLAYER_JUMP)
	end
end

function SWEP:Initialize()
	self.ActivityTranslate = {}
	self:ActivityToMelee()
end

function SWEP:Deploy()
	local owner = self.Owner
	owner:DrawViewModel(false)
	owner:RemoveStatus("weapon_*", false, true)
	owner:GiveStatus("weapon_heater")

	--return true
end

function SWEP:Clashed(pl, wep)
	self:SetSkin(0)
	self.FinishSwing = nil
	local owner = self.Owner
	owner:SetLastAttacker(pl)
	owner:RestartGesture(ACT_HL2MP_GESTURE_RANGE_ATTACK_CROSSBOW)
	owner:SetGroundEntity(NULL)
	local norm = owner:GetPos() - pl:GetPos()
	norm.z = 0
	norm = norm:Normalize()
	owner:SetVelocity(norm * 400 + Vector(0,0,210))

	local effectdata = EffectData()
		effectdata:SetOrigin(owner:GetShootPos())
		effectdata:SetEntity(owner)
	util.Effect("meleeclash", effectdata, true, true)
end

function SWEP:Guarded(pl, wep)
	pl:Stun(5)
	pl:RestartGesture(ACT_HL2MP_GESTURE_RANGE_ATTACK_CROSSBOW)
	pl:SetLastAttacker(self.Owner)

	local effectdata = EffectData()
		effectdata:SetOrigin(self.Owner:GetShootPos())
		effectdata:SetEntity(self.Owner)
	util.Effect("meleeclash", effectdata, true, true)
end

function SWEP:MeleeStrike(damage, dmgtyp, knockdown)
	local owner = self.Owner

	damage = damage * owner.MeleeDamageMultiplier

	local eyepos = owner:GetShootPos()
	local ownerpos = owner:GetPos()
	local aimvec = owner:GetAimVector()
	local ownerteam = owner:Team()

	local hit
	local effectpos

	local endpos = eyepos + aimvec * 30
	for _, ent in pairs(ents.FindInSphere(endpos, 40)) do
		if ent.PHealth or ent.CoreHealth or ent.ScriptVehicle then
			if MeleeVisible(ent:NearestPoint(eyepos), eyepos, {ent, owner}) then
				effectpos = ent:NearestPoint(eyepos)
				ent:TakeSpecialDamage(damage, dmgtyp, owner, self)
				hit = true
			end
		elseif ent ~= owner and ent:IsPlayer() then
			if ent:IsPlayer() then
				local nearest = ent:NearestPoint(eyepos)
				if ent:Alive() and TrueVisible(nearest, eyepos) then
					if ent:Team() ~= owner:Team() then
						hit = true
						local wep = ent:GetActiveWeapon()
						if wep.CanGuard and wep:CanGuard(owner, self) and not knockdown then
							wep:Guarded(owner, self)
						elseif wep.CanClash and wep:CanClash(owner, self) and not knockdown then
							wep:Clashed(owner, self)
							if self.Clashed then
								self:Clashed(wep.Owner, wep)
							end
						else
							ent:BloodSpray(nearest, math.random(10, 13), owner:GetAimVector(), 300)
							ent:HitByMelee(owner, self)
							effectpos = ent:NearestPoint(eyepos)
							ent:TakeSpecialDamage(damage, dmgtyp, owner, self)
							if (knockdown or ent.Stunned and not ent.SilentStunned) and ent:Team() ~= ownerteam then
								local vec = ent:GetPos() - ownerpos
								vec.z = 0
								vec = vec:Normalize()
								ent:SetGroundEntity(NULL)
								ent:SetVelocity(vec * 500 + Vector(0, 0, 300))
								ent:KnockDown()
							end
						end
					end
				end
			elseif TrueVisible(ent:NearestPoint(eyepos), eyepos) then
				hit = true
				ent:TakeSpecialDamage(damage, dmgtyp, owner, self)
				effectpos = ent:NearestPoint(eyepos)
			end
		end
	end

	if not hit then
		local tr = util.TraceLine({start = eyepos, endpos = eyepos + aimvec * 70, mask = MASK_PLAYERSOLID, filter = owner})
		if tr.Hit then
			effectpos = tr.HitPos
		end
	end

	if effectpos then
		local effectdata = EffectData()
			effectdata:SetOrigin(effectpos)
			effectdata:SetStart(eyepos)
		util.Effect("meleehit", effectdata, true, true)
		util.ScreenShake(effectpos, damage, 0.5, 0.75, 72)
	end
end

function SWEP:Think()
	local ct = CurTime()

	local owner = self.Owner
	local skin = self:GetSkin()
	if skin == 3 then
		if not owner:KeyDown(IN_ATTACK2) then
			self:SetSkin(0)
			self.FinishSwing = nil
		elseif self.FinishSwing <= ct then
			self:SetSkin(0)
			self.FinishSwing = nil
			owner:SetNextAttack(1)
			owner:Stun(1, true)
			owner:RestartGesture(ACT_HL2MP_GESTURE_RANGE_ATTACK_MELEE)

			local fwd = owner:GetForward()
			local eyepos = owner:GetShootPos()

			util.ScreenShake(eyepos, 40, 0.8, 1, 200)
			local effectdata = EffectData()
				effectdata:SetEntity(owner)
				effectdata:SetOrigin(eyepos)
			util.Effect("heaterchargeattack", effectdata, true, true)

			effectdata:SetStart(eyepos)

			for _, ent in pairs(ents.FindInSphere(eyepos, fwd, 128, 90)) do
				if ent ~= owner and ent:IsValid() then
					local nearest = ent:NearestPoint(eyepos)
					if TrueVisible(eyepos, nearest) then
						effectdata:SetOrigin(nearest)
						util.Effect("meleehit")
						ent:TakeSpecialDamage(25 * owner.MeleeDamageMultiplier, DMGTYPE_FIRE, owner, self)
						if ent.KnockDown and ent:GetTeamID() ~= owner:Team() and ent:Alive() then
							ent:SetGroundEntity(NULL)
							ent:SetLocalVelocity(fwd * 400 + Vector(0,0,500))
							ent:KnockDown()
						end
					end
				end
			end

			--[[local fwd = owner:GetForward()
			local eyepos = owner:GetShootPos()
			local startpos = owner:GetPos() + fwd * 24
			local dir = owner:GetUp():Angle()
			dir:RotateAroundAxis(owner:GetRight(), -15)

			util.ScreenShake(startpos, 40, 0.8, 1, 200)
			local effectdata = EffectData()
				effectdata:SetEntity(owner)
				effectdata:SetOrigin(eyepos)
			util.Effect("heaterchargeattack", effectdata, true, true)

			for _, ent in pairs(ents.FindInCone(startpos + Vector(0,0,-32), dir:Forward(), 128, 30)) do
				if ent ~= owner and TrueVisible(eyepos, ent:NearestPoint(eyepos)) then
					ent:TakeSpecialDamage(25 * owner.MeleeDamageMultiplier, DMGTYPE_FIRE, owner, self)
					if ent.KnockDown and ent:GetTeamID() ~= owner:Team() and ent:Alive() then
						ent:SetGroundEntity(NULL)
						ent:SetLocalVelocity(fwd * 400 + Vector(0,0,500))
						ent:KnockDown()
					end
				end
			end]]
		end
	elseif self.FinishSwing and self.FinishSwing <= ct then
		self.FinishSwing = nil
		self:MeleeStrike(35, DMGTYPE_PHYSICAL)
	elseif self.StartGuarding and self.StartGuarding <= ct then
		self.StartGuarding = nil
		self:SetSkin(2)
		self:ActivityToMelee2()
	elseif self.StopGuarding and self.StopGuarding <= ct then
		self.StopGuarding = nil
		self:SetSkin(0)
		self:ActivityToMelee()
	elseif skin == 2 and not owner:KeyDown(IN_RELOAD) and not owner:KeyDown(IN_ATTACK2) then
		self.StopGuarding = ct + 0.15
		self:SetSkin(1)
		self:ActivityToFist()
	end

	self:NextThink(ct)
	return true
end

function SWEP:HitByMelee(attacker, attackerweapon)
	self.FinishSwing = nil
	self.StartGuarding = nil
	self.StopGuarding = nil
	if self:GetSkin() ~= 0 then
		self:SetSkin(0)
		self:ActivityToMelee()
	end
	self.Owner:SetNextAttack(CurTime() + 0.75)
end

function SWEP:PrimaryAttack()
	local owner = self.Owner
	local ct = CurTime()
	if owner.Stunned or ct < owner:GetNextAttack() or 0 < self:GetSkin() then return end
	owner:SetNextAttack(ct + 0.75)

	if owner.Sprinting then
		owner:RemoveStatus("sprint", false, true)
	end

	if owner.DashDodging then
		owner:RemoveStatus("dashdodge*", false, true)
	end

	local pos = owner:GetPos()
	owner:EmitSound("nox/sword_miss.wav", 75, math.Rand(50, 63))
	owner:RestartGesture(ACT_HL2MP_GESTURE_RANGE_ATTACK_MELEE)
	self.FinishSwing = ct + 0.15
end

function SWEP:SecondaryAttack()
	self:Reload()
	--[[local owner = self.Owner
	local ct = CurTime()
	if owner.Stunned or ct < self:GetNextPrimaryFire() or 0 < self:GetSkin() then return end
	self:SetNextPrimaryFire(ct + 0.1)
	self:SetSkin(3)

	if owner.Sprinting then
		owner:RemoveStatus("sprint", false, true)
	end

	if owner.DashDodging then
		owner:RemoveStatus("dashdodge*", false, true)
	end

	if owner.WallRunning then
		owner:RemoveStatus("wallrun*", false, true)
	end

	self.FinishSwing = ct + 0.5]]
end

function SWEP:Reload()
	local owner = self.Owner
	local ct = CurTime()
	if owner.Stunned or 0 < self:GetSkin() or ct < owner:GetNextAttack() then return end

	if owner.Sprinting then
		owner:RemoveStatus("sprint", false, true)
	end

	if owner.DashDodging then
		owner:RemoveStatus("dashdodge*", false, true)
	end

	if owner.WallRunning then
		owner:RemoveStatus("wallrun*", false, true)
	end

	self.StartGuarding = ct + 0.15
	self:ActivityToFist()

	self:SetSkin(1)
end
