AddCSLuaFile("cl_init.lua")
AddCSLuaFile("shared.lua")

include("shared.lua")

function SWEP:Clashed(pl, wep)
	self:SetSkin(0)
	self.FinishSwing = nil
	local owner = self.Owner
	owner:SetLastAttacker(pl)
	owner:RestartGesture(ACT_HL2MP_GESTURE_RANGE_ATTACK_CROSSBOW)
	owner:SetGroundEntity(NULL)
	local norm = owner:GetPos() - pl:GetPos()
	norm.z = 0
	norm = norm:Normalize()
	owner:SetVelocity(norm * 400 + Vector(0,0,210))

	local effectdata = EffectData()
		effectdata:SetOrigin(owner:GetShootPos())
		effectdata:SetEntity(owner)
	util.Effect("meleeclash", effectdata, true, true)
end

function SWEP:MeleeStrike(damage, dmgtyp, knockdown)
	local owner = self.Owner

	damage = damage * owner.MeleeDamageMultiplier

	local eyepos = owner:GetShootPos()
	local ownerpos = owner:GetPos()
	local aimvec = owner:GetAimVector()
	local ownerteam = owner:Team()

	local hit
	local effectpos

	local endpos = eyepos + aimvec * 30
	for _, ent in pairs(ents.FindInSphere(endpos, 40)) do
		if ent.PHealth or ent.CoreHealth or ent.ScriptVehicle then
			if MeleeVisible(ent:NearestPoint(eyepos), eyepos, {ent, owner}) then
				effectpos = ent:NearestPoint(eyepos)
				ent:TakeSpecialDamage(damage, dmgtyp, owner, self)
				hit = true
			end
		elseif ent ~= owner and (ent:IsPlayer() or ent:IsNPC()) then
			if ent:IsPlayer() then
				local nearest = ent:NearestPoint(eyepos)
				if ent:Alive() and TrueVisible(nearest, eyepos) then
					if ent:Team() ~= owner:Team() then
						hit = true
						local wep = ent:GetActiveWeapon()
						if wep.CanGuard and wep:CanGuard(owner, self) and not knockdown then
							wep:Guarded(owner, self)
						elseif wep.CanClash and wep:CanClash(owner, self) and not knockdown then
							wep:Clashed(owner, self)
							if self.Clashed then
								self:Clashed(wep.Owner, wep)
							end
						else
							ent:BloodSpray(nearest, math.random(10, 13), owner:GetAimVector(), 300)
							ent:HitByMelee(owner, self)
							effectpos = ent:NearestPoint(eyepos)
							ent:TakeSpecialDamage(damage, dmgtyp, owner, self)
							if (knockdown or ent.Stunned and not ent.SilentStunned) and ent:Team() ~= ownerteam then
								local vec = ent:GetPos() - ownerpos
								vec.z = 0
								vec = vec:Normalize()
								ent:SetGroundEntity(NULL)
								ent:SetVelocity(vec * 500 + Vector(0, 0, 300))
								ent:KnockDown()
							end
						end
					end
				end
			elseif TrueVisible(ent:NearestPoint(eyepos), eyepos) then
				hit = true
				ent:TakeSpecialDamage(damage, dmgtyp, owner, self)
				effectpos = ent:NearestPoint(eyepos)
			end
		end
	end

	if not hit then
		local tr = util.TraceLine({start = eyepos, endpos = eyepos + aimvec * 70, mask = MASK_PLAYERSOLID, filter = owner})
		if tr.Hit then
			effectpos = tr.HitPos
		end
	end

	if effectpos then
		local effectdata = EffectData()
			effectdata:SetOrigin(effectpos)
			effectdata:SetStart(eyepos)
		util.Effect("meleehit", effectdata, true, true)
		util.ScreenShake(effectpos, damage, 0.5, 0.75, 72)
	end
end

function SWEP:OnAction()
	local owner = self.Owner
	
	if owner.Sprinting then
		owner:RemoveStatus("sprint", false, true)
	end

	if owner.DashDodging then
		owner:RemoveStatus("dashdodge*", false, true)
	end
	
	if owner.WallRunning then
		owner:RemoveStatus("wallrun*", false, true)
	end
end

function SWEP:Guarded(pl, wep)
	pl:Stun(5)
	pl:RestartGesture(ACT_HL2MP_GESTURE_RANGE_ATTACK_CROSSBOW)
	pl:SetLastAttacker(self.Owner)

	local effectdata = EffectData()
		effectdata:SetOrigin(self.Owner:GetShootPos())
		effectdata:SetEntity(self.Owner)
	util.Effect("meleeclash", effectdata, true, true)
end
