AddCSLuaFile("cl_init.lua")
AddCSLuaFile("shared.lua")
include("shared.lua")

function SWEP:Initialize()
	self.ActivityTranslate = {}
	self:SetActivity(ACT_HL2MP_IDLE_MELEE)
end

function SWEP:Think()
	local ct = CurTime()

	local owner = self.Owner
	if self.JumpAttackRecovery and self.JumpAttackRecovery <= CurTime() then
		self.JumpAttackRecovery = nil
	end

	if self.DoJumpAttack then
		self.DoJumpAttack = nil
		self.JumpAttackRecovery = CurTime() + 0.8
		owner:Stun(0.8, true)
		owner.NoJump = math.max(owner.NoJump or 0, self.JumpAttackRecovery)

		local hitpos, normal

		local effectdata = EffectData()
		local pos = owner:GetPos()
		local tr = util.TraceLine({start = pos, endpos = pos + Vector(0, 0, -64), mask = MASK_PLAYERSOLID, filter = owner})
		if tr.Hit then
			hitpos = tr.HitPos
			normal = tr.HitNormal
		else
			hitpos = pos
			normal = Vector(0, 0, 1)
		end
		effectdata:SetOrigin(hitpos)
		effectdata:SetNormal(normal)
		util.Effect("gladradusjump", effectdata, true, true)

		hitpos = hitpos + normal * 4

		owner:GodEnable()
		local damagedents = ExplosiveDamage(owner, self, hitpos, 120, 120, 0, 0.1, 30 * owner.MeleeDamageMultiplier, DMGTYPE_PHYSICAL)
		owner:GodDisable()
		for ent in pairs(damagedents) do
			if ent ~= owner and ent.KnockDown and ent:GetTeamID() ~= owner:Team() and ent:Alive() then
				ent:SetGroundEntity(NULL)
				ent:SetLocalVelocity((ent:GetPos() - hitpos):Normalize() * 400 + Vector(0,0,250))
				ent:KnockDown()
			--[[elseif ent.PHealth or ent.CoreHealth or ent.ScriptVehicle then
				if not ent.Destroyed then
					ent:TakeSpecialDamage(30 * owner.MeleeDamageMultiplier, DMGTYPE_FIRE, owner, self)
				end]]
			end
		end
		owner:SetLocalVelocity(Vector(0,0,0))
	elseif self.FinishSwing and self.FinishSwing <= ct then
		self.FinishSwing = nil
		local eyepos = owner:GetShootPos()
		local aimvec = owner:GetAimVector()
		local ownerteam = owner:Team()

		local hit
		local effectpos

		local endpos = eyepos + aimvec * 30
		for _, ent in pairs(ents.FindInSphere(endpos, 40)) do
			if ent.PHealth or ent.CoreHealth or ent.ScriptVehicle then
				if MeleeVisible(ent:NearestPoint(eyepos), eyepos, {ent, owner}) then
					effectpos = ent:NearestPoint(eyepos)
					ent:TakeSpecialDamage(23 * owner.MeleeDamageMultiplier, DMGTYPE_PHYSICAL, owner, self)
					hit = true
				end
			elseif ent ~= owner and (ent:IsPlayer() or ent:IsNPC()) then
				if ent:IsPlayer() then
					local nearest = ent:NearestPoint(eyepos)
					if ent:Alive() and TrueVisible(nearest, eyepos) then
						if ent:Team() ~= owner:Team() then
							hit = true
							local wep = ent:GetActiveWeapon()
							if wep.CanGuard and wep:CanGuard(owner, self) then
								wep:Guarded(owner, self)
							elseif wep.CanClash and wep:CanClash(owner, self) then
								wep:Clashed(owner, self)
								if self.Clashed then
									self:Clashed(wep.Owner, wep)
								end
							else
								ent:BloodSpray(nearest, math.random(8, 10), owner:GetAimVector(), 250)
								ent:HitByMelee(owner, self)
								effectpos = ent:NearestPoint(eyepos)
								ent:TakeSpecialDamage(23 * owner.MeleeDamageMultiplier, DMGTYPE_PHYSICAL, owner, self)
							end
						end
					end
				elseif TrueVisible(ent:NearestPoint(eyepos), eyepos) then
					hit = true
					ent:TakeSpecialDamage(23 * owner.MeleeDamageMultiplier, DMGTYPE_PHYSICAL, owner, self)
					effectpos = ent:NearestPoint(eyepos)
				end
			end
		end

		if not hit then
			local tr = util.TraceLine({start = eyepos, endpos = eyepos + aimvec * 70, mask = MASK_PLAYERSOLID, filter = owner})
			if tr.Hit then
				effectpos = tr.HitPos
			end
		end

		if effectpos then
			local effectdata = EffectData()
				effectdata:SetOrigin(effectpos)
				effectdata:SetStart(eyepos)
			util.Effect("meleehit", effectdata, true, true)
			util.ScreenShake(effectpos, 19, 0.5, 0.75, 72)
		end
	elseif self.Charging then
		local owner = self.Owner
		if self.Charging <= ct then
			self.Charging = nil

			local wepstat = owner.WeaponStatus
			if wepstat and wepstat:IsValid() then
				if wepstat:GetSkin() == 2 then
					owner:Stun(0.65, true)
				end
				wepstat:SetSkin(0)
			end

			local proj = ents.Create("projectile_gladraduscharge")
			if proj:IsValid() then
				proj:SetPos(owner:LocalToWorld(owner:OBBCenter()) + owner:GetForward() * -32)
				local dir = owner:GetAimVector()
				dir.z = 0
				dir = dir:Normalize()
				local ang = dir:Angle()
				ang:RotateAroundAxis(ang:Forward(), 90)
				ang:RotateAroundAxis(ang:Up(), 90)
				proj:SetAngles(ang)
				proj:SetOwner(owner)
				local col = team.GetColor(owner:Team())
				proj:SetColor(col.r, col.g, col.b, 120)
				proj.ProjectileHeading = dir
				proj.Inflictor = self
				proj:Spawn()
				proj.DamageMultiplier = owner.MeleeDamageMultiplier
				proj:SetTeamID(owner:Team())
			end

			self:SetActivity(ACT_HL2MP_IDLE_MELEE)
			owner:RestartGesture(ACT_HL2MP_GESTURE_RANGE_ATTACK_GRENADE)
		elseif not owner:KeyDown(IN_ATTACK2) and not owner:KeyDown(IN_ATTACK) then
			self.Charging = nil

			self:SetActivity(ACT_HL2MP_IDLE_MELEE)

			local wepstat = owner.WeaponStatus
			if wepstat and wepstat:IsValid() then
				wepstat:SetSkin(0)
			end
		end
	end

	self:NextThink(ct)
	return true
end

function SWEP:HitByMelee(attacker, attackerweapon)
	self.FinishSwing = nil
	self.JumpAttackStart = nil
	self.JumpAttackEnd = nil
	self.JumpAttackRecovery = nil
	self.Owner:SetNextAttack(CurTime() + 0.5)
	if self.Charging then
		self.Charging = nil
		self:SetActivity(ACT_HL2MP_IDLE_MELEE)

		local wepstat = self.Owner.WeaponStatus
		if wepstat and wepstat:IsValid() then
			wepstat:SetSkin(0)
		end
	end
end

function SWEP:PrimaryAttack()
	local owner = self.Owner
	if CurTime() <= owner:GetNextAttack() and not self.JumpAttackRecovery or owner.Stunned and not self.JumpAttackRecovery or self.Charging or self.JumpAttackStart or self.JumpAttackEnd then return end

	self:OnAction()

	local pos = owner:GetPos()
	if owner:IsOnGround() or owner.DodgedInAir or 2 <= owner:WaterLevel() or owner:GetMoveType() == MOVETYPE_LADDER or owner.WallRunning or owner.Stunned or util.TraceLine({start=pos, endpos = pos + Vector(0,0,-48), mask = MASK_PLAYERSOLID, filter = owner}).Hit then
		if self.JumpAttackRecovery then
			self.JumpAttackRecovery = nil
			self.Charging = CurTime() + 0.75
			owner:Stun(0.75, true)
			if owner.WeaponStatus:IsValid() then
				owner.WeaponStatus:SetSkin(2)
			end
		else
			owner:EmitSound("nox/sword_miss.wav", 75, math.Rand(80, 93))
			owner:RestartGesture(ACT_HL2MP_GESTURE_RANGE_ATTACK_MELEE)

			owner:SetNextAttack(CurTime() + 0.5)
			self.FinishSwing = CurTime() + 0.1
		end
	else
		self.JumpAttackStart = CurTime() + 0.35
		owner:SetNextAttack(CurTime() + 1)
	end
end

function SWEP:Move(move)
	local owner = self:GetOwner()
	if self.JumpAttackStart then
		move:SetForwardSpeed(0)
		move:SetSideSpeed(0)
		move:SetVelocity(Vector(0,0,0))
		if self.JumpAttackStart <= CurTime() then
			self.JumpAttackStart = nil
			self.JumpAttackEnd = CurTime() + 0.35
			owner:EmitSound("weapons/mortar/mortar_shell_incomming1.wav", 70, math.Rand(120, 135))
		end
	elseif self.JumpAttackEnd then
		move:SetForwardSpeed(0)
		move:SetSideSpeed(0)
		move:SetVelocity(Vector(0,0,-1000))
		if owner:IsOnGround() or self.JumpAttackEnd <= CurTime() or 2 <= owner:WaterLevel() then
			self.JumpAttackEnd = nil
			self.DoJumpAttack = true
		end
	elseif self.Charging then
		if owner.WeaponStatus:IsValid() and owner.WeaponStatus:GetSkin() == 1 then
			move:SetForwardSpeed(move:GetForwardSpeed() * 0.6)
			move:SetSideSpeed(move:GetSideSpeed() * 0.6)
		else
			move:SetForwardSpeed(0)
			move:SetSideSpeed(0)
		end
	end
end

function SWEP:SecondaryAttack()
	if self.JumpAttackRecovery then
		self:PrimaryAttack()
		return
	end

	local owner = self.Owner
	if CurTime() <= owner:GetNextAttack() or owner.Stunned or owner.Charging or owner.FinishSwing or self.JumpAttackStart or self.JumpAttackEnd then return end
	owner:SetNextAttack(CurTime() + 0.1)
	self.Charging = CurTime() + 1.5

	self:OnAction()

	self:SetActivity(ACT_HL2MP_IDLE_MELEE2)

	local wepstat = owner.WeaponStatus
	if wepstat and wepstat:IsValid() then
		wepstat:SetSkin(1)
	end
end
