AddCSLuaFile("cl_init.lua")
AddCSLuaFile("shared.lua")
include("shared.lua")

function SWEP:Initialize()
	self.ActivityTranslate = {}
	self:SetActivity(ACT_HL2MP_IDLE_MELEE)
end

function SWEP:Think()
	local ct = CurTime()

	local owner = self.Owner
	local skin = self:GetSkin()
	if skin == 3 then
		if not owner:KeyDown(IN_ATTACK2) then
			self:SetSkin(0)
			self.FinishSwing = nil
		elseif self.FinishSwing <= ct then
			self:SetSkin(0)
			self.FinishSwing = nil
			owner:SetNextAttack(1)
			owner:Stun(1, true)
			owner:RestartGesture(ACT_HL2MP_GESTURE_RANGE_ATTACK_MELEE)

			local fwd = owner:GetForward()
			local eyepos = owner:GetShootPos()

			util.ScreenShake(eyepos, 40, 0.8, 1, 200)
			local effectdata = EffectData()
				effectdata:SetEntity(owner)
				effectdata:SetOrigin(eyepos)
			util.Effect("heaterchargeattack", effectdata, true, true)

			effectdata:SetStart(eyepos)

			for _, ent in pairs(ents.FindInSphere(eyepos, fwd, 128, 90)) do
				if ent ~= owner and ent:IsValid() then
					local nearest = ent:NearestPoint(eyepos)
					if TrueVisible(eyepos, nearest) then
						effectdata:SetOrigin(nearest)
						util.Effect("meleehit")
						ent:TakeSpecialDamage(25 * owner.MeleeDamageMultiplier, DMGTYPE_FIRE, owner, self)
						if ent.KnockDown and ent:GetTeamID() ~= owner:Team() and ent:Alive() then
							ent:SetGroundEntity(NULL)
							ent:SetLocalVelocity(fwd * 400 + Vector(0,0,500))
							ent:KnockDown()
						end
					end
				end
			end

			--[[local fwd = owner:GetForward()
			local eyepos = owner:GetShootPos()
			local startpos = owner:GetPos() + fwd * 24
			local dir = owner:GetUp():Angle()
			dir:RotateAroundAxis(owner:GetRight(), -15)

			util.ScreenShake(startpos, 40, 0.8, 1, 200)
			local effectdata = EffectData()
				effectdata:SetEntity(owner)
				effectdata:SetOrigin(eyepos)
			util.Effect("heaterchargeattack", effectdata, true, true)

			for _, ent in pairs(ents.FindInCone(startpos + Vector(0,0,-32), dir:Forward(), 128, 30)) do
				if ent ~= owner and TrueVisible(eyepos, ent:NearestPoint(eyepos)) then
					ent:TakeSpecialDamage(25 * owner.MeleeDamageMultiplier, DMGTYPE_FIRE, owner, self)
					if ent.KnockDown and ent:GetTeamID() ~= owner:Team() and ent:Alive() then
						ent:SetGroundEntity(NULL)
						ent:SetLocalVelocity(fwd * 400 + Vector(0,0,500))
						ent:KnockDown()
					end
				end
			end]]
		end
	elseif self.FinishSwing and self.FinishSwing <= ct then
		self.FinishSwing = nil
		self:MeleeStrike(35, DMGTYPE_PHYSICAL)
	elseif self.StartGuarding and self.StartGuarding <= ct then
		self.StartGuarding = nil
		self:SetSkin(2)
		self:SetActivity(ACT_HL2MP_IDLE_MELEE2)
	elseif self.StopGuarding and self.StopGuarding <= ct then
		self.StopGuarding = nil
		self:SetSkin(0)
		self:SetActivity(ACT_HL2MP_IDLE_MELEE)
	elseif skin == 2 and not owner:KeyDown(IN_RELOAD) and not owner:KeyDown(IN_ATTACK2) then
		self.StopGuarding = ct + 0.15
		self:SetSkin(1)
		self:SetActivity(ACT_HL2MP_IDLE_FIST)
	end

	self:NextThink(ct)
	return true
end

function SWEP:HitByMelee(attacker, attackerweapon)
	self.FinishSwing = nil
	self.StartGuarding = nil
	self.StopGuarding = nil
	if self:GetSkin() ~= 0 then
		self:SetSkin(0)
		self:SetActivity(ACT_HL2MP_IDLE_MELEE)
	end
	self.Owner:SetNextAttack(CurTime() + 0.75)
end

function SWEP:PrimaryAttack()
	local owner = self.Owner
	local ct = CurTime()
	if owner.Stunned or ct < owner:GetNextAttack() or 0 < self:GetSkin() then return end
	owner:SetNextAttack(ct + 0.75)

	self:OnAction()

	local pos = owner:GetPos()
	owner:EmitSound("nox/sword_miss.wav", 75, math.Rand(50, 63))
	owner:RestartGesture(ACT_HL2MP_GESTURE_RANGE_ATTACK_MELEE)
	self.FinishSwing = ct + 0.15
end

function SWEP:SecondaryAttack()
	self:Reload()
	--[[local owner = self.Owner
	local ct = CurTime()
	if owner.Stunned or ct < self:GetNextPrimaryFire() or 0 < self:GetSkin() then return end
	self:SetNextPrimaryFire(ct + 0.1)
	self:SetSkin(3)

	if owner.Sprinting then
		owner:RemoveStatus("sprint", false, true)
	end

	if owner.DashDodging then
		owner:RemoveStatus("dashdodge*", false, true)
	end

	if owner.WallRunning then
		owner:RemoveStatus("wallrun*", false, true)
	end

	self.FinishSwing = ct + 0.5]]
end

function SWEP:Reload()
	local owner = self.Owner
	local ct = CurTime()
	if owner.Stunned or 0 < self:GetSkin() or ct < owner:GetNextAttack() then return end

	self:OnAction()

	self.StartGuarding = ct + 0.15
	self:SetActivity(ACT_HL2MP_IDLE_FIST)

	self:SetSkin(1)
end
