AddCSLuaFile("cl_init.lua")
AddCSLuaFile("shared.lua")

include("shared.lua")

SWEP.MinCharge = 0.45
SWEP.MaxChargeTime = 1.8

function SWEP:Initialize()
	self.JumpAttackRecovery = 0
	self:SetActivity(ACT_HL2MP_IDLE_MELEE2)
end

function SWEP:Think()
	local ct = CurTime()

	local owner = self.Owner
	local skin = self:GetSkin()
	if skin == 1 then
		local pow,stamcost
		local cancel = false
		local curstam = owner:GetStamina()
		local force = false
		
		if self.StartSwing then
			pow = (ct - self.StartSwing) / self.MaxChargeTime
			stamcost = 50 * pow
			if pow > self.MinCharge and self.PlayCharged then
				owner:EmitSound("npc/attack_helicopter/aheli_charge_up.wav", 76, math.Rand(140, 155))
				self.PlayCharged = nil
			end
			if stamcost > curstam and pow > self.MinCharge then
				pow = curstam / (stamcost/pow)
				force = true
			end
		end
		
		if not self.FinishSwing or not self.StartSwing then
			self:SetSkin(0)
		elseif not owner:KeyDown(IN_ATTACK2) or self.FinishSwing <= ct or force then
			if curstam >= stamcost and pow > self.MinCharge or force then
				owner:SetStamina(curstam - stamcost, true)
				self:SetSkin(2)
				self.FinishSwing = ct + 0.8 * pow
				owner:EmitSound("weapons/mortar/mortar_shell_incomming1.wav", 100, math.Rand(105, 115))
				owner:SetAnimation(PLAYER_JUMP)
				self.ChargePower = math.Clamp(pow, 0, 1)
			else
				cancel = true
			end
		elseif owner:KeyDown(IN_ATTACK) then
			cancel = true
		end
		
		if cancel then
			owner:SetNextAttack(ct + 0.6)
			self:SetSkin(0)
			self.FinishSwing = nil
			owner:EmitSound("npc/combine_gunship/attack_start2.wav", 100, math.random(60,70))
		end
	elseif skin == 2 then
		if not self.FinishSwing then
			self:SetSkin(0)
		elseif self.FinishSwing <= ct or util.TraceHull({start=owner:GetPos(), endpos=owner:GetPos() + owner:GetForward() * 32, mask=MASK_PLAYERSOLID, filter=owner, mins=owner:OBBMins(), maxs=owner:OBBMaxs()}).Hit then
			self.FinishSwing = nil
			owner:Stun(1.6*self.ChargePower, true)
			self.FinishSwing = ct + 0.1
			owner:RestartGesture(ACT_HL2MP_GESTURE_RANGE_ATTACK_MELEE2)
			owner:EmitSound("nox/sword_miss.wav", 75, math.Rand(50, 63))
			self:SetSkin(3)
		end
	elseif skin == 3 then
		if not self.FinishSwing then
			self:SetSkin(0)
		elseif self.FinishSwing <= ct then
			self.FinishSwing = nil
			self:MeleeStrike(34*self.ChargePower, DMGTYPE_FIRE, true)
			self:SetSkin(0)
			self.ChargePower = nil
		end
	elseif skin == 4 then
		if not self.FinishSwing then
			self:SetSkin(0)
		elseif self.FinishSwing <= ct then
			self:SetSkin(5)
			self.FinishSwing = ct + 0.3
			owner:EmitSound("weapons/mortar/mortar_shell_incomming1.wav", 73, math.Rand(105, 115))
			owner:SetAnimation(PLAYER_JUMP)
		end
	elseif skin == 5 then
		if not self.FinishSwing then
			self:SetSkin(0)
		elseif self.FinishSwing <= ct or owner:IsOnGround() then
			self:SetSkin(0)
			self.FinishSwing = nil
			owner:Stun(0.75, true)
			self.JumpAttackRecovery = ct + 0.75
			owner:SetLocalVelocity(Vector(0,0,0))

			owner:RestartGesture(ACT_HL2MP_GESTURE_RANGE_ATTACK_MELEE2)

			local pos = owner:GetPos() + owner:GetForward() * 32 + Vector(0, 0, 24)
			if not TrueVisible(pos, owner:GetShootPos()) then
				pos = owner:GetPos() + Vector(0, 0, 4)
			end

			local effectdata = EffectData()
				effectdata:SetOrigin(pos)
			util.Effect("sunbeamexplosion", effectdata, true, true)

			owner:GodEnable()
			local damagedents = ExplosiveDamage(owner, self, pos, 100, 100, 0, 0.01, 30 * owner.MeleeDamageMultiplier, DMGTYPE_FIRE)
			owner:GodDisable()
			for ent in pairs(damagedents) do
				if ent ~= owner and ent.KnockDown and ent:GetTeamID() ~= owner:Team() and ent:Alive() then
					ent:SetGroundEntity(NULL)
					ent:SetLocalVelocity(Vector(0, 0, 800))
					ent:KnockDown()
				end
			end
		end
	elseif self.FinishSwing and self.FinishSwing <= ct then
		self:MeleeStrike(29, DMGTYPE_PHYSICAL)
		self.FinishSwing = nil
	end

	self:NextThink(ct)
	return true
end

function SWEP:HitByMelee(attacker, attackerweapon)
	self.FinishSwing = nil
	self.JumpAttackRecovery = 0
	self.Owner:SetNextAttack(CurTime() + 0.75)
end

function SWEP:PrimaryAttack()	
	local owner = self.Owner
	local ct = CurTime()
	if owner.Stunned or ct < owner:GetNextAttack() or self:GetSkin() ~= 0 then return end
	owner:SetNextAttack(ct + 0.75)
	
	self:OnAction()
	
	local pos = owner:GetPos()
	if owner:IsOnGround() or owner.DodgedInAir or 2 <= owner:WaterLevel() or owner:GetMoveType() == MOVETYPE_LADDER or owner.WallRunning or owner.Stunned or util.TraceLine({start=pos, endpos = pos + Vector(0,0,-48), mask = MASK_PLAYERSOLID, filter = owner}).Hit then
		owner:EmitSound("nox/sword_miss.wav", 75, math.Rand(50, 63))
		owner:RestartGesture(ACT_HL2MP_GESTURE_RANGE_ATTACK_MELEE2)
		self.FinishSwing = ct + 0.15
	else
		owner:EmitSound("ambient/machines/thumper_dust.wav", 76, math.Rand(80, 95))
		owner:EmitSound("npc/attack_helicopter/aheli_charge_up.wav", 76, math.Rand(120, 125))
		self.FinishSwing = ct + 0.35
		self:SetSkin(4)
	end
end

function SWEP:SecondaryAttack()
	local owner = self.Owner
	local ct = CurTime()
	if owner.Stunned and self.JumpAttackRecovery < ct or ct < owner:GetNextAttack() or 0 < self:GetSkin() or owner.DodgedInAir or owner:GetStamina() < 15 then return end
	self.JumpAttackRecovery = 0
	owner:SetNextAttack(ct + 3)

	self:OnAction()

	owner.DodgedInAir = true
	owner:EmitSound("ambient/machines/thumper_dust.wav", 76, math.Rand(80, 95))
	owner:EmitSound("npc/attack_helicopter/aheli_charge_up.wav", 76, math.Rand(120, 125))
	self.FinishSwing = ct + self.MaxChargeTime
	self.StartSwing = ct
	self:SetSkin(1)
	self.PlayCharged = true
end

function SWEP:Reload()
end