AddCSLuaFile("shared.lua")

SWEP.Base = "weapon_gun_base"

SWEP.ViewModel = "models/weapons/v_shot_xm1014.mdl"
SWEP.WorldModel = "models/weapons/w_shot_xm1014.mdl"
SWEP.HoldType = "ar2"

if CLIENT then
	killicon.AddFont("weapon_nailer", "CSKillIcons", "n", color_white)

	SWEP.PrintName = "Nailer"
	SWEP.ViewModelFlip = true
	SWEP.Lerp = 1
	SWEP.Rotation = math.Rand(0, 180)

	function SWEP:CalcView(pl, origin, angles, fov, view)
		view.angles = angles
		view.origin = origin
		view.vm_origin = origin
		view.vm_angles = angles
		view.fov = fov * self.Lerp
	end

	function SWEP:SecondaryAttack()
	end

	local texReticle = surface.GetTextureID("gmod/scope")
	function SWEP:DrawHUD()
		if not self.Owner:InVehicle() then
			local screenscale = BetterScreenScale() * 0.5 + 0.5
			GAMEMODE:DrawAmmoCount(w * GetConVarNumber("nox_hud_ammo_x"), h * GetConVarNumber("nox_hud_ammo_y"), self:Clip1(), self.Primary.ClipSize, self.DisplayAmmo, screenscale)
		end

		local ft = FrameTime()

		local skin = self:GetSkin()
		if skin == 1 then
			self.Lerp = math.max(0.3, self.Lerp - ft * (3 - self.Lerp * 1.5))
		elseif skin == 2 then
			self.Lerp = math.max(0.1, self.Lerp - ft * (3 - self.Lerp * 1.5))
		elseif self.Lerp ~= 1 then
			self.Lerp = math.min(1, self.Lerp + ft * (3 + self.Lerp * 2))
		end

		local gamma
		local charge = self.Owner.NailerCharge
		if charge and charge:IsValid() then
			local delta = 1.25 - math.max(0, charge.DieTime - CurTime())
			gamma = ft * delta * 10
		else
			gamma = ft
		end

		local rot = self.Rotation + gamma
		if rot >= 360 then rot = rot - 360 end
		self.Rotation = rot

		if 0 < skin then
			surface.SetDrawColor(255, 0, 0, 255)

			local ww, hh, s, c = w * 0.5, h * 0.5, math.sin(rot) * 800, math.cos(rot) * 800
			surface.DrawLine(ww + s, hh + c, ww + s * 0.04, hh + c * 0.04)
			surface.DrawLine(ww - s, hh - c, ww - s * 0.04, hh - c * 0.04)

			s, c = math.sin(rot + 1.5) * 800, math.cos(rot + 1.5) * 800
			surface.DrawLine(ww + s, hh + c, ww + s * 0.04, hh + c * 0.04)
			surface.DrawLine(ww - s, hh - c, ww - s * 0.04, hh - c * 0.04)

			surface.SetDrawColor(0, 0, 0, 255)
			surface.DrawRect(0, 0, w * 0.2, h)
			surface.DrawRect(w * 0.8, 0, w * 0.2, h)
			surface.SetTexture(texReticle)
			surface.DrawTexturedRect(w * 0.5 - h * 0.5, 0, h, h)
		end
	end

	function SWEP:AdjustMouseSensitivity(def)
		return self.Lerp
	end
end

if SERVER then
	function SWEP:SecondaryAttack()
		if self:GetSkin() == 1 then
			self:SetSkin(2)
			self.Owner:EmitSound("weapons/sniper/sniper_zoomin.wav", 68, math.random(120, 125))
		elseif self:GetSkin() == 2 then
			self:SetSkin(0)
			self.Owner:EmitSound("weapons/sniper/sniper_zoomout.wav", 68, math.random(98, 102))
		else
			self:SetSkin(1)
			self.Owner:EmitSound("weapons/sniper/sniper_zoomin.wav", 68, math.random(98, 102))
		end
	end

	function SWEP:HitByMelee(attacker, attackerweapon)
		local owner = self.Owner
		self:SetNextPrimaryFire(math.max(self:GetNextPrimaryFire(), CurTime() + math.max(self.Primary.Delay * owner.RateOfFireMultiplier, 0.5)))
		self:SetNextSecondaryFire(math.max(self:GetNextSecondaryFire(), CurTime() + math.max(self.Secondary.Delay * owner.RateOfFireMultiplier, 0.5)))
		owner:SetNextAttack(math.max(owner:GetNextAttack(), self:GetNextPrimaryFire()))
		if self.IsReloading then
			self:SendWeaponAnim(ACT_VM_IDLE)
			self.IsReloading = nil
			self:SetNextReload(0)
		end
		if owner.NailerCharge then
			owner:RemoveStatus("nailercharge", false, true)
		end
	end
end

SWEP.Primary.Mana = 30
SWEP.Primary.Damage = 70
SWEP.Primary.Delay = 1
SWEP.Primary.Sound = Sound("weapons/shotgun/shotgun_dbl_fire.wav")
SWEP.Primary.Offsets = {Vector(0,0,0)}
SWEP.Primary.NumOffsets = #SWEP.Primary.Offsets
SWEP.Primary.Gesture = ACT_HL2MP_GESTURE_RANGE_ATTACK_CROSSBOW
SWEP.Primary.ClipSize = 1
SWEP.Primary.DefaultClip = SWEP.Primary.ClipSize
SWEP.Primary.BulletEntity = "projectile_bullet_knockdown"

SWEP.Secondary.Automatic = false

SWEP.ReloadSound = Sound("Weapon_Shotgun.Reload")
SWEP.ReloadGesture = ACT_HL2MP_GESTURE_RELOAD_AR2

SWEP.SpeedWhileShooting = 0.6
SWEP.EndShootingDelay = 0.75

SWEP.BulletSpeed = 4200

function SWEP:Move(pl, move)
	if CurTime() < self:GetLastPrimaryFire() + 0.5 or self.Owner.NailerCharge then
		move:SetForwardSpeed(move:GetForwardSpeed() * self.SpeedWhileShooting)
		move:SetSideSpeed(move:GetSideSpeed() * self.SpeedWhileShooting)
	end
end

function SWEP:CanSprint(pl)
	return not pl:KeyDown(IN_ATTACK) and not self.IsReloading and not self.Owner.NailerCharge
end
SWEP.CanWallRun = SWEP.CanSprint
SWEP.CanWallJump = SWEP.CanSprint
SWEP.CanDodge = SWEP.CanSprint

function SWEP:CanSwitchWeapon()
	return self:GetNextPrimaryFire() <= CurTime() and not self.Owner.NailerCharge
end

function SWEP:ShootNailer()
	if self:CanPrimaryAttack() then
		self:EmitSound(self.Primary.Sound)
		if self.Primary.Gesture then
			self.Owner:RestartGesture(self.Primary.Gesture)
		end
		self:TakePrimaryAmmo(1)
		self:ShootEffects(ACT_VM_PRIMARYATTACK, self.Primary.Gesture)
		self:ShootBullet(self.Primary.Damage, self.Primary.NumShots, self.Primary.Mana)
		self:SetNextReload(CurTime() + 1)
	end
end

function SWEP:PrimaryAttack()
	local owner = self.Owner
	if self:CanPrimaryAttack() and not owner.NailerCharge then
		local ct = CurTime()
		self:SetLastPrimaryFire(ct)
		self:SetNextPrimaryFire(ct + self.Primary.Delay * owner.RateOfFireMultiplier)
		self:SetNextSecondaryFire(self:GetNextPrimaryFire())
		owner.CantDodgeTime = math.max(owner.CantDodgeTime or 0, ct + 0.25)
		owner.CantSprintTime = math.max(owner.CantSprintTime or 0, ct + 0.25)

		owner:GiveStatus("nailercharge", 1.25)
	end
end
