AddCSLuaFile("cl_init.lua")
AddCSLuaFile("shared.lua")

include("shared.lua")

function SWEP:ActivityToMelee()
	self.ActivityTranslate[ACT_HL2MP_IDLE] = ACT_HL2MP_IDLE_MELEE
	self.ActivityTranslate[ACT_HL2MP_WALK] = ACT_HL2MP_WALK_MELEE
	self.ActivityTranslate[ACT_HL2MP_RUN] = ACT_HL2MP_RUN_MELEE
	self.ActivityTranslate[ACT_HL2MP_IDLE_CROUCH] = ACT_HL2MP_IDLE_CROUCH_MELEE
	self.ActivityTranslate[ACT_HL2MP_WALK_CROUCH] = ACT_HL2MP_WALK_CROUCH_MELEE
	self.ActivityTranslate[ACT_HL2MP_GESTURE_RANGE_ATTACK] = ACT_HL2MP_GESTURE_RANGE_ATTACK_MELEE
	self.ActivityTranslate[ACT_HL2MP_GESTURE_RELOAD] = ACT_HL2MP_GESTURE_RELOAD_MELEE
	self.ActivityTranslate[ACT_HL2MP_JUMP] = ACT_HL2MP_JUMP_MELEE
	self.ActivityTranslate[ACT_RANGE_ATTACK1] = ACT_RANGE_ATTACK_MELEE

	if self.Owner:IsValid() and not self.Owner:IsOnGround() then
		self.Owner:SetAnimation(PLAYER_JUMP)
	end
end

function SWEP:ActivityToMelee2()
	self.ActivityTranslate[ACT_HL2MP_IDLE] = ACT_HL2MP_IDLE_MELEE2
	self.ActivityTranslate[ACT_HL2MP_WALK] = ACT_HL2MP_WALK_MELEE2
	self.ActivityTranslate[ACT_HL2MP_RUN] = ACT_HL2MP_RUN_MELEE2
	self.ActivityTranslate[ACT_HL2MP_IDLE_CROUCH] = ACT_HL2MP_IDLE_CROUCH_MELEE2
	self.ActivityTranslate[ACT_HL2MP_WALK_CROUCH] = ACT_HL2MP_WALK_CROUCH_MELEE2
	self.ActivityTranslate[ACT_HL2MP_GESTURE_RANGE_ATTACK] = ACT_HL2MP_GESTURE_RANGE_ATTACK_MELEE2
	self.ActivityTranslate[ACT_HL2MP_GESTURE_RELOAD] = ACT_HL2MP_GESTURE_RELOAD_MELEE2
	self.ActivityTranslate[ACT_HL2MP_JUMP] = ACT_HL2MP_JUMP_MELEE2
	self.ActivityTranslate[ACT_RANGE_ATTACK1] = ACT_RANGE_ATTACK_MELEE2

	if self.Owner:IsValid() and not self.Owner:IsOnGround() then
		self.Owner:SetAnimation(PLAYER_JUMP)
	end
end

function SWEP:Initialize()
	self.JumpAttackRecovery = 0
	self.MaxChargeTime = 1.8
	self.ActivityTranslate = {}
	self:ActivityToMelee2()
	self.MinCharge = 0.45
end

function SWEP:Deploy()
	local owner = self.Owner
	owner:DrawViewModel(false)
	owner:RemoveStatus("weapon_*", false, true)
	owner:GiveStatus("weapon_ripdash")

	return true
end

function SWEP:Clashed(pl, wep)
	self:SetSkin(0)
	self.FinishSwing = nil
	local owner = self.Owner
	owner.LastAttacked = CurTime()
	owner.LastAttacker = pl
	owner:RestartGesture(ACT_HL2MP_GESTURE_RANGE_ATTACK_CROSSBOW)
	owner:SetGroundEntity(NULL)
	local norm = owner:GetPos() - pl:GetPos()
	norm.z = 0
	norm = norm:Normalize()
	owner:SetVelocity(norm * 400 + Vector(0,0,210))

	local effectdata = EffectData()
		effectdata:SetOrigin(owner:GetShootPos())
		effectdata:SetEntity(owner)
	util.Effect("meleeclash", effectdata, true, true)
end

function SWEP:MeleeStrike(damage, dmgtyp, knockdown)
	local owner = self.Owner

	damage = damage * owner.MeleeDamageMultiplier

	local eyepos = owner:GetShootPos()
	local ownerpos = owner:GetPos()
	local aimvec = owner:GetAimVector()
	local ownerteam = owner:Team()

	local hit
	local effectpos

	local endpos = eyepos + aimvec * 30
	for _, ent in pairs(ents.FindInSphere(endpos, 40)) do
		if ent.PHealth or ent.CoreHealth or ent.ScriptVehicle then
			if MeleeVisible(ent:NearestPoint(eyepos), eyepos, {ent, owner}) then
				effectpos = ent:NearestPoint(eyepos)
				ent:TakeSpecialDamage(damage, dmgtyp, owner, self)
				hit = true
			end
		elseif ent ~= owner and ent:IsPlayer() then
			if ent:IsPlayer() then
				local nearest = ent:NearestPoint(eyepos)
				if ent:Alive() and TrueVisible(nearest, eyepos) then
					if ent:Team() ~= owner:Team() then
						hit = true
						local wep = ent:GetActiveWeapon()
						if wep.CanGuard and wep:CanGuard(owner, self) then
							wep:Guarded(owner, self)
						elseif wep.CanClash and wep:CanClash(owner, self) then
							wep:Clashed(owner, self)
							if self.Clashed then
								self:Clashed(wep.Owner, wep)
							end
						else
							ent:BloodSpray(nearest, math.random(10, 13), owner:GetAimVector(), 300)
							ent:HitByMelee(owner, self)
							effectpos = ent:NearestPoint(eyepos)
							ent:TakeSpecialDamage(damage, dmgtyp, owner, self)
							if knockdown and ent:Team() ~= ownerteam then
								local vec = ent:GetPos() - ownerpos
								vec.z = 0
								vec = vec:Normalize()
								ent:SetGroundEntity(NULL)
								ent:SetVelocity(vec * 500 + Vector(0, 0, 300))
								ent:KnockDown()
							end
						end
					end
				end
			elseif TrueVisible(ent:NearestPoint(eyepos), eyepos) then
				hit = true
				ent:TakeSpecialDamage(damage, dmgtyp, owner, self)
				effectpos = ent:NearestPoint(eyepos)
			end
		end
	end

	if not hit then
		local tr = util.TraceLine({start = eyepos, endpos = eyepos + aimvec * 70, mask = MASK_PLAYERSOLID, filter = owner})
		if tr.Hit then
			effectpos = tr.HitPos
		end
	end

	if effectpos then
		local effectdata = EffectData()
			effectdata:SetOrigin(effectpos)
			effectdata:SetStart(eyepos)
		util.Effect("meleehit", effectdata, true, true)
		util.ScreenShake(effectpos, damage, 0.5, 0.75, 72)
	end
end

function SWEP:Think()
	local ct = CurTime()

	local owner = self.Owner
	local skin = self:GetSkin()
	if skin == 1 then
		local pow,stamcost
		local cancel = false
		local curstam = owner:GetStamina()
		local force = false
		
		if self.StartSwing then
			pow = (ct - self.StartSwing) / self.MaxChargeTime
			stamcost = 50 * pow
			if pow > self.MinCharge and self.PlayCharged then
				owner:EmitSound("npc/attack_helicopter/aheli_charge_up.wav", 76, math.Rand(140, 155))
				self.PlayCharged = nil
			end
			if stamcost > curstam and pow > self.MinCharge then
				pow = curstam / (stamcost/pow)
				force = true
			end
		end
		
		if not self.FinishSwing then
			self:SetSkin(0)
		elseif not owner:KeyDown(IN_ATTACK2) or self.FinishSwing <= ct or force then
			if curstam >= stamcost and pow > self.MinCharge or force then
				owner:SetStamina(curstam - stamcost, true)
				self:SetSkin(2)
				self.FinishSwing = ct + 0.8 * pow
				owner:EmitSound("weapons/mortar/mortar_shell_incomming1.wav", 100, math.Rand(105, 115))
				owner:SetAnimation(PLAYER_JUMP)
				self.ChargePower = math.Clamp(pow, 0, 1)
			else
				cancel = true
			end
		elseif owner:KeyDown(IN_ATTACK) then
			cancel = true
		end
		
		if cancel then
			owner:SetNextAttack(ct + 0.6)
			self:SetSkin(0)
			self.FinishSwing = nil
			owner:EmitSound("npc/combine_gunship/attack_start2.wav", 100, math.random(60,70))
		end
	elseif skin == 2 then
		if not self.FinishSwing then
			self:SetSkin(0)
		elseif self.FinishSwing <= ct or util.TraceHull({start=owner:GetPos(), endpos=owner:GetPos() + owner:GetForward() * 32, mask=MASK_PLAYERSOLID, filter=owner, mins=owner:OBBMins(), maxs=owner:OBBMaxs()}).Hit then
			self.FinishSwing = nil
			owner:Stun(1.6*self.ChargePower, true)
			self.FinishSwing = ct + 0.1
			owner:RestartGesture(ACT_HL2MP_GESTURE_RANGE_ATTACK_MELEE2)
			owner:EmitSound("nox/sword_miss.wav", 75, math.Rand(50, 63))
			self:SetSkin(3)
		end
	elseif skin == 3 then
		if not self.FinishSwing then
			self:SetSkin(0)
		elseif self.FinishSwing <= ct then
			self.FinishSwing = nil
			self:MeleeStrike(34*self.ChargePower, DMGTYPE_FIRE, true)
			self:SetSkin(0)
			self.ChargePower = nil
		end
	elseif skin == 4 then
		if not self.FinishSwing then
			self:SetSkin(0)
		elseif self.FinishSwing <= ct then
			self:SetSkin(5)
			self.FinishSwing = ct + 0.3
			owner:EmitSound("weapons/mortar/mortar_shell_incomming1.wav", 73, math.Rand(105, 115))
			owner:SetAnimation(PLAYER_JUMP)
		end
	elseif skin == 5 then
		if not self.FinishSwing then
			self:SetSkin(0)
		elseif self.FinishSwing <= ct or owner:IsOnGround() then
			self:SetSkin(0)
			self.FinishSwing = nil
			owner:Stun(0.75, true)
			self.JumpAttackRecovery = ct + 0.75
			owner:SetLocalVelocity(Vector(0,0,0))

			owner:RestartGesture(ACT_HL2MP_GESTURE_RANGE_ATTACK_MELEE2)

			local pos = owner:GetPos() + owner:GetForward() * 32 + Vector(0, 0, 24)
			if not TrueVisible(pos, owner:GetShootPos()) then
				pos = owner:GetPos() + Vector(0, 0, 4)
			end

			local effectdata = EffectData()
				effectdata:SetOrigin(pos)
			util.Effect("sunbeamexplosion", effectdata, true, true)

			owner:GodEnable()
			local damagedents = ExplosiveDamage(owner, self, pos, 100, 100, 0, 0.01, 30 * owner.MeleeDamageMultiplier, DMGTYPE_FIRE)
			owner:GodDisable()
			for ent in pairs(damagedents) do
				if ent ~= owner and ent.KnockDown and ent:GetTeamID() ~= owner:Team() and ent:Alive() then
					ent:SetGroundEntity(NULL)
					ent:SetLocalVelocity(Vector(0, 0, 800))
					ent:KnockDown()
				end
			end
		end
	elseif self.FinishSwing and self.FinishSwing <= ct then
		self:MeleeStrike(29, DMGTYPE_PHYSICAL)
		self.FinishSwing = nil
	end

	self:NextThink(ct)
	return true
end

function SWEP:HitByMelee(attacker, attackerweapon)
	self.FinishSwing = nil
	self.JumpAttackRecovery = 0
	self.Owner:SetNextAttack(CurTime() + 0.75)
end

function SWEP:PrimaryAttack()	
	local owner = self.Owner
	local ct = CurTime()
	if owner.Stunned or ct < owner:GetNextAttack() or self:GetSkin() ~= 0 then return end
	owner:SetNextAttack(ct + 0.75)

	if owner.Sprinting then
		owner:RemoveStatus("sprint", false, true)
	end

	if owner.DashDodging then
		owner:RemoveStatus("dashdodge*", false, true)
	end

	local pos = owner:GetPos()
	if owner:IsOnGround() or owner.DodgedInAir or 2 <= owner:WaterLevel() or owner:GetMoveType() == MOVETYPE_LADDER or owner.WallRunning or owner.Stunned or util.TraceLine({start=pos, endpos = pos + Vector(0,0,-48), mask = MASK_PLAYERSOLID, filter = owner}).Hit then
		owner:EmitSound("nox/sword_miss.wav", 75, math.Rand(50, 63))
		owner:RestartGesture(ACT_HL2MP_GESTURE_RANGE_ATTACK_MELEE2)
		self.FinishSwing = ct + 0.15
	else
		owner:EmitSound("ambient/machines/thumper_dust.wav", 76, math.Rand(80, 95))
		owner:EmitSound("npc/attack_helicopter/aheli_charge_up.wav", 76, math.Rand(120, 125))
		self.FinishSwing = ct + 0.35
		self:SetSkin(4)
	end
end

function SWEP:SecondaryAttack()
	local owner = self.Owner
	local ct = CurTime()
	if owner.Stunned and self.JumpAttackRecovery < ct or ct < owner:GetNextAttack() or 0 < self:GetSkin() or owner.DodgedInAir or owner:GetStamina() < 15 then return end
	self.JumpAttackRecovery = 0
	owner:SetNextAttack(ct + 3)

	if owner.Sprinting then
		owner:RemoveStatus("sprint", false, true)
	end

	if owner.DashDodging then
		owner:RemoveStatus("dashdodge*", false, true)
	end

	if owner.WallRunning then
		owner:RemoveStatus("wallrun*", false, true)
	end

	owner.DodgedInAir = true
	owner:EmitSound("ambient/machines/thumper_dust.wav", 76, math.Rand(80, 95))
	owner:EmitSound("npc/attack_helicopter/aheli_charge_up.wav", 76, math.Rand(120, 125))
	self.FinishSwing = ct + self.MaxChargeTime
	self.StartSwing = ct
	self:SetSkin(1)
	self.PlayCharged = true
end

function SWEP:Reload()
end