AddCSLuaFile("shared.lua")

SWEP.Base = "weapon_gun_base"

SWEP.ViewModel = "models/weapons/v_pistol.mdl"
SWEP.WorldModel = "models/weapons/w_pistol.mdl"
SWEP.HoldType = "pistol"

if CLIENT then
	killicon.AddFont("weapon_zagger", "HL2MPTypeDeath", "-", color_white)

	SWEP.PrintName = "Zagger"
	SWEP.AngleLerp = 0

	function SWEP:CalcView(pl, origin, angles, fov, view)
		view.angles = angles
		view.origin = origin
		view.fov = fov

		if pl:KeyDown(IN_ATTACK2) and not self.IsReloading then
			self.AngleLerp = math.max(-80, self.AngleLerp - FrameTime() * math.max(math.abs(self.AngleLerp) * 10, 400))
		elseif self.AngleLerp < 0 then
			self.AngleLerp = math.min(0, self.AngleLerp + FrameTime() * math.max(math.abs(self.AngleLerp) * 7, 300))
		end

		if self.AngleLerp < 0 then
			view.vm_origin = origin + self.AngleLerp * 0.12 * angles:Up()
			local vmangles = Angle(angles.pitch, angles.yaw, angles.roll)
			vmangles:RotateAroundAxis(vmangles:Forward(), self.AngleLerp)
			view.vm_angles = vmangles
		else
			view.vm_origin = origin
			view.vm_angles = angles
		end
	end
end

SWEP.Primary.Mana = 2.5
SWEP.Primary.Damage = 13
SWEP.Primary.Delay = 0.3
SWEP.Primary.Sound = Sound("Weapon_Pistol.NPC_Single")
SWEP.Primary.Offsets = {Vector(0,1.5,0), Vector(0,-1.5,0), Vector(1.5,0,0), Vector(-1.5,0,0), Vector(0,0,0)}
SWEP.Primary.NumOffsets = #SWEP.Primary.Offsets
SWEP.Primary.Gesture = ACT_HL2MP_GESTURE_RANGE_ATTACK_PISTOL

SWEP.Secondary.Mana = SWEP.Primary.Mana
SWEP.Secondary.Damage = SWEP.Primary.Damage
SWEP.Secondary.Delay = 0.2
SWEP.Secondary.Sound = SWEP.Primary.Sound
SWEP.Secondary.Offsets = {Vector(0,4.6,0), Vector(0,-4.6,0), Vector(4.6,0,0), Vector(-4.6,0,0)}
SWEP.Secondary.NumOffsets = #SWEP.Secondary.Offsets
SWEP.Secondary.Gesture = SWEP.Primary.Gesture
SWEP.Secondary.Automatic = true

SWEP.EndShootingDelay = 0.35

SWEP.ReloadSound = Sound("Weapon_Pistol.Reload")
SWEP.ReloadGesture = ACT_HL2MP_GESTURE_RELOAD_PISTOL

SWEP.HasSecondary = true

function SWEP:Holster()
	if self.Owner:CanSwitchWeapon() then
		self.IsReloading = nil

		if self.PlayingSideHold then
			self.Owner:StopLuaAnimation("zgrsdhld")
		end

		return true
	end

	return false
end

function SWEP:Think()
	local owner = self.Owner
	if self.IsReloading and self.IsReloading <= CurTime() then
		local curammo = self:Clip1()
		local manaperbullet = self.Primary.Mana * owner.GunManaUseMultiplier
		local curmana = owner:GetMana()
		if not self.ReloadSingle then
			local bulletstogive = math.min(self.Primary.ClipSize - curammo, math.floor(curmana / manaperbullet))

			self:SetClip1(curammo + bulletstogive)
			owner:SetMana(curmana - bulletstogive * manaperbullet)
			self:EmitSound("nox/manadraining.wav", 69, math.Rand(100, 110))
			--self:SetClip1(self.Primary.ClipSize)
			--self:SetClip2(self.Secondary.ClipSize)

			self.IsReloading = nil
			self:SendWeaponAnim(ACT_VM_IDLE)
		elseif self.Primary.ClipSize <= curammo or curmana < manaperbullet then
			self.IsReloading = nil
			if self.ReloadFinishAnim then
				self:SendWeaponAnim(self.ReloadFinishAnim)
			end
			if self.ReloadFinishSound then
				self:EmitSound(self.ReloadFinishSound)
			end
			if self.ReloadFinishGesture then
				owner:RestartGesture(self.ReloadFinishGesture)
			end
			owner:SetMana(curmana)
		else
			self:SetClip1(curammo + 1)
			owner:SetMana(curmana - manaperbullet)
			self:EmitSound("nox/manadraining.wav", 69, math.Rand(140, 155))
			if self.ReloadAnim then
				self:SendWeaponAnim(self.ReloadAnim)
			end
			self.IsReloading = CurTime() + (self.ReloadDuration or self:SequenceDuration())
			if self.ReloadSound then
				self:EmitSound(self.ReloadSound)
			end
			if self.ReloadGesture then
				owner:RestartGesture(self.ReloadGesture)
			end
		end
	end

	if self.PlayingSideHold then
		if not owner:KeyDown(IN_ATTACK2) or self.IsReloading then
			self.PlayingSideHold = nil
			owner:StopLuaAnimation("zgrsdhld")
		end
	elseif owner:KeyDown(IN_ATTACK2) and not self.IsReloading then
		self.PlayingSideHold = true
		owner:SetLuaAnimation("zgrsdhld")
	end
end

RegisterLuaAnimation("zgrsdhld", {
	TimeToArrive = 0.15,
	FrameData = {
		{
			BoneInfo = {
				["ValveBiped.Bip01_R_Hand"] = {
					RF = -80
				},
				["ValveBiped.Bip01_L_Forearm"] = {
					RU=-40
				},
				["ValveBiped.Bip01_L_Upperarm"] = {
					RU = 60
				},
				["ValveBiped.Bip01_L_Hand"] = {
					RF=50
				}
			}
		}
	},
	Type = TYPE_POSTURE
})
