killicon.Add("player", "spellicons/death", color_white)
killicon.Add("suicide", "spellicons/death", color_white)
killicon.Add("worldspawn", "spellicons/death", color_white)

killicon.AddFont("prop_physics", "HL2MPTypeDeath", "9", color_white)
killicon.AddFont("prop_physics_multiplayer", "HL2MPTypeDeath", "9", color_white)

killicon.Add("dummy_burn", "spellicons/burn", color_white)
killicon.AddAlias("env_fire", "dummy_burn")

killicon.Add("status_energybolt", "spellicons/energybolt", color_white)

killicon.Add("dummy_shock", "spellicons/shock", color_white)
killicon.Add("dummy_sunbeam", "spellicons/sunbeam", color_white)
killicon.Add("dummy_lightning", "spellicons/lightning", color_white)
killicon.AddAlias("status_lightning", "dummy_lightning")

killicon.Add("projectile_staticball", "spellicons/staticball", color_white)
killicon.Add("projectile_electronball", "spellicons/obliteration", color_white)
killicon.Add("projectile_protrusionspike", "spellicons/protrusion", color_white)
killicon.Add("projectile_firebomb", "spellicons/starburst", color_white)
killicon.Add("projectile_magicmissile", "spellicons/missilesofmagic", color_white)
killicon.Add("projectile_firebolt", "spellicons/fireball", color_white)
killicon.Add("projectile_flamespiral", "spellicons/fireball", color_white)
killicon.Add("projectile_magicarrow", "spellicons/moonglow", color_white)
killicon.Add("projectile_flare", "spellicons/firebullet", color_white)
killicon.Add("projectile_sparkler", "spellicons/sparkler", color_white)
killicon.Add("projectile_flamestrike", "spellicons/explosion", color_white)
killicon.Add("entityflame", "spellicons/explosion", color_white)

killicon.Add("npc_summonedzombie", "spellicons/summonzombie", color_white)

killicon.Add("vehicle_noxhovercycle", "spellicons/vehicle_noxhovercycle3", color_white)
killicon.AddAlias("projectile_plasmabolt_hovercycle", "vehicle_noxhovercycle")
killicon.Add("projectile_plasmabolt", "spellicons/plasma2", color_white)
killicon.AddAlias("projectile_plasma_mountablecannon", "projectile_plasmabolt")
killicon.Add("vehicle_noxbase", "spellicons/vehicle_noxbase", color_white)
killicon.AddAlias("projectile_assaultrovercannon", "vehicle_noxbase")
killicon.Add("vehicle_noxraven", "spellicons/vehicle_noxraven", color_white)
killicon.Add("vehicle_noxwasp", "spellicons/vehicle_noxwasp", color_white)
killicon.AddAlias("projectile_ravenmissile", "vehicle_noxraven")
killicon.Add("vehicle_noxdropship", "spellicons/vehicle_noxdropship", color_white)
killicon.AddAlias("projectile_dropshipcannon", "vehicle_noxdropship")
killicon.AddAlias("projectile_dropshipmissile", "vehicle_noxdropship")
killicon.Add("vehicle_noxvulture", "spellicons/vehicle_noxvulture", color_white)
killicon.AddAlias("projectile_vulturebomb", "vehicle_noxvulture")

local function RagdollColor(victim)
	local rag = victim:GetRagdollEntity()
	if rag and rag:IsValid() then
		local r,g,b,a = rag:GetColor()
		if r == 255 and g == 255 and b == 255 and a == 255 then
			rag:SetColor(victim:GetColor())
		end
	end
end

usermessage.Hook("PlayerKilledByPlayers", function(message)
	local victim = message:ReadEntity()
	local inflictor = message:ReadString()
	local attacker = message:ReadEntity()
	local attacker2 = message:ReadEntity()

	if victim:IsValid() and attacker:IsValid() and attacker2:IsValid() then
		RagdollColor(victim)
		local attackername = attacker:Name()
		local victimname = victim:Name()
		local attacker2name = attacker2:Name()
		GAMEMODE:AddDeathNotice(attackername, attacker:Team(), attacker2name, attacker2:Team(), inflictor, victimname, victim:Team())
		print(attackername.." killed "..victimname.." with assistance from "..attacker2name.." with "..inflictor)

		if attacker == MySelf then
			GAMEMODE:AddNotify("You killed "..victimname.." with help from "..attacker2name..".")
		elseif attacker2 == MySelf then
			GAMEMODE:AddNotify("You helped "..attackername.." kill "..victimname..".")
		elseif victim == MySelf then
			GAMEMODE:AddNotify("You were killed by "..attackername.." and "..attacker2name..".", COLOR_RED)
		end
	end
end)

usermessage.Hook("PlayerKilledByPlayer", function(message)
	local victim = message:ReadEntity()
	local inflictor = message:ReadString()
	local attacker = message:ReadEntity()

	if victim:IsValid() and attacker:IsValid() then
		RagdollColor(victim)
		local attackername = attacker:Name()
		local victimname = victim:Name()
		GAMEMODE:AddDeathNotice(attackername, attacker:Team(), nil, nil, inflictor, victimname, victim:Team())
		print(attackername.." killed "..victimname.." with "..inflictor)

		if attacker == MySelf then
			GAMEMODE:AddNotify("You killed "..victimname..".")
		elseif victim == MySelf then
			GAMEMODE:AddNotify("You were killed by "..attackername..".", COLOR_RED)
		end
	end
end)

usermessage.Hook("PlayerKilledSelf", function(message)
	local victim = message:ReadEntity()
	local inflictor = message:ReadString()

	if victim:IsValid() then
		RagdollColor(victim)
		GAMEMODE:AddDeathNotice(nil, nil, nil, nil, inflictor, victim:Name(), victim:Team())
		print(victim:Name().." killed themself with "..inflictor)

		if victim == MySelf then
			GAMEMODE:AddNotify("You killed yourself.", COLOR_RED)
		end
	end
end)

usermessage.Hook("PlayerKilled", function(message)
	local victim = message:ReadEntity()
	local inflictor = message:ReadString()
	local attacker = "#"..message:ReadString()

	if victim:IsValid() then
		RagdollColor(victim)
		GAMEMODE:AddDeathNotice(attacker, -1, nil, nil, inflictor, victim:Name(), victim:Team())
		print(victim:Name().." was killed by "..inflictor)

		if victim == MySelf then
			GAMEMODE:AddNotify("You were killed by a "..attacker..".", COLOR_RED)
		end
	end
end)

local deathnoticetime = CreateClientConVar("hud_deathnotice_time", 6, true, false)
local Deaths = {}

function GM:AddDeathNotice(leftstring, leftteam, assiststring, assistteam, inflictorstring, rightstring, rightteam)
	local Death = {time = RealTime() + deathnoticetime:GetFloat(), left = leftstring, right = rightstring, assist = assiststring, icon = inflictorstring}

	if leftteam == -1 then Death.leftcolor = color_white
	else Death.leftcolor = team.GetColor(leftteam) end

	if assistteam == -1 then Death.assistcolor = color_white
	else Death.assistcolor = team.GetColor(assistteam) end

	if rightteam == -1 then Death.rightcolor = color_white
	else Death.rightcolor = team.GetColor(rightteam) end

	if Death.left == Death.right then
		Death.left = nil
		Death.icon = "suicide"
	end

	if #Deaths > 8 then
		table.remove(Deaths, 1)
	end

	table.insert(Deaths, Death)
end

--local colTrans = Color(20, 20, 20, 90)
local function DrawDeath(x, y, death)
	local wid, hei = killicon.GetSize(death.icon)

	surface.SetFont("ChatFont")
	local texw, texh = surface.GetTextSize(death.right)
	x = x - texw
	draw.DrawText(death.right, "ChatFont", x, y, death.rightcolor, TEXT_ALIGN_LEFT)

	local tw, th = killicon.GetSize(death.icon)
	tw = tw * 0.5 + 6
	x = x - tw
	killicon.Draw(x, y, death.icon, 255)
	x = x - tw

	if death.assist then
		texw, texh = surface.GetTextSize(death.assist)
		x = x - texw - 12
		draw.DrawText(death.assist, "ChatFont", x, y, death.assistcolor, TEXT_ALIGN_LEFT)
		texw, texh = surface.GetTextSize(" + ")
		x = x - texw
		draw.DrawText(" + ", "ChatFont", x, y, color_white, TEXT_ALIGN_LEFT)
		draw.DrawText(death.left, "ChatFont", x, y, death.leftcolor, TEXT_ALIGN_RIGHT)
	elseif death.left then
		draw.DrawText(death.left, "ChatFont", x, y, death.leftcolor, TEXT_ALIGN_RIGHT)
	end

	return y + math.max(hei, texh)
end

function GM:DrawDeathNotice(x, y, screenscale)
	if #Deaths <= 0 then return end

	local done = true
	for k, Death in pairs(Deaths) do
		if RealTime() <= Death.time then
			done = false

			y = DrawDeath(x, y, Death)
		end
	end

	if done then
		Deaths = {}
	end
end
