include("global/cl_noxiousdb.lua")

if not MySelf then
	MySelf = NULL
end
hook.Add("Think", "GetLocal", function()
	MySelf = LocalPlayer()
	if MySelf:IsValid() then
		gamemode.Call("HookGetLocal", MySelf)
		MySelf.Money = MySelf.Money or 0
		MySelf.MemberLevel = MySelf.MemberLevel or MEMBER_NONE or 0
		RunConsoleCommand("PostPlayerInitialSpawn")
		hook.Remove("Think", "GetLocal")
	end
end)

include("shared.lua")

COLOR_RED = Color(255, 0, 0)
COLOR_BLUE = Color(0, 0, 255)
COLOR_GREEN = Color(0, 255, 0)
COLOR_YELLOW = Color(255, 255, 0)
COLOR_ORANGE = Color(255, 200, 0)
COLOR_PURPLE = Color(255, 0, 255)
COLOR_CYAN = Color(0, 255, 255)
COLOR_WHITE = Color(255, 255, 255)
COLOR_BLACK = Color(0, 0, 0)

color_black_alpha180 = Color(0, 0, 0, 180)

include("cl_scoreboard.lua")
include("cl_deathnotice.lua")
include("cl_notice.lua")
include("nox_shared_spelldefines.lua")
include("cl_noxious_localization.lua")
include("vehicles_shared.lua")
include("cl_dermaskin.lua")
include("cl_boneanimlib.lua")

include("vgui/dmodelpanel2.lua")
include("vgui/pmain.lua")
include("vgui/paspects.lua")
include("vgui/pbuilder.lua")
include("vgui/pspells.lua")
include("vgui/phelp.lua")
include("vgui/poptions.lua")
include("vgui/pprofiles.lua")
include("vgui/ploadout.lua")
include("vgui/vehiclepad.lua")

include("skins/steam-default.lua")

include("gametypes/cl_ctf.lua")
include("gametypes/cl_blitz.lua")

COLOR_HEALTHY = COLOR_GREEN
COLOR_HURT = COLOR_YELLOW
COLOR_CRITICAL = COLOR_RED

CreateClientConVar("nox_declinefriendlyteleports", 0, true, true)
CreateClientConVar("_nox_effectquality", 2, true, false)
EFFECT_QUALITY = math.max(0, math.min(math.floor(GetConVarNumber("_nox_effectquality")), 3))
EFFECT_IQUALITY = 3 - EFFECT_QUALITY
EYETRACE_ENTITY = NULL
EYETRACE_HITPOS = Vector(0,0,0)
EYETRACE_HITNORMAL = Vector(0,0,1)
TARGETID_LAST = NULL
nospellshint = true
w, h = ScrW(), ScrH()
color_black_alpha90 = Color(0, 0, 0, 90)
NEXT_FIGHTMODE = NEXT_FIGHTMODE or 0
DelayIcons = {}

HumanGibs = {Model("models/gibs/HGIBS.mdl"),
Model("models/gibs/HGIBS_spine.mdl"),
Model("models/gibs/HGIBS_rib.mdl"),
Model("models/gibs/HGIBS_scapula.mdl"),
Model("models/gibs/antlion_gib_medium_2.mdl"),
Model("models/gibs/Antlion_gib_Large_1.mdl"),
Model("models/gibs/Strider_Gib4.mdl")}

GM.MenuTabs = {"Help", "Profiles", "Aspects", "Loadout", "Spells", "Options"}

file.CreateDir("noxaspects")

if not file.Exists("noxaspects/default.txt") then
	local tosav = {}
	tosav.Aspects = {}
	for i=1, NUMASPECTS do
		--tosav.Aspects[i] = 0.5
		tosav.Aspects[i] = ASPECTS_MAX / NUMASPECTS
	end
	tosav.Loadout = {}
	for i=1, NUMWEAPONSLOTS do
		tosav.Loadout[i] = i
	end
	local spell_sheet = {}
	spell_sheet[IN_FORWARD] = {}
	spell_sheet[IN_FORWARD][1] = "-"
	spell_sheet[IN_FORWARD][2] = "-"
	spell_sheet[IN_BACK] = {}
	spell_sheet[IN_BACK][1] = "-"
	spell_sheet[IN_BACK][2] = "-"
	spell_sheet[IN_MOVELEFT] = {}
	spell_sheet[IN_MOVELEFT][1] = "-"
	spell_sheet[IN_MOVELEFT][2] = "-"
	spell_sheet[IN_MOVERIGHT] = {}
	spell_sheet[IN_MOVERIGHT][1] = "-"
	spell_sheet[IN_MOVERIGHT][2] = "-"
	spell_sheet[IN_FORWARD + IN_MOVELEFT] = {}
	spell_sheet[IN_FORWARD + IN_MOVELEFT][1] = "-"
	spell_sheet[IN_FORWARD + IN_MOVELEFT][2] = "-"
	spell_sheet[IN_FORWARD + IN_MOVERIGHT] = {}
	spell_sheet[IN_FORWARD + IN_MOVERIGHT][1] = "-"
	spell_sheet[IN_FORWARD + IN_MOVERIGHT][2] = "-"
	spell_sheet[IN_BACK + IN_MOVELEFT] = {}
	spell_sheet[IN_BACK + IN_MOVELEFT][1] = "-"
	spell_sheet[IN_BACK + IN_MOVELEFT][2] = "-"
	spell_sheet[IN_BACK + IN_MOVERIGHT] = {}
	spell_sheet[IN_BACK + IN_MOVERIGHT][1] = "-"
	spell_sheet[IN_BACK + IN_MOVERIGHT][2] = "-"
	tosav.Model = GetConVarString("cl_playermodel") or "kliener"
	tosav.SpellSheet = spell_sheet
	file.Write("noxaspects/default.txt", Serialize(tosav))
end

function BuildSpellSheet(spell_sheet)
	spell_sheet[IN_FORWARD] = spell_sheet[IN_FORWARD] or {}
	spell_sheet[IN_FORWARD][1] = spell_sheet[IN_FORWARD][1] or "-"
	spell_sheet[IN_FORWARD][2] = spell_sheet[IN_FORWARD][2] or "-"
	spell_sheet[IN_BACK] = spell_sheet[IN_BACK] or {}
	spell_sheet[IN_BACK][1] = spell_sheet[IN_BACK][1] or "-"
	spell_sheet[IN_BACK][2] = spell_sheet[IN_BACK][2] or "-"
	spell_sheet[IN_MOVELEFT] = spell_sheet[IN_MOVELEFT] or {}
	spell_sheet[IN_MOVELEFT][1] = spell_sheet[IN_MOVELEFT][1] or "-"
	spell_sheet[IN_MOVELEFT][2] = spell_sheet[IN_MOVELEFT][2] or "-"
	spell_sheet[IN_MOVERIGHT] = spell_sheet[IN_MOVERIGHT] or {}
	spell_sheet[IN_MOVERIGHT][1] = spell_sheet[IN_MOVERIGHT][1] or "-"
	spell_sheet[IN_MOVERIGHT][2] = spell_sheet[IN_MOVERIGHT][2] or "-"
	spell_sheet[IN_FORWARD + IN_MOVELEFT] = spell_sheet[IN_FORWARD + IN_MOVELEFT] or {}
	spell_sheet[IN_FORWARD + IN_MOVELEFT][1] = spell_sheet[IN_FORWARD + IN_MOVELEFT][1] or "-"
	spell_sheet[IN_FORWARD + IN_MOVELEFT][2] = spell_sheet[IN_FORWARD + IN_MOVELEFT][2] or "-"
	spell_sheet[IN_FORWARD + IN_MOVERIGHT] = spell_sheet[IN_FORWARD + IN_MOVERIGHT] or {}
	spell_sheet[IN_FORWARD + IN_MOVERIGHT][1] = spell_sheet[IN_FORWARD + IN_MOVERIGHT][1] or "-"
	spell_sheet[IN_FORWARD + IN_MOVERIGHT][2] = spell_sheet[IN_FORWARD + IN_MOVERIGHT][2] or "-"
	spell_sheet[IN_BACK + IN_MOVELEFT] = spell_sheet[IN_BACK + IN_MOVELEFT] or {}
	spell_sheet[IN_BACK + IN_MOVELEFT][1] = spell_sheet[IN_BACK + IN_MOVELEFT][1] or "-"
	spell_sheet[IN_BACK + IN_MOVELEFT][2] = spell_sheet[IN_BACK + IN_MOVELEFT][2] or "-"
	spell_sheet[IN_BACK + IN_MOVERIGHT] = spell_sheet[IN_BACK + IN_MOVERIGHT] or {}
	spell_sheet[IN_BACK + IN_MOVERIGHT][1] = spell_sheet[IN_BACK + IN_MOVERIGHT][1] or "-"
	spell_sheet[IN_BACK + IN_MOVERIGHT][2] = spell_sheet[IN_BACK + IN_MOVERIGHT][2] or "-"

	return spell_sheet
end

SPELL_SHEET = BuildSpellSheet(SPELL_SHEET or {})

GM.PredefinedProfiles = {}
GM.PredefinedProfiles["template_mage"] = {
	Aspects = {
		[ASPECT_MIGHT] = 0,
		[ASPECT_STRENGTH] = 0.1,
		[ASPECT_ENDURANCE] = 0.5,
		[ASPECT_SPIRIT] = 0.75,
		[ASPECT_INTELLIGENCE] = 0.75,
		[ASPECT_MIND] = 0.75,
		[ASPECT_DESTRUCTION] = 0.75,
		[ASPECT_DEFENSIVE] = 0.75,
		[ASPECT_CURSING] = 0.75,
		[ASPECT_HEALING] = 0.65,
		[ASPECT_DEXTERITY] = 0.25,
		[ASPECT_SPEED] = 0.5,
		[ASPECT_AGILITY] = 0.35,
		[ASPECT_WILL] = 0.5,
		[ASPECT_RECOVERY] = 0,
		[ASPECT_TECH] = 0.3,
		[ASPECT_GUNMASTERY] = 0.25,
		[ASPECT_CRAFTSMANSHIP] = 0,
		[ASPECT_ACCURACY] = 0,
		[ASPECT_INSTINCT] = 0.1
	},
	Loadout = {WEAPON_APPRENTICEWAND, WEAPON_APPRENTICESTAFF, WEAPON_ZAGGER},
	SpellSheet = {
		[IN_FORWARD] = {"Fire Bolt", "Flame Spiral"},
		[IN_BACK] = {"Greater Heal", "Reflective Shield"},
		[IN_MOVELEFT] = {"Electron Ball", "Flare"},
		[IN_MOVERIGHT] = {"Sparkler", "Protrusion"},
		[IN_FORWARD + IN_MOVELEFT] = {"Energy Bolt", "Lightning"},
		[IN_FORWARD + IN_MOVERIGHT] = {"Mana Burn", "Flash"},
		[IN_BACK + IN_MOVELEFT] = {"Protect From Fire", "Protect From Shock"},
		[IN_BACK + IN_MOVERIGHT] = {"Protect From Cold", "Protect From Poison"}
	},
	Model = "kliener"
}
GM.PredefinedProfiles["template_warrior"] = {
	Aspects = {
		[ASPECT_MIGHT] = 1,
		[ASPECT_STRENGTH] = 1,
		[ASPECT_ENDURANCE] = 1,
		[ASPECT_SPIRIT] = 0,
		[ASPECT_INTELLIGENCE] = 0,
		[ASPECT_MIND] = 0,
		[ASPECT_DESTRUCTION] = 0,
		[ASPECT_DEFENSIVE] = 0,
		[ASPECT_CURSING] = 0,
		[ASPECT_HEALING] = 0,
		[ASPECT_DEXTERITY] = 1,
		[ASPECT_SPEED] = 1,
		[ASPECT_AGILITY] = 1,
		[ASPECT_WILL] = 1,
		[ASPECT_RECOVERY] = 0,
		[ASPECT_TECH] = 0.3,
		[ASPECT_GUNMASTERY] = 0.7,
		[ASPECT_CRAFTSMANSHIP] = 0,
		[ASPECT_ACCURACY] = 0,
		[ASPECT_INSTINCT] = 0
	},
	Loadout = {WEAPON_GLADRADUS, WEAPON_FROTCHET, WEAPON_ZAGGER},
	SpellSheet = {
		[IN_FORWARD] = {"-", "-"},
		[IN_BACK] = {"-", "-"},
		[IN_MOVELEFT] = {"-", "-"},
		[IN_MOVERIGHT] = {"-", "-"},
		[IN_FORWARD + IN_MOVELEFT] = {"-", "-"},
		[IN_FORWARD + IN_MOVERIGHT] = {"-", "-"},
		[IN_BACK + IN_MOVELEFT] = {"-", "-"},
		[IN_BACK + IN_MOVERIGHT] = {"-", "-"}
	},
	Model = "stripped"
}
GM.PredefinedProfiles["template_runner"] = {
	Aspects = {
		[ASPECT_MIGHT] = 0.25,
		[ASPECT_STRENGTH] = 0.5,
		[ASPECT_ENDURANCE] = 1,
		[ASPECT_SPIRIT] = 0.25,
		[ASPECT_INTELLIGENCE] = 0.25,
		[ASPECT_MIND] = 0.25,
		[ASPECT_DESTRUCTION] = 0,
		[ASPECT_DEFENSIVE] = 0,
		[ASPECT_CURSING] = 0.2,
		[ASPECT_HEALING] = 0.25,
		[ASPECT_DEXTERITY] = 1,
		[ASPECT_SPEED] = 1,
		[ASPECT_AGILITY] = 1,
		[ASPECT_WILL] = 1,
		[ASPECT_RECOVERY] = 0.75,
		[ASPECT_TECH] = 0.3,
		[ASPECT_GUNMASTERY] = 0,
		[ASPECT_CRAFTSMANSHIP] = 0,
		[ASPECT_ACCURACY] = 0,
		[ASPECT_INSTINCT] = 0
	},
	Loadout = {WEAPON_GLADRADUS, WEAPON_APPRENTICEWAND, WEAPON_ZAGGER},
	SpellSheet = {
		[IN_FORWARD] = {"Tag", "-"},
		[IN_BACK] = {"Minor Heal", "-"},
		[IN_MOVELEFT] = {"-", "-"},
		[IN_MOVERIGHT] = {"-", "-"},
		[IN_FORWARD + IN_MOVELEFT] = {"-", "-"},
		[IN_FORWARD + IN_MOVERIGHT] = {"-", "-"},
		[IN_BACK + IN_MOVELEFT] = {"-", "-"},
		[IN_BACK + IN_MOVERIGHT] = {"-", "-"}
	},
	Model = "stripped"
}
GM.PredefinedProfiles["template_builder"] = {
	Aspects = {
		[ASPECT_MIGHT] = 0.5,
		[ASPECT_STRENGTH] = 0.5,
		[ASPECT_ENDURANCE] = 1,
		[ASPECT_SPIRIT] = 0,
		[ASPECT_INTELLIGENCE] = 0,
		[ASPECT_MIND] = 0,
		[ASPECT_DESTRUCTION] = 0,
		[ASPECT_DEFENSIVE] = 0,
		[ASPECT_CURSING] = 0,
		[ASPECT_HEALING] = 0,
		[ASPECT_DEXTERITY] = 0.5,
		[ASPECT_SPEED] = 0.75,
		[ASPECT_AGILITY] = 0.5,
		[ASPECT_WILL] = 0.5,
		[ASPECT_RECOVERY] = 0,
		[ASPECT_TECH] = 0.75,
		[ASPECT_GUNMASTERY] = 0.75,
		[ASPECT_CRAFTSMANSHIP] = 1,
		[ASPECT_ACCURACY] = 0.5,
		[ASPECT_INSTINCT] = 0.75
	},
	Loadout = {WEAPON_BUILDERA1, WEAPON_GLADRADUS, WEAPON_ZAGGER},
	SpellSheet = {
		[IN_FORWARD] = {"-", "-"},
		[IN_BACK] = {"-", "-"},
		[IN_MOVELEFT] = {"-", "-"},
		[IN_MOVERIGHT] = {"-", "-"},
		[IN_FORWARD + IN_MOVELEFT] = {"-", "-"},
		[IN_FORWARD + IN_MOVERIGHT] = {"-", "-"},
		[IN_BACK + IN_MOVELEFT] = {"-", "-"},
		[IN_BACK + IN_MOVERIGHT] = {"-", "-"}
	},
	Model = "odessa"
}

function GM:GenericVehicleTraceHUDPaint()
	local screenscale = 0.5 + BetterScreenScale() * 0.5
	if self:Team() == MySelf:Team() then
		GAMEMODE:DrawHealth(w * 0.5, h * 0.5 + screenscale * 64, 200, 32, self.Name, self:VHealth().." / "..self:GetMaxVHealth(), team.GetColor(self:Team()), self:VHealth(), self:GetMaxVHealth(), screenscale)
	else
		GAMEMODE:DrawHealth(w * 0.5, h * 0.5 + screenscale * 64, 200, 32, self.Name, nil, team.GetColor(self:Team()), self:VHealth(), self:GetMaxVHealth(), screenscale)
	end
end

function GM:SpawnMenuEnabled()
	return false
end

function GM:SpawnMenuOpen()
	return false
end

function GM:ContextMenuOpen()
	return false
end

function GM:HUDWeaponPickedUp(wep)
end

function GM:HUDItemPickedUp(itemname)
end

function GM:HUDAmmoPickedUp(itemname, amount)
end

function GM:HandleWiki(article)
	if pHelp then
		if article then
			MakepMain("Help")
			surface.PlaySound("weapons/ar2/ar2_reload_push.wav")
			pHelp.Output:OpenURL("http://heavy.noxiousnet.com/wiki/index.php?title="..tostring(article))
		end
		return true
	end
end

function GM:GameTypeStartIntermission(pl, teamid)
end

function GM:GameTypeEndIntermission()
end

function GM:EndIntermission()
	if self:GameTypeEndIntermission() then return end

	self.IntermissionPlayer = nil
	self.IntermissionTeam = nil
	self.IntermissionBegan = nil
	self.Intermission = nil

	ClearVehicleTimers()

	hook.Remove("CalcView", "CalcViewIntermission")
end

local ViewHullMins = Vector(-8, -8, -8)
local ViewHullMaxs = Vector(8, 8, 8)
local function CalcViewIntermission(pl, origin, angles, fov)
	if pl:Team() ~= GAMEMODE.IntermissionTeam then
		local ipl = GAMEMODE.IntermissionPlayer
		if ipl and ipl ~= pl and ipl:IsValid() then
			local thestart = ipl:EyePos()
			local theend = thestart + angles:Forward() * -128
			local tr = util.TraceHull({start = thestart, endpos = theend, mask = MASK_SOLID, filter = ipl, mins=ViewHullMins, maxs=ViewHullMaxs})
			return {origin = tr.HitPos + tr.HitNormal * 4, vm_origin = origin + angles:Up() * 512}
		end
	end
end

function GM:StartIntermission(pl, teamid)
	if self:GameTypeStartIntermission(pl, teamid) then return end

	self.Intermission = true
	self.IntermissionTeam = teamid
	self.IntermissionPlayer = pl

	hook.Add("CalcView", "CalcViewIntermission", CalcViewIntermission)
end

function GM:HookGetLocal(pl)
	pl.Mana = pl.Mana or 0
	pl.ManaBase = pl.ManaBase or CurTime()
	pl.MaxMana = pl.MaxMana or 100
	pl.ManaRegenerate = pl.ManaRegenerate or 0
	pl.Stamina = pl.Stamina or 0
	pl.StaminaBase = pl.StaminaBase or CurTime()
	pl.MaxStamina = pl.MaxStamina or 100
	pl.StaminaRegenerate = pl.StaminaRegenerate or 0
	pl.AccuracyMultiplier = pl.AccuracyMultiplier or 1
	pl.RateOfFireMultiplier = pl.RateOfFireMultiplier or 1
	pl.GunManaUseMultiplier = pl.GunManaUseMultiplier or 1
	pl.CastingRateMultiplier = pl.CastingRateMultiplier or 1
	pl.BuildingRateMultiplier = pl.BuildingRateMultiplier or 1

	pl.m_LastKeyPressedForward = 0

	self.Think = self._Think

	if 90 <= render.GetDXLevel() then
		self.RenderScreenspaceEffects = self._RenderScreenspaceEffectsHiFi
	else
		self.RenderScreenspaceEffects = self._RenderScreenSpaceEffectsLowFi
	end

	self.HUDShouldDraw = self._HUDShouldDraw
end

function GM:RenderVehicleParticleTunnel()
	if MySelf:InVehicle() and not self.VehicleThirdPerson then
		local veh = MySelf:GetVehicle()
		if veh:IsValid() then
			if 512 < veh:GetVelocity():Length() then
				local eyepos = MySelf:GetShootPos()

				if self.VehicleEmitter then
					self.VehicleEmitter:SetPos(eyepos)
				else
					self.VehicleEmitter = ParticleEmitter(eyepos)
					self.VehicleEmitter:SetNearClip(8, 20)
				end

				local emitter = self.VehicleEmitter
				emitter:SetPos(eyepos)
				local velang = EyeAngles()
				local fwd = velang:Forward()
				velang:RotateAroundAxis(fwd, math.Rand(0, 360))
				local up = velang:Up()
				local particle = emitter:Add("effects/spark", eyepos + veh:GetVelocity():Length() * 0.1 * fwd + up * math.Rand(16, 100)) --eyepos + (VectorRand() + vel:Normalize() * -2):Normalize() * math.Rand(speed * 0.25, speed * 0.5))
				particle:SetStartAlpha(190)
				particle:SetEndAlpha(0)
				particle:SetStartSize(2.5)
				particle:SetEndSize(0)
				particle:SetDieTime(0.25)
				particle:SetAngles(Angle(velang.roll / -57.296, 0, 0))
			end
		end
	elseif self.VehicleEmitter then
		self.VehicleEmitter:Finish()
		self.VehicleEmitter = nil
	end
end

function GM:RenderScreenspaceEffectsLowFi()
end

local cvarMotionBlurStun = CreateClientConVar("noxious_drawmotionblur_stun", 1, true, false)
local cvarMotionBlurKnockDown = CreateClientConVar("noxious_drawmotionblur_knockdown", 1, true, false)
local cvarMotionBlurDodge = CreateClientConVar("noxious_drawmotionblur_dodge", 1, true, false)
local cvarMotionBlurSprint = CreateClientConVar("noxious_drawmotionblur_sprint", 0, true, false)
local cvarMotionBlurWallRun = CreateClientConVar("noxious_drawmotionblur_wallrun", 1, true, false)
function GM:RenderScreenspaceEffectsHiFi()
	if MySelf.Stunned and not MySelf.SilentStunned and cvarMotionBlurStun:GetBool() then
		DrawMotionBlur(0.2, 1.5, math.min(0.02, FrameTime()))
	elseif MySelf.KnockedDown and cvarMotionBlurKnockDown:GetBool() or MySelf.DashDodging and cvarMotionBlurDodge:GetBool() or MySelf.WallRunning and cvarMotionBlurWallRun:GetBool() or MySelf.Sprinting and cvarMotionBlurSprint:GetBool() then
		DrawMotionBlur(0.2, math.min(0.75, MySelf:GetVelocity():Length() * 0.0015), math.min(0.02, FrameTime()))
	end
end

function GM:_HUDShouldDraw(name)
	if name == "CHudDamageIndicator" then
		return MySelf:Alive()
	elseif name == "CHudCrosshair" then
		return not NOX_VIEW
	end

	return name ~= "CHudHealth" and name ~= "CHudBattery" and name ~= "CHudAmmo" and name ~= "CHudSecondaryAmmo"
end

local TEXT_ALIGN_CENTER = TEXT_ALIGN_CENTER
local TEXT_ALIGN_LEFT = TEXT_ALIGN_LEFT
local TEXT_ALIGN_RIGHT = TEXT_ALIGN_RIGHT

local hud_HealthX = CreateClientConVar("nox_hud_newhealth_x", 0.5, true, false)
local hud_HealthY = CreateClientConVar("nox_hud_newhealth_y", 0.75, true, false)
local hud_HealthAlign = CreateClientConVar("nox_hud_newhealth_align", TEXT_ALIGN_CENTER, true, false)

local hud_StaminaX = CreateClientConVar("nox_hud_newstamina_x", 0.3, true, false)
local hud_StaminaY = CreateClientConVar("nox_hud_newstamina_y", 0.85, true, false)
local hud_StaminaAlign = CreateClientConVar("nox_hud_newstamina_align", TEXT_ALIGN_CENTER, true, false)

local hud_ManaX = CreateClientConVar("nox_hud_newmana_x", 0.7, true, false)
local hud_ManaY = CreateClientConVar("nox_hud_newmana_y", 0.85, true, false)
local hud_ManaAlign = CreateClientConVar("nox_hud_newmana_align", TEXT_ALIGN_CENTER, true, false)

local hud_StatusBarX = CreateClientConVar("nox_hud_statusbar_x", 0.375, true, false)
local hud_StatusBarY = CreateClientConVar("nox_hud_statusbar_y", 0.75, true, false)

local hud_SpellMenuX = CreateClientConVar("nox_hud_spellmenu_x", 0.85, true, false)
local hud_SpellMenuY = CreateClientConVar("nox_hud_spellmenu_y", 0.75, true, false)

local hud_LargeSpellIcons = CreateClientConVar("nox_hud_largespellicons", 1, true, false)

local hud_AmmoX = CreateClientConVar("nox_hud_ammo_x", 0.5, true, false)
local hud_AmmoY = CreateClientConVar("nox_hud_ammo_y", 0.55, true, false)

function GM:RestoreHUDDefaults()
	RunConsoleCommand("nox_hud_newhealth_x", hud_HealthX:GetDefault())
	RunConsoleCommand("nox_hud_newhealth_y", hud_HealthY:GetDefault())
	RunConsoleCommand("nox_hud_newhealth_align", hud_HealthAlign:GetDefault())
	RunConsoleCommand("nox_hud_newmana_x", hud_ManaX:GetDefault())
	RunConsoleCommand("nox_hud_newmana_y", hud_ManaY:GetDefault())
	RunConsoleCommand("nox_hud_newmana_align", hud_ManaAlign:GetDefault())
	RunConsoleCommand("nox_hud_newstamina_x", hud_StaminaX:GetDefault())
	RunConsoleCommand("nox_hud_newstamina_y", hud_StaminaY:GetDefault())
	RunConsoleCommand("nox_hud_newstamina_align", hud_StaminaAlign:GetDefault())
	RunConsoleCommand("nox_hud_statusbar_x", hud_StatusBarX:GetDefault())
	RunConsoleCommand("nox_hud_statusbar_y", hud_StatusBarY:GetDefault())
	RunConsoleCommand("nox_hud_spellmenu_x", hud_SpellMenuX:GetDefault())
	RunConsoleCommand("nox_hud_spellmenu_y", hud_SpellMenuY:GetDefault())
	RunConsoleCommand("nox_hud_largespellicons", hud_LargeSpellIcons:GetDefault())
	RunConsoleCommand("nox_hud_ammo_x", hud_AmmoX:GetDefault())
	RunConsoleCommand("nox_hud_ammo_y", hud_AmmoY:GetDefault())
end

function ExplosiveEffect(pos, maxrange, damage, dmgtype)
	local pos2 = pos + Vector(0,0,12)
	for _, pl in pairs(player.GetAll()) do
		local rag = pl:GetRagdollEntity()
		if rag and not rag.Frozen then
			local phys = rag:GetPhysicsObject()
			if phys:IsValid() then
				local physpos = phys:GetPos()
				local dist = physpos:Distance(pos)
				if dist < maxrange then
					for i=0, rag:GetPhysicsObjectCount() do
						local subphys = rag:GetPhysicsObjectNum(i)
						if subphys then
							subphys:Wake()
						end
					end

					if dmgtype == DMGTYPE_FIRE then
						phys:ApplyForceOffset(damage * 1000 * maxrange / dist * (physpos - pos):Normalize(), pos2)
						if not rag.Burnt then
							local effectdata = EffectData()
								effectdata:SetOrigin(physpos)
								effectdata:SetEntity(pl)
							util.Effect("fire_death", effectdata)
							rag:EmitSound("ambient/fire/mtov_flame2.wav", 50, math.random(105, 110))
						end
					elseif dmgtype == DMGTYPE_LIGHTNING then
						phys:ApplyForceOffset(damage * 1000 * maxrange / dist * (physpos - pos):Normalize(), pos2)
						if not rag.Electricuted then
							local effectdata = EffectData()
								effectdata:SetOrigin(physpos)
								effectdata:SetEntity(pl)
							util.Effect("electric_death", effectdata)
						end
					elseif dmgtype == DMGTYPE_ICE then
						phys:ApplyForceOffset(damage * 500 * maxrange / dist * (physpos - pos):Normalize(), pos2)
						local effectdata = EffectData()
							effectdata:SetOrigin(physpos)
							effectdata:SetEntity(pl)
						util.Effect("ice_death", effectdata)
					else
						phys:ApplyForceOffset(damage * 1000 * maxrange / dist * (physpos - pos):Normalize(), pos2)
					end
				end
			end
		end
	end
end

concommand.Add("nox_effectquality", function(sender, command, arguments)
	EFFECT_QUALITY = math.max(0, math.min(math.floor(tonumber(arguments[1] or 2)), 3))
	EFFECT_IQUALITY = 3 - EFFECT_QUALITY
	if not arguments[2] then
		if EFFECT_QUALITY == 3 then
			MySelf:ChatPrint("Particle density changed to HIGH")
		elseif EFFECT_QUALITY == 2 then
			MySelf:ChatPrint("Particle density changed to MEDIUM (Default)")
		elseif EFFECT_QUALITY == 1 then
			MySelf:ChatPrint("Particle density changed to LOW")
		else
			MySelf:ChatPrint("Particle density changed to MINIMAL")
		end
	end
end)

--[[function GM:Move(pl, move)
	if pl:WaterLevel() == 0 and not pl:IsOnGround() then
		move:SetSideSpeed(move:GetSideSpeed() * 0.15)
		move:SetForwardSpeed(move:GetForwardSpeed() * 0.15)
	end

	if StatusWeaponHook("Move", pl, move) then return true end

	if pl:IsSprinting() then
		pl:MoveSprinting(move)
	end

	if pl.DashDodging then
		pl:SetGroundEntity(NULL)
		move:SetSideSpeed(0)
		move:SetForwardSpeed(0)
	elseif pl.WallJumping then
		pl:SetGroundEntity(NULL)
		move:SetVelocity(Vector(0,0,0))
		move:SetSideSpeed(0)
		move:SetForwardSpeed(0)
	elseif pl.Stunned then
		move:SetSideSpeed(0)
		move:SetForwardSpeed(0)
	elseif pl.WallRunning then
		move:SetMaxSpeed(0)
		move:SetMaxClientSpeed(0)
		move:SetSideSpeed(0)
		move:SetForwardSpeed(0)

		if pl.WallRunningUp then
			if CurTime() - pl.WallRunningUpStart > 0 then
				pl:SetGroundEntity(NULL)
				local spd = pl.WallVertSpeed
				if pl.Slow then spd = spd * 0.7 end
				move:SetVelocity(Vector(0, 0, spd))
			end
		else
			local spd = pl.WallRunSpeed
			if pl.Slow then spd = spd * 0.7 end
			local vNew = pl:GetForward() * spd
			vNew.z = move:GetVelocity().z + FrameTime() * 690
			move:SetVelocity(vNew)
		end
	elseif pl.HealCharge or pl.Slow then
		move:SetSideSpeed(move:GetSideSpeed() * 0.7)
		move:SetForwardSpeed(move:GetForwardSpeed() * 0.7)
	end
end]]

--local betawarning = CreateClientConVar("noxious_betawarning", 0, true, false)
function GM:Initialize()
	surface.CreateFont("coolvetica", 48, 500, true, false, "ScoreboardHead")
	surface.CreateFont("coolvetica", 24, 500, true, false, "ScoreboardSub")
	surface.CreateFont("Tahoma", 16, 1000, true, false, "NoticeFont")
	surface.CreateFont("coolvetica", 24, 700, false, false, "SpellFont")
	surface.CreateFont("arial", 12, 400, true, false, "SpellFontSmall")
	surface.CreateFont("akbar", 32, 500, true, false, "akbarnormal")
	surface.CreateFont("akbar", ScreenScale(16), 400, true, false, "healthandmana")
	surface.CreateFont("csd", 42, 500, true, true, "Signs")
	surface.CreateFont("frosty", 32, 200, true, false, "noxnetbig")
	surface.CreateFont("akbar", 18, 300, true, false, "scoreboardfine")
	surface.CreateFont("akbar", BetterScreenScale() * 9 + 9, 300, true, false, "ammodisplay")
	surface.CreateFont("akbar", 24, 500, true, false, "noxnetnormal")
	surface.CreateFont("akbar", 32, 400, true, false, "noxnetscoreboard")
	surface.CreateFont("Tohoma", BetterScreenScale() * 10 + 10, 600, true, false, "NoXiousNoticeFont", true)

	surface.CreateFont("coolvetica", 48, 500, true, false, "NoXiousLogoText")
	surface.CreateFont("coolvetica", 32, 500, true, false, "NoXiousLogoSubText")

	PrecacheParticleSystem("portal_lightning_01")
	PrecacheParticleSystem("citadel_shockwave")

	surface.SetFont("DefaultBold")

	timer.Simple(5, RunConsoleCommand, "requestgametype")

	self.VehicleThirdPerson = GetConVarNumber("gmod_vehicle_viewmode") == 1

	for _, tab in pairs(PROPTYPES) do
		tab.CleanName = string.lower(string.gsub(tab.Name, " ", "_"))
		if tab.UsableMaterials then
			tab.cvarMaterial = CreateClientConVar("noxbuildingmaterial_"..tab.CleanName, "", true, false)
		end
	end

	for templatename, template in pairs(self.PredefinedProfiles) do
		if not file.Exists("noxaspects/"..templatename..".txt") then
			file.Write("noxaspects/"..templatename..".txt", Serialize(template))
		end
	end

	--timer.Simple(3.5, self.BetaWarning, self)
end

--[[function GM:BetaWarning()
	if betawarning:GetBool() then return end
	RunConsoleCommand("noxious_betawarning", 1)

	surface.PlaySound("HL1/fvox/warning.wav")

	local bpan = vgui.Create("DFrame")
	bpan:SetTitle("Tip")
	bpan:SetDeleteOnClose(true)

	local lab = vgui.Create("DLabel", bpan)
	lab:SetFont("Default")
	lab:SetFGColor(COLOR_RED)
	lab:SetText("This is an early beta so don't expect the full game. Report any bugs or suggestions in the forum topic.")
	lab:SizeToContents()
	bpan:SetSize(lab:GetWide() + 16, lab:GetTall() + 32)
	lab:SetPos(8, 28)

	local but = vgui.Create("DButton", bpan)
	but:SetText("CLOSE")
	but:SizeToContents()
	but:SetSize(but:GetWide() + 8, but:GetTall() + 4)
	but:SetPos(bpan:GetWide() * 0.5 - but:GetWide() * 0.5, 2)
	but.DoClick = function(me)
		me:GetParent():Close()
	end

	bpan:Center()
	bpan:MakePopup()
end]]

function GM:InitPostEntity()
end

function GM:PlayerShouldTakeDamage(ply, attacker)
	if attacker:IsPlayer() then
		return ply:Team() ~= attacker:Team() or attacker == ply
	end
	return true
end

function GM:UpdateAnimation(pl)
	if pl:InVehicle() then
		local steer = pl:GetVehicle():GetPoseParameter("vehicle_steer")
		pl:SetPoseParameter("vehicle_steer", steer) 
	end

	local chealth = pl:Health()
	pl:SetPoseParameter("breathing", 2 - chealth / pl:GetSkin())

	--if pl:Team() ~= TEAM_SPECTATE then
		if pl.WallRunning then
			local ang = pl:GetAngles()
			local fCurTime = CurTime()
			if pl.WallRunningUp then
				ang.pitch = math.max(-60, (fCurTime - pl.WallRunningUp.Created) * -240)
			elseif pl.WallRunningLeft then
				ang.roll = math.min(30, (fCurTime - pl.WallRunningLeft.Created) * 60)
			elseif pl.WallRunningRight then
				ang.roll = math.max(-30, (fCurTime - pl.WallRunningRight.Created) * -60)
			end
			pl:SetAngles(ang)
		elseif pl.WallRunningUpInterp then
			local fCurTime = CurTime()
			if fCurTime >= pl.WallRunningUpInterp then
				pl.WallRunningUpInterp = nil
			else
				local ang = pl:GetAngles()
				ang.pitch = (pl.WallRunningUpInterp - fCurTime) * -240
				pl:SetAngles(ang)
			end
		elseif pl.WallRunningLeftInterp then
			local fCurTime = CurTime()
			if fCurTime >= pl.WallRunningLeftInterp then
				pl.WallRunningLeftInterp = nil
			else
				local ang = pl:GetAngles()
				ang.roll = (pl.WallRunningLeftInterp - fCurTime) * 60
				pl:SetAngles(ang)
			end
		elseif pl.WallRunningRightInterp then
			local fCurTime = CurTime()
			if fCurTime >= pl.WallRunningRightInterp then
				pl.WallRunningRightInterp = nil
			else
				local ang = pl:GetAngles()
				ang.roll = (pl.WallRunningRightInterp - fCurTime) * -60
				pl:SetAngles(ang)
			end
		elseif pl.DashDodging then
			pl:SetPlaybackRate(0)
		end
	--end
end

function GM:CalcVehicleThirdPersonView(Vehicle, seat, ply, origin, angles, fov)
	local view = {}
	view.angles = angles
	view.fov = fov

	if Vehicle.CalcViewFunc then
		return Vehicle:CalcViewFunc(seat, ply, origin, angles, fov)
	elseif not Vehicle.CalcViewUp then
		local min, max = Vehicle:WorldSpaceAABB()
		local size = max - min

		Vehicle.CalcViewOffsetUp = math.min(175, size.z * 1.25)
		Vehicle.CalcViewOffsetOut = size:Length()
	end

	--local Up = view.angles:Up() * Vehicle.CalcView.OffsetUp
	local Up = Vector(0, 0, Vehicle.CalcViewOffsetUp)
	local Offset = view.angles:Forward() * -Vehicle.CalcViewOffsetOut

	local TargetOrigin = Vehicle:GetPos() + Up + Offset
	local distance = origin - TargetOrigin

	local filt = {Vehicle, par}
	filt = table.Add(filt, ents.FindByClass("vehiclepart"))
	filt = table.Add(filt, ents.FindByClass("prop_vehicle_prisoner_pod"))
	filt = table.Add(filt, player.GetAll())
	local tr = util.TraceLine({start = origin, endpos = TargetOrigin, filter = filt})

	angles.roll = 0
	view.angles = angles
	view.origin = origin + tr.Normal * (distance:Length() - 10) * tr.Fraction

	return view
end

function GM:CalcVehicleFirstPersonView(Vehicle, seat, ply, origin, angles, fov)
	if Vehicle.CalcViewFirstFunc then
		return Vehicle:CalcViewFirstFunc(seat, ply, origin, angles, fov)
	end
end

--local cvarHeadBob = CreateClientConVar("nox_hud_headbob", "1", true, false)
local ViewOffset = 22
local CamLerp = 0
local StunLerp = 0
local view = {}
function GM:CalcView(pl, origin, angles, fov)
	local Vehicle = pl:GetVehicle()
	if Vehicle:IsValid() then
		local par = Vehicle:GetNetworkedEntity("vehicle")
		if par and par:IsValid() then
			if self.VehicleThirdPerson then
				return self:CalcVehicleThirdPersonView(par, Vehicle, pl, origin, angles, fov)
			else
				return self:CalcVehicleFirstPersonView(par, Vehicle, pl, origin, angles, fov)
			end
		end
	elseif pl:Alive() then
		local ct = CurTime()
		if pl.Stunned and not pl.SilentStunned then
			StunLerp = ct + 0.5
		end
		if ct < StunLerp then
			local lerp = StunLerp - ct
			angles:RotateAroundAxis(angles:Up(), math.sin(RealTime() * 3) * 40 * lerp)
			angles:RotateAroundAxis(angles:Forward(), math.sin(RealTime()) * 24 * lerp)
			angles:RotateAroundAxis(angles:Right(), math.cos(RealTime() * 2) * 30 * lerp)
		end

		if NOX_VIEW then
			CamLerp = math.Approach(CamLerp, ViewOffset, FrameTime() * math.max(math.abs(CamLerp - ViewOffset) * 11, 5))
			local tr2 = util.TraceHull({start=origin, endpos=origin + angles:Right() * CamLerp, mask = MASK_SOLID, filter = player.GetAll(), mins=ViewHullMins, maxs=ViewHullMaxs})
			local realstart = tr2.HitPos + tr2.HitNormal * 3
			local theend = realstart + angles:Forward() * -48
			local tr = util.TraceHull({start = realstart, endpos = theend, mask = MASK_SOLID, filter = pl, mins=ViewHullMins, maxs=ViewHullMaxs}) -- TODO: Fix colliding with players.
			origin = tr.HitPos + tr.HitNormal * 4
		elseif pl:GetRagdollEntity() and pl:Alive() then
			local rpos, rang = self:GetRagdollEyes(pl)
			if rpos then
				origin = rpos
				angles = rang
			end
		end

		if pl.WallRunning then
			--[[if pl.WallRunningUp then
				angles:RotateAroundAxis(angles:Right(), math.min(60, (ct - pl.WallRunningUp.Created) * 120))
			else]]if pl.WallRunningLeft then
				angles:RotateAroundAxis(angles:Forward(), math.min(30, (ct - pl.WallRunningLeft.Created) * 60))
			elseif pl.WallRunningRight then
				angles:RotateAroundAxis(angles:Forward(), math.max(-30, (ct - pl.WallRunningRight.Created) * -60))
			end
		--[[elseif pl.WallRunningUpInterp then
			if ct < pl.WallRunningUpInterp then
				angles:RotateAroundAxis(angles:Right(), (pl.WallRunningUpInterp - ct) * 120)
			end]]
		elseif pl.WallRunningLeftInterp then
			if ct < pl.WallRunningLeftInterp then
				angles:RotateAroundAxis(angles:Forward(), (pl.WallRunningLeftInterp - ct) * 60)
			end
		elseif pl.WallRunningRightInterp then
			if ct < pl.WallRunningRightInterp then
				angles:RotateAroundAxis(angles:Forward(), (pl.WallRunningRightInterp - ct) * -60)
			end
		end

		local wep = pl:GetActiveWeapon()
		if wep.CalcView then
			wep:CalcView(pl, origin, angles, fov, view)
		else
			view.angles = angles
			view.origin = origin
			view.fov = fov
			view.vm_origin = origin
			view.vm_angles = angles
		end
		return view
	end
end

function GM:PlayerFootstep(pl, vFootPos, iFoot, strSoundName, fVolume)
end

usermessage.Hook("SLM", function(um)
	MySelf.Mana = um:ReadFloat()
	MySelf.ManaBase = um:ReadFloat()
end)

usermessage.Hook("SLS", function(um)
	MySelf.Stamina = um:ReadFloat()
	MySelf.StaminaBase = um:ReadFloat()
end)

usermessage.Hook("intmsend", function(um)
	gamemode.Call("EndIntermission")
end)

function GM:RefreshPlayerCollisions()
	for k, v in pairs(player.GetAll()) do
		if self:PlayersShouldCollide(MySelf, v) then
			v:SetCollisionGroup(COLLISION_GROUP_PLAYER)
		else
			v:SetCollisionGroup(COLLISION_GROUP_DEBRIS_TRIGGER)
		end
	end
end

function GM:_Think()
	MySelf:Think(FrameTime())

	self:GameTypeThink()

	self:RefreshPlayerCollisions()

	self:RenderVehicleParticleTunnel()
end

function GM:ShouldDrawLocalPlayer()
	return NOX_VIEW and not MySelf.KnockedDown and not MySelf:InVehicle()
end

local DodgeTime = CreateClientConVar("nox_dodgetime", 0.2, true, false)
local LAST_IN_MOVELEFT = 0
local LAST_IN_MOVERIGHT = 0
local LAST_IN_FORWARD = 0
local LAST_IN_BACK = 0
local BACKTOBUILDERWEP
function GM:PlayerBindPress(pl, bind, wasin)
	if not wasin then return end

	if pl.KnockedDown and (bind == "+attack" or bind == "+attack2" or string.find(bind, "jump", 1, true)) then
		RunConsoleCommand("getup")
	end

	if bind == "+speed" then
		if pl:GetVehicle():IsValid() then
			local iVal = GetConVarNumber("gmod_vehicle_viewmode")
			if iVal == 0 then iVal = 1 else iVal = 0 end
			RunConsoleCommand("gmod_vehicle_viewmode", iVal)
			self.VehicleThirdPerson = iVal == 1
			return true
		elseif 0 < #CASTABLE_SPELLS and CURRENT_SPELL and pl:GetActiveWeapon().CanCast then
			RunConsoleCommand("cast", string.lower(CURRENT_SPELL))
			return true
		end
	elseif bind == "+menu_context" then
		if NOX_VIEW and ViewOffset == 22 then
			ViewOffset = -17
		else
			ViewOffset = 22
			NOX_VIEW = not NOX_VIEW
		end

		return true
	elseif string.find(bind, "jump", 1, true) then
		if not pl:KeyDown(IN_FORWARD) and not pl:KeyDown(IN_BACK) and pl.AbleToDodge and pl:GetStamina() >= STAMINA_DODGE then
			if pl:KeyDown(IN_MOVELEFT) then
				RunConsoleCommand("dashleft")
				return true
			elseif pl:KeyDown(IN_MOVERIGHT) then
				RunConsoleCommand("dashright")
				return true
			end
		end
	elseif bind == "slot4" then
		if pl:CanHolster() then
			RunConsoleCommand("use", "weapon_physgun")
		end

		return true
	elseif bind == "lastinv" or bind == "use" or ((bind == "invnext" or bind == "invprev") and GetConVarNumber("hud_fastswitch") == 1) then
		return not pl:CanHolster()
	elseif string.sub(bind, 1, 4) == "slot" then
		local loadout = pl.Loadout
		if pl:CanHolster() and loadout then
			local slot = tonumber(string.sub(bind, 5, 5)) or 1
			if loadout and loadout[slot] then
				local wepid = loadout[slot]
				local class = WEAPONS[wepid].SWEP
				if class then
					RunConsoleCommand("use", class)
				end
				return true
			end
		end

		return true
	elseif bind == "+menu" then
		local wep = pl:GetActiveWeapon()
		if wep:IsValid() and (wep.IsBuilder or wep:GetClass() == "weapon_physgun") then
			MakepBuilder()
		end
	elseif bind == "+walk" then
		return true
	end
end

function GM:DrawGameTypeHUD()
end

function GM:GameTypeThink()
end

local texHealth = surface.GetTextureID("noxctf/healthbar")
local texStamina = surface.GetTextureID("noxctf/staminabar")
local texMana = surface.GetTextureID("noxctf/manabar")
local cvarMovieHUD = CreateClientConVar("nox_hud_moviehud", 0, true, false)
local cvarNoHUD = CreateClientConVar("nox_hud_nohud", 0, true, false)
local texBullet = surface.GetTextureID("noxctf/bulleticon")
function GM:DrawAmmoCount(x, y, bullets, maxbullets, displaybullets, screenscale)
	if cvarNoHUD:GetBool() then return end

	local wid = displaybullets * 8 * screenscale
	local x2 = x - wid * 0.5

	draw.RoundedBox(4, x2 - 4, y - 2, wid + 8, 38 * screenscale, color_black_alpha180)

	local col
	if bullets <= 0 then
		col = COLOR_RED
	elseif bullets <= maxbullets * 0.5 then
		col = COLOR_YELLOW
	else
		col = color_white
	end
	draw.DrawText(bullets.." / "..maxbullets, "ammodisplay", x, y + 17 * screenscale, col, TEXT_ALIGN_CENTER)

	surface.SetDrawColor(30, 255, 30, 220)
	for i = 1, displaybullets do
		if (displaybullets / maxbullets) * bullets < i then
			surface.SetDrawColor(80, 80, 80, 220)
		end
		surface.SetTexture(texBullet)
		surface.DrawTexturedRect(x2, y, 8 * screenscale, 16 * screenscale)
		x2 = x2 + 8 * screenscale
	end
end

local texHealthBar = surface.GetTextureID("gui/gradient_down")
function GM:DrawHealth(x, y, width, height, name, inbartext, namecolor, health, maxhealth, screenscale)
	if cvarNoHUD:GetBool() then return end

	local wid = screenscale * width
	local hei = screenscale * height

	if name then
		draw.DrawTextShadow(name, "TargetID", x, y, namecolor, color_black, TEXT_ALIGN_CENTER)
		local tx, ty = surface.GetTextSize(name)
		y = y + ty + 2
	end

	x = x - wid * 0.5

	surface.SetDrawColor(0, 0, 0, 220)
	surface.DrawRect(x, y, wid, hei)
	surface.SetDrawColor(namecolor.r, namecolor.g, namecolor.b, namecolor.a)
	surface.SetTexture(texHealthBar)
	local wid2 = wid * (health / maxhealth)
	surface.DrawTexturedRect(x, y, wid2, hei)
	surface.SetDrawColor(namecolor.r, namecolor.g, namecolor.b, namecolor.a * 0.1)
	surface.DrawRect(x, y, wid2, hei)
	surface.SetDrawColor(30, 30, 30, 255)
	surface.DrawOutlinedRect(x, y, wid, hei)
	surface.SetDrawColor(20, 20, 20, 255)
	surface.DrawOutlinedRect(x + 1, y + 1, wid - 2, hei - 2)
	surface.SetDrawColor(10, 10, 10, 255)
	surface.DrawOutlinedRect(x + 2, y + 2, wid - 4, hei - 4)

	if inbartext then
		draw.SimpleText(inbartext, "TargetID", x + wid * 0.5, y + hei * 0.5, color_white, TEXT_ALIGN_CENTER, TEXT_ALIGN_CENTER)
	end
end

function GM:GetScreenScale()
	return 0.5 + BetterScreenScale() * 0.5
end
GM.GetScreenscale = GM.GetScreenScale

function GM:HUDPaint()
	if not MySelf:IsValid() or cvarNoHUD:GetBool() then return end

	w, h = ScrW(), ScrH()

	local curtime = CurTime()
	local screenscale = self:GetScreenScale()

	if MySelf:InVehicle() then
		EYETRACE_ENTITY = NULL
	else
		local eyetrace = MySelf:TraceLine(10240)
		local eyeent = eyetrace.Entity
		EYETRACE_ENTITY = eyeent
		EYETRACE_HITPOS = eyetrace.HitPos
		EYETRACE_HITNORMAL = eyetrace.HitNormal
		if eyeent.TraceHUDPaint then
			if eyeent.MaxTraceHUDPaintLength then
				if eyetrace.HitPos:Distance(MySelf:GetShootPos()) <= eyeent.MaxTraceHUDPaintLength then
					eyetrace.Entity:TraceHUDPaint(eyetrace, curtime, screenscale)
				end
			else
				eyetrace.Entity:TraceHUDPaint(eyetrace, curtime, screenscale)
			end
		end
	end

	if self.MainMenu and self.MainMenu:Valid() then return end

	self:PaintNotes()
	self:DrawDeathNotice(w * 0.95, 16, screenscale)
	self:HUDDrawTargetID(screenscale)
	self:DrawGameTypeHUD(curtime, screenscale)
	if not cvarMovieHUD:GetBool() then
		self:DeadHUD(curtime, screenscale)
		self:DrawHUD(curtime, screenscale)
	end
end

local colEnemy = Color(255, 15, 15, 255)
local colFriendly = Color(25, 255, 25, 255)
function GM:HUDDrawTargetID(screenscale)
	local trace = MySelf:GetEyeTrace()

	local entity = trace.Entity
	if not (entity:IsValid() and entity:IsPlayer()) then return end

	TARGETID_LAST = entity

	local otherteam = entity:Team()
	if MySelf:Team() == otherteam then
		self:DrawHealth(w * 0.5, h * 0.5 + screenscale * 64, 150, 24, entity:Name(), entity:Health().." / "..entity:GetSkin(), team.GetColor(otherteam), entity:Health(), entity:GetSkin(), screenscale)
	else
		self:DrawHealth(w * 0.5, h * 0.5 + screenscale * 64, 150, 24, entity:Name(), nil, team.GetColor(otherteam), entity:Health(), entity:GetSkin(), screenscale)
	end
end

function GM:DeadHUD(curtime, screenscale)
	if not MySelf:Alive() then
		local timleft = math.max(0, (MySelf.NextSpawnTime or 0) - CurTime())
		if timleft == 0 then
			if MySelf:Team() == TEAM_SPECTATE then
				draw.DrawTextShadow("Press F2 to open the menu.", "akbarnormal", w * 0.5, h * 0.56, COLOR_RED, color_black, TEXT_ALIGN_CENTER)
			elseif not self.Intermission then
				draw.DrawTextShadow("Press fire to respawn.", "akbarnormal", w * 0.5, h * 0.56, COLOR_RED, color_black, TEXT_ALIGN_CENTER)
			end
		elseif not self.Intermission then
			draw.DrawTextShadow("Respawning...", "akbarnormal", w * 0.5, h*0.56, color_white, color_black, TEXT_ALIGN_CENTER)
			draw.DrawTextShadow(string.ToMinutesSecondsMilliseconds(timleft), "DefaultBold", w * 0.5, h * 0.6, color_white, color_black, TEXT_ALIGN_CENTER)
		end
	end
end

local DelayIcons = DelayIcons
local USE_OLD_HUD = CreateClientConVar("nox_hud_useoldstyle", "0", true, false)
local HUD_SCALE = CreateClientConVar("nox_hud_scale", "1", true, false)
local HUD_DRAWGETUP = CreateClientConVar("nox_hud_drawgetup", "1", true, false)
local colGetUp = Color(255, 0, 0, 255)
function GM:DrawHUD(curtime, screenscale)
	if not MySelf:InVehicle() then
		local eyetrace = MySelf:TraceLine(4096)
		local eyeent = eyetrace.Entity
		if eyeent and eyeent.TraceHUDPaint then
			if eyeent.MaxTraceHUDPaintLength then
				if eyetrace.HitPos:Distance(MySelf:GetShootPos()) < eyeent.MaxTraceHUDPaintLength then
					eyetrace.Entity:TraceHUDPaint(eyetrace)
				end
			else
				eyetrace.Entity:TraceHUDPaint(eyetrace)
			end
		end
	end

	if MySelf:Team() == TEAM_SPECTATE then return end

	local mana = math.max(0, MySelf:GetMana())
	local stamina = math.max(0, MySelf:GetStamina())
	local health = math.max(0, MySelf:Health())
	local maxhealth = MySelf:GetSkin()
	local entityhealth = health / maxhealth

	local scale = (h / 1200) * HUD_SCALE:GetFloat()
	local wid, hei = 512 * scale, 128 * scale

	local align = hud_HealthAlign:GetInt()
	local x
	if align == TEXT_ALIGN_CENTER then
		x = w * hud_HealthX:GetFloat() - wid * 0.5
	elseif align == TEXT_ALIGN_LEFT then
		x = w * hud_HealthX:GetFloat()
	else
		x = w * hud_HealthX:GetFloat() - wid
	end
	local y = h * hud_HealthY:GetFloat()
	draw.RoundedBox(4, x + 186 * scale, y + 26 * scale, 140 * scale, 26 * scale, color_black_alpha180)
	draw.SimpleText(health.." / "..maxhealth, "ChatFont", x + 256 * scale, y + 39 * scale, color_white, TEXT_ALIGN_CENTER, TEXT_ALIGN_CENTER)
	surface.SetDrawColor(255, 0, 0, 255)
	surface.DrawRect(x + 24 * scale, y + 54 * scale, 432 * scale * entityhealth, 21 * scale)
	surface.SetTexture(texHealth)
	surface.SetDrawColor(255, 255, 255, 255)
	surface.DrawTexturedRect(x, y, wid, hei)

	align = hud_ManaAlign:GetInt()
	if align == TEXT_ALIGN_CENTER then
		x = w * hud_ManaX:GetFloat() - wid * 0.5
	elseif align == TEXT_ALIGN_LEFT then
		x = w * hud_ManaX:GetFloat()
	else
		x = w * hud_ManaX:GetFloat() - wid
	end
	y = h * hud_ManaY:GetFloat()
	draw.RoundedBox(4, x + 186 * scale, y + 26 * scale, 140 * scale, 26 * scale, color_black_alpha180)
	draw.SimpleText(math.floor(mana).." / "..MySelf.MaxMana, "ChatFont", x + 256 * scale, y + 39 * scale, color_white, TEXT_ALIGN_CENTER, TEXT_ALIGN_CENTER)
	surface.SetDrawColor(mana_color)
	surface.DrawRect(x + 24 * scale, y + 54 * scale, 432 * scale * (mana / MySelf.MaxMana), 21 * scale)
	surface.SetTexture(texMana)
	surface.SetDrawColor(255, 255, 255, 255)
	surface.DrawTexturedRect(x, y, wid, hei)

	align = hud_StaminaAlign:GetInt()
	if align == TEXT_ALIGN_CENTER then
		x = w * hud_StaminaX:GetFloat() - wid * 0.5
	elseif align == TEXT_ALIGN_LEFT then
		x = w * hud_StaminaX:GetFloat()
	else
		x = w * hud_StaminaX:GetFloat() - wid
	end
	y = h * hud_StaminaY:GetFloat()
	draw.RoundedBox(4, x + 186 * scale, y + 26 * scale, 140 * scale, 26 * scale, color_black_alpha180)
	draw.SimpleText(math.floor(stamina).." / "..MySelf.MaxStamina, "ChatFont", x + 256 * scale, y + 39 * scale, color_white, TEXT_ALIGN_CENTER, TEXT_ALIGN_CENTER)
	if MySelf.Sprinting or MySelf.WallRunning then
		stamina_color2.b = math.abs(math.sin(curtime * 9)) * 255
		surface.SetDrawColor(stamina_color2)
	else
		surface.SetDrawColor(stamina_color)
	end
	surface.DrawRect(x + 24 * scale, y + 54 * scale, 432 * scale * (stamina / MySelf.MaxStamina), 21 * scale)
	surface.SetTexture(texStamina)
	surface.SetDrawColor(255, 255, 255, 255)
	surface.DrawTexturedRect(x, y, wid, hei)

	local kd = MySelf.KnockedDown
	if kd and HUD_DRAWGETUP:GetBool() and kd:IsValid() and kd:GetSkin() == 0 and MySelf:Alive() then
		colGetUp.a = math.abs(math.sin(curtime * 8)) * 205 + 50
		draw.DrawText("Press JUMP to get back up!", "ChatFont", w * 0.5, h * (0.45 - math.abs(math.cos(curtime * 3)) * 0.05), colGetUp, TEXT_ALIGN_CENTER)
	end

	if 0 < #CASTABLE_SPELLS and MySelf:GetActiveWeapon().CanCast then
		self:DrawSpellSelection(mana, stamina, screenscale)
	end

	local siz
	if hud_LargeSpellIcons:GetBool() then
		siz = screenscale * 48
	else
		siz = screenscale * 32
	end

	surface.SetFont("noxnetnormal")
	local tw, th = surface.GetTextSize("T")

	local dX = w * hud_StatusBarX:GetFloat()
	local dY = h * hud_StatusBarY:GetFloat() - siz - th
	for spellid, tab in pairs(DelayIcons) do
		local endtime = tab.EndTime
		local starttime = tab.StartTime

		if curtime < starttime + 1 then
			local timeleft = curtime - starttime
			surface.SetDrawColor(255, 255, 160, 255 - (255 * timeleft))
			local start = 5 * timeleft + 1
			local size = siz + start * 2
			surface.DrawRect(dX - start, dY - start, size, size)
		end

		surface.SetDrawColor(255, 255, 255, 255)
		if endtime == -10 then
			surface.SetTexture(Spells[spellid].Icon)
			surface.DrawTexturedRect(dX, dY, siz, siz)
			draw.DrawTextShadow("-", "noxnetnormal", dX + siz * 0.5, dY + siz, color_white, color_black, TEXT_ALIGN_CENTER)
		else
			local timeleft = endtime - curtime
			if timeleft <= 0 then
				DelayIcons[spellid] = nil
			else
				surface.SetTexture(Spells[spellid].Icon)
				surface.DrawTexturedRect(dX, dY, siz, siz)
				if timeleft < 3 then
					draw.DrawTextShadow(math.ceil(timeleft), "noxnetnormal", dX + siz * 0.5, dY + siz, COLOR_RED, color_black, TEXT_ALIGN_CENTER)
				elseif timeleft < 5 then
					draw.DrawTextShadow(math.ceil(timeleft), "noxnetnormal", dX + siz * 0.5, dY + siz, COLOR_YELLOW, color_black, TEXT_ALIGN_CENTER)
				else
					draw.DrawTextShadow(math.ceil(timeleft), "noxnetnormal", dX + siz * 0.5, dY + siz, color_white, color_black, TEXT_ALIGN_CENTER)
				end
			end
		end
		dX = dX + siz + 4
	end
end

local function selpaint(me)
	draw.RoundedBox(8, 0, 0, me:GetWide(), me:GetTall(), color_black_alpha180)
end

function GM:SwitchWeaponHUD(slot)
	-- TODO: later.
end

local texSpellSelection = surface.GetTextureID("noxctf/spellselection")
function GM:DrawSpellSelection(mana, stamina, screenscale)
	local sheet = SPELL_SHEET
	if not sheet then return end

	--[[local siz
	if hud_LargeSpellIcons:GetBool() then
		siz = ScreenScale(16)
	else
		siz = ScreenScale(10.66666667)
	end]]

	screenscale = screenscale * 0.75 + 0.25
	local siz = screenscale * 32
	--local siz = 24 + screenscale * 8

	--local dX = w - siz * 6
	--local dY = h - siz * 6
	local dX = w * hud_SpellMenuX:GetFloat()
	local dY = h * hud_SpellMenuY:GetFloat()
	local x = dX
	local y = dY

	--[[if nospellshint then
		local padding = math.sin(RealTime() * 5) * 6 + 16
		surface.SetFont("Default")
		local wsiz, __ = surface.GetTextSize("Press F3 to assign some now and learn how to cast!")
		wsiz = wsiz + 32
		surface.SetDrawColor(0, 0, 0, 180)
		surface.DrawRect(w - 350 - wsiz * 0.5 - padding, h - 240 - padding, wsiz + padding * 2, 72 + padding * 2)
		surface.SetDrawColor(math.sin(RealTime() * 3) * 127.5 + 127.5, math.cos(RealTime() * 3) * 127.5 + 127.5, math.tan(RealTime() * 3) * 127.5 + 127.5, 255)
		surface.DrawOutlinedRect(w - 350 - wsiz * 0.5 - padding, h - 240 - padding, wsiz + padding * 2, 72 + padding * 2)

		draw.DrawText("You have no spells assigned!!", "DefaultBold", w - 350, h - 230, COLOR_RED, TEXT_ALIGN_CENTER)
		draw.DrawText("Press F3 to assign some now and learn how to cast!", "Default", w - 350, h - 200, COLOR_RED, TEXT_ALIGN_CENTER)
	end]]

	surface.SetDrawColor(255, 255, 255, 255)
	surface.SetTexture(texSpellSelection)
	surface.DrawTexturedRect(x - screenscale * 48, y - screenscale * 45, screenscale * 256, screenscale * 256)

	local spellid = NameToSpell[ sheet[IN_FORWARD + IN_MOVELEFT][2] ]
	local _CURRENT_SPELL = NameToSpell[CURRENT_SPELL] or "-"
	if spellid then
		if Spells[spellid].Mana and mana < Spells[spellid].Mana then
			surface.SetDrawColor(255, 0, 0, 255)
		elseif self.DisabledSpells[spellid] then
			surface.SetDrawColor(100, 100, 100, 255)
		elseif _CURRENT_SPELL == spellid then
			surface.SetDrawColor(80, 255, 100, 255)
		else
			surface.SetDrawColor(255, 255, 255, 255)
		end
		surface.SetTexture(Spells[spellid].Icon)
		surface.DrawTexturedRect(dX, dY, siz, siz)
	--else
		--surface.SetDrawColor(255, 255, 255, 127)
		--surface.DrawOutlinedRect(dX, dY, siz, siz)
	end
	dX = dX + siz * 2
	spellid = NameToSpell[ sheet[IN_FORWARD][2] ]
	if spellid then
		if Spells[spellid].Mana and mana < Spells[spellid].Mana then
			surface.SetDrawColor(255, 0, 0, 255)
		elseif self.DisabledSpells[spellid] then
			surface.SetDrawColor(100, 100, 100, 255)
		elseif _CURRENT_SPELL == spellid then
			surface.SetDrawColor(80, 255, 100, 255)
		else
			surface.SetDrawColor(255, 255, 255, 255)
		end
		surface.SetTexture(Spells[spellid].Icon)
		surface.DrawTexturedRect(dX, dY, siz, siz)
	--else
		--surface.SetDrawColor(255, 255, 255, 127)
		--surface.DrawOutlinedRect(dX, dY, siz, siz)
	end
	dX = dX + siz * 2
	spellid = NameToSpell[ sheet[IN_FORWARD + IN_MOVERIGHT][2] ]
	if spellid then
		if Spells[spellid].Mana and mana < Spells[spellid].Mana then
			surface.SetDrawColor(255, 0, 0, 255)
		elseif self.DisabledSpells[spellid] then
			surface.SetDrawColor(100, 100, 100, 255)
		elseif _CURRENT_SPELL == spellid then
			surface.SetDrawColor(80, 255, 100, 255)
		else
			surface.SetDrawColor(255, 255, 255, 255)
		end
		surface.SetTexture(Spells[spellid].Icon)
		surface.DrawTexturedRect(dX, dY, siz, siz)
	--else
		--surface.SetDrawColor(255, 255, 255, 127)
		--surface.DrawOutlinedRect(dX, dY, siz, siz)
	end
	dX = x + siz
	dY = dY + siz
	spellid = NameToSpell[ sheet[IN_FORWARD + IN_MOVELEFT][1] ]
	if spellid then
		if Spells[spellid].Mana and mana < Spells[spellid].Mana then
			surface.SetDrawColor(255, 0, 0, 255)
		elseif self.DisabledSpells[spellid] then
			surface.SetDrawColor(100, 100, 100, 255)
		elseif _CURRENT_SPELL == spellid then
			surface.SetDrawColor(80, 255, 100, 255)
		else
			surface.SetDrawColor(255, 255, 255, 255)
		end
		surface.SetTexture(Spells[spellid].Icon)
		surface.DrawTexturedRect(dX, dY, siz, siz)
	--else
		--surface.SetDrawColor(255, 255, 255, 127)
		--surface.DrawOutlinedRect(dX, dY, siz, siz)
	end
	dX = dX + siz
	spellid = NameToSpell[ sheet[IN_FORWARD][1] ]
	if spellid then
		if Spells[spellid].Mana and mana < Spells[spellid].Mana then
			surface.SetDrawColor(255, 0, 0, 255)
		elseif self.DisabledSpells[spellid] then
			surface.SetDrawColor(100, 100, 100, 255)
		elseif _CURRENT_SPELL == spellid then
			surface.SetDrawColor(80, 255, 100, 255)
		else
			surface.SetDrawColor(255, 255, 255, 255)
		end
		surface.SetTexture(Spells[spellid].Icon)
		surface.DrawTexturedRect(dX, dY, siz, siz)
	--else
		--surface.SetDrawColor(255, 255, 255, 127)
		--surface.DrawOutlinedRect(dX, dY, siz, siz)
	end
	dX = dX + siz
	spellid = NameToSpell[ sheet[IN_FORWARD + IN_MOVERIGHT][1] ]
	if spellid then
		if Spells[spellid].Mana and mana < Spells[spellid].Mana then
			surface.SetDrawColor(255, 0, 0, 255)
		elseif self.DisabledSpells[spellid] then
			surface.SetDrawColor(100, 100, 100, 255)
		elseif _CURRENT_SPELL == spellid then
			surface.SetDrawColor(80, 255, 100, 255)
		else
			surface.SetDrawColor(255, 255, 255, 255)
		end
		surface.SetTexture(Spells[spellid].Icon)
		surface.DrawTexturedRect(dX, dY, siz, siz)
	--else
		--surface.SetDrawColor(255, 255, 255, 127)
		--surface.DrawOutlinedRect(dX, dY, siz, siz)
	end
	dY = dY + siz
	dX = x
	spellid = NameToSpell[ sheet[IN_MOVELEFT][2] ]
	if spellid then
		if Spells[spellid].Mana and mana < Spells[spellid].Mana then
			surface.SetDrawColor(255, 0, 0, 255)
		elseif self.DisabledSpells[spellid] then
			surface.SetDrawColor(100, 100, 100, 255)
		elseif _CURRENT_SPELL == spellid then
			surface.SetDrawColor(80, 255, 100, 255)
		else
			surface.SetDrawColor(255, 255, 255, 255)
		end
		surface.SetTexture(Spells[spellid].Icon)
		surface.DrawTexturedRect(dX, dY, siz, siz)
	--else
		--surface.SetDrawColor(255, 255, 255, 127)
		--surface.DrawOutlinedRect(dX, dY, siz, siz)
	end
	dX = dX + siz
	spellid = NameToSpell[ sheet[IN_MOVELEFT][1] ]
	if spellid then
		if Spells[spellid].Mana and mana < Spells[spellid].Mana then
			surface.SetDrawColor(255, 0, 0, 255)
		elseif self.DisabledSpells[spellid] then
			surface.SetDrawColor(100, 100, 100, 255)
		elseif _CURRENT_SPELL == spellid then
			surface.SetDrawColor(80, 255, 100, 255)
		else
			surface.SetDrawColor(255, 255, 255, 255)
		end
		surface.SetTexture(Spells[spellid].Icon)
		surface.DrawTexturedRect(dX, dY, siz, siz)
	--else
		--surface.SetDrawColor(255, 255, 255, 127)
		--surface.DrawOutlinedRect(dX, dY, siz, siz)
	end
	dX = dX + siz * 2
	spellid = NameToSpell[ sheet[IN_MOVERIGHT][1] ]
	if spellid then
		if Spells[spellid].Mana and mana < Spells[spellid].Mana then
			surface.SetDrawColor(255, 0, 0, 255)
		elseif self.DisabledSpells[spellid] then
			surface.SetDrawColor(100, 100, 100, 255)
		elseif _CURRENT_SPELL == spellid then
			surface.SetDrawColor(80, 255, 100, 255)
		else
			surface.SetDrawColor(255, 255, 255, 255)
		end
		surface.SetTexture(Spells[spellid].Icon)
		surface.DrawTexturedRect(dX, dY, siz, siz)
	--else
		--surface.SetDrawColor(255, 255, 255, 127)
		--surface.DrawOutlinedRect(dX, dY, siz, siz)
	end
	dX = dX + siz
	spellid = NameToSpell[ sheet[IN_MOVERIGHT][2] ]
	if spellid then
		if Spells[spellid].Mana and mana < Spells[spellid].Mana then
			surface.SetDrawColor(255, 0, 0, 255)
		elseif self.DisabledSpells[spellid] then
			surface.SetDrawColor(100, 100, 100, 255)
		elseif _CURRENT_SPELL == spellid then
			surface.SetDrawColor(80, 255, 100, 255)
		else
			surface.SetDrawColor(255, 255, 255, 255)
		end
		surface.SetTexture(Spells[spellid].Icon)
		surface.DrawTexturedRect(dX, dY, siz, siz)
	--else
		--surface.SetDrawColor(255, 255, 255, 127)
		--surface.DrawOutlinedRect(dX, dY, siz, siz)
	end
	dY = dY + siz
	dX = x + siz
	spellid = NameToSpell[ sheet[IN_BACK + IN_MOVELEFT][1] ]
	if spellid then
		if Spells[spellid].Mana and mana < Spells[spellid].Mana then
			surface.SetDrawColor(255, 0, 0, 255)
		elseif self.DisabledSpells[spellid] then
			surface.SetDrawColor(100, 100, 100, 255)
		elseif _CURRENT_SPELL == spellid then
			surface.SetDrawColor(80, 255, 100, 255)
		else
			surface.SetDrawColor(255, 255, 255, 255)
		end
		surface.SetTexture(Spells[spellid].Icon)
		surface.DrawTexturedRect(dX, dY, siz, siz)
	--else
		--surface.SetDrawColor(255, 255, 255, 127)
		--surface.DrawOutlinedRect(dX, dY, siz, siz)
	end
	dX = dX + siz
	spellid = NameToSpell[ sheet[IN_BACK][1] ]
	if spellid then
		if Spells[spellid].Mana and mana < Spells[spellid].Mana then
			surface.SetDrawColor(255, 0, 0, 255)
		elseif self.DisabledSpells[spellid] then
			surface.SetDrawColor(100, 100, 100, 255)
		elseif _CURRENT_SPELL == spellid then
			surface.SetDrawColor(80, 255, 100, 255)
		else
			surface.SetDrawColor(255, 255, 255, 255)
		end
		surface.SetTexture(Spells[spellid].Icon)
		surface.DrawTexturedRect(dX, dY, siz, siz)
	--else
		--surface.SetDrawColor(255, 255, 255, 127)
		--surface.DrawOutlinedRect(dX, dY, siz, siz)
	end
	dX = dX + siz
	spellid = NameToSpell[ sheet[IN_BACK + IN_MOVERIGHT][1] ]
	if spellid then
		if Spells[spellid].Mana and mana < Spells[spellid].Mana then
			surface.SetDrawColor(255, 0, 0, 255)
		elseif self.DisabledSpells[spellid] then
			surface.SetDrawColor(100, 100, 100, 255)
		elseif _CURRENT_SPELL == spellid then
			surface.SetDrawColor(80, 255, 100, 255)
		else
			surface.SetDrawColor(255, 255, 255, 255)
		end
		surface.SetTexture(Spells[spellid].Icon)
		surface.DrawTexturedRect(dX, dY, siz, siz)
	--else
		--surface.SetDrawColor(255, 255, 255, 127)
		--surface.DrawOutlinedRect(dX, dY, siz, siz)
	end
	dX = x
	dY = dY + siz
	spellid = NameToSpell[ sheet[IN_BACK + IN_MOVELEFT][2] ]
	if spellid then
		if Spells[spellid].Mana and mana < Spells[spellid].Mana then
			surface.SetDrawColor(255, 0, 0, 255)
		elseif self.DisabledSpells[spellid] then
			surface.SetDrawColor(100, 100, 100, 255)
		elseif _CURRENT_SPELL == spellid then
			surface.SetDrawColor(80, 255, 100, 255)
		else
			surface.SetDrawColor(255, 255, 255, 255)
		end
		surface.SetTexture(Spells[spellid].Icon)
		surface.DrawTexturedRect(dX, dY, siz, siz)
	--else
		--surface.SetDrawColor(255, 255, 255, 127)
		--surface.DrawOutlinedRect(dX, dY, siz, siz)
	end
	dX = dX + siz * 2
	spellid = NameToSpell[ sheet[IN_BACK][2] ]
	if spellid then
		if Spells[spellid].Mana and mana < Spells[spellid].Mana then
			surface.SetDrawColor(255, 0, 0, 255)
		elseif self.DisabledSpells[spellid] then
			surface.SetDrawColor(100, 100, 100, 255)
		elseif _CURRENT_SPELL == spellid then
			surface.SetDrawColor(80, 255, 100, 255)
		else
			surface.SetDrawColor(255, 255, 255, 255)
		end
		surface.SetTexture(Spells[spellid].Icon)
		surface.DrawTexturedRect(dX, dY, siz, siz)
	--else
		--surface.SetDrawColor(255, 255, 255, 127)
		--surface.DrawOutlinedRect(dX, dY, siz, siz)
	end
	dX = dX + siz * 2
	spellid = NameToSpell[ sheet[IN_BACK + IN_MOVERIGHT][2] ]
	if spellid then
		if Spells[spellid].Mana and mana < Spells[spellid].Mana then
			surface.SetDrawColor(255, 0, 0, 255)
		elseif self.DisabledSpells[spellid] then
			surface.SetDrawColor(100, 100, 100, 255)
		elseif _CURRENT_SPELL == spellid then
			surface.SetDrawColor(80, 255, 100, 255)
		else
			surface.SetDrawColor(255, 255, 255, 255)
		end
		surface.SetTexture(Spells[spellid].Icon)
		surface.DrawTexturedRect(dX, dY, siz, siz)
	--else
		--surface.SetDrawColor(255, 255, 255, 127)
		--surface.DrawOutlinedRect(dX, dY, siz, siz)
	end

	local spellid = NameToSpell[CURRENT_SPELL]
	if spellid then
		if Spells[spellid].Mana and MySelf:GetMana() < Spells[spellid].Mana then
			draw.SimpleTextShadow(CURRENT_SPELL, "noxnetnormal", x + siz * 2.5, y - siz, COLOR_RED, color_black, TEXT_ALIGN_CENTER, TEXT_ALIGN_TOP)
		else
			draw.SimpleTextShadow(CURRENT_SPELL, "noxnetnormal", x + siz * 2.5, y - siz, COLOR_LIMEGREEN, color_black, TEXT_ALIGN_CENTER, TEXT_ALIGN_BOTTOM)
		end
	end
	if MySelf:KeyDown(IN_ATTACK2) and MySelf:GetActiveWeapon().CanCast then
		if MySelf:KeyDown(IN_ATTACK) then
			draw.SimpleTextShadow("2", "noxnetnormal", x + siz * 2.5, y + siz * 2.5, COLOR_LIMEGREEN, color_black, TEXT_ALIGN_CENTER, TEXT_ALIGN_CENTER)
			self:SelectSpellsFromPage2()
		else
			draw.SimpleTextShadow("1", "noxnetnormal", x + siz * 2.5, y + siz * 2.5, COLOR_LIMEGREEN, color_black, TEXT_ALIGN_CENTER, TEXT_ALIGN_CENTER)
			self:SelectSpellsFromPage1()
		end
	end
end

function GM:SelectSpellsFromPage1()
	local class = MySelf.NoXClass or 1
	if MySelf:KeyDown(IN_MOVELEFT) and MySelf:KeyDown(IN_FORWARD) then
		if SPELL_SHEET[IN_FORWARD + IN_MOVELEFT][1] ~= "-" then
			CURRENT_SPELL = SPELL_SHEET[IN_FORWARD + IN_MOVELEFT][1]
		end
	elseif MySelf:KeyDown(IN_MOVERIGHT) and MySelf:KeyDown(IN_FORWARD) then
		if SPELL_SHEET[IN_FORWARD + IN_MOVERIGHT][1] ~= "-" then
			CURRENT_SPELL = SPELL_SHEET[IN_FORWARD + IN_MOVERIGHT][1]
		end
	elseif MySelf:KeyDown(IN_MOVERIGHT) and MySelf:KeyDown(IN_BACK) then
		if SPELL_SHEET[IN_BACK + IN_MOVERIGHT][1] ~= "-" then
			CURRENT_SPELL = SPELL_SHEET[IN_BACK + IN_MOVERIGHT][1]
		end
	elseif MySelf:KeyDown(IN_MOVELEFT) and MySelf:KeyDown(IN_BACK) then
		if SPELL_SHEET[IN_BACK + IN_MOVELEFT][1] ~= "-" then
			CURRENT_SPELL = SPELL_SHEET[IN_BACK + IN_MOVELEFT][1]
		end
	elseif MySelf:KeyDown(IN_MOVELEFT) then
		if SPELL_SHEET[IN_MOVELEFT][1] ~= "-" then
			CURRENT_SPELL = SPELL_SHEET[IN_MOVELEFT][1]
		end
	elseif MySelf:KeyDown(IN_MOVERIGHT) then
		if SPELL_SHEET[IN_MOVERIGHT][1] ~= "-" then
			CURRENT_SPELL = SPELL_SHEET[IN_MOVERIGHT][1]
		end
	elseif MySelf:KeyDown(IN_FORWARD) then
		if SPELL_SHEET[IN_FORWARD][1] ~= "-" then
			CURRENT_SPELL = SPELL_SHEET[IN_FORWARD][1]
		end
	elseif MySelf:KeyDown(IN_BACK) then
		if SPELL_SHEET[IN_BACK][1] ~= "-" then
			CURRENT_SPELL = SPELL_SHEET[IN_BACK][1]
		end
	end
end

function GM:SelectSpellsFromPage2()
	local class = MySelf.NoXClass or 1
	if MySelf:KeyDown(IN_MOVELEFT) and MySelf:KeyDown(IN_FORWARD) then
		if SPELL_SHEET[IN_FORWARD + IN_MOVELEFT][2] ~= "-" then
			CURRENT_SPELL = SPELL_SHEET[IN_FORWARD + IN_MOVELEFT][2]
		end
	elseif MySelf:KeyDown(IN_MOVERIGHT) and MySelf:KeyDown(IN_FORWARD) then
		if SPELL_SHEET[IN_FORWARD + IN_MOVERIGHT][2] ~= "-" then
			CURRENT_SPELL = SPELL_SHEET[IN_FORWARD + IN_MOVERIGHT][2]
		end
	elseif MySelf:KeyDown(IN_MOVERIGHT) and MySelf:KeyDown(IN_BACK) then
		if SPELL_SHEET[IN_BACK + IN_MOVERIGHT][2] ~= "-" then
			CURRENT_SPELL = SPELL_SHEET[IN_BACK + IN_MOVERIGHT][2]
		end
	elseif MySelf:KeyDown(IN_MOVELEFT) and MySelf:KeyDown(IN_BACK) then
		if SPELL_SHEET[IN_BACK + IN_MOVELEFT][2] ~= "-" then
			CURRENT_SPELL = SPELL_SHEET[IN_BACK + IN_MOVELEFT][2]
		end
	elseif MySelf:KeyDown(IN_MOVELEFT) then
		if SPELL_SHEET[IN_MOVELEFT][2] ~= "-" then
			CURRENT_SPELL = SPELL_SHEET[IN_MOVELEFT][2]
		end
	elseif MySelf:KeyDown(IN_MOVERIGHT) then
		if SPELL_SHEET[IN_MOVERIGHT][2] ~= "-" then
			CURRENT_SPELL = SPELL_SHEET[IN_MOVERIGHT][2]
		end
	elseif MySelf:KeyDown(IN_FORWARD) then
		if SPELL_SHEET[IN_FORWARD][2] ~= "-" then
			CURRENT_SPELL = SPELL_SHEET[IN_FORWARD][2]
		end
	elseif MySelf:KeyDown(IN_BACK) then
		if SPELL_SHEET[IN_BACK][2] ~= "-" then
			CURRENT_SPELL = SPELL_SHEET[IN_BACK][2]
		end
	end
end

function GM:HUDPaintBackground()
	if not MySelf:IsValid() or not MySelf:Alive() or cvarNoHUD:GetBool() then return end

	local veh = MySelf:GetVehicle()
	if veh != NULL then
		local realveh = veh:GetNetworkedEntity("vehicle", NULL)
		if realveh.DrawHUD then
			realveh:DrawHUD(veh)
		end
	end

	if NOX_VIEW and not (self.Intermission and MySelf:Team() ~= self.IntermissionTeam) then
		local startpos = MySelf:GetShootPos()
		local pos = util.TraceLine({start=startpos, endpos = startpos + MySelf:GetAimVector() * 2048, filter = MySelf}).HitPos:ToScreen()
		local x, y = pos.x, pos.y
		local w2 = h * 0.015
		local w22 = w2 * 0.75
		local w222 = w2 * 1.5
		surface.SetDrawColor(40, 255, 40, 200)
		surface.DrawLine(x - w222, y, x + w222, y)
		surface.DrawLine(x, y - w222, x, y + w222)

		surface.SetDrawColor(255, 0, 0, 180)
		surface.DrawLine(x - w22, y, x, y - w22)
		surface.DrawLine(x, y - w22, x + w22, y)
		surface.DrawLine(x - w22, y, x, y + w22)
		surface.DrawLine(x, y + w22, x + w22, y)
	end
end

function GM:ResetSpellsHint()
	local nospells = true
	for key, value in pairs(SPELL_SHEET) do
		for subkey, subvalue in pairs(value) do
			if subvalue ~= "-" then nospells = false end
		end
	end
	nospellshint = nospells
end

function GM:CreateMove(cmd)
end

function GM:PostProcessPermitted(str)
	return false
end

stamina_color = Color(255, 255, 0, 255)
stamina_color2 = Color(255, 255, 0, 255)
mana_color = Color(0, 0, 255, 255)
health_color = Color(255, 0, 0, 255)

local staminaoff = Color(255, 0, 0, 254)
local staminaon = Color(255, 255, 0, 254)
local manaoff = staminaoff
local manaon = Color(0, 0, 255, 254)

local function setmanacolor(col)
	mana_color = col
end

local function setstaminacolor(col)
	stamina_color = col
end

usermessage.Hook("insst", function(um)
	if stamina_color.a == 254 then return end
	timer.Simple(0.05, setstaminacolor, staminaoff)
	timer.Simple(0.1, setstaminacolor, staminaon)
	timer.Simple(0.15, setstaminacolor, staminaoff)
	timer.Simple(0.2, setstaminacolor, staminaon)
	timer.Simple(0.25, setstaminacolor, staminaoff)
	timer.Simple(0.3, setstaminacolor, staminaon)
	timer.Simple(0.35, setstaminacolor, staminaoff)
	timer.Simple(0.4, setstaminacolor, staminaon)
	timer.Simple(0.45, setstaminacolor, staminaoff)
	timer.Simple(0.5, setstaminacolor, stamina_color)

	surface.PlaySound("nox/nomana.wav")
end)

function insma()
	if mana_color.a == 254 then return end
	timer.Simple(0.05, setmanacolor, manaoff)
	timer.Simple(0.1, setmanacolor, manaon)
	timer.Simple(0.15, setmanacolor, manaoff)
	timer.Simple(0.2, setmanacolor, manaon)
	timer.Simple(0.25, setmanacolor, manaoff)
	timer.Simple(0.3, setmanacolor, manaon)
	timer.Simple(0.35, setmanacolor, manaoff)
	timer.Simple(0.4, setmanacolor, manaon)
	timer.Simple(0.45, setmanacolor, manaoff)
	timer.Simple(0.5, setmanacolor, mana_color)

	surface.PlaySound("nox/nomana.wav")
end

usermessage.Hook("insma", function(um)
	insma()
end)

usermessage.Hook("mastu", function(um)
	if mana_color.a == 254 then return end
	timer.Simple(0.05, setmanacolor, manaoff)
	timer.Simple(0.1, setmanacolor, manaon)
	timer.Simple(0.15, setmanacolor, manaoff)
	timer.Simple(0.2, setmanacolor, manaon)
	timer.Simple(0.25, setmanacolor, manaoff)
	timer.Simple(0.3, setmanacolor, manaon)
	timer.Simple(0.35, setmanacolor, manaoff)
	timer.Simple(0.4, setmanacolor, manaon)
	timer.Simple(0.45, setmanacolor, manaoff)
	timer.Simple(0.5, setmanacolor, mana_color)

	surface.PlaySound("nox/manastuncast.wav")

	LM(27)
end)

function DesOT()
	--[[local dontdestroy = {}
	for i=1, #TEAMS_PLAYING do
		dontdestroy[ TEAMS_PLAYING[i] ] = true
	end
	for i in pairs(TEAMS_PLAYING) do
		if not dontdestroy[i] and i < 9 and 0 < i then
			team.TeamInfo[i] = nil
		end
	end]]
end

CASTABLE_SPELLS = {}
CURRENT_SPELL = "-"
CURRENT_SPELL_PAGE = 1
ACTIVEPROFILE = ""

usermessage.Hook("sp", function(um)
	DelayIcons = {}
	RefreshCastableSpells()

	local viewmod = MySelf:GetViewModel()
	if viewmod:IsValid() then
		viewmod:SetColor(255, 255, 255, 255)
	end

	LoadAspects(ASPECTFILE)
	ACTIVEPROFILE = ASPECTFILE

	local aspects = MySelf.Aspects
	MySelf.AccuracyMultiplier = GAMEMODE:GetAccuracyMultiplier(aspects[ASPECT_ACCURACY])
	MySelf.RateOfFireMultiplier = GAMEMODE:GetRateOfFireMultiplier(aspects[ASPECT_INSTINCT])
	MySelf.GunManaUseMultiplier = GAMEMODE:GetGunManaMultiplier(aspects[ASPECT_GUNMASTERY])
	MySelf.BuildingRateMultiplier = GAMEMODE:GetBuildingRateMultiplier(aspects[ASPECT_CRAFTSMANSHIP])
	MySelf.MeleeDamageMultiplier = GAMEMODE:GetMeleeDamageMultiplier(aspects[ASPECT_MIGHT])
	MySelf.SprintSpeed = GAMEMODE:GetSprintSpeed(aspects[ASPECT_SPEED])
	MySelf.WallRunSpeed = GAMEMODE:GetWallRunSpeed(aspects[ASPECT_SPEED])
	MySelf.WallVertSpeed = GAMEMODE:GetWallVertSpeed(aspects[ASPECT_SPEED])
	MySelf.AbleToSprint = GAMEMODE:GetCanSprint(aspects[ASPECT_DEXTERITY])
	MySelf.AbleToDodge = GAMEMODE:GetCanDodge(aspects[ASPECT_DEXTERITY])
	MySelf.AbleToWallRun = GAMEMODE:GetCanWallRun(aspects[ASPECT_DEXTERITY])
	MySelf.AbleToWallJump = GAMEMODE:GetCanWallJump(aspects[ASPECT_DEXTERITY])
	MySelf.AbleToWallVert = GAMEMODE:GetCanWallVert(aspects[ASPECT_DEXTERITY])
	MySelf.ObeliskManaRetainer = GAMEMODE:GetObeliskManaRetainer(aspects[ASPECT_SPIRIT])
	MySelf.AgilityMultiplier = GAMEMODE:GetAgilityMultiplier(aspects[ASPECT_AGILITY])
	MySelf.CastingRateMultiplier = GAMEMODE:GetCastingRate(aspects[ASPECT_INTELLIGENCE])

	MySelf.m_NextAttack = 0

	GAMEMODE:ResetSpellsHint()
end)

function CreateAspects(nam, bas)
	local tab = {}
	LoadAspects(bas or "default", tab)

	local currentfile = ASPECTFILE
	ASPECTFILE = nam
	SaveAspects(tab)
	ASPECTFILE = currentfile
end
CreateProfile = CreateAspects

function SaveAspects(member)
	member = member or MySelf

	local savetab = {}
	savetab.Aspects = member.Aspects or {}
	savetab.Loadout = member.Loadout or {}
	if member == MySelf then
		savetab.SpellSheet = SPELL_SHEET or {}
	else
		savetab.SpellSheet = member.SpellSheet or {}
	end
	savetab.Model = member.Model or "kliener"

	for i=NUMASPECTS+1, NUMASPECTS+#savetab.Aspects do
		table.remove(savetab.Aspects, NUMASPECTS+1)
	end

	file.Write("noxaspects/"..ASPECTFILE..".txt", Serialize(savetab))
end
SaveProfile = SaveAspects

function LoadAspects(nam, member)
	if not file.Exists("noxaspects/"..nam..".txt") then
		nam = "default"
		print("Couldn't find profile for "..tostring(nam)..". Using default.")
	end

	member = member or MySelf

	local loadtab = Deserialize(file.Read("noxaspects/"..nam..".txt"))
	member.Aspects = NormalizeAspects(loadtab.Aspects or {})
	member.Loadout = loadtab.Loadout or {}
	member.SpellSheet = loadtab.SpellSheet or {}
	member.Model = loadtab.Model or "kliener"

	if member == MySelf then
		SPELL_SHEET = BuildSpellSheet(member.SpellSheet)
	end
end
LoadProfile = LoadAspects

function RefreshCastableSpells()
	CASTABLE_SPELLS = {}
	for i, spelltab in ipairs(Spells) do
		if spelltab.Desc ~= "Hidden" then
			table.insert(CASTABLE_SPELLS, i)
		end
	end
end

function SetFadingMessage(msg, msg2, tim)
	if tim and tim == -1 then hook.Remove("HUDPaint", "FadingBigMessage") return end

	FADINGBIGTIME = CurTime() + (tim or 4)
	FADINGBIGMESSAGE = markup.Parse(msg)
	if msg2 then
		FADINGSUBMESSAGE = markup.Parse(msg2)
	else
		FADINGSUBMESSAGE = nil
	end

	hook.Add("HUDPaint", "FadingBigMessage", FadingBigMessage)
end

function FadingBigMessage()
	if CurTime() < FADINGBIGTIME then
		local totalwidth
		local totalheight
		if FADINGSUBMESSAGE then
			totalwidth = math.max(FADINGBIGMESSAGE.totalWidth, FADINGSUBMESSAGE.totalWidth) + 16
			totalheight = FADINGBIGMESSAGE.totalHeight + FADINGSUBMESSAGE.totalHeight + 8
		else
			totalwidth = FADINGBIGMESSAGE.totalWidth + 16
			totalheight = FADINGBIGMESSAGE.totalHeight + 8
		end
		local alpha = math.min((FADINGBIGTIME - CurTime()) * 100, 180)
		draw.RoundedBox(16, w * 0.5 - totalwidth * 0.5, h * 0.74, totalwidth, totalheight, Color(0, 0, 0, alpha))

		FADINGBIGMESSAGE:Draw(w * 0.5 - FADINGBIGMESSAGE.totalWidth * 0.5, h * 0.74 + 4)
		--FADINGBIGMESSAGE:Draw(w * 0.5, h * 0.74 + 4)

		if FADINGSUBMESSAGE then
			FADINGSUBMESSAGE:Draw(w * 0.5 - FADINGSUBMESSAGE.totalWidth * 0.5, h * 0.74 + FADINGBIGMESSAGE.totalHeight + 4)
			--FADINGSUBMESSAGE:Draw(w * 0.5, h * 0.74 + FADINGBIGMESSAGE.totalHeight + 4)
		end
	else
		FADINGBIGTIME = nil
		FADINGBIGMESSAGE = nil
		FADINGSUBMESSAGE = nil
		hook.Remove("HUDPaint", "FadingBigMessage")
	end
end

usermessage.Hook("RecGameState", function(um)
	local state = um:ReadShort()
	if state == GAMESTATE_PLAY then
		SetFadingMessage("<font=akbarnormal>Begin!", nil, 4)
	elseif state == GAMESTATE_VERIFY then
		SetFadingMessage("<font=akbarnormal>Verify your bases!", "<font=DefaultBold><color=red>Go to the center of the map, then your flag stand, then the center of the map again.", VERIFY_LENGTH)
	elseif state == GAMESTATE_BUILD then
		SetFadingMessage("<font=akbarnormal>Build your bases!", nil, 4)
	end
end)

usermessage.Hook("EndG", function(um)
	local winner = um:ReadShort()
	END_GAME = true
	NEXT_MAP = CurTime() + 35
	if 0 < winner then
		SetFadingMessage("<font=akbarnormal>".. team.GetName(winner) .." has won the match!", nil, 60)
	else
		SetFadingMessage("<font=akbarnormal>DRAW GAME", nil, 60)
	end
	if winner == MySelf:Team() then
		surface.PlaySound("nox/flagcaptured.wav")
	else
		surface.PlaySound("nox/roundlose.wav")
	end

	GAMEMODE.Whiteness = 8
	hook.Add("HUDPaint", "PaintNotesHook", GAMEMODE.PaintNotes)
	function GAMEMODE:HUDPaint() end
	function GAMEMODE:HUDPaintBackground()
		self.Whiteness = math.min(255, self.Whiteness + FrameTime() * self.Whiteness)
		surface.SetDrawColor(0, 0, 0, self.Whiteness)
		surface.DrawRect(0, 0, w, h)
		if CurTime() <= NEXT_MAP then
			draw.RoundedBox(16, w*0.45, h*0.8, w*0.1, h*0.05, color_black)
			draw.SimpleText("Next Map: "..ToMinutesSeconds(NEXT_MAP - CurTime()), "Default", w*0.5, h*0.825, color_white, TEXT_ALIGN_CENTER, TEXT_ALIGN_CENTER)
		else
			draw.RoundedBox(16, w*0.45, h*0.8, w*0.1, h*0.05, color_black)
			draw.SimpleText("Loading...", "Default", w*0.5, h*0.825, Color(255, 0, 0), TEXT_ALIGN_CENTER, TEXT_ALIGN_CENTER)
		end
	end
end)

usermessage.Hook("FlagReturnEffect", function(um)
	local effectdata = EffectData()
		effectdata:SetOrigin(um:ReadVector())
		effectdata:SetStart(um:ReadVector())
		effectdata:SetScale(um:ReadShort())
	util.Effect("flagreturn", effectdata)
end)

usermessage.Hook("intmsstart", function(um)
	GAMEMODE.IntermissionBegan = um:ReadFloat()
	gamemode.Call("StartIntermission", um:ReadEntity(), um:ReadShort())
end)

usermessage.Hook("RecFlagInfo", function(um)
	local i = um:ReadShort()
	team.TeamInfo[i].FlagPoint = um:ReadVector()
	local flagent = um:ReadEntity()
	team.TeamInfo[i].Flag = flagent
	if flagent:IsValid() then
		flagent:SetTeamID(i)
	end
end)

usermessage.Hook("9", function(um)
	MySelf.Mana = um:ReadShort()
end)

usermessage.Hook("RM", function(um)
	MySelf.Mana = um:ReadShort()
end)

function DI(spellid, tTime)
	if tTime == 0 then
		DelayIcons[spellid] = nil
	elseif 0 < tTime then
		local curtime = CurTime()
		DelayIcons[spellid] = {StartTime = curtime, EndTime = curtime + tTime}
	else
		DelayIcons[spellid] = {StartTime = CurTime(), EndTime = -10}
	end
end

usermessage.Hook("DI", function(um)
	DI(um:ReadShort(), um:ReadFloat())
end)

usermessage.Hook("RecInvis", function(um)
	local ent = um:ReadEntity()

	if ent and ent:IsValid() then
		local effectdata = EffectData()
			effectdata:SetOrigin(MySelf:GetPos())
			effectdata:SetEntity(ent)
		util.Effect("invisibility_in", effectdata, true, true)
	end
end)

function DeVB()
	local effectdata = EffectData()
		effectdata:SetEntity(MySelf)
		effectdata:SetMagnitude(0)
	util.Effect("assassin_venomblade", effectdata, true)
end

function gib()
	local effectdata = EffectData()
		effectdata:SetEntity(MySelf)
		effectdata:SetNormal(MySelf:GetVelocity():Normalize())
	util.Effect("gib_player", effectdata)
end

function drayed()
	local effectdata = EffectData()
		effectdata:SetEntity(MySelf)
	util.Effect("DeathRayDeath", effectdata)
end

function axes()
	if MySelf.Axe and MySelf.Axe.IMANEFFECT then
		AXE_SWING = RealTime() + 1
	end
end

usermessage.Hook("SetInvisible", function(um)
	local ent = um:ReadEntity()

	if ent and ent:IsValid() then
		local effectdata = EffectData()
			effectdata:SetOrigin(ent:GetPos())
			effectdata:SetEntity(ent)
		if um:ReadBool() then
			util.Effect("invisibility_in", effectdata, true, true)
		else
			util.Effect("invisibility_out", effectdata, true, true)
		end
	end
end)

usermessage.Hook("NextRespawn", function(um)
	MySelf.NextSpawnTime = um:ReadFloat()
end)

usermessage.Hook("RecInfo", function(um)
	local ent = um:ReadEntity()
	if ent:IsValid() and ent.Info then
		ent:Info(um)
	end
end)

--[[function OpenGTVoteMenu()
	if pVoteMap then
		pVoteMap:SetVisible(false)
	end

	if pGTVote then
		pGTVote:Remove()
		pGTVote = nil
	end

	local pw = 550
	local ph = 510

	local Window = vgui.Create("DFrame")
	Window:SetSize(pw, ph)
	Window:Center()
	Window:SetTitle("Gametype Vote")
	Window:SetVisible(true)
	Window:MakePopup()
	Window:SetDeleteOnClose(false)
	Window:SetKeyboardInputEnabled(false)
	pGTVote = Window

	surface.SetFont("noxnetnormal")
	local tw, th = surface.GetTextSize("Vote for next map's gametype...")
	local label = vgui.Create("DLabel", Window)
	label:SetText("Vote for next map's gametype...")
	label:SetFont("noxnetnormal")
	label:SetTextColor(color_white)
	label:SetPos(pw * 0.5 - tw * 0.5, 8)
	label:SetSize(tw, th)
	label:SetMouseInputEnabled(false)

	surface.SetFont("Default")
	local mapname, numvotes = GetMostVotes()
	local tw2, th2 = surface.GetTextSize("(The next map is "..mapname..")")
	local label = vgui.Create("DLabel", Window)
	label:SetText("(The next map is "..mapname..")")
	label:SetFont("Default")
	label:SetTextColor(color_white)
	label:SetPos(pw * 0.5 - tw2 * 0.5, 8 + th)
	label:SetSize(tw2, th2)
	label:SetMouseInputEnabled(false)

	local tgametypes = #GAMEMODE.GameTypes
	local spacing = ph / (tgametypes + 1)
	local x = 72
	local y = 8 + th * 2
	for i, gt in ipairs(GAMEMODE.GameTypes) do
		surface.SetFont("noxnetnormal")
		local dispname = GAMEMODE.GameTranslates[gt] or gt
		local tw3, th3 = surface.GetTextSize(dispname)
		local label = vgui.Create("DLabel", Window)
		label:SetText(dispname)
		label:SetFont("noxnetnormal")
		label:SetTextColor(COLOR_LIMEGREEN)
		label:SetPos(x - tw3 * 0.5, y)
		label:SetSize(tw, th)
		label:SetMouseInputEnabled(false)

		local desc = GAMEMODE.GameTypeDescriptions[gt]
		if desc then
			desc = " - "..desc
			surface.SetFont("DefaultSmall")
			local tw2, th2 = surface.GetTextSize(desc)
			local label = vgui.Create("DLabel", Window)
			label:SetText(desc)
			label:SetFont("DefaultSmall")
			label:SetTextColor(color_white)
			label:SetPos(x + tw3 * 0.5, y + th3 * 0.5 - th2 * 0.5)
			label:SetSize(tw2, th2)
			label:SetMouseInputEnabled(false)
		end

		local button = vgui.Create("DButton", Window)
		button:SetPos(x - 32, y + 6 + th3)
		button:SetSize(64, 24)
		button:SetText("Vote!")
		if gt == GAMEMODE.GameType and 2 < #GAMEMODE.GameTypes then
			button:SetDisabled(true)
		else
			button.DoClick = function(btn)
				btn:GetParent():SetVisible(false)
				RunConsoleCommand("votegt", gt)
			end
		end

		y = y + spacing
	end
end
concommand.Add("votegtopen", OpenGTVoteMenu)]]

function GM:MakeTip(str)
end

local function SmartSound(ent, snd)
	if ent:IsValid() and ent:Alive() then
		ent:EmitSound(snd, 70, 100)
	end
end

usermessage.Hook("SI", function(um)
	local ent = um:ReadEntity()
	local mul = um:ReadFloat()
	local tab = Spells[um:ReadShort()]
	if tab and ent:IsValid() then
		ent.Casting = CurTime() + tab.Delay * mul + 0.5
		local timnam = "SI"..ent:EntIndex()
		for i, word in ipairs(tab.Words) do
			timer.Create(i..timnam, (i - 1) * 0.1 * mul, 1, SmartSound, ent, word)
		end
	end
end)

usermessage.Hook("SIStop", function(um)
	local ent = um:ReadEntity()
	if ent and ent:IsValid() then
		--ent.Casting = nil
		local timnam = "SI"..ent:EntIndex()
		for i=1, 20 do
			timer.Destroy(i..timnam)
		end
	end
end)

ASPECTFILE = CreateClientConVar("noxdefaultaspectprofile", "default", true, false):GetString()
if not file.Exists("noxaspects/"..ASPECTFILE..".txt") then ASPECTFILE = "default" end
LoadProfile(ASPECTFILE, MENUPROFILE)
