local LocalizedStuff = {}

LocalizedStuff[-1] = "NULL"
LocalizedStuff[1] = "-1 defense penalty for removing base defense!~wbuttons/button10.wav"
LocalizedStuff[2] = "Your loadout will be changed the next time you respawn."
LocalizedStuff[3] = "Your team's global prop limit has been reached."
LocalizedStuff[4] = "You don't have enough Silver to spawn this."
LocalizedStuff[5] = "+1 defense bonus for building base defense!"
LocalizedStuff[9] = "Invalid location."
LocalizedStuff[21] = "Not enough mana."
LocalizedStuff[23] = "Unknown spell ID."
LocalizedStuff[24] = "You must specify a spell name."
LocalizedStuff[26] = "You must wait to use this ability again."
LocalizedStuff[27] = "Your concentration has been broken."
LocalizedStuff[29] = "Too close to an objective to place it there."
LocalizedStuff[30] = "You can't teleport while holding a flag."
LocalizedStuff[33] = "You must be on the ground to cast this spell!"
LocalizedStuff[36] = "You have too many of those in play!"
LocalizedStuff[38] = "Your manually bound spawn point was destroyed."
LocalizedStuff[44] = "That spell is forbidden by the current game rules."
LocalizedStuff[45] = "That ability is forbidden by the current game rules."
LocalizedStuff[50] = "You have reached your personal maximum amount of those."
LocalizedStuff[51] = "Your team has reached the maximum amount of those."
LocalizedStuff[54] = "That spell is disabled on this map."
LocalizedStuff[55] = "You can't teleport while under the effects of Anchor."
LocalizedStuff[57] = "This Health Dispenser requires mana from a Mana Capacitor."
LocalizedStuff[58] = "This Teleport Pad requires mana from a Mana Capacitor."
LocalizedStuff[60] = "You can't cast spells without a caster weapon."
LocalizedStuff[61] = "Your bound spawn point is inside of a wall so you have spawned in another location."
LocalizedStuff[62] = "Your spawn point has been reset for the new round."
LocalizedStuff[64] = "Invalid spot for placement."
LocalizedStuff[65] = "That structure is too close to other structures of the same frequency."
LocalizedStuff[66] = "That structure must be placed standing upright and on solid ground."
LocalizedStuff[67] = "That would be blocking a spawn point."
LocalizedStuff[68] = "That structure won't operate in liquid."
LocalizedStuff[69] = "You can't concentrate on that many unfinished structures!"

function GetLocalized(int)
	return LocalizedStuff[int] or "NULL"
end
GL = GetLocalized

usermessage.Hook("lm", function(um)
	local int = um:ReadShort()
	local args = um:ReadString()
	local str = GetLocalized(int)
	if 0 < string.len(args) then
		args = string.Explode("@", args)
		for k, v in ipairs(args) do
			str = string.gsub(str, "_"..k.."_", v)
		end
	end
	GAMEMODE:AddNotify(str, COLOR_WHITE)
end)

usermessage.Hook("lmr", function(um)
	local int = um:ReadShort()
	local args = um:ReadString()
	local str = GetLocalized(int)
	if 0 < string.len(args) then
		args = string.Explode("@", args)
		for k, v in ipairs(args) do
			str = string.gsub(str, "_"..k.."_", v)
		end
	end
	GAMEMODE:AddNotify(str, COLOR_RED)
end)

usermessage.Hook("lmg", function(um)
	local int = um:ReadShort()
	local args = um:ReadString()
	local str = GetLocalized(int)
	if 0 < string.len(args) then
		args = string.Explode("@", args)
		for k, v in ipairs(args) do
			str = string.gsub(str, "_"..k.."_", v)
		end
	end
	GAMEMODE:AddNotify(str, COLOR_LIMEGREEN)
end)

function LM(int, args)
	local str = GetLocalized(int)
	if args then
		for k, v in ipairs(args) do
			str = string.gsub(str, "_"..k.."_", v)
		end
	end
	GAMEMODE:AddNotify(str, COLOR_WHITE)
end

function LMR(int, args)
	local str = GetLocalized(int)
	if args then
		for k, v in ipairs(args) do
			str = string.gsub(str, "_"..k.."_", v)
		end
	end
	GAMEMODE:AddNotify(str, COLOR_RED)
end

function LMG(int, args)
	local str = GetLocalized(int)
	if args then
		for k, v in ipairs(args) do
			str = string.gsub(str, "_"..k.."_", v)
		end
	end
	GAMEMODE:AddNotify(str, COLOR_LIMEGREEN)
end
