GM.GameTypes = {"CTF", "Blitz"}
GM.GameTypeDescriptions = {CTF = "Steal the enemy flag and bring it back to your base while defending your own!", Blitz = "One ball exists on the map. Bring it to the enemy goal to score!"}
GM.GameTranslates = {CTF = "Capture the Flag"}

GAMESTATE_BUILD = 0
GAMESTATE_READY = GAMESTATE_BUILD
GAMESTATE_VERIFY = 1
GAMESTATE_PLAY = 2

DMGTYPE_GENERIC = DMG_GENERIC
DMGTYPE_CUTTING = DMG_SLASH
DMGTYPE_IMPACT = DMG_CRUSH
DMGTYPE_PIERCING = DMG_BULLET
DMGTYPE_ARCANE = DMG_DIRECT
DMGTYPE_FIRE = DMG_BURN
DMGTYPE_ENERGY = DMG_SHOCK
DMGTYPE_COLD = DMG_DROWN
DMGTYPE_POISON = DMG_ACID

DAMAGETYPES = {
[DMGTYPE_GENERIC] = "Generic",
[DMGTYPE_CUTTING] = "Cutting",
[DMGTYPE_PIERCING] = "Piercing",
[DMGTYPE_IMPACT] = "Impact",
[DMGTYPE_ARCANE] = "Arcane",
[DMGTYPE_FIRE] = "Fire",
[DMGTYPE_ENERGY] = "Energy",
[DMGTYPE_COLD] = "Cold",
[DMGTYPE_POISON] = "Poison"
}
DMGTYPES = DAMAGETYPES

DMGTYPE_SLASHING = DMGTYPE_CUTTING
DMGTYPE_WIND = DMGTYPE_ENERGY
DMGTYPE_BLUDGEONING = DMGTYPE_IMPACT
DMGTYPE_BASHING = DMGTYPE_BLUDGEONING
DMGTYPE_LIGHTNING = DMGTYPE_ENERGY
DMGTYPE_SHOCK = DMGTYPE_LIGHTNING
DMGTYPE_ELECTRIC = DMGTYPE_LIGHTNING
DMGTYPE_ICE = DMGTYPE_COLD
DMGTYPE_WATER = DMGTYPE_COLD
DMGTYPE_AIR = DMGTYPE_ENERGY
DMGTYPE_WIND = DMGTYPE_AIR
DMGTYPE_VOID = DMGTYPE_ARCANE
DMGTYPE_BULLET = DMGTYPE_PIERCING
DMGTYPE_PIERCE = DMGTYPE_PIERCING

--[[DMGTYPE_GENERIC = 0
DMGTYPE_FIRE = 1
DMGTYPE_ENERGY = 2
DMGTYPE_ICE = 3
DMGTYPE_POISON = 4
DMGTYPE_PHYSICAL = 5
DMGTYPE_WIND = 6
DMGTYPE_BULLET = 7]]

DMGTYPE_LIGHTNING = DMGTYPE_ENERGY
DMGTYPE_SHOCK = DMGTYPE_LIGHTNING
DMGTYPE_ELECTRIC = DMGTYPE_LIGHTNING
DMGTYPE_COLD = DMGTYPE_ICE
DMGTYPE_AIR = DMGTYPE_WIND

RESISTANCE_NORMAL = 0
RESISTANCE_CONCRETE = 1
RESISTANCE_RUBBER = 2
RESISTANCE_METAL = 3
RESISTANCE_WOOD = 4
RESISTANCE_ELECTRONIC = 5
RESISTANCE_INVULNERABLE = 6

ASPECT_MIGHT = 1
ASPECT_AGILITY = 2
ASPECT_MIND = 3
ASPECT_TECH = 4
ASPECT_DESTRUCTION = 5
ASPECT_DEFENSIVE = 6
ASPECT_CURSING = 7
ASPECT_HEALING = 8
ASPECT_SPEED = 9
ASPECT_STRENGTH = 10
ASPECT_ENDURANCE = 11
ASPECT_DEXTERITY = 12
ASPECT_WILL = 13
ASPECT_GUNMASTERY = 14
ASPECT_CRAFTSMANSHIP = 15
ASPECT_ACCURACY = 16
ASPECT_INSTINCT = 17
ASPECT_RECOVERY = 18
ASPECT_SPIRIT = 19
ASPECT_INTELLIGENCE = 20
NUMASPECTS = 20
ASPECTS_MAX = 8

NUMWEAPONSLOTS = 3

ASPECTS = {}

ASPECTS[ASPECT_MIGHT] = {
	Name = "Might",
	Description = "Might is the amount of brute force one is capable of.\nIncreases overall melee weapon damage."
}
ASPECTS[ASPECT_STRENGTH] = {
	Name = "Strength",
	Description = "Strength is the measurement of how much one can carry and how well they can handle it.\nRequired to hold heavier weaponry."
}
ASPECTS[ASPECT_ENDURANCE] = {
	Name = "Endurance",
	Description = "Endurance is a measurement of how much of a beating one's body can take before giving out.\nIncreases maximum health."
}
ASPECTS[ASPECT_SPIRIT] = {
	Name = "Spirit",
	Description = "Spirit is the measurement of one's ability to harness and control the power of Mana.\nIncreases natural mana recovery rate and increases mana gained from Obelisks."
}
ASPECTS[ASPECT_INTELLIGENCE] = {
	Name = "Intelligence",
	Description = "Intelligence is the measure of how fast one can think, especially under pressure.\nDetermines the casting rate of spells."
}
ASPECTS[ASPECT_MIND] = {
	Name = "Mind",
	Description = "Mind is the amount of ones knowledge.\nIncreases maximum Mana and is required to cast all spells."
}

ASPECTS[ASPECT_DESTRUCTION] = {
	Name = "Destruction",
	Description = "Determines what level of Destruction magic you can cast.\nThe higher the aspect, the more Destruction spells that can be cast."
}
ASPECTS[ASPECT_DEFENSIVE] = {
	Name = "Defensive Casting",
	Description = "Determines what level of Defensive magic you can cast.\nThe higher the aspect, the more Defensive Casting spells that can be cast."
}
ASPECTS[ASPECT_CURSING] = {
	Name = "Cursing",
	Description = "Determines what level of Cursing magic you can cast.\nThe higher the aspect, the more Cursing spells that can be cast."
}
ASPECTS[ASPECT_HEALING] = {
	Name = "Healing",
	Description = "Determines what level of Healing magic you can cast.\nThe higher the aspect, the more Healing spells that can be cast.",
}

ASPECTS[ASPECT_DEXTERITY] = {
	Name = "Dexterity",
	Description = "Dexterity is the measure of how well one is in control of their body.\nDetermines what stamina-draining moves can be used such as wall running, dodging, and wall-jumping.",
}
ASPECTS[ASPECT_SPEED] = {
	Name = "Speed",
	Description = "Speed is the measure of how fast one can get from point A to point B.\nIncreases running, sprinting, and wall running speed."
}
ASPECTS[ASPECT_AGILITY] = {
	Name = "Agility",
	Description = "Agility is the measure of how fluid one's movements are.\nIncreases jump, dodge, and wall-jump power."
}
ASPECTS[ASPECT_WILL] = {
	Name = "Will",
	Description = "Will is a measurement of how much one is determined to do something.\nIncreases maximum stamina."
}
ASPECTS[ASPECT_RECOVERY] = {
	Name = "Recovery",
	Description = "Recovery is how quickly one can recover from fatigue.\nIncreases stamina regeneration rate."
}

ASPECTS[ASPECT_TECH] = {
	Name = "Tech",
	Description = "Tech is the general knowledge of how things work.\nDetermines the maximum usable level of building and ranged weaponry."
}
ASPECTS[ASPECT_GUNMASTERY] = {
	Name = "Gunmastery",
	Description = "Gunmastery is the measurement of how much one's body is able to using their own Mana to feed their Mana-draining weapons.\nGreatly decreases the Mana required to reload ranged weaponry."
}
ASPECTS[ASPECT_CRAFTSMANSHIP] = {
	Name = "Craftsmanship",
	Description = "Craftsmanship is the measurement of one's skill in piecing things together accurately and quickly.\nIncreases the rate of repairing and building."
}
ASPECTS[ASPECT_ACCURACY] = {
	Name = "Accuracy",
	Description = "Accuracy is the measurement of one's depth perception, hand-eye-coordination, and skill with a ranged weapon.\nDecreases inacurracy on ranged weaponry."
}
ASPECTS[ASPECT_INSTINCT] = {
	Name = "Instinct",
	Description = "Instinct is the measurement of one's ability to quickly make decisions without thinking.\nIncreases the rate of fire on ranged weaponry."
}

function GM:GetMaximumStamina(aspect)
	return math.floor(30 + aspect * 70)
end

function GM:GetStaminaRegeneration(aspect)
	return 5 + aspect * 5
end

function GM:GetMaximumMana(aspect)
	return math.floor(30 + aspect * 120)
end

function GM:GetManaRegeneration(aspect)
	return 0.5 + aspect * 4
end

function GM:GetObeliskManaRetainer(aspect)
	return 0.25 + aspect * 0.75
end

function GM:GetMaximumHealth(aspect)
	return 75 + math.floor(aspect * 50)
end

function GM:GetRateOfFireMultiplier(aspect)
	return 1.2 - aspect * 0.4
end

function GM:GetAccuracyMultiplier(aspect)
	return 1.5 - aspect * 0.75
end

function GM:GetBuildingRateMultiplier(aspect)
	return 0.5 + aspect
end

function GM:GetGunManaMultiplier(aspect)
	return 2 - aspect * 1.5
end

function GM:GetMeleeDamageMultiplier(aspect)
	return 0.85 + aspect * 0.3
end

function GM:GetCanWallJump(aspect)
	return DEXTERITY_WALLJUMP <= aspect
end

function GM:GetCanDodge(aspect)
	return DEXTERITY_DODGE <= aspect
end

function GM:GetCanSprint(aspect)
	return DEXTERITY_SPRINT <= aspect
end

function GM:GetWallRunSpeed(aspect)
	return 350 + aspect * 100
end

function GM:GetWallVertSpeed(aspect)
	return 275 + aspect * 75
end

function GM:GetSprintSpeed(aspect)
	return 325 + aspect * 75
end

function GM:GetSpeed(aspect)
	return 200 + aspect * 50
end

function GM:GetCanWallRun(aspect)
	return DEXTERITY_WALLRUN <= aspect
end

function GM:GetCanWallVert(aspect)
	return DEXTERITY_WALLVERT <= aspect
end

function GM:GetAgilityMultiplier(aspect)
	return 0.85 + aspect * 0.3
end

function GM:GetCastingRate(aspect)
	return 1.75 - aspect * 1
end

DURABILITY_GENERIC = 100
DURABILITY_BUILDER = 600
DURABILITY_MAGIC = DURABILITY_GENERIC
MAXCOUNT_PER_WEAPON = 3

WEAPON_ZAGGER = 1
WEAPON_APPRENTICEWAND = 2
WEAPON_GLADRADUS = 3
WEAPON_BUILDERA1 = 4
WEAPON_STIGMA = 5
WEAPON_FROTCHET = 6
WEAPON_REPEATER = 7
WEAPON_NAILER = 8
WEAPON_RIPDASH = 9
WEAPON_SWEEPER = 10
WEAPON_HEATER = 11
WEAPON_APPRENTICESTAFF = 12
WEAPON_AVENGER = 13

TYPE_WEAPON = 0
TYPE_ITEM = 1
TYPE_USEABLEITEM = 2
TYPE_AUGMENTER = 3

WEAPONS = {}
ITEMS = WEAPONS
local vec0 = Vector(0,0,0)
local genericcampos = Vector(0, 64, 32)
WEAPONS[WEAPON_ZAGGER] = {
	Name = "Zagger",
	Category = "Guns",
	SWEP = "weapon_zagger",
	Starting = true,
	Tooltip = "This pistol's slow recyle time is made up by its above average damage and accuracy.\n\nControls:\n[PRIMARY ATTACK]\nFire weapon\n[SECONDARY ATTACK]\nRapid fire",
	Model = "models/weapons/w_pistol.mdl",
	[ASPECT_TECH] = 0.3,
	[ASPECT_STRENGTH] = 0.1,
	Price = 15000,
	Durability = DURABILITY_GENERIC,
	Maximum = MAXCOUNT_PER_WEAPON,
	LookAt = vec0,
	CamPos = Vector(0, 12, 8),
	Type = TYPE_WEAPON
}
WEAPONS[WEAPON_APPRENTICEWAND] = {
	Name = "Apprentice Wand",
	Category = "Casters",
	SWEP = "weapon_apprenticewand",
	Starting = true,
	Model = "models/weapons/w_stunbaton.mdl",
	Tooltip = "A magic wand with nothing special about it. Spell potency is purely based on its user.\n\nControls:\n[SECONDARY ATTACK]\nInner spell menu\n[SECONDARY ATTACK + PRIMARY ATTACK]\nOutter spell menu\n[SPRINT KEY]\nCast spell",
	[ASPECT_MIND] = 0.1,
	Price = 7500,
	Durability = DURABILITY_MAGIC,
	Maximum = MAXCOUNT_PER_WEAPON,
	LookAt = vec0,
	CamPos = Vector(20, 20, 8),
	Type = TYPE_WEAPON
}
WEAPONS[WEAPON_APPRENTICESTAFF] = {
	Name = "Apprentice Staff",
	Category = "Casters",
	SWEP = "weapon_apprenticestaff",
	Starting = true,
	Model = "models/props_c17/signpole001.mdl",
	Tooltip = "A magic staff with nothing special about it. Spell potency is purely based on its user.\nStaffs have the unique ability of being able to hold a spell in them instead of casting right away.\nIf you do not discharge the spell after 10 seconds then the spell will fizzle away.\n\nControls:\n[SECONDARY ATTACK]\nInner spell menu\n[SECONDARY ATTACK + PRIMARY ATTACK]\nOutter spell menu\n[SPRINT KEY]\nLoad spell\n[SPRINT KEY AGAIN]\nDischarge spell",
	[ASPECT_MIND] = 0.2,
	Price = 10000,
	Durability = DURABILITY_MAGIC,
	Maximum = MAXCOUNT_PER_WEAPON,
	LookAt = vec0,
	CamPos = genericcampos,
	Type = TYPE_WEAPON
}
WEAPONS[WEAPON_GLADRADUS] = {
	Name = "Gladradus",
	Category = "Melee",
	SWEP = "weapon_gladradus",
	Price = 0,
	Starting = true,
	Model = "models/weapons/w_gladradus/w_gladradus.mdl",
	Tooltip = "A light sword enchanted with the power of gravity.\n\nControls:\n[PRIMARY ATTACK]\nSwing\n[JUMP + PRIMARY ATTACK]\nGround Slam\n[HOLD SECONDARY ATTACK]\nAir Blade\n[HOLD SECONDARY AFTER JUMP ATTACK]\nQuick Air Blade",
	[ASPECT_STRENGTH] = 0.5,
	Price = 18000,
	Durability = DURABILITY_GENERIC,
	Maximum = MAXCOUNT_PER_WEAPON,
	LookAt = vec0,
	CamPos = genericcampos,
	Type = TYPE_WEAPON
}
WEAPONS[WEAPON_BUILDERA1] = {
	Name = "Builder A-1",
	Category = "Builders",
	SWEP = "weapon_buildera-1",
	Price = 0,
	Starting = true,
	Model = "models/weapons/w_physics.mdl",
	Tooltip = "A standard-issue building laser with nothing special about it. A serial number is faintly visible on the side.\n\nControls:\n[PRIMARY ATTACK]\nRepair or build structure or vehicle.\n[SECONDARY ATTACK]\nBuilder menu",
	Price = 5000,
	[ASPECT_TECH] = 0.4,
	[ASPECT_STRENGTH] = 0.25,
	Durability = DURABILITY_BUILDER,
	Maximum = MAXCOUNT_PER_WEAPON,
	LookAt = vec0,
	CamPos = Vector(0, 32, 8),
	Builder = true,
	Type = TYPE_WEAPON
}
WEAPONS[WEAPON_STIGMA] = {
	Name = "Stigma",
	Category = "Guns",
	SWEP = "weapon_stigma",
	Price = 20000,
	Model = "models/weapons/w_357.mdl",
	Tooltip = "A powerful spread-fire pistol with a blind spot in its center.\n\nControls:\n[PRIMARY ATTACK]\nFire weapon\n[SECONDARY ATTACK]\nFire alternate pattern",
	[ASPECT_TECH] = 0.6,
	[ASPECT_STRENGTH] = 0.3,
	Durability = DURABILITY_GENERIC,
	Maximum = MAXCOUNT_PER_WEAPON,
	LookAt = vec0,
	CamPos = Vector(0, 24, 8),
	Type = TYPE_WEAPON
}
WEAPONS[WEAPON_FROTCHET] = {
	Name = "Frotchet",
	Category = "Melee",
	SWEP = "weapon_frotchet",
	Price = 22000,
	Model = "models/weapons/frotchet/w_frotchet.mdl",
	Tooltip = "A massive axe enchanted with the power of ice.\n\nControls:\n[PRIMARY ATTACK]\nSwing\n[HOLD SECONDARY ATTACK]\nFrost Slash\n[FROST SLASH GROUND AFTER JUMPING]\nProtrusion",
	[ASPECT_STRENGTH] = 0.75,
	Durability = DURABILITY_GENERIC,
	Maximum = MAXCOUNT_PER_WEAPON,
	LookAt = vec0,
	CamPos = genericcampos,
	Type = TYPE_WEAPON
}
WEAPONS[WEAPON_REPEATER] = {
	Name = "Repeater",
	Category = "Guns",
	SWEP = "weapon_repeater",
	Price = 18000,
	Model = "models/weapons/w_smg1.mdl",
	Tooltip = "An automatic gun designed purely for covering an area in bullets.\n\nControls:\n[PRIMARY ATTACK]\nFire weapon",
	[ASPECT_TECH] = 0.65,
	[ASPECT_STRENGTH] = 0.35,
	Durability = DURABILITY_GENERIC,
	Maximum = MAXCOUNT_PER_WEAPON,
	LookAt = vec0,
	CamPos = Vector(0, 24, 12),
	Type = TYPE_WEAPON
}
WEAPONS[WEAPON_NAILER] = {
	Name = "Nailer",
	Category = "Guns",
	SWEP = "weapon_nailer",
	Price = 24000,
	Model = "models/weapons/w_shot_xm1014.mdl",
	Tooltip = "This rifle fires powerful bullets at an incredible speed. The power is enough to throw back anyone unlucky enough to get hit.\n\nControls:\n[PRIMARY ATTACK]\nCharge and fire weapon\n[SECONDARY ATTACK]\nZoom",
	[ASPECT_TECH] = 0.7,
	--[ASPECT_ACCURACY] = 0.75,
	[ASPECT_STRENGTH] = 0.45,
	Durability = DURABILITY_GENERIC,
	Maximum = MAXCOUNT_PER_WEAPON,
	LookAt = vec0,
	CamPos = Vector(0, 48, 16),
	Type = TYPE_WEAPON
}
WEAPONS[WEAPON_RIPDASH] = {
	Name = "Ripdash",
	Category = "Melee",
	SWEP = "weapon_ripdash",
	Price = 25000,
	Model = "models/peanut/conansword.mdl",
	Tooltip = "A two-handed sword enchanted with the power of fire.\n\nControls:\n[PRIMARY ATTACK]\nSwing\n[SECONDARY ATTACK]\nFire Dash\n[JUMP + PRIMARY ATTACK]\nSun Beam",
	[ASPECT_STRENGTH] = 0.65,
	Durability = DURABILITY_GENERIC,
	Maximum = MAXCOUNT_PER_WEAPON,
	LookAt = Vector(0, 0, -12),
	CamPos = Vector(0, 54, 0),
	Type = TYPE_WEAPON
}
WEAPONS[WEAPON_SWEEPER] = {
	Name = "Sweeper",
	Category = "Guns",
	SWEP = "weapon_sweeper",
	Price = 24000,
	Model = "models/weapons/w_shotgun.mdl",
	Tooltip = "This shotgun fires bullets in an wide, cross pattern designed to hit large or close targets.\n\nControls:\n[PRIMARY ATTACK]\nFire weapon\n[SECONDARY ATTACK]\nFire alternate pattern",
	[ASPECT_TECH] = 0.65,
	[ASPECT_STRENGTH] = 0.4,
	Durability = DURABILITY_GENERIC,
	Maximum = MAXCOUNT_PER_WEAPON,
	LookAt = vec0,
	CamPos = Vector(0, 32, 16),
	Type = TYPE_WEAPON
}
WEAPONS[WEAPON_HEATER] = {
	Name = "Heater",
	Category = "Melee",
	SWEP = "weapon_heater",
	Price = 25000,
	Model = "models/weapons/steel_might/w_steel_might.mdl",
	Tooltip = "An axe and shield capable of guarding against melee attacks. Its true powers are currently unknown.\n\nControls:\n[PRIMARY ATTACK]\nSwing\n[HOLD RELOAD]\nGuard",
	[ASPECT_STRENGTH] = 0.7,
	Durability = DURABILITY_GENERIC,
	Maximum = MAXCOUNT_PER_WEAPON,
	LookAt = vec0,
	CamPos = genericcampos,
	Type = TYPE_WEAPON
}
WEAPONS[WEAPON_AVENGER] = {
	Name = "Avenger",
	Category = "Guns",
	SWEP = "weapon_avenger",
	Tooltip = "A powerful handgun. Its weight makes it hard to aim.\n\nControls:\n[PRIMARY ATTACK]\nFire weapon\n[SECONDAR ATTACK]\nAimed shot",
	Model = "models/weapons/w_pist_deagle.mdl",
	[ASPECT_TECH] = 0.7,
	[ASPECT_STRENGTH] = 0.3,
	Price = 25000,
	Durability = DURABILITY_GENERIC,
	Maximum = MAXCOUNT_PER_WEAPON,
	LookAt = vec0,
	CamPos = Vector(0, 12, 8),
	Type = TYPE_WEAPON
}
vec0 = nil
genericcampos = nil

for i, tab in pairs(WEAPONS) do
	if tab.Tooltip then
		local added
		for z=1, NUMASPECTS do
			if tab[z] then
				if not added then
					added = true
					tab.Tooltip = tab.Tooltip.."\n\nRequirements:"
				end
				tab.Tooltip = tab.Tooltip.."\n"..ASPECTS[z].Name.." - ".. tab[z] * 100
			end
		end
	end
end

RESISTANCES = {
	[RESISTANCE_NORMAL] = {},
	[RESISTANCE_CONCRETE] = {[DMGTYPE_CUTTING] = 0.5, [DMGTYPE_PIERCING] = 0.25, [DMGTYPE_BASHING] = 1.25, [DMGTYPE_FIRE] = 0.75, [DMGTYPE_ICE] = 1.25, [DMGTYPE_ENERGY] = 0.25, [DMGTYPE_POISON] = 0},
	[RESISTANCE_RUBBER] = {[DMGTYPE_CUTTING] = 1.25, [DMGTYPE_PIERCING] = 1.25, [DMGTYPE_BASHING] = 0.25, [DMGTYPE_FIRE] = 1.25, [DMGTYPE_ICE] = 1, [DMGTYPE_ENERGY] = 0, [DMGTYPE_POISON] = 0},
	[RESISTANCE_METAL] = {[DMGTYPE_CUTTING] = 0.5, [DMGTYPE_PIERCING] = 0.75, [DMGTYPE_BASHING] = 0.5, [DMGTYPE_FIRE] = 0.75, [DMGTYPE_ICE] = 1, [DMGTYPE_ENERGY] = 1.25, [DMGTYPE_POISON] = 0},
	[RESISTANCE_WOOD] = {[DMGTYPE_CUTTING] = 1, [DMGTYPE_PIERCING] = 1, [DMGTYPE_BASHING] = 0.75, [DMGTYPE_FIRE] = 1.25, [DMGTYPE_ICE] = 0.5, [DMGTYPE_ENERGY] = 1, [DMGTYPE_POISON] = 0.5},
	[RESISTANCE_ELECTRONIC] = {[DMGTYPE_CUTTING] = 1, [DMGTYPE_PIERCING] = 1, [DMGTYPE_BASHING] = 1, [DMGTYPE_FIRE] = 1, [DMGTYPE_ICE] = 0.25, [DMGTYPE_ENERGY] = 1.25, [DMGTYPE_POISON] = 0},
}

GM.ResistanceToString = {
	[RESISTANCE_CONCRETE] = "Stone",
	[RESISTANCE_RUBBER] = "Rubber",
	[RESISTANCE_METAL] = "Metal",
	[RESISTANCE_WOOD] = "Wood",
	[RESISTANCE_ELECTRONIC] = "Electronic"
}
GM.StringToResistance = {} for k,v in pairs(GM.ResistanceToString) do GM.StringToResistance[v] = k end

GM.ResistanceToColor = {
	[RESISTANCE_CONCRETE] = Color(128, 128, 128, 255),
	[RESISTANCE_RUBBER] = Color(180, 150, 150, 255),
	[RESISTANCE_METAL] = Color(180, 180,180, 255),
	[RESISTANCE_WOOD] = Color(150, 78, 50, 255),
	[RESISTANCE_ELECTRONIC] = Color(20, 200, 120, 255)
}

GM.ResistanceMaterials = {[RESISTANCE_CONCRETE] = "brick/brick_model", [RESISTANCE_RUBBER] = "models/props_c17/FurnitureFabric003a", [RESISTANCE_METAL] = "models/props_c17/FurnitureMetal001a", [RESISTANCE_WOOD] = "models/props_wasteland/wood_fence01a"}

STAMINA_WALLJUMP = 20
STAMINA_DODGE = 20
STAMINA_DODGE_STUNNED = 75
STAMINA_SPRINT = 8
STAMINA_WALLRUNNING = 13
STAMINA_WALLVERTING = 27
STAMINA_WALLRUN = STAMINA_WALLRUNNING
STAMINA_HOLDING_BALL = 8
STAMINA_LONGJUMP = 8

DEXTERITY_SPRINT = 0.15
DEXTERITY_DODGE = 0.25
DEXTERITY_WALLJUMP = 0.5
DEXTERITY_WALLRUN = 0.75
DEXTERITY_WALLVERT = 1

JUMPPOWER_DEFAULT = 360

if SERVER then
	function PROPGENERICREMOVALTHINK(self)
		GAMEMODE:RemoveProp(NULL, self)
	end

	function PROPGENERICPROCESSSPECIALDAMAGE(self, damage, dmgtype, attacker, inflictor)
		if dmgtype then
			local resistancetable = self.ResistanceTable
			if resistancetable and resistancetable[dmgtype] then
				damage = math.floor(damage * resistancetable[dmgtype])
			end
		end

		return damage, dmgtype, attacker, inflictor
	end

	function PROPGENERICPROCESSDAMAGE(self, attacker, inflictor, dmginfo)
		if self.Removing or GAMEMODE.Intermission or attacker:GetTeamID() == self:GetTeamID() then
			dmginfo:SetDamage(0)
			dmginfo:ScaleDamage(0)
		elseif self.Destroyed then
			local damage = dmginfo:GetDamage()
			if damage > 0 then
				dmginfo:SetDamage(damage * 1.5)
				self.NoAutoBuildTime = CurTime() + 1
			end
		end
	end

	--[[function PROPGENERICPROCESSDAMAGE(self, damage, attacker, inflictor)
		local myteam = self:GetTeamID()
		if self.Removing or GAMEMODE.Intermission or attacker:GetTeamID() == myteam then
			return 0, attacker, inflictor
		end

		if self.Destroyed then
			damage = math.floor(damage * 1.5)
			if damage > 0 then
				self.NoAutoBuildTime = CurTime() + 1
			end
		else
			local magusshield = self.MagusShield

			if magusshield and magusshield:IsValid() and magusshield:GetTeamID() == myteam then
				damage = math.ceil(damage * 1.5)

				local manausage = math.min(damage, magusshield.ManaStorage)
				damage = damage - manausage

				local healthusage = math.min(damage, magusshield.PHealth)
				damage = damage - healthusage

				magusshield.ManaStorage = math.floor(magusshield.ManaStorage - manausage)

				if 0 < healthusage then
					magusshield:TakeDamage(healthusage, attacker, inflictor)
				end

				if damage <= 0 then
					return damage, attacker, inflictor
				end
			end
		end

		return damage, attacker, inflictor
	end]]

	function PROPGENERICOVERRIDETAKEDAMAGE(self, damage, attacker, inflictor)
		if self.PHealth <= damage then
			if attacker.AssaultOffense and not self.Destroyed then
				if self.OffenseBonus then
					attacker:AddOffense(self.OffenseBonus)
				end
				if self.MoneyBonus then
					attacker:AddMoney(self.MoneyBonus)
				end
				if self.FragsBonus then
					attacker:AddFrags(3)
				end
			end

			self.PHealth = 0
			self.Destroyed = true
			self.Removing = true
			self.NoValue = true

			if self.DestructionEffect then
				self:DestructionEffect(damage, attacker, inflictor)
			end

			self.Think = PROPGENERICREMOVALTHINK
		else
			self.PHealth = math.ceil(self.PHealth - damage)

			if not self.NoSetColorOnDamage then
				local col = team.GetColor(self:GetTeamID())
				local brit = self.PHealth / self.MaxPHealth

				if self.Destroyed then
					self:SetColor(math.ceil(col.r * brit), math.ceil(col.g * brit), math.ceil(col.b * brit), math.ceil(brit * 240))
				else
					self:SetColor(math.ceil(col.r * brit), math.ceil(col.g * brit), math.ceil(col.b * brit), 255)
				end
			end
		end
	end

	function PROPGENERICDESTRUCTIONEFFECT(self)
		local effectdata = EffectData()
			effectdata:SetRadius(1)
			effectdata:SetMagnitude(1)
			effectdata:SetScale(1)
			effectdata:SetOrigin(self:GetPos())
		util.Effect("explosion", effectdata, true, true)
	end

	function PROPGENERICDESTRUCTIONEFFECT2(self)
		local effectdata = EffectData()
			effectdata:SetOrigin(self:GetPos())
		util.Effect("firebombexplosion", effectdata, true, true)
	end
end

TEAM_BLUE = 1
TEAM_YELLOW = 2
TEAM_GREEN = 3
TEAM_RED = 4

TEAM_SPECTATE = 256

BLUE_NAME = "Blue Bulls"
YELLOW_NAME = "Yellow Yaks"
GREEN_NAME = "Green Gazelles"
RED_NAME = "Red Rhinos"

BLUE_CHAT_NAME = "<lightblue>"..BLUE_NAME.."</lightblue>"
YELLOW_CHAT_NAME = "<yellow>"..YELLOW_NAME.."</yellow>"
GREEN_CHAT_NAME = "<limegreen>"..GREEN_NAME.."</limegreen>"
RED_CHAT_NAME = "<red>"..RED_NAME.."</red>"

team.SetUp(TEAM_BLUE, BLUE_NAME, Color(0, 160, 255), BLUE_CHAT_NAME)
team.SetUp(TEAM_YELLOW, YELLOW_NAME, Color(255, 255, 0), YELLOW_CHAT_NAME)
team.SetUp(TEAM_GREEN, GREEN_NAME, Color(30, 255, 30), GREEN_CHAT_NAME)
team.SetUp(TEAM_RED, RED_NAME, Color(255, 0, 0), RED_CHAT_NAME)
team.SetUp(TEAM_SPECTATE, "Spectating", color_white, "Spectating")

TOTAL_TEAMS = 0
TEAMS_PLAYING = {}
GAMESTATE = 0
ENDGAME = false
CTF_LENGTH = 1500
VERIFY_LENGTH = 120
BUILD_LENGTH = 60
GLOBALMAXPROPS = 100
CORE_HEALTH = 10000
CORE_HEAL = 25
CORE_HEAL_TIME = 5
MAX_SCORE = 4
BONUS_WIN = 1500
BONUS_CAPTURE = 250
BONUS_RETURN = 50
RESPAWN_TIME = 8
CRAFTER_RESPAWN = 1
CRAFTER_CORE_DEFENSE_BONUS = 15
BONUS_CORE_DESTROYED = 500
BONUS_CORE_DAMAGED = 20
BONUS_CORE_DEFENSE = 10
HTF_TIME = 480
KOTH_TIME = 600
TDM_KILLS = 100
TDM_SCORE = TDM_KILLS
CAPACITOR_RANGE = 768
CORE_MAX_MANA = 5000
CTF_FLAG_RETURNTIME = 5
ACTIVE_BUILDINGS_MAX = 2500

BLITZ_SCORE_LIMIT = 6
BLITZ_SCORE_FRAGS = 10
BLITZ_SCORE_MONEY = 200
BLITZ_INTERMISSION_TIME = 10

FRAGS_PERKILL = 2
FRAGS_PERASSIST = 4
FRAGS_PERCAPTURE = 10

local allmaterials = {RESISTANCE_CONCRETE, RESISTANCE_RUBBER, RESISTANCE_METAL, RESISTANCE_WOOD}
local allmaterials2 = {RESISTANCE_CONCRETE, RESISTANCE_METAL, RESISTANCE_WOOD}
local allmaterials3 = {RESISTANCE_METAL, RESISTANCE_WOOD}

local nometalmaterial = {[RESISTANCE_METAL] = ""}
local norubbermaterial = {[RESISTANCE_RUBBER] = ""}
local nowoodmaterial = {[RESISTANCE_WOOD] = ""}
local noconcretematerial = {[RESISTANCE_CONCRETE] = ""}

PROPTYPES = {
{
Name="Slim Wall",
Group="Props",
Model=Model("models/props_lab/blastdoor001b.mdl"),
Type="prop_prop",
PHealth=500,
DefaultResistance = RESISTANCE_METAL,
MaterialOverrides = nometalmaterial,
UsableMaterials = allmaterials
},
{
Name="Wide Wall",
Group="Props",
Model=Model("models/props_lab/blastdoor001c.mdl"),
Type="prop_prop",
PHealth=525,
DefaultResistance = RESISTANCE_METAL,
MaterialOverrides = nometalmaterial,
UsableMaterials = allmaterials
},
{
Name="4x4 Box",
Group="Props",
Model=Model("models/props_junk/wood_crate001a.mdl"),
Type="prop_prop",
PHealth=400,
DefaultResistance = RESISTANCE_WOOD,
MaterialOverrides = nowoodmaterial,
UsableMaterials = allmaterials
},
{
Name="4x8 Box",
Group="Props",
Model=Model("models/props_junk/wood_crate002a.mdl"),
Type="prop_prop",
PHealth=450,
DefaultResistance = RESISTANCE_WOOD,
MaterialOverrides = nowoodmaterial,
UsableMaterials = allmaterials
},
{
Name="Stick",
Group="Props",
Model=Model("models/props_docks/dock01_pole01a_128.mdl"),
Type="prop_prop",
PHealth=400,
DefaultResistance = RESISTANCE_WOOD,
MaterialOverrides = nowoodmaterial,
UsableMaterials = allmaterials2
},
{
Name="Wood Pallet",
Group="Props",
Model=Model("models/props_junk/wood_pallet001a.mdl"),
Type="prop_prop",
PHealth=450,
DefaultResistance = RESISTANCE_WOOD,
MaterialOverrides = nowoodmaterial
},
{
Name="Fence",
Group="Props",
Model=Model("models/props_wasteland/wood_fence01a.mdl"),
Type="prop_prop",
PHealth=425,
DefaultResistance = RESISTANCE_WOOD,
MaterialOverrides = nowoodmaterial,
UsableMaterials = allmaterials
},
{
Name="Cylinder",
Group="Props",
Model=Model("models/props_c17/oildrum001.mdl"),
Type="prop_prop",
PHealth=425,
DefaultResistance = RESISTANCE_METAL,
MaterialOverrides = nometalmaterial,
UsableMaterials = allmaterials
},
{
Name="Short Panel",
Group="Props",
Model=Model("models/props_debris/metal_panel02a.mdl"),
Type="prop_prop",
PHealth=400,
DefaultResistance = RESISTANCE_METAL,
MaterialOverrides = nometalmaterial,
UsableMaterials = allmaterials3
},
{
Name="Long Panel",
Group="Props",
Model=Model("models/props_debris/metal_panel01a.mdl"),
Type="prop_prop",
PHealth=450,
DefaultResistance = RESISTANCE_METAL,
MaterialOverrides = nometalmaterial,
UsableMaterials = allmaterials3
},
{
Name="Shield Barricade",
Group="Props",
Model=Model("models/props_combine/combine_barricade_short01a.mdl"),
Type="prop_prop",
PHealth=550,
DefaultResistance = RESISTANCE_METAL,
MaterialOverrides = nometalmaterial
},
{
Name="Bars",
Group="Props",
Model=Model("models/props_wasteland/prison_gate001b.mdl"),
Type="prop_prop",
PHealth=550,
DefaultResistance = RESISTANCE_METAL,
MaterialOverrides = nometalmaterial,
UsableMaterials = allmaterials3
},
{
Name="Barrier",
Group="Props",
Model=Model("models/props_c17/concrete_barrier001a.mdl"),
Type="prop_prop",
PHealth=500,
DefaultResistance = RESISTANCE_CONCRETE,
MaterialOverrides = noconcretematerial,
UsableMaterials = allmaterials
},
{
Name="Wide Combine Wall",
Group="Props",
Model="models/props_combine/combine_barricade_med03b.mdl",
Type="prop_prop",
PHealth=750,
MaterialOverrides = nometalmaterial,
UsableMaterials = allmaterials2
},
{
Name="Short Combine Wall",
Group="Props",
Model=Model("models/props_combine/combine_barricade_med01a.mdl"),
Type="prop_prop",
PHealth=750,
MaterialOverrides = nometalmaterial,
UsableMaterials = allmaterials2
},
{
Name="Tall Combine Wall",
Group="Props",
Model=Model("models/props_combine/combine_barricade_tall01a.mdl"),
Type="prop_prop",
PHealth=750,
MaterialOverrides = nometalmaterial,
UsableMaterials = allmaterials2
},
{
Name="Slotted Combine Wall",
Group="Props",
Model=Model("models/props_combine/combine_barricade_med02b.mdl"),
Type="prop_prop",
PHealth=750,
MaterialOverrides = nometalmaterial,
UsableMaterials = allmaterials2
},
{
Name="Shield Window",
Group="Props",
Model=Model("models/props_combine/combine_window001.mdl"),
Type="prop_prop",
PHealth=550,
MaterialOverrides = nometalmaterial,
DefaultResistance = RESISTANCE_METAL
},
{
Name="Short Fortress Wall",
Group="Props",
Model=Model("models/slyfo/wallshort.mdl"),
Type="prop_prop",
PHealth=1200,
MaterialOverrides = nometalmaterial,
UsableMaterials = allmaterials2
},
--[[{
Name="Long Fortress Wall",
Group="Props",
Model=Model("models/slyfo/walllong.mdl"),
Type="prop_prop",
PHealth=1600,
MaterialOverrides = nometalmaterial,
UsableMaterials = allmaterials2
},]]
{
Name="Long Fortress Gate",
Group="Props",
Model=Model("models/slyfo/walllonggate.mdl"),
Type="prop_prop",
PHealth=1200,
MaterialOverrides = nometalmaterial,
UsableMaterials = allmaterials2
},
{
Name="Short Fortress Gate",
Group="Props",
Model=Model("models/slyfo/wallshortgate.mdl"),
Type="prop_prop",
PHealth=1000,
MaterialOverrides = nometalmaterial,
UsableMaterials = allmaterials2
},
{
Name="Mana Extractor",
Group="Resource Management",
Model=Model("models/props_combine/combine_light001a.mdl"),
Type="prop_manaextractor",
Max=16,
TeamMax=32,
PHealth=500,
Callback=function(pl, ent) pl:PrintMessage(HUD_PRINTTALK, "This will convert an obelisk's Mana in to a storable form. It needs to be placed appropriately near a Mana Obelisk.") local ang = ent:GetAngles() ang.yaw = math.NormalizeAngle(ang.yaw + 180) ent:SetAngles(ang) end,
MaterialOverrides = nometalmaterial,
DefaultResistance = RESISTANCE_ELECTRONIC
},
{
Name="Large Mana Capacitor",
Group="Resource Management",
Model=Model("models/props_trainstation/trainstation_ornament001.mdl"),
Type="prop_largemanacapacitor",
PHealth=750,
Max=8,
TeamMax=24,
Callback=function(pl, ent) pl:PrintMessage(HUD_PRINTTALK, "This will store mana gained from Mana Extracters and nearby structures can then use the stored mana.") end,
MaterialOverrides = nometalmaterial,
DefaultResistance = RESISTANCE_ELECTRONIC
},
{
Name="Small Mana Capacitor",
Group="Resource Management",
Model=Model("models/props_c17/substation_transformer01d.mdl"),
Type="prop_smallmanacapacitor",
PHealth=400,
Max=8,
TeamMax=24,
Callback=function(pl, ent) pl:PrintMessage(HUD_PRINTTALK, "This will store mana gained from Mana Extracters and nearby structures can then use the stored mana.") end,
MaterialOverrides = nometalmaterial,
DefaultResistance = RESISTANCE_ELECTRONIC
},
{
Name="Mana Translocator",
Group="Resource Management",
Model=Model("models/props_c17/utilityconnecter006c.mdl"),
Type="prop_manatranslocator",
PHealth=600,
Max=8,
TeamMax=32,
Callback=function(pl, ent) pl:PrintMessage(HUD_PRINTTALK, "Attaching this to an active Mana Capacitor will allow you to link together another capacitor that it's pointing to.") end,
MaterialOverrides = nometalmaterial,
DefaultResistance = RESISTANCE_ELECTRONIC
},
{
Name="Mana Relay",
Group="Resource Management",
Model=Model("models/props_c17/utilityconducter001.mdl"),
Type="prop_manarelay",
PHealth=500,
Max=8,
TeamMax=24,
Callback=function(pl, ent) pl:PrintMessage(HUD_PRINTTALK, "This is a much smaller capacitor that does not power nearby structures but can be used as a relay station for translocators.") end,
MaterialOverrides = nometalmaterial,
DefaultResistance = RESISTANCE_ELECTRONIC
},
{
Name="Spawn Point",
Group="Deployables",
Model=Model("models/props_combine/combine_mine01.mdl"),
Type="prop_spawnpoint",
Max=4,
TeamMax=20,
PHealth=300,
Callback=function(pl, ent) pl:PrintMessage(HUD_PRINTTALK, "Press USE on it to set your spawn.") end,
MaterialOverrides = nometalmaterial,
DefaultResistance = RESISTANCE_ELECTRONIC
},
{
Name="Mana Dispenser",
Group="Powered Deployables",
Model=Model("models/props_trainstation/trainstation_ornament002.mdl"),
Type="prop_obelisk",
PHealth=300,
Max=4,
TeamMax=16,
MaterialOverrides = nometalmaterial,
DefaultResistance = RESISTANCE_ELECTRONIC,
Tutorial = "Mana Dispensers"
},
{
Name="Teleport Pad",
Group="Deployables",
Model=Model("models/props_lab/teleplatform.mdl"),
Type="prop_teleportpad",
Max=6,
TeamMax=20,
PHealth=500,
Callback=function(pl, ent) pl:PrintMessage(HUD_PRINTTALK, "Press USE on this telepad and then press USE on another telepad to link them.") end,
MaterialOverrides = nometalmaterial,
DefaultResistance = RESISTANCE_ELECTRONIC,
NoRemove = true,
NoWater = true
},
{
Name="Vehicle Pad",
Group="Powered Deployables",
Model=Model("models/props_trainyard/crane_platform001.mdl"),
Type="prop_vehiclepad",
PHealth=2000,
Max=2,
TeamMax=5,
MaterialOverrides = nometalmaterial,
DefaultResistance = RESISTANCE_METAL,
SolidBase=true,
Callback=function(pl, ent)
	if util.TraceLine({start=ent:GetPos(), endpos=ent:GetPos() + Vector(0,0,256), mask=MASK_SOLID, filter=ent}).Hit then
		pl:PrintMessage(HUD_PRINTTALK, "Not enough head room to deploy here.")
		return true
	end

	if ents.FindByClass("info_novehicles")[1] then
		pl:PrintMessage(HUD_PRINTTALK, "Vehicles are disabled in this map.")
		return true
	end
end,
NoWater = true
},
{
Name="Anti-Projectile Tower",
Group="Powered Deployables",
Model=Model("models/props_c17/substation_circuitbreaker01a.mdl"),
Type="prop_antiprojectiletower",
PHealth=1000,
TeamMax=4,
SolidBase=true,
ClusterPrevention=1,
MaterialOverrides = nometalmaterial,
DefaultResistance = RESISTANCE_ELECTRONIC,
NoWater = true
},
{
Name="Anchor Beacon",
Group="Powered Deployables",
Model=Model("models/props_wasteland/buoy01.mdl"),
Type="prop_anchorbeacon",
PHealth=1000,
TeamMax=4,
SolidBase=true,
ClusterPrevention=1,
MaterialOverrides = nometalmaterial,
DefaultResistance = RESISTANCE_ELECTRONIC,
NoWater = true
},
--[[{
Name="Magnetic Disruptor Beam Tower",
Group="Powered Deployables",
Model=Model("models/props_combine/CombineThumper002.mdl"),
Type="prop_mdbtower",
PHealth=500,
TeamMax=4,
SolidBase=true,
ClusterPrevention=1,
MaterialOverrides = nometalmaterial,
DefaultResistance = RESISTANCE_ELECTRONIC,
NoWater = true
},]]
--[[{
Name="Magus Shield",
Group="Powered Deployables",
Model=Model("models/props_c17/substation_stripebox01a.mdl"),
Type="prop_magusshield",
PHealth=1250,
Max=1,
TeamMax=4,
SolidBase=true,
ClusterPrevention=2,
MaterialOverrides = nometalmaterial,
DefaultResistance = RESISTANCE_ELECTRONIC,
NoWater = true,
Callback=function(pl, ent) pl:PrintMessage(HUD_PRINTTALK, "Fully absorbs damage dealt to normal props in a wide area. If it has no Mana income, it will use its own health. It also acts as its OWN capacitor.") end
},]]
{
Name="Prop Repairer",
Group="Powered Deployables",
Model=Model("models/props_junk/TrafficCone001a.mdl"),
Type="prop_reenforcer",
PHealth=300,
Max=4,
TeamMax=12,
ClusterPrevention=2,
MaterialOverrides = nometalmaterial,
DefaultResistance = RESISTANCE_ELECTRONIC,
Callback=function(pl, ent) pl:PrintMessage(HUD_PRINTTALK, "Point this at a prop and it will repair it over time.") end,
NoWater = true
},
{
Name="Fire Mine",
Group="Deployables",
Model=Model("models/props_combine/combine_mine01.mdl"),
Type="prop_firemine",
Max=8,
TeamMax=32,
SolidBase=true,
CountsTowards="mines",
PHealth=100,
MaterialOverrides = nometalmaterial,
DefaultResistance = RESISTANCE_ELECTRONIC,
NoWater = true
},
{
Name="Jump Pad",
Group="Deployables",
Model=Model("models/props_c17/lamp_standard_off01.mdl"),
Type="prop_jumppad",
Max=3,
SolidBase=true,
TeamMax=8,
PHealth=250,
MaterialOverrides = nometalmaterial,
DefaultResistance = RESISTANCE_ELECTRONIC,
NoWater = true
},
{
Name="Health Dispenser",
Group="Powered Deployables",
Model=Model("models/props_combine/health_charger001.mdl"),
Type="prop_healthdispenser",
Max=3,
TeamMax=12,
PHealth=350,
MaterialOverrides = nometalmaterial,
DefaultResistance = RESISTANCE_ELECTRONIC
},
{
Name="Auto-Turret",
Group="Powered Deployables",
Model=Model("models/Combine_turrets/Floor_turret.mdl"),
Type="prop_turret",
Max=3,
TeamMax=9,
PHealth=250,
MaterialOverrides = nometalmaterial,
DefaultResistance = RESISTANCE_ELECTRONIC,
NoWater = true
},
{
Name="Auto-Turret",
Group="Auto-Turret",
Model=Model("models/Combine_turrets/Floor_turret.mdl"),
Type="prop_turret",
Max=3,
TeamMax=9,
PHealth=250,
MaterialOverrides = nometalmaterial,
DefaultResistance = RESISTANCE_ELECTRONIC,
NoWater = true
},
{
Name="Barrel: Plasma",
Group="Auto-Turret",
Model=Model("models/Items/item_item_crate.mdl"),
Type="prop_turretbarrel_plasma",
PHealth=100,
MaterialOverrides = nometalmaterial,
DefaultResistance = RESISTANCE_ELECTRONIC
},
{
Name="Barrel: Slow",
Group="Auto-Turret",
Model=Model("models/Items/item_item_crate.mdl"),
Type="prop_turretbarrel_slow",
PHealth=100,
MaterialOverrides = nometalmaterial,
DefaultResistance = RESISTANCE_ELECTRONIC
},
{
Name="Barrel: Missiles of Magic",
Group="Auto-Turret",
Model=Model("models/Items/item_item_crate.mdl"),
Type="prop_turretbarrel_magicmissiles",
PHealth=100,
MaterialOverrides = nometalmaterial,
DefaultResistance = RESISTANCE_ELECTRONIC
},
--[[{
Name="Barrel: Pulse Cannon",
Group="Auto-Turret",
Model=Model("models/Items/item_item_crate.mdl"),
Type="prop_turretbarrel_pulse",
PHealth=100,
MaterialOverrides = nometalmaterial,
DefaultResistance = RESISTANCE_ELECTRONIC
},]]
{
Name="Mountable Turret",
Group="Powered Deployables",
Model=Model("models/props_combine/combine_mortar01b.mdl"),
Type="prop_mountableturret",
PHealth=350,
Max = 2,
TeamMax = 8,
MaterialOverrides = nometalmaterial,
DefaultResistance = RESISTANCE_ELECTRONIC,
NoWater = true
},
{
Name="Mountable Turret",
Group="Mountable Turret",
Model=Model("models/props_combine/combine_mortar01b.mdl"),
Type="prop_mountableturret",
PHealth=350,
Max = 2,
TeamMax = 8,
MaterialOverrides = nometalmaterial,
DefaultResistance = RESISTANCE_ELECTRONIC,
NoWater = true
},
{
Name="Barrel: Plasma",
Group="Mountable Turret",
Model=Model("models/Items/ammoCrate_Rockets.mdl"),
Type="prop_mturretbarrel_plasma",
PHealth=100,
MaterialOverrides = nometalmaterial,
DefaultResistance = RESISTANCE_ELECTRONIC
},
{
Name="Barrel: Lock-on Missiles",
Group="Mountable Turret",
Model=Model("models/Items/ammoCrate_Rockets.mdl"),
Type="prop_mturretbarrel_lockons",
PHealth=100,
MaterialOverrides = nometalmaterial,
DefaultResistance = RESISTANCE_ELECTRONIC
},
{
Name="Barrel: Mortar",
Group="Mountable Turret",
Model=Model("models/Items/ammoCrate_Rockets.mdl"),
Type="prop_mturretbarrel_mortar",
PHealth=100,
MaterialOverrides = nometalmaterial,
DefaultResistance = RESISTANCE_ELECTRONIC
},
{
Name="Force Field Door",
Group="Deployables",
Model=Model("models/props_wasteland/interior_fence003e.mdl"),
Type="prop_forcefielddoor",
Max = 2,
TeamMax = 8,
PHealth=750,
MaterialOverrides = nometalmaterial,
DefaultResistance = RESISTANCE_ELECTRONIC
}
}
