include("global/noxiousdb.lua")

AddCSLuaFile("cl_init.lua")
AddCSLuaFile("shared.lua")
AddCSLuaFile("cl_deathnotice.lua")
AddCSLuaFile("cl_noxious_localization.lua")
AddCSLuaFile("cl_scoreboard.lua")
AddCSLuaFile("nox_shared_spelldefines.lua")
AddCSLuaFile("obj_entity_extend.lua")
AddCSLuaFile("obj_player_extend.lua")
AddCSLuaFile("obj_weapon_extend.lua")
AddCSLuaFile("cl_notice.lua")
AddCSLuaFile("globals.lua")
AddCSLuaFile("noxteams.lua")
AddCSLuaFile("vehicles_shared.lua")
AddCSLuaFile("cl_dermaskin.lua")
AddCSLuaFile("animations.lua")

AddCSLuaFile("vgui/dmodelpanel2.lua")
AddCSLuaFile("vgui/pmain.lua")
AddCSLuaFile("vgui/pbuilder.lua")
AddCSLuaFile("vgui/pspells.lua")
AddCSLuaFile("vgui/phelp.lua")
AddCSLuaFile("vgui/paspects.lua")
AddCSLuaFile("vgui/poptions.lua")
AddCSLuaFile("vgui/pprofiles.lua")
AddCSLuaFile("vgui/ploadout.lua")
AddCSLuaFile("vgui/scoreboard.lua")
AddCSLuaFile("vgui/vehiclepad.lua")

AddCSLuaFile("skins/steam-default.lua")

-- TODO: Move local cvars from :GetBool(), :GetInt() etc to the cvars.AddChangeCallback method. About 10x more efficient.
-- TODO: Decrease the hang time for jump attacks very slightly.
-- TODO: Weapons are completely shittily written. Use RPG weapons for coding bases.

-- TODO: Gladradus charge attack effect better.
-- TODO: Gladradus charge projectile: use a better material.
-- TODO: Favorites system for building. Click a star next to a prop in the menu to make it show up in the Favorites tab. The favorites tab is smaller. The model is displayed as a tooltip (SetToolTipPanel).
-- TODO: Add a 'currently-equiped' thing to the loadout screen so you don't have to press an equip button to see it. Just use a think function to get MENUPROFILE.Loadout and see if it's not matching the current UID's in order to do a refresh.
-- TODO: Add a HUD thing for when you switch weapons like s4. Should be in the bottom center or can be 0.25, 0.5 or 0.75, 0.5. Also display ammo.
-- TODO: Add a loadout display to the profile and inventory window. It displays all of your currently equipped weapons.
-- TODO: NOX_VIEW crosshair could be better. In fact, each weapon could have its own crosshair.
-- TODO: Flashier winning screen. Some sort of "most something" categories. MVP, LVP, etc.
-- TODO: Team select / splash screen. Shown after TEAMS_PLAYING is sent. Use a think hook checking that TEAMS_PLAYING isn't 0. Closes if your team isn't spectator or a team's score isn't 0.
-- TODO: Make it so the profile menu comes up when your team isn't spectator.
-- TODO: Spell: Comet. Shoots a big ice ball with a ring & smoke trail. Explosion is a bunch of ice chunks + snow. Has a bit of gravity.
-- TODO: Spell: Icicle. Shoots a small, pointy icicle that sticks in walls which can then be used to climb with. Taking damage destroys it and any single user can have 3 active at once. Dying or disconnecting destroys all owned icicles. "models/Gibs/wood_gib01d.mdl"
-- TODO: Spell: Zolt. Shoots a projectile that constantly checks under it for anyone there. If a target is found then it calls a lightning bolt. If it's a person, they get stunned. Does 20 lightning damage. Effect could be some kind of flashy projectile and then lightning beams coming down to one point below it. Doesn't try to hit prop_prop or prop_physics*.
-- TODO: Spell: Feather. Makes the caster or person being cast on have their stamina-draining moves drain 25% less stamina. Can be foot wings as an effect.
-- TODO: Spell: Burden. Anyone hit will make their stamina-draining moves drain 50% more stamina. Effect can be two black balls rotating around their legs.
-- TODO: Spell: Teleport. Projectile has your hull. Successful if TrueVisible from shootpos to the entity pos.
-- TODO: Weapon: Rocket launcher that homes in on your crosshair.
-- TODO: Weapon: Crowbarang?
-- TODO: Weapon: Vulcan of some sort. Model in bookmarks.
-- TODO: Add a delay to the Avenger's secondary attack.
-- TODO: Try a Lua animation for the Avenger secondary attack.
-- TODO: Weapon: Grenades of some sort?
-- TODO: New scoreboard.
-- TODO: Vehicle HUD is ugly and doesn't work well with the new game HUD.
-- TODO: Vehicle pad menu is ugly.
-- TODO: Option to determine if you get any heatwave / refract particles.
-- TODO: Tesla award: Kill someone with energy bolt while they're above some kind of height in the air.
-- TODO: Augmentation system.
-- TODO: Make the VGUI not look like derma. Make it have its own theme, look like a game menu not a windows form.

GM.MapEditorPrefix = "noxious"

GM.PlayerStatus = {}
GM.PlayerStatusTimers = {}

if not file.Exists("uid.txt") then file.Write("uid.txt", 512) end
function GetUID()
	local num = tonumber(file.Read("uid.txt")) + 1
	file.Write("uid.txt", num)

	return num
end

function GM:OnKnockedDown(pl)
	local wep = pl:GetActiveWeapon()
	if wep:IsValid() and wep.OnKnockedDown then
		wep:OnKnockedDown(pl)
	end
end

function GM:GenericVehiclePhysicsCollide(data, phys)
	if 300 <= data.Speed then
		local ent = data.HitEntity
		if util.TraceLine({start = self:NearestPoint(data.HitPos), endpos = data.HitPos + data.OurOldVelocity:Normalize() * 8, mask = MASK_SOLID_BRUSHONLY}).HitSky or ent:IsValid() and ent:GetPhysicsObject():IsValid() and ent:GetPhysicsObject():GetMass() < 100 then
			return
		end

		local damage = math.ceil(data.Speed * 0.03)

		if self.NextCollisionSound <= CurTime() then
			self.NextCollisionSound = CurTime() + 0.025

			if 40 <= damage then
				self:EmitSound("vehicles/v8/vehicle_impact_heavy"..math.random(1, 4)..".wav")
			else
				self:EmitSound("vehicles/v8/vehicle_impact_medium"..math.random(1, 4)..".wav")
			end
		end

		self:TakeSpecialDamage(damage, DMGTYPE_GENERIC, NULL, NULL)
	end
end

function GM:HandleOvertime()
end

function GM:GameTypeStartIntermission(pl)
end

function GM:GameTypeEndIntermission()
end

function GM:GameTypeDisconnect(pl)
end

function GM:GameTypeSetMode(int)
end

function GM:PlayerFootstep(pl, vPos, iFoot, strSoundName, fVolume, pFilter)
end

local PlayerStatus = GM.PlayerStatus
local PlayerStatusTimers = GM.PlayerStatusTimers
function GM:AddStatus(name)
	if name then
		PlayerStatus[#PlayerStatus + 1] = name
	end
end

function GM:AddStatusTimer(name)
	if name then
		PlayerStatusTimers[#PlayerStatusTimers + 1] = name
	end
end

include("gametypes/ctf.lua")
include("gametypes/blitz.lua")

include("shared.lua")
include("nox_spelldefines.lua")
include("nox_shared_spelldefines.lua")
include("vehicles_shared.lua")
include("mapeditor.lua")
include("boneanimlib.lua")

if file.Exists("../gamemodes/noxious/gamemode/maps/"..game.GetMap()..".lua") then
	MsgN("Executing map profile...")
	include("maps/"..game.GetMap()..".lua")
	MsgN("Done.")
end

function gmod.BroadcastLua(lua)
	for _, pl in pairs(player.GetAll()) do
		pl:SendLua(lua)
	end
end

function GM:Initialize()
	timer.Destroy("HostnameThink")

	PrecacheParticleSystem("portal_lightning_01")
	PrecacheParticleSystem("citadel_shockwave")

	RunConsoleCommand("mp_flashlight", 0)
	RunConsoleCommand("sv_gravity", 800)
	RunConsoleCommand("sk_zombie_health", 100)
	RunConsoleCommand("sk_zombie_dmg_both_slash", 50)
	RunConsoleCommand("sk_zombie_dmg_one_slash", 40)

	VOTEMAPLOCKED = true

	--[[resource.AddFile("models/Samuel/samzanemesis/noxious_flag.mdl")
	resource.AddFile("materials/Skins/bluebulls.vmt")
	resource.AddFile("materials/Skins/bluebulls_red.vmt")
	resource.AddFile("materials/Skins/bluebulls_blue.vmt")
	resource.AddFile("materials/Skins/bluebulls_yellow.vmt")
	resource.AddFile("materials/Skins/bluebulls_green.vmt")]]

	resource.AddFile("materials/gmod/scope.vmt")
	--resource.AddFile("materials/gmod/scope-refract.vmt")

	resource.AddFile("sound/sprint2.wav")
	resource.AddFile("materials/refract_ring.vmt")
	resource.AddFile("materials/vgui/health2.vmt")
	resource.AddFile("materials/vgui/mana2.vmt")

	resource.AddFile("materials/spacebuild/lwmetal1nc1.vmt")
	resource.AddFile("models/slyfo/walllong.mdl")
	resource.AddFile("models/slyfo/walllonggate.mdl")
	resource.AddFile("models/slyfo/wallshort.mdl")
	resource.AddFile("models/slyfo/wallshortgate.mdl")

	resource.AddFile("models/weapons/v_shot_xm1014.mdl")
	resource.AddFile("materials/models/weapons/w_models/w_shot_xm1014/w_shot_xm1014.vmt")
	resource.AddFile("materials/models/weapons/v_models/shot_xm1014/shot_xm1014.vmt")
	resource.AddFile("materials/models/weapons/v_models/shot_xm1014/shot_xm1014_ref.vtf")

	resource.AddFile("sound/weapons/deagle/deagle-1.wav")
	resource.AddFile("sound/weapons/deagle/de_clipout.wav")
	resource.AddFile("sound/weapons/deagle/de_clipin.wav")
	resource.AddFile("sound/weapons/deagle/de_deploy.wav")
	resource.AddFile("sound/weapons/deagle/de_slideback.wav")
	resource.AddFile("models/weapons/v_pist_deagle.mdl")
	resource.AddFile("materials/models/weapons/w_models/w_pist_deagle/w_pist_deagle.vmt")
	resource.AddFile("materials/models/weapons/v_models/pist_deagle/deagle_skin1.vmt")
	resource.AddFile("materials/models/weapons/v_models/pist_deagle/deagle_skin1_ref.vtf")

	resource.AddFile("materials/noxctf/bulleticon.vmt")
	resource.AddFile("materials/noxctf/sprite_nova.vmt")
	resource.AddFile("materials/noxctf/sprite_smoke.vmt")
	resource.AddFile("materials/noxctf/sprite_bloodspray1.vmt")
	resource.AddFile("materials/noxctf/sprite_bloodspray2.vmt")
	resource.AddFile("materials/noxctf/sprite_bloodspray3.vmt")
	resource.AddFile("materials/noxctf/sprite_bloodspray4.vmt")
	resource.AddFile("materials/noxctf/sprite_bloodspray5.vmt")
	resource.AddFile("materials/noxctf/sprite_bloodspray6.vmt")
	resource.AddFile("materials/noxctf/sprite_bloodspray7.vmt")
	resource.AddFile("materials/noxctf/sprite_bloodspray8.vmt")
	resource.AddFile("materials/noxctf/spellselection.vmt")
	resource.AddFile("materials/noxctf/healthbar.vmt")
	resource.AddFile("materials/noxctf/staminabar.vmt")
	resource.AddFile("materials/noxctf/manabar.vmt")
	resource.AddFile("materials/noxctf/flag_blue.vmt")
	resource.AddFile("materials/noxctf/flag_red.vmt")
	resource.AddFile("materials/noxctf/flag_yellow.vmt")
	resource.AddFile("materials/noxctf/flag_green.vmt")
	resource.AddFile("materials/noxctf/flag_taken.vmt")
	resource.AddFile("materials/noxctf/flag_down.vmt")

	for _, filename in pairs(file.Find("../materials/spellicons/*.vmt")) do
		resource.AddFile("materials/spellicons/"..filename)
	end

	for _, filename in pairs(file.Find("../sound/nox/*.wav")) do
		resource.AddFile("sound/nox/"..filename)
	end

	for _, filename in pairs(file.Find("../sound/nox/*.mp3")) do
		resource.AddFile("sound/nox/"..filename)
	end

	resource.AddFile("npc/advisor/advisor_blast6.wav")

	for _, filename in pairs(file.Find("../materials/mixerman3d/weapons/*.*")) do
		resource.AddFile("materials/mixerman3d/weapons/"..filename)
	end

	for _, filename in pairs(file.Find("../models/mixerman3d/weapons/*.mdl")) do
		resource.AddFile("models/mixerman3d/weapons/"..filename)
	end

	for _, filename in pairs(file.Find("../models/peanut/*.mdl")) do
		resource.AddFile("models/peanut/"..filename)
	end

	for _, filename in pairs(file.Find("../materials/peanut/*.*")) do
		resource.AddFile("materials/peanut/"..filename)
	end

	--[[for _, filename in pairs(file.Find("../models/katharsmodels/flags/*.*")) do
		resource.AddFile("models/katharsmodels/flags/"..filename)
	end

	for _, filename in pairs(file.Find("../materials/katharsmodels/flags/*.*")) do
		resource.AddFile("materials/katharsmodels/flags/"..filename)
	end]]

	resource.AddFile("materials/noxctf/flagicon_home.vmt")
	resource.AddFile("materials/noxctf/flagicon_field.vmt")
	resource.AddFile("materials/noxctf/flagicon_dropped.vmt")

	resource.AddFile("materials/killicon/axe.vmt")

	resource.AddFile("models/nox_sword_short_v001.mdl")
	resource.AddFile("models/w_nox_short_sword.mdl")
	resource.AddFile("materials/models/wp_sword_short/wp_sword_short.vmt")
	resource.AddFile("materials/models/wp_sword_short/wp_sword_short.vtf")
	resource.AddFile("materials/models/wp_sword_short/wp_sword_short_normal.vtf")

	resource.AddFile("models/nox_longbow_v2.mdl")
	resource.AddFile("models/w_nox_longbow.mdl")
	resource.AddFile("materials/models/arrows/arrow.vmt")
	resource.AddFile("materials/models/arrows/arrow.vtf")
	resource.AddFile("materials/models/orcbow/ornesbow.vmt")
	resource.AddFile("materials/models/orcbow/ornesbow.vtf")
	resource.AddFile("materials/models/orcbow/ornesbow_normal.vtf")

	resource.AddFile("models/weapons/frotchet/w_frotchet.mdl")
	resource.AddFile("materials/models/weapons/frotchet.vmt")
	resource.AddFile("materials/models/weapons/frotchet.vtf")
	resource.AddFile("materials/models/weapons/frotchet_env.vtf")
	resource.AddFile("materials/models/weapons/frotchet_env_mask.vtf")

	resource.AddFile("models/weapons/steel_might/w_steel_might.mdl")
	resource.AddFile("models/weapons/steel_might/w_steel_might_shield.mdl")
	resource.AddFile("materials/models/weapons/axe.vmt")
	resource.AddFile("materials/models/weapons/axe_env.vtf")
	resource.AddFile("materials/models/weapons/axe_env_mask.vtf")
	resource.AddFile("materials/models/weapons/axeshield.vmt")

	resource.AddFile("models/weapons/w_gladradus/w_gladradus.mdl")
	resource.AddFile("materials/models/weapons/gladradus.vmt")
	resource.AddFile("materials/models/weapons/gladradus_env_mask.vtf")

	-- Car seat.
	resource.AddFile("models/props_phx/carseat2.mdl")

	-- Vehicle pad from TF2
	resource.AddFile("models/props_trainyard/crane_platform001.mdl")
	resource.AddFile("materials/models/props_trainyard/crane_platform001.vtf")
	resource.AddFile("materials/models/props_trainyard/crane_platform001.vmt")
end

function GM:InitPostEntity()
	gamemode.Call("CreateDummyEntities")

	local mapname = game.GetMap()

	if string.sub(mapname, 1, 3) == "df_" then
		for _, ent in pairs(ents.FindByClass("prop_physics*")) do
			ent:Remove()
		end
	end

	for _, ent in pairs(ents.FindByClass("item_*")) do
		ent:Remove()
	end

	for _, ent in pairs(ents.FindByClass("game_player_equip")) do
		ent:Remove()
	end

	for _, ent in pairs(ents.FindByClass("weapon_*")) do
		ent:Remove()
	end

	gamemode.Call("LoadMapEditorFile")
	gamemode.Call("RebuildSpawns")

	local someold = ents.FindByClass("gmod_player_start")
	someold = table.Add(someold, ents.FindByClass("info_player_team_spawn"))
	for _, oldspawn in pairs(someold) do
		table.insert(self.Spawns[TEAM_SPECTATE], oldspawn)

		if oldspawn.GreenTeam then
			table.insert(self.Spawns[TEAM_GREEN], oldspawn)
		elseif oldspawn.BlueTeam then
			table.insert(self.Spawns[TEAM_BLUE], oldspawn)
		elseif oldspawn.RedTeam then
			table.insert(self.Spawns[TEAM_RED], oldspawn)
		elseif oldspawn.YellowTeam then
			table.insert(self.Spawns[TEAM_YELLOW], oldspawn)
		end
	end

	for _, ent in pairs(ents.FindByClass("info_target")) do
		if not ent.FuckMe then
			local lowername = string.lower(ent:GetName())
			if lowername == "blueflagpoint" then
				if team.TeamInfo[TEAM_BLUE] then team.TeamInfo[TEAM_BLUE].FlagPoint = ent:GetPos() end
			elseif lowername == "redflagpoint" then
				if team.TeamInfo[TEAM_RED] then team.TeamInfo[TEAM_RED].FlagPoint = ent:GetPos() end
			elseif lowername == "yellowflagpoint" then
				if team.TeamInfo[TEAM_YELLOW] then team.TeamInfo[TEAM_YELLOW].FlagPoint = ent:GetPos() end
			elseif lowername == "greenflagpoint" then
				if team.TeamInfo[TEAM_GREEN] then team.TeamInfo[TEAM_GREEN].FlagPoint = ent:GetPos() end
			end
		end
	end

	if team.TeamInfo[TEAM_BLUE] then
		for _, ent in pairs(ents.FindByClass("blueflagpoint")) do
			team.TeamInfo[TEAM_BLUE].FlagPoint = ent:GetPos()
		end
	end

	if team.TeamInfo[TEAM_RED] then
		for _, ent in pairs(ents.FindByClass("redflagpoint")) do
			team.TeamInfo[TEAM_RED].FlagPoint = ent:GetPos()
		end
	end

	if team.TeamInfo[TEAM_YELLOW] then
		for _, ent in pairs(ents.FindByClass("yellowflagpoint")) do
			team.TeamInfo[TEAM_YELLOW].FlagPoint = ent:GetPos()
		end
	end

	if team.TeamInfo[TEAM_GREEN] then
		for _, ent in pairs(ents.FindByClass("greenflagpoint")) do
			team.TeamInfo[TEAM_GREEN].FlagPoint = ent:GetPos()
		end
	end

	for _, ent in pairs(ents.FindByClass("flagspawn")) do
		if ent.BlueTeam then
			if team.TeamInfo[TEAM_BLUE] then team.TeamInfo[TEAM_BLUE].FlagPoint = ent:GetPos() end
		elseif ent.RedTeam then
			if team.TeamInfo[TEAM_RED] then team.TeamInfo[TEAM_RED].FlagPoint = ent:GetPos() end
		elseif ent.YellowTeam then
			if team.TeamInfo[TEAM_YELLOW] then team.TeamInfo[TEAM_YELLOW].FlagPoint = ent:GetPos() end
		elseif ent.GreenTeam then
			if team.TeamInfo[TEAM_GREEN] then team.TeamInfo[TEAM_GREEN].FlagPoint = ent:GetPos() end
		end
	end

	for _, teamid in pairs(TEAMS_PLAYING) do
		if not team.TeamInfo[teamid].FlagPoint then
			local poss = {}
			for _, ent in pairs(self.Spawns[teamid]) do
				table.insert(poss, ent:GetPos())
				if 0 < #poss then
					local pos = Vector(0, 0, 0)
					for _, ppp in pairs(poss) do
						pos = pos + ppp
					end
					team.TeamInfo[teamid].FlagPoint = pos / #poss + Vector(0, 0, 32)
				else
					team.TeamInfo[teamid].FlagPoint = Vector(0,0,0)
				end
			end
		end
	end

	TOTAL_TEAMS = 4
	for i in pairs(self.Spawns) do
		if i ~= TEAM_SPECTATE then
			if not team.TeamInfo[i].FlagPoint then
				TOTAL_TEAMS = TOTAL_TEAMS - 1
				--team.TeamInfo[i] = nil
			else
				table.insert(TEAMS_PLAYING, i)
			end
		end
	end

	gamemode.Call("RebuildBallDrop")

	for _, teamid in pairs(TEAMS_PLAYING) do
		for _, ent in pairs(self.Spawns[teamid]) do
			ent:SetPos(util.TraceLine({start=ent:GetPos() + Vector(0,0,16), endpos=ent:GetPos() + Vector(0,0,-48), filter=ent}).HitPos + Vector(0,0,16))
			if ent:GetAngles() == Angle(0,0,0) then
				local ang = (GAMEMODE.BallDrop - ent:GetPos()):Angle()
				ang.pitch = 0
				ent:SetAngles(ang)
			end
		end
	end

	if file.Exists(GAMEMODE_NAME.."_gametype.txt") then
		local gt = file.Read(GAMEMODE_NAME.."_gametype.txt")

		if self[gt.."Initialize"] then
			self[gt.."Initialize"](self)
		else
			self:CTFInitialize()
		end
	else
		self:CTFInitialize()
	end
end

function GM:RebuildBallDrop()
	local ent = ents.FindByClass("balldrop")[1]
	if ent then
		GAMEMODE.BallDrop = ent:GetPos()
	else
		local poss = {}
		for _, teamid in pairs(TEAMS_PLAYING) do
			local fp = team.TeamInfo[ teamid ].FlagPoint
			if fp then
				table.insert(poss, fp)
			end
		end
		if 0 < #poss then
			local pos = Vector(0,0,0)
			for _, ppp in pairs(poss) do
				pos = pos + ppp
			end
			local midpos = (pos / #poss) + Vector(0, 0, 64)
			GAMEMODE.BallDrop = util.TraceLine({start = midpos, endpos = midpos + Vector(0, 0, -10240), mask = MASK_SOLID_BRUSHONLY}).HitPos + Vector(0, 0, 48)
		else
			GAMEMODE.BallDrop = Vector(0,0,0)
		end
	end
end

function GM:IsOnRightSide(ent, teamid)
	if teamid then
		local teaminfo=team.TeamInfo[teamid]
		if teaminfo then
			local flagpoint=teaminfo.FlagPoint
			if flagpoint then
				local desireddistance = ent:NearestPoint(flagpoint):Distance(flagpoint)
				for _, teamid2 in pairs(TEAMS_PLAYING) do
					if ent:NearestPoint(flagpoint):Distance(team.TeamInfo[teamid2].FlagPoint) < desireddistance then
						return false
					end
				end
			end
		end
	end

	return true
end

--[[function GM:Move(pl, move)
	local wep = pl:GetActiveWeapon()
	if wep.Move and wep:Move(pl, move) then return true end

	if pl.Run then
		move:SetSideSpeed(0)
		if pl:Crouching() then
			move:SetForwardSpeed(pl:GetMaxSpeed() * 0.5)
		else
			move:SetForwardSpeed(pl:GetMaxSpeed())
		end
	end

	if pl.DashDodging then
		pl:SetGroundEntity(NULL)
		move:SetSideSpeed(0)
		move:SetForwardSpeed(0)
	elseif pl.WallJumping then
		pl:SetGroundEntity(NULL)
		move:SetVelocity(Vector(0,0,0))
		move:SetSideSpeed(0)
		move:SetForwardSpeed(0)
	elseif pl.Stunned then
		move:SetSideSpeed(0)
		move:SetForwardSpeed(0)
	elseif pl.Sprinting then
		local spd = pl.SprintSpeed
		if pl.Slow then spd = spd * 0.7 end
		move:SetMaxSpeed(spd)
		move:SetMaxClientSpeed(spd)
		move:SetSideSpeed(0)
		move:SetForwardSpeed(spd)
	elseif pl.WallRunning then
		move:SetMaxSpeed(0)
		move:SetMaxClientSpeed(0)
		move:SetSideSpeed(0)
		move:SetForwardSpeed(0)

		if pl.WallRunningUp then
			if CurTime() - pl.WallRunningUpStart > 0 then
				pl:SetGroundEntity(NULL)
				local spd = pl.WallVertSpeed
				if pl.Slow then spd = spd * 0.7 end
				move:SetVelocity(Vector(0, 0, spd))
			end
		else
			local spd = pl.WallRunSpeed
			if pl.Slow then spd = spd * 0.7 end
			local vNew = pl:GetForward() * spd
			vNew.z = move:GetVelocity().z + FrameTime() * 690
			move:SetVelocity(vNew)
		end
	elseif pl.HealCharge or pl.Slow then
		move:SetSideSpeed(move:GetSideSpeed() * 0.7)
		move:SetForwardSpeed(move:GetForwardSpeed() * 0.7)
	end

	if pl:WaterLevel() == 0 and not pl:IsOnGround() then
		move:SetSideSpeed(move:GetSideSpeed() * 0.15)
		move:SetForwardSpeed(move:GetForwardSpeed() * 0.15)
	end
end]]

function GM:GetFallDamage(pl, fallspeed)
	return 0
end

concommand.Add("dashleft", function(sender, command, arguments)
	if sender:IsPlayer() and sender:Alive() and not sender:InVehicle() and sender:CanDodge() then
		local staminarequirement = STAMINA_DODGE
		if sender.Stunned then staminarequirement = STAMINA_DODGE_STUNNED end

		if sender:GetStamina() < staminarequirement then return end

		if sender.KnockedDown then
			sender:RemoveStatus("knockdown", false, true)
		end
		if sender.Stunned then
			sender:RemoveStatus("stun", false, true)
		end
		if sender.Sprinting then
			sender:RemoveStatus("sprint", false, true)
		end
		if sender.DashingDodging then
			sender:RemoveStatus("dashdodge*", false, true)
		end

		sender.CantDodgeTime = CurTime() + 0.65
		sender:GiveStatus("dashdodgeleft")
		sender:SetStamina(sender:GetStamina() - staminarequirement, true)
	end
end)

concommand.Add("dashright", function(sender, command, arguments)
	if sender:IsPlayer() and sender:Alive() and not sender:InVehicle() and sender:CanDodge() then
		local staminarequirement = STAMINA_DODGE
		if sender.Stunned then staminarequirement = STAMINA_DODGE_STUNNED end

		if sender:GetStamina() < staminarequirement then return end

		if sender.KnockedDown then
			sender:RemoveStatus("knockdown", false, true)
		end
		if sender.Stunned then
			sender:RemoveStatus("stun", false, true)
		end
		if sender.Sprinting then
			sender:RemoveStatus("sprint", false, true)
		end
		if sender.DashingDodging then
			sender:RemoveStatus("dashdodge*", false, true)
		end

		sender.CantDodgeTime = CurTime() + 0.65
		sender:GiveStatus("dashdodgeright")
		sender:SetStamina(sender:GetStamina() - staminarequirement, true)
	end
end)

concommand.Add("getup", function(pl, command, arguments)
	--if pl:IsValid() and pl:Alive() and pl.KnockedDown and not pl.Stunned and (not GAMEMODE.Intermission or GAMEMODE.IntermissionPlayer == pl) then
	if pl:IsValid() and pl:Alive() and pl.KnockedDown and not pl.Stunned and (not GAMEMODE.Intermission or GAMEMODE.IntermissionTeam == pl:Team()) then
		local ct = CurTime()
		local knockedent = pl.KnockedDown
		if knockedent:IsValid() and ct <= knockedent.DieTime - 0.3 and (not knockedent.AppliedWallDamage or 1 < pl:WaterLevel()) then
			knockedent.DieTime = ct + 0.3
			knockedent.GettingUp = true
			knockedent:SetNetworkedFloat("endtime", knockedent.DieTime)
			pl:EmitSound("physics/nearmiss/whoosh_huge2.wav", 75, math.Rand(235, 255))
		end
	end
end)

function GM:OnDamagedByExplosion(pl)
end

function GM:CreateDummyEntities()
	local mapname = game.GetMap()

	local vVec0 = Vector(0, 0, 0)
	for _, name in pairs(file.Find("../gamemodes/noxious/entities/entities/dummy_*")) do
		local ent = ents.Create(name)
		if ent:IsValid() then
			ent:SetPos(vVec0)
			ent:Spawn()
			_G[string.upper(name)] = ent
		end
	end
end

function GM:PlayerSwitchFlashlight(pl, switchon)
	return false
end

function GM:RebuildSpawns()
	self.Spawns = {}
	self.Spawns[TEAM_BLUE] = ents.FindByClass("info_player_blue")
	self.Spawns[TEAM_YELLOW] = ents.FindByClass("info_player_yellow")
	self.Spawns[TEAM_GREEN] = ents.FindByClass("info_player_green")
	self.Spawns[TEAM_RED] = ents.FindByClass("info_player_red")
	self.Spawns[TEAM_SPECTATE] = ents.FindByClass("info_player*")
end

function GM:PlayerSelectSpawn(pl)
	local myteam = pl:Team()
	local Count = #GAMEMODE.Spawns[myteam]
	if Count == 0 then return pl end
	for i=0, 15 do
		local ChosenSpawnPoint = GAMEMODE.Spawns[myteam][math.random(1, Count)]
		if ChosenSpawnPoint and ChosenSpawnPoint:IsValid() and ChosenSpawnPoint:IsInWorld() then
			local blocked = false
			for _, ent in pairs(ents.FindInBox(ChosenSpawnPoint:GetPos() + Vector(-48, -48, 0), ChosenSpawnPoint:GetPos() + Vector(48, 48, 60))) do
				if ent and ent:IsValid() then
					if ent:IsPlayer() or string.sub(ent:GetClass(), 1, 5) == "prop_" then
						blocked = true
						break
					end
				end
			end
			if not blocked then
				return ChosenSpawnPoint
			end
		end
		if i == 15 then return ChosenSpawnPoint end
	end
	return pl
end

local function randomize(a, b)
	return b.RandomWeight < a.RandomWeight
end

function GM:Think()
	for _, pl in pairs(player.GetAll()) do
		pl:Think(FrameTime())
	end

	if ENDGAME then return end

	if GAMESTATE == GAMESTATE_PLAY and NEXT_FIGHTMODE + CTF_LENGTH <= CurTime() then
		gamemode.Call("SetMode", GAMESTATE_BUILD)
	elseif NEXT_FIGHTMODE <= CurTime() then
		gamemode.Call("SetMode", GAMESTATE_PLAY)
	end
end

NEXT_FIGHTMODE = BUILD_LENGTH
function GM:SetMode(int)
	if int == GAMESTATE then return end

	self:GameTypeSetMode(int)

	if GAMESTATE == GAMESTATE_BUILD then
		for _, ent in pairs(ALLPROPS) do
			if ent and ent:IsValid() then
				local phys = ent:GetPhysicsObject()
				if ent:IsPlayerHolding() or phys and phys:IsValid() and phys:IsMoveable() then
					ent.NoValue = true
					self:RemoveProp(nil, ent)
				end
			end
		end
	end

	if int == GAMESTATE_PLAY then
		if GAMESTATE == GAMESTATE_VERIFY then
			local averagepos = Vector(0,0,0)
			for _, teamid in pairs(TEAMS_PLAYING) do
				averagepos = averagepos + team.TeamInfo[teamid].FlagPoint
			end
			averagepos = averagepos / #TEAMS_PLAYING

			for _, teamid in pairs(TEAMS_PLAYING) do
				if not team.TeamInfo[teamid].Verified then
					PrintMessage(HUD_PRINTTALK, team.GetName(teamid).." failed to verify their base. Any of their props in a line leading to the center of the map are now vulnerable.")
					local pos = team.TeamInfo[teamid].FlagPoint
					local dir = (averagepos - pos):Normalize()
					for i=0, averagepos:Distance(pos), 48 do
						for __, ent in pairs(ents.FindInSphere(pos + dir * i, 48)) do
							if ent.PHealth and ent.PHealth == 64000 then
								ent.PHealth = ent.OriginalPHealth
								ent.MaxPHealth = ent.PHealth
								ent:SetMaterial(self.ResistanceMaterials[RESISTANCE_WOOD])
								ent.MaterialType = RESISTANCE_WOOD
								ent.ResistanceTable = RESISTANCES[RESISTANCE_WOOD]
							end
						end
					end
				end
			end
		end

		for _, ent in pairs(ents.FindByClass("func_nofreeze")) do
			if ent.BuildOnly then ent:Remove() end
		end

		NEXT_FIGHTMODE = CurTime()
		GAMESTATE = int
		for _, pl in pairs(player.GetAll()) do
			pl:SetCollisionGroup(COLLISION_GROUP_PLAYER)
			if pl:Team() ~= TEAM_SPECTATE then
				pl:ForceRespawn()
			end
		end

		for _, ent in pairs(ents.GetAll()) do
			if ent.PHealth then
				local col = team.GetColor(ent:GetTeamID())
				ent:SetColor(col.r, col.g, col.b, 255)
				ent.PHealth = ent.MaxPHealth
				if ent.Destroyed then
					ent.Destroyed = nil
					if ent:GetClass() == "prop_teleportpad" then
						ent:SetCollisionGroup(COLLISION_GROUP_WEAPON)
					else
						ent:SetCollisionGroup(COLLISION_GROUP_NONE)
					end
					ent:GetPhysicsObject():EnableCollisions(true)
					ent:Fire("created", "", 0)
				end
			end
		end
	else
		NEXT_FIGHTMODE = 999999
		gamemode.Call("HandleOvertime")
		return
	end

	gmod.BroadcastLua("NEXT_FIGHTMODE="..NEXT_FIGHTMODE.." GAMESTATE="..tostring(GAMESTATE))
	gamemode.Call("SetWalls", GAMESTATE == GAMESTATE_BUILD)

	if int ~= GAMESTATE_BUILD then
		for _, ent in pairs(ALLPROPS) do
			if ent and ent:IsValid() then
				local phys = ent:GetPhysicsObject()
				if phys:IsValid() then phys:EnableMotion(false) end
			end
		end
	end

	if not ENDGAME then
		umsg.Start("RecGameState")
			umsg.Short(GAMESTATE)
		umsg.End()
	end
end

WALLS_UP = true
function GM:SetWalls(bool)
	if bool ~= WALLS_UP then
		for _, wall in pairs(ents.FindByClass("func_wall_toggle")) do
			wall:Fire("toggle", "", 0)
		end

		if string.sub(game.GetMap(), 1, 2) == "sf" then
			if bool then
				for _, brush in pairs(ents.FindByName("build*")) do
					if brush:GetClass() == "func_brush" then
						brush:Fire("Enable", "", 0)
					end
				end
			else
				for _, brush in pairs(ents.FindByName("build*")) do
					if brush:GetClass() == "func_brush" then
						brush:Fire("Disable", "", 0)
					end
				end
			end
		end

		WALLS_UP = not WALLS_UP
	end
end

ALLPROPS = {}
function GM:DestroyAllProps()
	for _, ent in pairs(ALLPROPS) do
		if ent and ent:IsValid() then
			ent:Remove()
		end
	end
	ALLPROPS = {}
end

function GM:RemoveAllProps()
	for _, ent in pairs(ALLPROPS) do
		if ent and ent:IsValid() then
			self:RemoveProp(nil, ent)
		end
	end
	ALLPROPS = {}
end

function GM:CleanUpForNewRound()
	for _, ent in pairs(ents.FindByClass("projectile_*")) do ent:Remove() end
	for _, ent in pairs(ents.FindByClass("vehicle_nox*")) do ent:Remove() end
	for _, pl in pairs(player.GetAll()) do pl:RemoveAllStatus(true, true) pl:StripWeapons() pl:ExitVehicle() end
end

function GM:EntityTakeDamage(ent, inflictor, attacker, amount, dmginfo)
	if attacker == inflictor and attacker:IsProjectile() and dmginfo:GetDamageType() == DMG_CRUSH then -- Fixes projectiles doing physics-based damage.
		dmginfo:SetDamage(0)
		dmginfo:ScaleDamage(0)
		return
	end

	if dmginfo:GetDamageType() == DMGTYPE_ENERGY then
		dmginfo:SetDamage(dmginfo:GetDamage() * (1 + ent:WaterLevel() * 0.125))
	end

	if ent.ProcessDamage then
		ent:ProcessDamage(attacker, inflictor, dmginfo)
	end
end

--[[function GM:EntityTakeDamage(ent, inflictor, attacker, amount, dmginfo)
	if ent.ProcessDamage then
		if attacker:IsValid() and attacker:GetClass() == "entityflame" and ent.LastIgniter then
			dmginfo:ScaleDamage(0)

			ent:TakeSpecialDamage(amount, DMGTYPE_FIRE, ent.LastIgniter, inflictor)
		else
			ent:ProcessDamage(amount, attacker, inflictor, dmginfo)
		end
	end
end]]

function GM:OnNPCKilled(ent, attacker, inflictor)
	if inflictor and attacker == inflictor and (inflictor:IsPlayer() or inflictor:IsNPC()) then
		inflictor = inflictor:GetActiveWeapon()
		if attacker == nil then inflictor = attacker end
	end

	if ent.Death then
		ent.Death(ent, attacker, inflictor)
	end
end

function GM:PlayerNoClip(pl, on)
	if pl:IsAdmin() then
		if on then
			LogAction("[Admin CMD] <"..pl:SteamID().."> "..pl:Name().." TURNED ON NOCLIP")
		else
			LogAction("[Admin CMD] <"..pl:SteamID().."> "..pl:Name().." TURNED OFF NOCLIP")
		end
		return true
	end

	return false
end

function GM:OnPhysgunFreeze(weapon, phys, ent, pl)
	return false
end

function GM:RepairVehicle(pl, ent, amount)
	local maxhealth = ent:GetMaxVHealth()
	local newhealth = math.min(ent:VHealth() + amount, maxhealth)
	if newhealth ~= ent:VHealth() then
		ent:SetVHealth(newhealth)
		if ent.Ignited and maxhealth * 0.3 < newhealth then
			for _, ent2 in pairs(ents.FindByClass("env_fire_trail")) do
				if ent2:GetParent() == ent then
					ent2:Remove()
				end
			end
			ent.Ignited = nil
		end

		return true
	end

	return false
end

function GM:RepairProp(pl, ent, amount)
	pl = pl or NULL

	local maxhealth = ent.MaxPHealth
	local col = team.GetColor(ent:GetTeamID())
	if ent.Destroyed then
		local newhealth = math.ceil(math.min(ent.PHealth + amount, maxhealth))
		local brit = newhealth / maxhealth
		if newhealth == maxhealth then
			local aa, bb = ent:WorldSpaceAABB()
			for _, e2 in pairs(ents.FindInBox(aa, bb)) do
				if e2:IsValid() and e2:IsPlayer() and e2:Alive() and e2:Team() ~= TEAM_SPECTATE then
					newhealth = maxhealth - 1
				end
			end
			if newhealth == maxhealth then	
				ent.Destroyed = nil
				ent.PHealth = maxhealth
				ent:SetColor(math.ceil(col.r * brit), math.ceil(col.g * brit), math.ceil(col.b * brit), 255)
				ent:SetCollisionGroup(COLLISION_GROUP_NONE)
				ent:GetPhysicsObject():EnableCollisions(true)
				ent:Fire("created", "", 0)
				local entpos = ent:GetPos()
				local effectdata = EffectData()
					effectdata:SetEntity(ent)
					effectdata:SetOrigin(entpos)
				util.Effect("building_spawn", effectdata, true, true)
				if 200 <= maxhealth then
					local core = team.TeamInfo[ent:GetTeamID()].FlagPoint
					if core:Distance(entpos) < 1400 then
						local ownersteamid = ent.Owner
						for _, p in pairs(player.GetAll()) do
							if p:SteamID() == ownersteamid or p == pl then
								p:LMG(5)
								p:AddMoney(CRAFTER_CORE_DEFENSE_BONUS)
								p:AddFrags(1)
								p:AddDefense(1)
								ent.ReversePointsThresh = CurTime() + 30
							end
						end
					end
				end

				return true
			elseif pl and pl:IsPlayer() then
				pl:PrintMessage(HUD_PRINTCENTER, "Building is being blocked and can't be completed.")
			end
		else
			ent.PHealth = newhealth
			ent:SetColor(math.ceil(col.r * brit), math.ceil(col.g * brit), math.ceil(col.b * brit), math.ceil(brit * 240))

			return true
		end
	else
		local newhealth = math.ceil(math.min(ent.PHealth + amount, maxhealth))
		if newhealth ~= ent.PHealth then
			ent.PHealth = newhealth
			local brit = newhealth / maxhealth
			ent:SetColor(math.ceil(col.r * brit), math.ceil(col.g * brit), math.ceil(col.b * brit), 255)
			return true
		end
	end

	return false
end

function GM:DrainPower(prop, amount)
	if prop.Destroyed then
		return false
	end

	local totalpower = 0
	local shouldpower = false
	local todrain = {}
	local proppos = prop:GetPos()
	local propteam = prop:GetTeamID()
	for _, ent in pairs(CAPACITORS) do
		if ent.IsCapacitor and not ent.Destroyed and ent:GetTeamID() == propteam and ent:GetPos():Distance(prop:NearestPoint(ent:GetPos())) <= CAPACITOR_RANGE then
			local totake = math.min(ent.ManaStorage, amount - totalpower)
			todrain[ent] = totake
			totalpower = totalpower + totake
			if amount <= totalpower then
				shouldpower = true
				break
			end
		end
	end

	if shouldpower then
		for ent, amount in pairs(todrain) do
			ent.ManaStorage = ent.ManaStorage - amount
		end
		return true
	end

	return false
end

function GM:Evaluate(prop, nodrain)
	if prop.Destroyed then
		prop.Powered = false
		return
	end
	local totalpower = 0
	local targetpower = prop.ManaDrainPerSecond
	local shouldpower = false
	local todrain = {}
	local propteam = prop:GetTeamID()
	for _, ent in pairs(ents.FindInSphere(prop:GetPos(), CAPACITOR_RANGE)) do
		if ent.IsCapacitor and not ent.Destroyed and ent:GetTeamID() == propteam then
			local totake = math.min(ent.ManaStorage, targetpower - totalpower)
			todrain[ent] = totake
			totalpower = totalpower + totake
			if targetpower <= totalpower then
				shouldpower = true
				break
			end
		end
	end

	if shouldpower then
		if not prop.Powered then
			prop.Powered = true
			prop:Fire("powered", "", 0)
		end
		if not nodrain then
			for ent, amount in pairs(todrain) do
				ent.ManaStorage = ent.ManaStorage - amount
				ent:SetSkin(ent.ManaStorage)
			end
		end
	elseif prop.Powered then
		prop.Powered = false
		prop:Fire("depowered", "", 0)
	end
end

function GM:EvaluatePower()
	for _, ent in pairs(ents.GetAll()) do
		if ent.MagusShield then ent.MagusShield = nil end
	end

	for _, shield in pairs(ents.FindByClass("prop_magusshield")) do
		if not shield.Destroyed then
			local myteam = shield:GetTeamID()
			for _, ent in pairs(ents.FindInSphere(shield:GetPos(), 750)) do
				if not ent.NoMagusShield and ent.PHealth and ent:GetTeamID() == myteam then
					ent.MagusShield = shield
				end
			end
		end
	end
end

function GM:AspectsChanged(pl)
	local aspects = pl.Aspects
	pl:SetMaxMana(self:GetMaximumMana(aspects[ASPECT_MIND]), self:GetManaRegeneration(aspects[ASPECT_SPIRIT]))
	pl:SetMaxStamina(self:GetMaximumStamina(aspects[ASPECT_WILL]), self:GetStaminaRegeneration(aspects[ASPECT_RECOVERY]))
	pl.AccuracyMultiplier = self:GetAccuracyMultiplier(aspects[ASPECT_ACCURACY])
	pl.RateOfFireMultiplier = self:GetRateOfFireMultiplier(aspects[ASPECT_INSTINCT])
	pl.GunManaUseMultiplier = self:GetGunManaMultiplier(aspects[ASPECT_GUNMASTERY])
	pl.BuildingRateMultiplier = self:GetBuildingRateMultiplier(aspects[ASPECT_CRAFTSMANSHIP])
	pl.MeleeDamageMultiplier = self:GetMeleeDamageMultiplier(aspects[ASPECT_MIGHT])
	pl.SprintSpeed = self:GetSprintSpeed(aspects[ASPECT_SPEED])
	pl.WallRunSpeed = self:GetWallRunSpeed(aspects[ASPECT_SPEED])
	pl.WallVertSpeed = self:GetWallVertSpeed(aspects[ASPECT_SPEED])
	pl.AbleToSprint = self:GetCanSprint(aspects[ASPECT_DEXTERITY])
	pl.AbleToDodge = self:GetCanDodge(aspects[ASPECT_DEXTERITY])
	pl.AbleToWallRun = self:GetCanWallRun(aspects[ASPECT_DEXTERITY])
	pl.AbleToWallJump = self:GetCanWallJump(aspects[ASPECT_DEXTERITY])
	pl.AbleToWallVert = self:GetCanWallVert(aspects[ASPECT_DEXTERITY])
	pl.ObeliskManaRetainer = self:GetObeliskManaRetainer(aspects[ASPECT_SPIRIT])
	pl.AgilityMultiplier = self:GetAgilityMultiplier(aspects[ASPECT_AGILITY])
	pl.CastingRateMultiplier = self:GetCastingRate(aspects[ASPECT_INTELLIGENCE])
end

function GM:PhysgunDrop(ply, ent)
	local phys = ent:GetPhysicsObject()
	if phys:IsValid() then phys:EnableMotion(false) end

	if ent:IsInFlagArea() then
		ent:EmitSound("npc/roller/mine/rmine_blip3.wav")
		self:RemoveProp(ply, ent)
		ply:LMR(29)
		return
	end

	if ent.NoWater and 0 < ent:WaterLevel() then
		ent:EmitSound("npc/roller/mine/rmine_blip3.wav")
		self:RemoveProp(ply, ent)
		ply:LMR(68)
		return
	end

	if IsGlitched(ent, ply, passive) then
		ent:EmitSound("npc/roller/mine/rmine_blip3.wav")
		self:RemoveProp(ply, ent)
		return
	end

	local entpos = ent:GetPos()

	local spawns = ents.FindByClass("info_player*")
	table.Add(spawns, ents.FindByClass("prop_spawnpoint"))
	table.Add(spawns, ents.FindByClass("gmod_player_start"))
	for _, ent2 in pairs(spawns) do
		local ent2pos = ent2:GetPos()
		for _, ent3 in pairs(ents.FindInBox(ent2pos + Vector(-17, -17, 0), ent2pos + Vector(17, 17, 73))) do
			if ent3 == ent and ent2 ~= ent then
				ent:EmitSound("npc/roller/mine/rmine_blip3.wav")
				self:RemoveProp(ply, ent)
				ply:LMR(67)
				return
			end
		end
	end

	if ent.SolidBase then
		local tr = util.TraceLine({start=entpos, endpos=entpos + ent:GetUp() * (ent:OBBMins().z - 16), filter=ent})
		if not tr.HitWorld or tr.HitSky or tr.HitNoDraw or tr.HitNormal.z < 0.9 then
			ent:EmitSound("npc/roller/mine/rmine_blip3.wav")
			self:RemoveProp(ply, ent)
			ply:LMR(66)
			return
		end
	end

	if ent.NoWater and util.PointContents(entpos) & CONTENTS_WATER == 32 then
		ent:EmitSound("npc/roller/mine/rmine_blip3.wav")
		self:RemoveProp(ply, ent)
		ply:PrintMessage(HUD_PRINTTALK, "That type of structure can't opperate in water or lava.")
		return
	end

	if ent.NoFreeze then
		ent:EmitSound("npc/roller/mine/rmine_blip3.wav")
		self:RemoveProp(ply, ent)
		ply:LMR(64)
		return
	end

	if ent.ClusterPrevention then
		local entteam = ent:GetTeamID()
		for _, ent2 in pairs(ents.FindInSphere(entpos, 256)) do
			if ent ~= ent2 and ent2.ClusterPrevention == ent.ClusterPrevention and ent2:GetTeamID() == entteam then
				ent:EmitSound("npc/roller/mine/rmine_blip3.wav")
				self:RemoveProp(ply, ent)
				ply:LMR(65)
				return
			end
		end
	end

	ply.PropCarry = nil
	self:EvaluatePower()
	ent:Fire("dropped", "", 0)
end

function GM:CanPlayerEnterVehicle(pl, veh, role)
	if not pl:CanEnterVehicle() then return false end

	local vehbase = veh:GetNetworkedEntity("vehicle", NULL)
	if vehbase.PilotSeat == veh then
		if pl:IsCarrying() then
			pl:PrintMessage(HUD_PRINTCENTER, "You can't drive vehicles or control turrets while holding the flag!")
			return false
		end

		if not veh.Turret then
			local deployer = vehbase.Deployer
			if deployer and deployer:IsValid() and deployer:Team() == pl:Team() and deployer ~= pl and deployer:Alive() and CurTime() < vehbase.DeployTime + 6 then
				pl:PrintMessage(HUD_PRINTCENTER, "You can't drive vehicles recently spawned by another team member.")
				return false
			end

			return true
		end
	end

	return pl:Team() == vehbase:Team()
end

function GM:CanExitVehicle(veh, pl)
	if pl and pl:IsValid() then
		pl:ExitVehicle()
	end

	return true
end

function GM:PlayerEnteredVehicle(pl, veh, role)
	local vehbase = veh:GetNetworkedEntity("vehicle", NULL)
	if vehbase.Enter then
		vehbase:Enter(pl, veh, role)
	end

	pl:SendLua("NOX_VIEW=nil")
end

function GM:RemoveProp(ply, ent)
	local teamid = ent:GetTeamID()
	if teamid and not ent.RevokedTeamCount then
		team.AddProps(teamid, -1)
		ent.RevokedTeamCount = true
	end

	if ent.Removing then ent:Remove() return end

	if not teamid then return end

	if ent.ReversePointsThresh and ent.ReversePointsThresh <= CurTime() and ent.Owner then
		for _, pl in pairs(player.GetAll()) do
			if pl:SteamID() == ent.Owner then
				pl:LMR(1)
				pl:AddMoney(-CRAFTER_CORE_DEFENSE_BONUS)
				pl:AddFrags(-1)
				pl:AddDefense(-1)
				break
			end
		end
	end

	--[[if not ent.NoValue then
		local refund = 0
		for i=1, #PROPTYPES do
			if PROPTYPES[i].Type == ent:GetClass() and PROPTYPES[i].Model == ent:GetModel() then
				refund = PROPTYPES[i].Price
				break
			end
		end

		for _, pl in pairs(player.GetAll()) do
			if pl:SteamID() == ent.Owner then
				pl:AddMoney(refund, true)
			end
		end
	end]]

	for i, prop in pairs(ALLPROPS) do
		if ent == prop then
			table.remove(ALLPROPS, i)
		end
	end

	ent.Removing = true
	ent:Remove()

	return true
end

function GM:PhysgunPickup(pl, ent)
	if ent:GetClass() == self.FlagEntity then return false end
	if ent:IsPlayer() then return false end
	if not ent.Owner then return false end

	if pl:IsAdmin() and ent.Owner ~= pl:SteamID() then
		pl:PrintMessage(HUD_PRINTCENTER, "This prop was spawned by <"..tostring(ent.Owner)..">")
	end

	if (ent:GetTeamID() ~= pl:Team() or ent.Owner ~= pl:SteamID()) and not pl:IsAdmin() then
		for _, pl2 in pairs(player.GetAll()) do
			if pl2:SteamID() == ent.Owner then
				pl:PrintMessage(HUD_PRINTCENTER, "This prop was spawned by "..pl2:Name().." <"..pl2:SteamID()..">")
				return false
			end
		end
		if type(ent.Owner) == "string" then
			pl:PrintMessage(HUD_PRINTTALK, "This prop was spawned by <"..tostring(ent.Owner).."> who has left the game. You now own this prop.")
		end
		ent.Owner = pl:SteamID()
		ent.NoValue = true
	end

	if GAMESTATE == GAMESTATE_BUILD or ent.Destroyed and ent.PHealth == 0 then
		pl.PropCarry = ent
		return true
	end

	return false
end

function GM:ResetAllFlags(mode)
	for _, pl in pairs(player.GetAll()) do
		pl.Carrying = nil
	end
	for _, ent in pairs(ents.FindByClass("flag")) do
		ent.Carrier = ent
		ent:SetPos(team.TeamInfo[ent:GetTeamID()].FlagPoint + Vector(0,0,38))
		ent:SetSolid(SOLID_VPHYSICS)
		ent.Phys:EnableGravity(true)
		ent.Phys:EnableMotion(mode == 2)
		if mode == 2 then
			ent.Phys:Wake()
		end
		ent:SetSkin(0)
	end
end

function GM:PlayerCanPickupWeapon(pl, wep)
	return pl.AllowWeaponPickup
end

GM.AlreadyLost = {}
function GM:PlayerDisconnected(pl)
	if pl.Summons then
		for _, ent in pairs(pl.Summons) do
			ent:Fire("sethealth", "0", 1)
		end
	end

	if pl.Summoning and pl.Summoning:IsValid() then
		local effectdata = EffectData()
			effectdata:SetOrigin(pl.Summoning:GetPos())
		util.Effect("counterspell", effectdata, true)
		pl.Summoning:EmitSound("nox/summondie.wav")

		pl.Summoning:Remove()
	end

	pl:RemoveAllStatus(true, true)

	self:GameTypeDisconnect(pl)
end

function GM:PlayerDeathThink(pl)
	if self.Intermission then return end

	if pl.NextSpawnTime <= CurTime() and pl:KeyDown(IN_ATTACK) and 0 <= pl.NextSpawnTime then
		pl:Spawn()
	elseif pl.NextSpectateTime <= CurTime() then
		local desired = pl.DesiredObserverMode
		if pl:GetObserverMode() ~= desired then
			pl:Spectate(desired)
		end

		if desired == OBS_MODE_CHASE or desired == OBS_MODE_IN_EYE then
			local curspec = pl:GetObserverTarget()
			if curspec and curspec:IsValid() then
				if pl:KeyPressed(IN_ATTACK) then
					local nextspec = pl:GetNextSpectate()
					if nextspec then
						pl:SpectateEntity(nextspec)
					end
				elseif pl:KeyPressed(IN_ATTACK2) then
					local nextspec = pl:GetPrevSpectate()
					if nextspec then
						pl:SpectateEntity(nextspec)
					end
				else
					pl:SetPos(curspec:GetPos())
				end
			else
				local nextspec = pl:GetNextSpectate()
				if nextspec then
					pl:SpectateEntity(nextspec)
				end
			end
		end

		if pl:KeyPressed(IN_JUMP) then
			if pl.DesiredObserverMode == OBS_MODE_ROAMING then
				pl.DesiredObserverMode = OBS_MODE_CHASE
			elseif pl.DesiredObserverMode == OBS_MODE_CHASE then
				pl.DesiredObserverMode = OBS_MODE_IN_EYE
			else
				pl.DesiredObserverMode = OBS_MODE_ROAMING
			end
		end
	end
end

function GM:PlayerUse(pl, entity)
	return true
end

local function SortByScore(a,b)
	local afrags, bfrags = a:Frags(), b:Frags()
	if afrags == bfrags then
		return a:Deaths() < b:Deaths()
	end
	return afrags > bfrags
end

function GM:EndGame(winner, slaves)
	if ENDGAME then return end

	mysql_threaded_query("UPDATE noxnetmaps SET Played = Played + 1 WHERE noxnetmaps.MapName = '"..game.GetMap().."'")

	NEXTMAP = CurTime() + 35
	ENDGAME = true

	hook.Add("Think", "NextMapChecker", function()
		if NEXTMAP <= CurTime() then
			game.LoadNextMap()
			hook.Remove("Think", "NextMapChecker")
		end
	end)

	VOTEMAPLOCKED = nil
	timer.Simple(4, gmod.BroadcastLua, "OpenVoteMenu()")
	VOTEMAPOVER = CurTime() + 22.5
	timer.Simple(22.5, gmod.BroadcastLua, "OpenGTVoteMenu()")

	local allplayers = player.GetAll()

	if 0 < winner then
		local givmon = #allplayers >= 6
		if givmon then
			PrintMessage(HUD_PRINTTALK, "All members of the "..team.GetName(winner).." team have been awarded "..BONUS_WIN.." Silver for winning the match!")
		else
			PrintMessage(HUD_PRINTTALK, "No money has been awarded because there is not at least 6 people playing!")
		end

		for _, pl in pairs(allplayers) do
			local steamid = pl:SteamID()
			if CurTime() < pl.InitialSpawned + 120 then
				--pl:PrintMessage(HUD_PRINTTALK, "You did not receive a win or loss due to not being in the game for more than two minutes.")
			elseif pl:Team() == winner then
				if slaves[steamid] then
					if not GAMEMODE.AlreadyLost[steamid] then
						GAMEMODE.AlreadyLost[steamid] = true
						--pl.NoXiousTPLosses = pl.AssaultLosses + 1
					end
					--pl:PrintMessage(HUD_PRINTTALK, "Being taken in as a slave, you did not receive a bonus for winning. Personal wins / losses: "..pl.AssaultWins.." / "..pl.AssaultLosses)
				else
					if givmon then
						pl:AddMoney(BONUS_WIN)
					end
					--pl.NoXiousTPWins = pl.AssaultWins + 1
					--pl:PrintMessage(HUD_PRINTTALK, winmessage.." Personal wins / losses: "..pl.AssaultWins.." / "..pl.AssaultLosses)
				end
			elseif pl:Team() ~= TEAM_SPECTATE and not GAMEMODE.AlreadyLost[steamid] then
				GAMEMODE.AlreadyLost[steamid] = true
				--pl.NoXiousTPLosses = pl.AssaultLosses + 1
				--pl:PrintMessage(HUD_PRINTTALK, "Your team has lost the round. Personal wins / losses: "..pl.AssaultWins.." / "..pl.AssaultLosses)
			end
		end
	end

	for _, pl in pairs(allplayers) do
		pl:Freeze(true)
		pl:GodEnable()
	end

	umsg.Start("EndG")
		umsg.Short(winner)
	umsg.End()

	NDB.GlobalSave()

	hook.Add("PlayerSpawn", "FREEZENEW", function(p) p:Freeze(true) p:GodEnable() end)
end

function GM:EndIntermission()
	if ENDGAME then return end

	if self:GameTypeEndIntermission() then return end

	self.Intermission = nil
	self.IntermissionPlayer = nil
	self.IntermissionTeam = nil

	hook.Remove("SetupPlayerVisibility", "SetupPlayerVisibilityIntermission")
	hook.Remove("PlayerSpawn", "PlayerSpawnIntermission")
	hook.Remove("CanPlayerSuicide", "CanPlayerSuicideIntermission")
	hook.Remove("PlayerReady", "PlayerReadyIntermission")

	--gamemode.Call("RebuildBallDrop")

	for _, pl in pairs(player.GetAll()) do
		pl.VehicleTimers = {}

		if pl.SpawnPoint and pl.SpawnPoint:IsValid() then
			pl.SpawnPoint = nil
			pl:LM(62)
		end

		if pl:Team() ~= TEAM_SPECTATE then
			pl:Freeze(false)
			pl:Spawn()
		end
	end

	for _, ent in pairs(ents.FindByClass(self.FlagEntity)) do
		if ent.Reset then
			ent:Reset(true)
		end
	end

	umsg.Start("intmsend")
	umsg.End()
end

local vec2 = Vector(0,0,2)
local function SetupPlayerVisibilityIntermission(pl)
	if pl:Team() ~= GAMEMODE.IntermissionTeam then
		local intermissionplayer = GAMEMODE.IntermissionPlayer
		if intermissionplayer:IsValid() then
			AddOriginToPVS(intermissionplayer:GetPos() + vec2)
		end
	end
end

local function CanPlayerSuicideIntermission(pl)
	return pl:Team() == GAMEMODE.IntermissionTeam
end

local function PlayerSpawnIntermission(pl)
	if pl:Team() == TEAM_SPECTATE or pl:Team() == GAMEMODE.IntermissionTeam then return end

	pl:ExitVehicle()
	pl:Freeze(true)
end

local function PlayerReadyIntermission(pl)
	umsg.Start("intmsstart", pl)
		umsg.Float(GAMEMODE.IntermissionBegan)
		umsg.Entity(GAMEMODE.IntermissionPlayer)
		umsg.Short(GAMEMODE.IntermissionTeam)
	umsg.End()
end

function GM:StartIntermission(pl, myteam)
	if self:GameTypeStartIntermission(pl) then return end

	pl = pl or NULL

	self.Intermission = true
	self.IntermissionBegan = CurTime()
	self.IntermissionPlayer = pl
	self.IntermissionTeam = pl:GetTeamID()

	--[[if pl:IsValid() then
		local cament = ents.Create("point_playercamera")
		if cament:IsValid() then
			cament:SetPos(pl:EyePos())
			cament:SetAngles(pl:EyeAngles())
			cament:Spawn()
			cament:SetParent(pl)
			pl.IntermissionCamera = cament
		end
	end]]

	if pl:IsValid() then
		myteam = pl:GetTeamID()
	end

	for _, ent in pairs(player.GetAll()) do
		--if ent ~= pl then
		if ent:Team() ~= myteam then
			PlayerSpawnIntermission(ent)
		end
	end

	PlayerReadyIntermission()

	hook.Add("SetupPlayerVisibility", "SetupPlayerVisibilityIntermission", SetupPlayerVisibilityIntermission)
	hook.Add("PlayerSpawn", "PlayerSpawnIntermission", PlayerSpawnIntermission)
	hook.Add("CanPlayerSuicide", "CanPlayerSuicideIntermission", CanPlayerSuicideIntermission)
	hook.Add("PlayerReady", "PlayerReadyIntermission", PlayerReadyIntermission)
end

function GM:PlayerDeathSound()
	return true
end

local MineAwards = {}
MineAwards[2] = "Novice_Miner"
MineAwards[4] = "Adept_Miner"
MineAwards[8] = "Master_Miner"
MineAwards[16] = "Awesome_Miner"
MineAwards[24] = "Crazy_Miner"
MineAwards[32] = "Lunatic_Miner"
MineAwards[49] = "MINER_FOURTY-NINER"

GM:AddStatus("BomberKills")
GM:AddStatus("HarpoonKills")
GM:AddStatus("BurnKills")
GM:AddStatus("RoverKills")

function GM:PlayerHurt(pl, attacker, healthremaining, damage)
	if attacker:IsPlayer() and attacker ~= pl then
		if healthremaining <= 0 then
			if attacker:InVehicle() then
				local pilot = attacker:GetVehicle().VehicleParent.PilotSeat:GetDriver()
				if attacker ~= pilot then
					pl.LastAttacker2 = pilot
					pl.LastAttacked2 = CurTime()
					return
				end
			end
			if attacker ~= pl.LastAttacker and CurTime() < pl.LastAttacked + 3 and pl.LastAttacker:IsPlayer() then
				pl.LastAttacker2 = pl.LastAttacker
				pl.LastAttacked2 = CurTime()
			end
		end
		pl:SetLastAttacker(attacker)
	end

	if pl.NextPainSound <= CurTime() and 1 <= healthremaining then
		pl.NextPainSound = CurTime() + 0.35
		local fraction = pl:Health() / pl:GetMaxHealth()
		if fraction <= 0.25 then
			pl:EmitSound("nox/playerhurt_heavy"..math.random(1, 10)..".wav", 74, math.random(95, 105))
		elseif fraction <= 0.75 then
			pl:EmitSound("nox/playerhurt_med"..math.random(1, 11)..".wav", 74, math.random(95, 105))
		else
			pl:EmitSound("nox/playerhurt_light"..math.random(1, 6)..".wav", 74, math.random(95, 105))
		end
	end
end

function GM:DoPlayerDeath(pl, attacker, dmginfo)
	if pl:IsOnFire() then
		pl:Extinguish()
	end

	local fCurTime = CurTime()
	if ENDGAME then
		pl.NextSpawnTime = -1
	elseif pl == attacker then
		pl.NextSpawnTime = fCurTime + RESPAWN_TIME + 3
	else
		pl.NextSpawnTime = fCurTime + RESPAWN_TIME
	end

	umsg.Start("NextRespawn", pl)
		umsg.Float(pl.NextSpawnTime)
	umsg.End()

	pl.NextSpectateTime = fCurTime + 3

	if pl.KnockedDown then
		pl:RemoveStatus("knockdown", false, true)
	end

	local lastattacker, lastattacked, lastattacker2, lastattacked2 = pl:GetLastAttacker()
	if (attacker == pl or not attacker:IsPlayer()) and lastattacker:IsValid() and fCurTime < pl.LastAttacked + 8 then attacker = lastattacker end

	if attacker.VehicleParent then
		attacker = attacker.VehicleParent
	end

	local inflictor = dmginfo:GetInflictor()
	if inflictor.VehicleParent then
		inflictor = inflictor.VehicleParent
	end

	if attacker.ScriptVehicle then
		local driver = attacker.PilotSeat:GetDriver()
		if driver:IsValid() then
			inflictor = attacker
			attacker = driver
		end
	elseif attacker:IsNPC() and attacker.Owner and attacker.Owner:IsValid() then
		attacker = attacker.Owner
	end

	if attacker:IsValid() then
		local owner = attacker:GetOwner()
		if owner:IsPlayer() then
			attacker = owner
		end
	end

	local isassist = lastattacker2:IsValid() and lastattacker2 ~= attacker and lastattacker2 ~= pl and fCurTime < pl.LastAttacked2 + 3

	if inflictor == DUMMY_DEATHRAY or pl.draydeath and fCurTime < pl.draydeath then
		pl:DeathRayed()
	elseif pl:Health() < -30 then
		pl:Gib(dmginfo)
	else
		if not pl.KnockedDown then
			pl:CreateRagdoll()
		end
		pl:EmitSound("nox/pdie"..math.random(1,7)..".wav", 95, math.random(90, 105))
	end

	local uid = pl:UniqueID()
	for key, timername in pairs(PlayerStatusTimers) do
		timer.Destroy(uid..timername)
	end
	for key, status in pairs(PlayerStatus) do
		pl[status] = nil
	end
	pl:RemoveAllStatus(true, true)
	if pl:IsCarrying() then
		pl.Carrying:Dropped(pl)
		pl.Carrying = nil
	end

	pl.LastDeath = fCurTime

	if GAMESTATE ~= GAMESTATE_PLAY or self.Intermission or ENDGAME then return end

	pl:AddDeaths(1)

	local fragstoadd = 0
	local assistfragstoadd = 0

	if attacker == pl then
		attacker:AddFrags(-1)
	elseif attacker:IsPlayer() and attacker:Team() ~= pl:Team() then
		if pl:IsCarrying() then
			attacker:AddFrags(4)
		else
			attacker:AddFrags(2)
		end

		if isassist then
			if pl:IsCarrying() then
				lastattacker2:AddFrags(2)
			else
				lastattacker2:AddFrags(1)
			end
			lastattacker2:AddAssists(1)
		end

		--if attacker:IsCarrying() then
			--attacker:SetStamina(math.min(attacker.MaxStamina, attacker:GetStamina() + 20), true)
		--end

		gamemode.Call("OnPlayerAddFrag", attacker, pl, 1)

		local spawntime = fCurTime - pl.SpawnTime

		if pl:GetPos():Distance(team.TeamInfo[attacker:Team()].FlagPoint or Vector(0,0,99999)) <= 1024 then
			attacker:AddMoney(math.ceil(15 + math.min(150, spawntime * 0.25)) + BONUS_CORE_DEFENSE)
			attacker:AddDefense(1)
			if isassist then
				lastattacker2:AddMoney(math.ceil(5 + math.min(150, spawntime * 0.125) + BONUS_CORE_DEFENSE * 0.5))
				lastattacker2:AddDefense(1)
			end
		else
			attacker:AddMoney(math.ceil(15 + math.min(300, spawntime * 0.25)))
			if isassist then
				lastattacker2:AddMoney(math.ceil(5 + math.min(150, spawntime * 0.125)))
			end
		end

		attacker:AddKills(1)

		local inflictorclass = inflictor:GetClass()
		if inflictorclass == "prop_firemine" then
			if not (attacker.LastMineKill == pl and fCurTime < attacker.NextMineKillTime) then
				attacker.LastMineKill = pl
				attacker.NextMineKillTime = fCurTime + 60
				local newmines = attacker.MineKills + 1
				attacker.MineKills = newmines
				for amount, award in pairs(MineAwards) do
					if amount <= newmines then
						if not attacker:HasAward(award) then
							NDB.GiveAward(attacker, award)
						end
					end
				end
			end
		elseif inflictorclass == "projectile_vulturebomb" then
			local newkills = (attacker.BomberKills or 0) + 1
			attacker.BomberKills = newkills
			if newkills == 5 and not attacker:HasAward("Bomberman") then
				NDB.GiveAward(attacker, "Bomberman")
			elseif newkills == 20 and not attacker:HasAward("Fatboy") then
				NDB.GiveAward(attacker, "Fatboy")
			elseif newkills == 50 and not attacker:HasAward("Beeee_17_Boamber") then
				NDB.GiveAward(attacker, "Beeee_17_Boamber")
			end
		elseif inflictorclass == "vehicle_noxbase" or inflictorclass == "roverwheel" then
			local newkills = (attacker.RoverKills or 0) + 1
			attacker.RoverKills = newkills
			if newkills == 3 and not attacker:HasAward("You_Cant_Pull_Me_Over") then
				NDB.GiveAward(attacker, "You_Cant_Pull_Me_Over")
			elseif newkills == 8 and not attacker:HasAward("Vroom_Im_A_Car") then
				NDB.GiveAward(attacker, "Vroom_Im_A_Car")
			elseif newkills == 15 and not attacker:HasAward("Get_Out_Of_The_Way") then
				NDB.GiveAward(attacker, "Get_Out_Of_The_Way")
			end
		elseif inflictorclass == "vehicle_noxraven" and 0 < inflictor:VHealth() and not pl:IsOnGround() and not attacker:HasAward("No_Flying_Zone") then
			NDB.GiveAward(attacker, "No_Flying_Zone")
		end
	end

	self:PlayerDeath2(pl, inflictor, attacker, lastattacker2, isassist, fragstoadd, assistfragstoadd)
end
GM:AddStatus("PreInvisibleDrawWorldModel")

function GM:ShowHelp(pl)
	pl:SendLua("MakepMain(\"Help\")")
end

function GM:ShowTeam(pl)
	pl:SendLua("MakepMain(\"Profiles\")")
end

function GM:ShowSpare1(pl)
	pl:SendLua("MakepMain(\"Spells\")")
end

function GM:ShowSpare2(pl)
	pl:SendLua("MakepMain(\"Options\")")
end

function GM:PlayerDeath(Victim, Inflictor, Attacker)
end

function GM:PlayerDeath2(Victim, Inflictor, Attacker, Attacker2, isassist)
	Victim:StripAmmo()

	if Inflictor and Inflictor == Attacker and (Inflictor:IsPlayer() or Inflictor:IsNPC()) then
		Inflictor = Inflictor:GetActiveWeapon()
		if not Inflictor:IsValid() then Inflictor = Attacker end
	end

	local owner = Attacker:GetOwner()
	if owner:IsPlayer() then
		Attacker = owner
	end

	local inf
	if Inflictor.DisplayClass then
		inf = Inflictor.DisplayClass
	else
		inf = Inflictor:GetClass()
	end

	if Attacker == Victim then
		umsg.Start("PlayerKilledSelf")
			umsg.Entity(Victim)
			umsg.String(inf)
		umsg.End()
	elseif Attacker:IsPlayer() then
		if isassist then
			umsg.Start("PlayerKilledByPlayers")
				umsg.Entity(Victim)
				umsg.String(inf)
				umsg.Entity(Attacker)
				umsg.Entity(Attacker2)
			umsg.End()
		else
			umsg.Start("PlayerKilledByPlayer")
				umsg.Entity(Victim)
				umsg.String(inf)
				umsg.Entity(Attacker)
			umsg.End()
		end
	else
		umsg.Start("PlayerKilled")
			umsg.Entity(Victim)
			umsg.String(inf)
			umsg.String(Attacker:GetClass())
		umsg.End()
	end
end

function SortTeams(a, b)
	local aamount = team.NumPlayers(a)
	local bamount = team.NumPlayers(b)

	if aamount < bamount * 1.2 and bamount * 0.8 < aamount then
		return team.TotalWeight(a) < team.TotalWeight(b)
	end

	return aamount < bamount
end

function GM:PlayerLoadout(pl)
end

function GM:PlayerCanSuicide(pl)
	return pl:Team() ~= TEAM_SPECTATE
end

local HealerAwards = {}
HealerAwards[250] = "250HP_Cleric"
HealerAwards[500] = "500HP_Cleric"
HealerAwards[750] = "750HP_Cleric"
HealerAwards[1000] = "1000HP_Cleric"
HealerAwards[1500] = "1500HP_Cleric"
HealerAwards[2500] = "2500HP_Cleric"
HealerAwards[5000] = "5000HP_Cleric"

function GM:PlayerHeal(pl, caster, amount)
	local maxhealth = pl:GetMaxHealth()
	local curhealth = pl:Health()
	pl:SetHealth(math.min(maxhealth, curhealth + amount))
	if pl ~= caster and caster:IsValid() and pl.LastAttacker ~= pl then
		local newhphealed = caster.AllyHPHealed + (pl:Health() - curhealth)
		caster.AllyHPHealed = newhphealed
		for amount, award in pairs(HealerAwards) do
			if amount <= newhphealed then
				local found = false
				for _, plaward in pairs(caster.Awards) do
					if plaward == award then
						found = true
						break
					end
				end
				if not found then
					NDB.GiveAward(caster, award)
				end
			end
		end
	end
end

concommand.Add("PostPlayerInitialSpawn", function(sender, command, arguments)
	if not sender.PostPlayerInitialSpawn then
		sender.PostPlayerInitialSpawn = true

		gamemode.Call("PlayerReady", sender)
	end
end)

function GM:DelayFeed(pl)
	if pl:IsValid() then
		pl:SendLua("TEAMS_PLAYING={"..table.concat(TEAMS_PLAYING, ",").."} TOTAL_TEAMS="..#TEAMS_PLAYING)

		if self.FlagEntity then
			for _, i in pairs(TEAMS_PLAYING) do
				if i < 9 and 0 < i then
					umsg.Start("RecFlagInfo", pl)
						umsg.Short(i)
						umsg.Vector(team.TeamInfo[i].FlagPoint)
						umsg.Entity(team.TeamInfo[i].Flag)
					umsg.End()
				end
			end
		end

		pl:SendLua("NEXT_FIGHTMODE="..NEXT_FIGHTMODE.." GAMESTATE="..tostring(GAMESTATE).." MakepMain(\"Profiles\")")

		self:InitialQuery(pl)
	end
end

function GM:PlayerReady(pl)
	if pl:IsValid() then
		timer.Simple(2, self.DelayFeed, self, pl)
	end
end

--[[function GM:GetTrialWeapon(i)
	if WEAPONS[i] and not WEAPONS[i].NoTrial then
		local durability = math.ceil((WEAPONS[i].Durability or DURABILITY_GENERIC) * 0.5)
		return {Name = tostring(WEAPONS[i].Name).." (Trial)", Class = i, Durability = durability, MaxDurability = durability, Value = -1, NoRepair = true, OnBreak = "DemoWeaponBreak", UID = GetUID()}
	end
end]]

function GM:InitialVariables(pl)
	pl.InitialSpawned = CurTime()
	pl.LastInfo = {}
	pl.LastDeath = 0
	pl.NextWallJump = 0
	pl.NextPainSound = 0
	pl.NextDashDodge = 0
	pl.NextSpawnTime = 0
	pl.NextSpectateTime = 0
	pl.CoreDamageLevel = 0
	pl.CounterSpelled = -10
	pl.AllyHPHealed = 0
	pl.DefenseThisRound = 0
	pl.AccuracyMultiplier = 1
	pl.RateOfFireMultiplier = 1
	pl.OffenseThisRound = 0
	pl.AssistsThisRound = 0
	pl.KillsThisRound = 0
	pl.MineKills = 0
	pl.KnockDownNoFric = 0
	pl.NextDodge = 0
	pl:ClearLastAttacker()
	pl.NextReqInfo = 0
	pl.m_LastKeyPressedForward = 0
	pl.ManaRegenerate = 0
	pl.MaxMana = 0
	pl.ManaBase = 0
	pl.StaminaRegenerate = 0
	pl.StaminaBase = 0
	pl.MaxStamina = 0
	pl.DesiredObserverMode = OBS_MODE_CHASE
	pl.AgilityMultiplier = 1
	pl.CastingRateMultiplier = 1
	pl.MeleeDamageMultiplier = 1
	pl.m_NextAttack = 0
	pl.VehicleTimers = {}
	pl.Loadout = {}
	pl.InventorySlotFor = {}

	pl:SprintDisable()
	--pl:SetCanWalk(false)
	pl:SetCanZoom(false)
end

function GM:PlayerInitialSpawn(pl)
	self:InitialVariables(pl)

	pl:SetTeamID(TEAM_SPECTATE)
end

function GM:InitialQuery(pl)
end

local function NoColliding(ent)
	if ent:IsValid() then
		ent:SetCollisionGroup(COLLISION_GROUP_PLAYER)
	end
end

function GM:PlayerSpawn(pl)
	if pl:IsOnFire() then
		pl:Extinguish()
	end

	pl.NextTriggerNoXHurt = 0
	pl.SpawnTime = CurTime()
	pl.NextSpell = 0
	pl.GibEffects = 0
	pl:ClearLastAttacker()
	pl:ShouldDropWeapon(false)

	if pl.ChangedGravity then
		pl:SetGravity(1)
		pl.ChangedGravity = nil
	end

	if pl:Team() == TEAM_SPECTATE then
		pl:Spectate(OBS_MODE_ROAMING)
		pl.Mana = 0
		pl.ManaRegenerate = 0
		pl.MaxMana = 0
		pl.Stamina = 0
		pl.StaminaRegenerate = 0
		pl.MaxStamina = 0
		return
	end

	pl:UnSpectate()

	if GAMESTATE ~= GAMESTATE_PLAY then
		pl:SetCollisionGroup(COLLISION_GROUP_DEBRIS_TRIGGER)
	end

	if pl.RespawnLoadout then
		pl.Loadout = pl.RespawnLoadout
		pl.RespawnLoadout = nil
	end

	if pl.RespawnAspects then
		pl.Aspects = pl.RespawnAspects
		self:AspectsChanged(pl)
		pl.RespawnAspects = nil
	end

	pl:SetMaxHealth(self:GetMaximumHealth(pl.Aspects[ASPECT_ENDURANCE]))
	pl:SetHealth(pl:GetMaxHealth())
	pl:SetMana(pl.MaxMana, true)
	pl:SetStamina(pl.MaxStamina, true)
	pl:SetSpeed(self:GetSpeed(pl.Aspects[ASPECT_SPEED]))

	if GAMESTATE == GAMESTATE_PLAY then
		pl.InventorySlotFor = {}

		local toselect
		for i, id in ipairs(pl.Loadout) do
			if i > 3 then break end

			local weapontab = WEAPONS[id]
			if weapontab and weapontab.SWEP then
				pl.InventorySlotFor[weapontab.SWEP] = i
				pl:Give(weapontab.SWEP)
				if not toselect then
					toselect = weapontab.SWEP
				end
			end
		end

		pl:Give("weapon_physgun")

		if toselect then
			pl:SelectWeapon(toselect)
		end
	end

	pl:SetModel(string.lower(player_manager.TranslatePlayerModel(pl:GetInfo("cl_playermodel"))))

	pl:sP()

	local teamstuff = team.TeamInfo[pl:Team()]
	if teamstuff then
		local teamcolor = teamstuff.Color
		pl:SetColor(teamcolor.r, teamcolor.g, teamcolor.b, 255)
	else
		pl:SetColor(255, 255, 255, 255)
	end

	if pl.SpawnPoint then
		local sp = pl.SpawnPoint
		if sp:IsValid() and sp:IsInWorld() and sp:GetTeamID() == pl:Team() then
			local pos = sp:GetPos()
			if util.TraceLine({start = pos, endpos = pos + Vector(0,0,102), mask = MASK_SOLID_BRUSHONLY}).Hit or util.TraceLine({start = pos + Vector(-20,20,0), endpos = pos + Vector(-20,20,102), mask = MASK_SOLID_BRUSHONLY}).Hit or util.TraceLine({start = pos + Vector(20,-20,0), endpos = pos + Vector(20,-20,102), mask = MASK_SOLID_BRUSHONLY}).Hit or util.TraceLine({start = pos + Vector(20,20,0), endpos = pos + Vector(20,20,102), mask = MASK_SOLID_BRUSHONLY}).Hit or util.TraceLine({start = pos + Vector(-20,-20,0), endpos = pos + Vector(-20,-20,102), mask = MASK_SOLID_BRUSHONLY}).Hit then
				pl:LMR(61)
			else
				pl:SetPos(sp:GetPos() + Vector(0, 0, 32))
				pl:SetCollisionGroup(COLLISION_GROUP_DEBRIS_TRIGGER)
				timer.Create(tostring(pl).."teleportnocollide", 1, 1, NoColliding, pl)
			end
		else
			pl.SpawnPoint = nil
			pl:LMR(38)
		end
	end
end

NDB.AddChatCommand("/resetspawn", function(sender, text)
	if sender:IsValid() and sender.SpawnPoint then
		sender.SpawnPoint = nil
		sender:PrintMessage(HUD_PRINTTALK, "You reset your spawn point.")
	end

	return ""
end, "Resets your spawn point.")

function GM:PlayerCantChangeClass(pl)
	return nil
end

concommand.Add("changeaspects", function(sender, command, arguments)
	--if #arguments ~= NUMASPECTS + NUMWEAPONSLOTS then return end -- +3 Weapons
	if not arguments[1] then return end

	arguments = string.Explode(" ", arguments[1])

	for i=1, NUMASPECTS + NUMWEAPONSLOTS do
		arguments[i] = tonumber(arguments[i]) or 0
	end

	local weps = {}
	local alreadychosen = {}
	for i = NUMASPECTS + 1, NUMASPECTS + NUMWEAPONSLOTS do
		local index = arguments[i]
		if not alreadychosen[index] then
			weps[#weps + 1] = index
			alreadychosen[index] = i
		end
	end

	local result = NormalizeAspects(arguments)

	if sender.Aspects and sender.Loadout and table.concat(result, " ") == table.concat(sender.Aspects, " ") and table.concat(weps, " ") == table.concat(sender.Loadout, " ") then return end

	if sender:Team() == TEAM_SPECTATE then
		sender.RespawnAspects = result
		sender.RespawnLoadout = weps
		GAMEMODE:PlayerFirstLoadout(sender)
	else
		sender.RespawnAspects = result
		sender.RespawnLoadout = weps
		if GAMEMODE:PlayerCanInstantRespawn(sender) then
			sender:ForceRespawn()
		else
			sender:LMG(2)
		end
	end
end)

function GM:PlayerCanInstantRespawn(pl)
	if not pl:Alive() then return false end

	for _, ent in pairs(player.GetAll()) do
		if ent.LastAttacker == pl and CurTime() <= ent.LastAttacked + 10 then
			return false
		end
	end

	if pl:IsCarrying() or pl:InVehicle() or pl.LastAttacked and CurTime() < pl.LastAttacked + 10 then
		return false
	end

	if GAMESTATE ~= GAMESTATE_BUILD then
		local plteam = pl:Team()
		for _, ent in pairs(ents.FindInSphere(pl:GetPos(), 1000)) do
			if ent:IsPlayer() and ent:Alive() and ent ~= pl and ent:Team() ~= plteam and ent:Team() ~= TEAM_SPECTATE then
				return false
			end
		end
	end

	return true
end

function GM:PlayerFirstLoadout(pl)
	local sortteams = table.Copy(TEAMS_PLAYING)
	table.sort(sortteams, SortTeams)

	local desiredteamid = sortteams[1]

	pl:SetTeam(desiredteamid)
	pl:Spawn()

	local col = team.GetColor(desiredteamid)
	PrintMessage(HUD_PRINTTALK, pl:NoParseName().." is joining the "..team.GetChatName(desiredteamid).." team.")
end

function GM:ScalePlayerDamage(pl, hitgroup, dmginfo)
end

function GM:ScaleNPCDamage(npc, hitgroup, dmginfo)
end

function GM:PlayerShouldTakeDamage(pl, attacker)
	if pl:Team() == TEAM_SPECTATE then return false end

	if pl:InVehicle() and pl:GetVehicle().Protects then
		return false
	elseif attacker.SendLua then
		return attacker == pl or attacker:Team() ~= pl:Team()
	elseif attacker.VehicleParent then
		return attacker.VehicleParent:Team() ~= pl:Team() or pl == attacker.VehicleParent.LastEject
	elseif attacker.ScriptVehicle then
		return attacker:Team() ~= pl:Team() or pl == attacker.LastEject
	elseif attacker:IsValid() then
		return attacker:GetTeamID() ~= pl:Team()
	end

	return true
end

function GM:WeaponEquip(weapon)
end

function GM:CreateNoBuildPads()
	for _, ent in pairs(ents.FindByClass("rednobuildpad")) do
		local vehpad = ents.Create("prop_vehiclepad")
		if vehpad:IsValid() then
			vehpad:SetPos(ent:GetPos() + Vector(0, 0, 16))
			vehpad:SetAngles(Angle(270,0,0))
			vehpad:SetTeamID(TEAM_RED)
			vehpad:Spawn()
			vehpad:SetColor(255, 0, 0, 255)
		end
	end

	for _, ent in pairs(ents.FindByClass("bluenobuildpad")) do
		local vehpad = ents.Create("prop_vehiclepad")
		if vehpad:IsValid() then
			vehpad:SetPos(ent:GetPos() + Vector(0, 0, 16))
			vehpad:SetAngles(Angle(270,0,0))
			vehpad:SetTeamID(TEAM_BLUE)
			vehpad:Spawn()
			vehpad:SetColor(0, 160, 255, 255)
		end
	end

	for _, ent in pairs(ents.FindByClass("greennobuildpad")) do
		local vehpad = ents.Create("prop_vehiclepad")
		if vehpad:IsValid() then
			vehpad:SetPos(ent:GetPos() + Vector(0, 0, 16))
			vehpad:SetAngles(Angle(270,0,0))
			vehpad:SetTeamID(TEAM_GREEN)
			vehpad:Spawn()
			vehpad:SetColor(0, 255, 0, 255)
		end
	end

	for _, ent in pairs(ents.FindByClass("yellownobuildpad")) do
		local vehpad = ents.Create("prop_vehiclepad")
		if vehpad:IsValid() then
			vehpad:SetPos(ent:GetPos() + Vector(0, 0, 16))
			vehpad:SetAngles(Angle(270,0,0))
			vehpad:SetTeamID(TEAM_YELLOW)
			vehpad:Spawn()
			vehpad:SetColor(255, 255, 0, 255)
		end
	end
end

local function AutoBuilding()
	local docontinue
	local ct = CurTime()
	for _, prop in pairs(ALLPROPS) do
		if prop.Destroyed and not prop.Removing and prop.PHealth and prop.PHealth > 0 then
			docontinue = true

			if not prop.NoAutoBuildTime or prop.NoAutoBuildTime < ct then
				GAMEMODE:RepairProp(prop.Owner, prop, 2)
			end
		end
	end

	if not docontinue then
		timer.Destroy("AutoBuilding")
	end
end

function GM:StartAutoBuilding()
	if not timer.IsTimer("AutoBuilding") then
		timer.Create("AutoBuilding", 0.5, 0, AutoBuilding)
	end
end

function GM:PlayerMakeProp(pl, index, materialtype)
	if GAMESTATE ~= GAMESTATE_PLAY or not pl:Alive() or pl:Team() == TEAM_SPECTATE or ENDGAME then return end

	local proptab = PROPTYPES[index]
	if not proptab then return end

	local rightgt = true
	if proptab.GameTypes then
		rightgt = false
		for _, gt in pairs(proptab.GameTypes) do
			if GAMEMODE.GameType == gt then
				rightgt = true
				break
			end
		end
	end
	if not rightgt then
		return
	end

	if GLOBALMAXPROPS <= team.GetProps(pl:Team()) then
		pl:LMR(3)
		return
	end

	local mysteam = pl:SteamID()
	if proptab.Max then
		local count = 0
		if proptab.Type == "prop_physics" then
			for _, ent in pairs(ents.FindByClass("prop_prop")) do
				if ent.Owner == mysteam and string.lower(ent:GetModel()) == proptab.Model then
					count = count + 1
					if proptab.Max <= count then
						pl:LMR(50)
						return
					end
				end
			end
		else
			for _, ent in pairs(ents.FindByClass(proptab.Type)) do
				if ent.Owner == mysteam then
					count = count + 1
					if proptab.Max <= count then
						pl:LMR(50)
						return
					end
				end
			end
		end
	end

	local myteam = pl:Team()
	if proptab.TeamMax then
		local count = 0
		if proptab.Type == "prop_physics" then
			for _, ent in pairs(ents.FindByClass("prop_prop")) do
				if ent:GetTeamID() == myteam and string.lower(ent:GetModel()) == proptab.Model then
					count = count + 1
					if proptab.Max <= count then
						pl:LMR(51)
						return
					end
				end
			end
		else
			for _, ent in pairs(ents.FindByClass(proptab.Type)) do
				if ent:GetTeamID() == myteam then
					count = count + 1
					if proptab.TeamMax <= count then
						pl:LMR(51)
						return
					end
				end
			end
		end
	end

	if proptab.CountsTowards then
		local mastergroup = proptab.CountsTowards
		local count = 0
		local personalcount = 0
		for _, ent in pairs(ents.GetAll()) do
			if ent.CountsTowards == mastergroup then
				if ent.Owner == mysteam then
					personalcount = personalcount + 1
				end
				if ent:GetTeamID() == myteam then
					count = count + 1
				end

				if proptab.TeamMax <= count then
					pl:LMR(51)
					return
				end

				if proptab.Max and proptab.Max <= personalcount then
					pl:LMR(50)
					return
				end
			end
		end
	end

	pl.NextPropSpawn = pl.NextPropSpawn or 0
	if CurTime() < pl.NextPropSpawn then return end
	pl.NextPropSpawn = CurTime() + 1

	local vStart = pl:GetShootPos()
	local vForward = pl:GetAimVector()

	local trace = {}
	trace.start = vStart
	trace.endpos = vStart + vForward * 2048
	trace.filter = pl

	local tr = util.TraceLine(trace)

	local typ = proptab.Type
	local ent = ents.Create(typ)
	if not ent:IsValid() then return end

	if proptab.Model then
		ent:SetModel(proptab.Model)
	end

	local ang = pl:EyeAngles()
	ang.yaw = ang.yaw + 180
	ang.roll = 0
	ang.pitch = 0
	if 0.95 < tr.HitNormal.z then
		ent:SetAngles(pl:GetAngles())
	else
		local ang = tr.HitNormal:Angle()
		ang.Pitch = ang.Pitch + 90
		ent:SetAngles(ang)
	end

	ent:SetPos(tr.HitPos)

	if typ == "prop_dynamic_override" then
		ent:SetKeyValue("solid", "6")
	end
	ent:SetTeamID(pl:Team())
	ent.Owner = pl:SteamID()
	local hel = proptab.PHealth
	ent.NoWater = proptab.NoWater
	ent.NoRemove = proptab.NoRemove
	ent.ReverseTerritory = proptab.ReverseTerritory
	ent.CountsTowards = proptab.CountsTowards
	if tr.Entity:IsValid() then
		ent.BasedOn = tr.Entity
	end
	ent:SetCollisionGroup(COLLISION_GROUP_DEBRIS_TRIGGER)
	ent:Spawn()
	ent:GetPhysicsObject():EnableCollisions(false)

	local entpos = tr.HitPos - ent:NearestPoint(tr.HitPos - tr.HitNormal * 512)
	entpos = tr.HitPos + entpos
	ent:SetPos(entpos)

	ent.SolidBase = proptab.SolidBase
	ent.ClusterPrevention = proptab.ClusterPrevention

	ent.PHealth = hel
	ent.MaxPHealth = hel

	local desiredresistance = GAMEMODE.StringToResistance[materialtype]
	if desiredresistance and proptab.UsableMaterials then
		for _, mat in pairs(proptab.UsableMaterials) do
			if desiredresistance == mat then
				ent.MaterialType = mat
				break
			end
		end
	end

	ent.MaterialType = ent.MaterialType or proptab.DefaultResistance
	local mat = ent.MaterialType
	if mat then
		ent.ResistanceTable = RESISTANCES[mat]
		if proptab.MaterialOverrides and proptab.MaterialOverrides[mat] then
			if proptab.MaterialOverrides[mat] ~= "" then
				ent:SetMaterial(proptab.MaterialOverrides[mat])
			end
		elseif GAMEMODE.ResistanceMaterials[mat] then
			ent:SetMaterial(GAMEMODE.ResistanceMaterials[mat])
		end
	end

	if ent:IsInFlagArea() then
		ent:EmitSound("npc/roller/mine/rmine_blip3.wav")
		ent:Remove()
		pl:LMR(29)
		return
	end

	if ent.SolidBase and (not tr.HitWorld or tr.HitSky or tr.HitNoDraw or tr.HitNormal.z < 0.9) then
		ent:EmitSound("npc/roller/mine/rmine_blip3.wav")
		ent:Remove()
		pl:PrintMessage(HUD_PRINTTALK, "That type of structure's base must be placed on solid ground.")
		return
	end

	local spawns = ents.FindByClass("info_player*")
	table.Add(spawns, ents.FindByClass("prop_spawnpoint"))
	table.Add(spawns, ents.FindByClass("gmod_player_start"))
	for _, ent2 in pairs(spawns) do
		local ent2pos = ent2:GetPos()
		for _, ent3 in pairs(ents.FindInBox(ent2pos + Vector(-17, -17, 0), ent2pos + Vector(17, 17, 73))) do
			if ent3 == ent and ent2 ~= ent then
				ent:EmitSound("npc/roller/mine/rmine_blip3.wav")
				ent:Remove()
				pl:PrintMessage(HUD_PRINTTALK, "That would be blocking a spawn point.")
				return
			end
		end
	end

	if ent.NoWater and util.PointContents(entpos) & CONTENTS_WATER == 32 then
		ent:EmitSound("npc/roller/mine/rmine_blip3.wav")
		ent:Remove()
		pl:PrintMessage(HUD_PRINTTALK, "That type of structure can't opperate in water or lava.")
		return
	end

	local trigs = ents.FindByClass("trigger_hurt*")
	table.Add(trigs, ents.FindByClass("func_disposer"))
	for _, brushent in pairs(trigs) do
		for _, findent in pairs(ents.FindInBox(brushent:LocalToWorld(brushent:OBBMins()), brushent:LocalToWorld(brushent:OBBMaxs()))) do
			if ent == findent then
				ent:EmitSound("npc/roller/mine/rmine_blip3.wav")
				ent:Remove()
				pl:PrintMessage(HUD_PRINTTALK, "You can't place props in that area.")
				return
			end
		end
	end

	for _, brush in pairs(ents.FindByClass("func_nofreeze")) do
		if ent:IsInBox(brush:OBBMins(), brush:OBBMaxs()) then
			ent:EmitSound("npc/roller/mine/rmine_blip3.wav")
			ent:Remove()
			pl:PrintMessage(HUD_PRINTTALK, "Invalid spot for placement! Probably blocking something important.")
			return
		end
	end

	if ent.ClusterPrevention then
		for _, ent2 in pairs(ents.FindInSphere(entpos, 256)) do
			if ent2 ~= ent and ent2.ClusterPrevention == ent.ClusterPrevention and ent2:GetTeamID() == ent:GetTeamID() then
				ent:EmitSound("npc/roller/mine/rmine_blip3.wav")
				ent:Remove()
				pl:PrintMessage(HUD_PRINTTALK, "The structure is too close to other friendly structures of the same frequency and is creating interference.")
				return
			end
		end
	end

	pl.NextGhost = pl.NextGhost or 0
	if CurTime() < pl.NextGhost then
		ent:EmitSound("npc/roller/mine/rmine_blip3.wav")
		ent:Remove()
		pl:PrintMessage(HUD_PRINTTALK, "You must wait "..math.ceil(pl.NextGhost - CurTime()).." seconds before spawning another ghost.")
		return
	end

	local core = team.TeamInfo[ent:GetTeamID()].Flag
	local desireddistance = entpos:Distance(team.TeamInfo[ent:GetTeamID()].FlagPoint)

	if ent.ReverseTerritory then
		for _, teamid in pairs(TEAMS_PLAYING) do
			if desireddistance < entpos:Distance(team.TeamInfo[teamid].FlagPoint) then
				ent:EmitSound("npc/roller/mine/rmine_blip3.wav")
				ent:Remove()
				pl:PrintMessage(HUD_PRINTTALK, "Can only be placed in enemy territory.")
				return
			end
		end
	end

	ent:SetColor(0, 0, 0, 60)
	ent.Destroyed = true
	ent.NoValue = true
	ent.PHealth = 0

	if ent.NoWater and 0 < ent:WaterLevel() then
		ent:EmitSound("npc/roller/mine/rmine_blip3.wav")
		ent:Remove()
		pl:PrintMessage(HUD_PRINTCENTER, "That type of prop can't be placed in liquid.")
		return
	end

	if proptab.Callback then
		if proptab.Callback(pl, ent) then
			ent:EmitSound("npc/roller/mine/rmine_blip3.wav")
			ent:Remove()
			return
		end
	end

	team.AddProps(ent:GetTeamID(), 1)
	table.insert(ALLPROPS, ent)

	local effectdata = EffectData()
		effectdata:SetOrigin(ent:GetPos())
		effectdata:SetEntity(ent)
	util.Effect("propenter", effectdata)

	pl.NextGhost = CurTime() + CRAFTER_RESPAWN
	local steamid = pl:SteamID()

	local alreadyhp = 0
	local alreadyplaced = {}
	for _, ent2 in ipairs(ALLPROPS) do
		if ent2 ~= ent and ent2.Destroyed and ent2.Owner == steamid and ent2.MaxPHealth then
			alreadyhp = alreadyhp + ent2.MaxPHealth
			if alreadyhp >= ACTIVE_BUILDINGS_MAX then
				alreadyplaced[#alreadyplaced + 1] = ent2
			end
		end
	end

	if 0 < #alreadyplaced then
		pl:LMR(69)
		for _, toremove in pairs(alreadyplaced) do
			team.AddProps(toremove:GetTeamID(), -1)
			toremove:EmitSound("npc/roller/mine/rmine_blip3.wav")
			toremove:Remove()
		end
	end

	pl.LastBuild = ent

	GAMEMODE:EvaluatePower()

	ent:Fire("precreated", "", 0)
end

function GM:PlayerMakeVehicle(pl, tab)
	if not pl:Alive() or pl:Team() == TEAM_SPECTATING or GAMESTATE ~= GAMESTATE_PLAY then return end

	if NOVEHICLES then
		pl:PrintMessage(HUD_PRINTCENTER, "Vehicles are disabled in this map.")
		return
	end

	if NOAIRVEHICLES and tab.AirVehicle then
		pl:PrintMessage(HUD_PRINTCENTER, "Air Vehicles are disabled in this map.")
		return
	end

	if NOGROUNDVEHICLES and tab.GroundVehicle then
		pl:PrintMessage(HUD_PRINTCENTER, "Ground Vehicles are disabled in this map.")
		return
	end

	if NOHOVERVEHICLES and tab.HoverVehicle then
		pl:PrintMessage(HUD_PRINTCENTER, "Hover Vehicles are disabled in this map.")
		return
	end

	local pad
	local plteam = pl:Team()
	for _, ent in pairs(ents.FindByClass("prop_vehiclepad")) do
		local teamid = ent:GetTeamID()
		if (teamid == 0 or teamid == plteam) and ent:NearestPoint(pl:GetPos()):Distance(pl:GetPos()) < 200 then
			pad = ent
			break
		end
	end

	if not pad then
		return pl:PrintMessage(HUD_PRINTTALK, "You are too far from a vehicle pad to spawn it.")
	end

	local padpos = pad:GetPos()
	local vehclass = tab.Class

	local count = 0
	for _, ent in pairs(ents.FindByClass(vehclass)) do
		if ent:Team() == plteam then
			count = count + 1
		end
	end

	if tab.StocksPerTeam <= count then
		return pl:PrintMessage(HUD_PRINTTALK, "Your team has too many of these vehicles already.")
	end

	for _, ent in pairs(ents.FindByClass("vehicle_nox*")) do
		if ent.Deployer and ent.Deployer == pl and ent:Team() == plteam then
			ent.Destroy = 0
		end
	end

	local spawnpos = padpos + Vector(0, 0, 32)

	for _, ent in pairs(ents.FindInSphere(spawnpos, 128)) do
		if string.sub(ent:GetClass(), 1, 8) == "vehicle_" then
			return pl:PrintMessage(HUD_PRINTTALK, "There is a vehicle blocking the pad.")
		end
	end

	if pl.VehicleTimers[tab.Name] and CurTime() < pl.VehicleTimers[tab.Name] then
		pl:PrintMessage(HUD_PRINTTALK, "You must wait "..math.ceil(pl.VehicleTimers[tab.Name] - CurTime()).." more seconds before spawning that vehicle type again.")
		return
	end

	if pad.ManaStorage < tab.ManaToSpawn then
		pl:PrintMessage(HUD_PRINTTALK, "The vehicle pad does not have enough Mana to spawn that vehicle.")
		return
	end

	local veh = ents.Create(vehclass)
	if veh:IsValid() then
		veh:SetPos(spawnpos + tab.CreationOffset)
		veh.Deployer = pl
		veh.DeployTime = CurTime()
		veh:Spawn()
		pad.ManaStorage = pad.ManaStorage - tab.ManaToSpawn
		veh:SetTeam(plteam)
		pl:PrintMessage(HUD_PRINTCENTER, tab.Name.." created!")
		local effectdata = EffectData()
			effectdata:SetOrigin(veh:GetPos())
			effectdata:SetEntity(veh)
		util.Effect("SpawnEffect", effectdata)
		util.Effect("building_spawn", effectdata)

		pl.VehicleTimers[tab.Name] = CurTime() + tab.RespawnTime
		umsg.Start("RecVehTimer", pl)
			umsg.String(tab.Name)
			umsg.Float(pl.VehicleTimers[tab.Name])
		umsg.End()
	end
end

concommand.Add("ccmakeprop", function(sender, command, arguments)
	if not sender:IsValid() then return end

	local index = tonumber(arguments[1])
	if not index then return end

	gamemode.Call("PlayerMakeProp", sender, index, table.concat(arguments, " ", 2) or "")
end)

-- TODO: Allow spawning of vehicles at different angles. Base on the GetForward() of the player.
concommand.Add("createvehicle", function(sender, command, arguments)
	if not sender:IsValid() then return end

	local tab = Vehicles[table.concat(arguments, " ")]
	if not tab then return end

	gamemode.Call("PlayerMakeVehicle", sender, tab)
end)

concommand.Add("reqinfo", function(sender, command, arguments)
	if CurTime() <= sender.NextReqInfo then return end
	sender.NextReqInfo = CurTime() + 0.5

	local ent = Entity(tonumber(arguments[1]) or 1)
	if ent.Info then
		local str = ent:Info(sender)
		if str and str ~= sender.LastInfo[ent] then
			sender.LastInfo[ent] = str
			umsg.Start("RecInfo", sender)
				umsg.Entity(ent)
				umsg.String(str)
			umsg.End()
		end
	end
end)

local function CC_VoteRemove(pl, ent)
	if not pl:IsValid() then return end

	if CurTime() < (pl.NextPhysReload or 0) then return end
	pl.NextPhysReload = CurTime() + 0.75

	ent = ent or pl:TraceLine(32000).Entity

	if not (ent and ent:IsValid() and ent.PHealth and not ent:IsPlayer()) then return end

	if (ent.NoRemove or ent.PHealth == 64000) and GAMESTATE == GAMESTATE_PLAY and not ent.Destroyed then
		pl:PrintMessage(HUD_PRINTCENTER, "This type of prop can't be removed during gameplay.")
		return
	end

	local entteam = ent:GetTeamID()
	if entteam ~= pl:Team() then return end

	local class = ent:GetClass()
	if class == "obelisk" or class == GAMEMODE.FlagEntity then return end

	if ent.Owner ~= pl:SteamID() and not pl:IsAdmin() or entteam ~= pl:Team() then
		ent.VoteRemove = ent.VoteRemove or {}
		ent.VoteRemove[pl:SteamID()] = true
		local count = table.Count(ent.VoteRemove)
		local needed = math.ceil(team.NumPlayers(pl:Team()) * 0.51)

		if needed <= count then
			pl:PrintMessage(HUD_PRINTCENTER, "The prop has been voted out of the world.")
			ent:EmitSound("npc/roller/mine/rmine_predetonate.wav")
			return GAMEMODE:RemoveProp(pl, ent)
		else
			local votesneeded = math.ceil(needed - count)
			if votesneeded ~= 1 then
				pl:PrintMessage(HUD_PRINTCENTER, "This prop needs "..votesneeded.." more votes to remove it.")
			else
				pl:PrintMessage(HUD_PRINTCENTER, "This prop needs 1 more vote to remove it.")
			end
		end
	else
		return GAMEMODE:RemoveProp(pl, ent)
	end
end
concommand.Add("voteremove", function(pl) CC_VoteRemove(pl) end)
NDB.AddPrivateChatCommand("/voteremove", function(pl) CC_VoteRemove(pl) return "" end, "Votes to remove the prop you are looking at.")
concommand.Add("undo", function(sender)
	if CC_VoteRemove(sender, sender.LastBuild) then
		sender.LastBuild = nil
		sender:SendLua("surface.PlaySound(\"buttons/button15.wav\")")
		sender:PrintMessage(HUD_PRINTCENTER, "Previous object undone")
	end
end)

function GM:OnPhysgunReload(weapon, pl)
	--[[local plweapons = pl:GetWeapons()
	if pl.BACKTOBUILDERWEP then
		for _, wep in pairs(plweapons) do
			if wep:GetClass() == pl.BACKTOBUILDERWEP then
				pl:SelectWeapon(pl.BACKTOBUILDERWEP)
				return
			end
		end
	end

	for _, wep in pairs(plweapons) do
		if wep.IsBuilder then
			pl:SelectWeapon(wep:GetClass())
			return
		end
	end]]

	CC_VoteRemove(pl)
end

concommand.Add("requestgametype", function(sender, command, arguments)
	if GAMEMODE.GameType then
		sender:SendLua("GAMEMODE:"..GAMEMODE.GameType.."Initialize()")
	end
end)
