util.PrecacheSound("weapons/shotgun/shotgun_dbl_fire.wav")
for _, filename in pairs(file.Find("../sound/nox/*.wav")) do
	util.PrecacheSound("nox/"..filename)
end
for _, filename in pairs(file.Find("../sound/nox/*.mp3")) do
	util.PrecacheSound("nox/"..filename)
end

util.PrecacheSound("weapons/flaregun/fire.wav")
util.PrecacheSound("ambient/fire/fire_big_loop1.wav")
util.PrecacheModel("models/props/cs_italy/orange.mdl")
util.PrecacheModel("models/Items/combine_rifle_ammo01.mdl")
util.PrecacheSound("ambient/levels/labs/electric_explosion1.wav")
util.PrecacheSound("ambient/levels/labs/electric_explosion2.wav")
util.PrecacheSound("ambient/levels/labs/electric_explosion3.wav")
util.PrecacheSound("ambient/levels/labs/electric_explosion4.wav")
util.PrecacheSound("ambient/levels/labs/electric_explosion5.wav")
util.PrecacheSound("beams/beamstart5.wav")
util.PrecacheSound("npc/waste_scanner/grenade_fire.wav")

COUNTERSPELL_CUSTOM = -1
COUNTERSPELL_DESTROY = 1
COUNTERSPELL_EXPLODE = 2

INVERSION_CUSTOM = -1
INVERSION_DESTROY = 0
INVERSION_SETOWNER = 1
INVERSION_SETOWNER_REVERSE = 2
INVERSION_SETOWNER_REVERSE_TARGET = 3
INVERSION_SETOWNER_REVERSE_TARGET_VELOCITY = 4

Spells = {}
NameToSpell = {}
NameToSpellLower = {}
if CLIENT then
	function AddSpell(name, desc, mana, stamina, words, shit, icon, inversable, hostile, requirements)
		local int = #Spells + 1
		local wordtab
		local delay = 0
		if words then
			wordtab = {}
			for i, word in ipairs(string.Explode(" ", words)) do
				table.insert(wordtab, "nox/"..word.."2.wav")
			end
			delay = #wordtab * 0.1
		end

		Spells[int] = {Name=name, Desc=desc, Mana=mana, Stamina = stamina, Words=wordtab, RawWords = words, Delay=delay, Icon=icon, Inversable=inversable, Hostile=hostile}
		if requirements then
			for k, v in pairs(requirements) do
				Spells[int][k] = v
			end
		end
		NameToSpell[name] = int
		NameToSpellLower[string.lower(name)] = int

		if icon then
			Spells[int].Texture = icon
			Spells[int].Icon = surface.GetTextureID(icon)
		end
	end
else
	SpellFunctions = {}
	function AddSpell(name, desc, mana, stamina, words, funct, shit, inversable, hostile, requirements)
		local int = #Spells + 1
		local wordtab
		local delay = 0
		if words then
			wordtab = {}
			for i, word in ipairs(string.Explode(" ", words)) do
				table.insert(wordtab, "nox/"..word.."2.wav")
			end
			delay = #wordtab * 0.1
		end

		Spells[int] = {Name=name, Desc=desc, Mana=mana, Stamina = stamina, Words=wordtab, Delay=delay, Icon=icon, Inversable=inversable, Hostile=hostile}
		if requirements then
			for k, v in pairs(requirements) do
				Spells[int][k] = v
			end
		end
		NameToSpell[name] = int
		NameToSpellLower[string.lower(name)] = int

		SpellFunctions[int] = funct
	end
end


if CLIENT then spells = {} end

AddSpell("Missiles of Magic", "Summon two magical balls of fire that home in to nearby targets.", 18, 0, "et cha un cha un", spells.MissilesOfMagic, "spellicons/missilesofmagic", nil, true, {[ASPECT_DESTRUCTION] = 0.25, [ASPECT_MIND] = 0.25})
AddSpell("Minor Heal", "Heal yourself or an ally for 6 points of health.", 20, 0, "du ru in ru", spells.MinorHeal, "spellicons/lesserheal", true, nil, {[ASPECT_HEALING] = 0.15, [ASPECT_MIND] = 0.15})
AddSpell("Lesser Heal", "Heal yourself or an ally for 12 points of health.", 20, 0, "du ru in", spells.LesserHeal, "spellicons/lesserheal", true, nil, {[ASPECT_HEALING] = 0.3, [ASPECT_HEALING] = 0.3})
AddSpell("Heal", "Heal yourself or an ally for 19 points of health.", 30, 0, "du un in ru du", spells.Heal, "spellicons/lesserheal", true, nil, {[ASPECT_HEALING] = 0.45, [ASPECT_HEALING] = 0.45})
AddSpell("Greater Heal", "Heal yourself or an ally for 26 points of health.", 30, 0, "du un in ru du ru", spells.GreaterHeal, "spellicons/greaterheal", true, nil, {[ASPECT_HEALING] = 0.65, [ASPECT_MIND] = 0.65})
AddSpell("Major Heal", "Heal yourself or an ally for 35 points of health.", 40, 0, "du un in ru du ru ru", spells.MajorHeal, "spellicons/greaterheal", true, nil, {[ASPECT_HEALING] = 0.75, [ASPECT_MIND] = 0.75})
AddSpell("Reflective Shield", "Quickly conjure a barrier that can block or deflect incoming projectiles.", 30, 0, "zo du", spells.ReflectiveShield, "spellicons/reflectiveshield", nil, true, {[ASPECT_DEFENSIVE] = 0.5, [ASPECT_MIND] = 0.5})
AddSpell("Fire Bolt", "Create a bolt of fire to engulf your enemies.", 30, 0, "zo zo un", spells.FireBolt, "spellicons/fireball", nil, true, {[ASPECT_DESTRUCTION] = 0.45, [ASPECT_MIND] = 0.45})
AddSpell("Flare", "Summon a ball of flame that seeks out nearby enemies.", 40, 0, "zo ru zo ru ru zo", spells.Flare, "spellicons/firebullet", nil, true, {[ASPECT_DESTRUCTION] = 0.45, [ASPECT_MIND] = 0.45})
AddSpell("Flame Spiral", "Summon a powerful ball of fire with an explosive force.", 40, 0, "zo zo ru un", spells.FlameSpiral, "spellicons/fireball", nil, true, {[ASPECT_DESTRUCTION] = 0.6, [ASPECT_MIND] = 0.6})
AddSpell("Electron Ball", "Create a ball of energy that discharges in a wide area on impact.", 25, 0, "du et ka et zo et", spells.ElectronBall, "spellicons/obliteration", nil, true, {[ASPECT_DESTRUCTION] = 0.3, [ASPECT_MIND] = 0.3})
AddSpell("Magic Arrow", "Conjure a weak but quick ball of fire.", 17, 0, "in zo ru", spells.MagicArrow, "spellicons/moonglow", nil, true, {[ASPECT_DESTRUCTION] = 0.15, [ASPECT_MIND] = 0.15})
AddSpell("Sparkler", "Fire a ball of energy that deals significant shock damage.", 30, 0, "du in et zo et zo", spells.Sparkler, "spellicons/sparkler", nil, true, {[ASPECT_DESTRUCTION] = 0.45, [ASPECT_MIND] = 0.45})
AddSpell("Fire Bomb", "Create a large cannister of fire that violently explodes shortly after hitting something.", 75, 0, "zo ru un in zo ru", spells.FireBomb, "spellicons/starburst", true, true, {[ASPECT_DESTRUCTION] = 0.85, [ASPECT_MIND] = 0.85})
AddSpell("Protect From Fire", "Summon two magical orbs that each reduce fire damage one time.", 30, 0, "du ka ru un et", spells.ProtectFromFire, "spellicons/protectfromfire", true, true, {[ASPECT_DEFENSIVE] = 0.4, [ASPECT_MIND] = 0.4})
AddSpell("Protect From Shock", "Summon two magical orbs that each reduce shock damage one time.", 30, 0, "du ka ru un zo", spells.ProtectFromShock, "spellicons/protectfromshock", true, true, {[ASPECT_DEFENSIVE] = 0.4, [ASPECT_MIND] = 0.4})
--AddSpell("Protect From Poison", "Summon two magical orbs that each reduce poison damage one time.", 30, 0, "du ka ru un ka", spells.ProtectFromPoison, "spellicons/protectfrompoison", true, true, {[ASPECT_DEFENSIVE] = 0.4, [ASPECT_MIND] = 0.4})
AddSpell("Protect From Cold", "Summon two magical orbs that each reduce cold damage one time.", 30, 0, "du ka ru ka et cha", spells.ProtectFromCold, "spellicons/protectfromcold", true, true, {[ASPECT_DEFENSIVE] = 0.4, [ASPECT_MIND] = 0.4})
AddSpell("Force Field", "Defends against one attack that would otherwise kill you and provides slight protection against all damage.", 60, 0, "un et zo ka cha un et zo ka cha", spells.ForceField, "spellicons/forcefield", true, true, {[ASPECT_DEFENSIVE] = 0.7, [ASPECT_MIND] = 0.7})
AddSpell("Protrusion", "Call up a prism of ice directly in front of you.", 40, 0, "ka et cha zo ru ka", spells.Protrusion, "spellicons/protrusion", nil, true, {[ASPECT_MIND] = 0.6, [ASPECT_DESTRUCTION] = 0.6})
AddSpell("Energy Bolt", "Channel a powerful stream of electricity.", 0, 0, "du ka ru et", spells.EnergyBolt, "spellicons/energybolt", nil, true, {[ASPECT_MIND]=0.45, [ASPECT_DESTRUCTION]=0.45})
AddSpell("Lightning", "Channel a stream of lightning that also arcs and hits nearby enemies.", 0, 0, "du ka et ru zo et ka zo", spells.Lightning, "spellicons/lightning", nil, true, {[ASPECT_MIND]=0.55, [ASPECT_DESTRUCTION]=0.55})
AddSpell("Anchor", "Causes anyone hit to be unable to jump for a short time.", 15, 0, "du ka ru zo zo", spells.Anchor, "spellicons/anchor", nil, true, {[ASPECT_MIND]=0.35, [ASPECT_CURSING]=0.35})
AddSpell("Slow", "Slows the movement speed of anyone hit for a short time.", 15, 0, "zo zo zo", spells.Slow, "spellicons/slow", nil, true, {[ASPECT_MIND]=0.35, [ASPECT_CURSING]=0.35})
AddSpell("Tag", "Allows you to see where a person is regardless of where they are on the map.", 15, 0, "ka et zo", spells.Tag, "spellicons/tag", nil, true, {[ASPECT_MIND]=0.15})
AddSpell("Shock", "Deal damage via static charge to anything that happens to be near you.", 30, 0, "du in cha et", spells.Shock, "spellicons/shock", nil, true, {[ASPECT_MIND]=0.5, [ASPECT_DEFENSIVE]=0.5})
AddSpell("Run", "Force anyone hit to run forward for a short time.", 20, 0, "et cha cha cha", spells.Run, "spellicons/run", nil, true, {[ASPECT_MIND]=0.5, [ASPECT_CURSING]=0.5})
AddSpell("Mana Burn", "Anyone hit has their natural mana regeneration inverted.", 25, 0, "un ka zo et", spells.ManaBurn, "spellicons/flash", nil, true, {[ASPECT_MIND]=0.7, [ASPECT_CURSING]=0.7})
AddSpell("Flash", "Create a blinding light that disorients anyone looking at or near the blast.", 35, 0, "ka zo cha un zo et", spells.Flash, "spellicons/light", nil, true, {[ASPECT_MIND]=0.35})
AddSpell("Flame Strike", "Create a very hot ball of fire that burns anyone near the blast over time.", 45, 0, "zo zo ru ru un", spells.FlameStrike, "spellicons/explosion", nil, true, {[ASPECT_MIND]=0.7, [ASPECT_DESTRUCTION]=0.7})

-- Here for other reasons

AddSpell("Stun", "Completly stop the movement of an enemy for a short time.", 1000, 0, "zo zo zo zo", spells.Stun, "spellicons/stun", nil, true, {[ASPECT_MIND] = 1000})

--[[

-- Below need to be converted to new format with stamina included + no AddAbility (or just removed).

AddSpell("Invisibility", "Make yourself invisible, so long as you stay still and niether take nor give damage.", 30, "et cha et cha", spells.Invisibility, "spellicons/invisibility", true)
AddSpell("Drain Mana", "Take the mana of all those around you while supplying yourself with your own magical energy.", 0, "un ka zo in", spells.DrainMana, "spellicons/drainmana")
AddSpell("Death Ray", "A beam of necromancy.", 80, "du du", spells.DeathRay, "spellicons/deathray", nil, true)
AddSpell("Scatterfrost", "Create a freezing ball of snow that splits in to many ice fragments.", 35, "ka et zo zo un", spells.Scatterfrost, "spellicons/scatterfrost", nil, true)
AddSpell("Meteor", "Bring flaming meteors crashing down wherever you desire.", 50, "ru ru", spells.Meteor, "spellicons/meteor", nil, true)
AddSpell("Lightning", "An accurate lightning bolt.", 30, "du in", spells.Lightning, "spellicons/lightning", nil, true)
AddSpell("Inversion", "Cause projectile-based spells near you to attack their caster.", 10, "ka in", spells.Inversion, "spellicons/inversion")
AddSpell("Pull", "Pull all nearby things towards you.", 20, "un un zo", spells.Pull, "spellicons/pull", nil, true)
AddSpell("Push", "Push all nearby things away from you.", 20, "un un un", spells.Push, "spellicons/push", nil, true)
AddAbility("Harpoon", "Shoot a harpoon to reel in foes that are too far to hit.", spells.Harpoon, "spellicons/harpoon", nil, true)
AddSpell("Force Field", "Reduce incoming damage by half until the field is destroyed.", 80, "un et zo ka cha un et zo ka cha", spells.ForceField, "spellicons/forcefield", true, true)
AddAbility("War Cry", "Emit a thunderous roar that disturbs casters and stuns the meek.", spells.WarCry, "spellicons/warcry")
AddSpell("Channel Life", "Trade your own life for mana on a 1:1 ratio.", 0, "ka zo in", spells.ChannelLife, "spellicons/channellife")
AddAbility("Berserker Charge", "Charge head long in to battle, toppling anyone in your way.", spells.BerserkerCharge, "spellicons/berserkercharge", nil, true)
AddSpell("Burn", "Create a small patch of flame where your cursor is.", 15, "zo zo un un", spells.Burn, "spellicons/burn", nil, true)
AddSpell("Toxic Cloud", "Create a cloud of toxic gas at your cursor.", 40, "ka zo ru ka", spells.ToxicCloud, "spellicons/toxiccloud", nil, true)
AddSpell("Vampirism", "Convert all damage given to others in to health.", 25, "ru du ka zo", spells.Vampirism, "spellicons/vampirism", true, true)
AddSpell("Swap Location", "Swap the position of you and another person, so long as they're in view.", 15, "zo zo un zo", spells.SwapLocation, "spellicons/swap")
AddAbility("Dragoon Flight", "Call the power of your dragon to let you sprout flaming wings for 10 seconds.", spells.DragoonFlight, "spellicons/dragoonflight", nil, true)
AddAbility("Inferno Blast", "A single powerful fire ball.", spells.DragoonFireBall, "spellicons/dragoonfireball", nil, true)
AddSpell("Sun Beam", "Create a concentrated beam of Sun light at your target.", 50, "zo ru zo ru et ru", spells.SunBeam, "spellicons/sunbeam", nil, true)
AddAbility("Night Wish", "Conceal yourself and stay hidden so long as you remain motionless.", spells.NightWish, "spellicons/nightwish")
AddAbility("Venom Blade", "Your next attack will contain a deadly poison. Be careful not to miss!", spells.VenomBlade, "spellicons/venomblade")
AddSpell("Fire Arrow", "Enchant your next arrow with fire to do area of effect damage.", 25, "zo in zo zo ru", spells.FireArrow, "spellicons/firebullet")
AddSpell("Lightning Arrow", "Enchant your next arrow with lightning to do extra damage and be 100% accurate!", 40, "zo in et du", spells.LightningArrow, "spellicons/lightningbullet")
AddSpell("Vampiric Arrow", "Enchant your next arrow to leech health.", 30, "zo in du un", spells.VampiricArrow, "spellicons/vampiricbullet")
AddSpell("Bouncer Arrow", "Enchant your next arrow to bounce off of surfaces up to 5 times!", 30, "zo in zo zo et", spells.BouncerArrow, "spellicons/bouncerbullet")
AddSpell("Silver Arrow", "Enchant your next arrow to counter all magic. Hitting an enemy removes all of thier status effects.", 30, "zo in cha ka in", spells.SilverArrow, "spellicons/silverbullet")
AddSpell("Sprite Arrow", "Enchant your next arrow to home in on enemies.", 30, "zo in et in zo", spells.SpriteArrow, "spellicons/magicbullet")
AddSpell("Scatter Arrow", "Enchant your bow to fire three arrows at once.", 35, "zo in zo zo zo zo zo du", spells.ScatterArrow, "spellicons/russianroulette")
AddSpell("Poison", "Invoke a magic poison to plague enemies.", 15, "in ka", spells.Poison, "spellicons/poison", nil, true)
AddSpell("Cure Poison", "Magically flush all toxins from yourself or an ally.", 10, "et du ka", spells.CurePoison, "spellicons/curepoison", true)
AddAbility("Evade", "Jump out of the way of danger.", spells.Evade, "spellicons/evade")
AddAbility("Eye of the Wolf", "Your eyes become like a wolf's as hidden things are brought to light.", spells.EyeOfTheWolf, "spellicons/eyeofthewolf")
AddSpell("Infravision", "Briefly reveal all things around you that are invisible.", 20, "zo cha ka et", spells.Infravision, "spellicons/infravision", true)
AddSpell("Static Ball", "Send out a bolt of free electricity that homes in on and zaps enemies.", 40, "cha ka et du ka et zo", spells.StaticBall, "spellicons/staticball", nil, true)
AddSpell("Air Hike", "Use mana to jump on thin air.", 15, "zo ka cha zo", spells.AirHike, "spellicons/run")
AddSpell("Summon Zombie", "Conjure a zombie, the sad foot soldier of the Undead.", 60, "ru ka un et zo zo ka", spells.SummonZombie, "spellicons/summonzombie", nil, true)
AddSpell("Sanctuary", "Bless a point of land with holy markings that prevent enemies from passing while healing teamates.", 50, "zo ru in zo cha cha", spells.Sanctuary, "spellicons/sanctuary")
AddSpell("Divine Bolt", "Call down the fury of Heaven on a point, doing increased damage when more targets are nearby.", 35, "et du in un", spells.DivineBolt, "spellicons/divinebolt", nil, true)
AddSpell("Star Burst", "Control a burning light that splits in to an inferno of small explosions.", 40, "zo zo in cha ru ru zo", spells.StarBurst, "spellicons/starburst2", nil, true)
AddSpell("Heal Ring", "Use an emmense amount of your mana to completely heal everyone near you!", 70, "du ru cha et un zo ka un zo et in ru", spells.HealRing, "spellicons/healring", nil, true)
AddSpell("Levitate", "Become light as a feather to hover above the ground.", 25, "ka ru zo", spells.Levitate, "spellicons/levitate")
AddSpell("Regeneration", "Gradually heal yourself or an ally over time.", 30, "du ru cha zo un", spells.Regeneration, "spellicons/regeneration", true)
AddSpell("Leech", "Steal the very life force from another being and transfer it to your own.", 40, "du et du", spells.Leech, "spellicons/leech", nil, true)
AddSpell("Typhoon", "Summon a huge whirlwind that sucks in both enemies and projectiles alike.", 75, "ka cha et in ru zo ru et du zo cha cha zo in", spells.Typhoon, "spellicons/typhoon", nil, true)
AddSpell("Flame Strike", "Engulf a small area in a magical flame.", 35, "ru ru in zo ru", spells.FlameStrike, "spellicons/explosion", nil, true)
AddSpell("Fire Sprites", "Summon two fire sprites that do their best to home in on far away targets.", 40, "in ru ru zo cha", spells.FireSprites, "spellicons/firesprites", nil, true)
AddSpell("Hex", "Curse an enemy to take 50% enhanced damage for a short time.", 40, "du cha du in", spells.Hex, "spellicons/dispelundead", nil, true)
AddSpell("Jolt", "A massive lightning storm that damages anything that happens to be under it.", 40, "et du ka in zo", spells.Jolt, "spellicons/jolt", nil, true)
AddSpell("Grapple Arrow", "Enchant your next arrow with a magical rope!", 40, "et zo et zo zo un", spells.GrappleArrow, "spellicons/grapplearrow")
]]

collectgarbage("collect")
