--[[
	Steam - Flat Default
	Derma Skin
	Ryan 'Joudoki' Lewellen
	Friday, July 11, 2008
]]--

local surface = surface
local draw = draw

local SKIN = {}

SKIN.PrintName = "Steam - Default Flat"
SKIN.Author = "Ryan Lewellen"
SKIN.DermaVersion = 1

SKIN.fontFrame	= "Default"
SKIN.fontTab = "Default"
SKIN.fontCategoryHeader	= "TabLarge"
SKIN.fontButton	= "Default"

SKIN.colPureWhite = Color(255, 255, 255, 255)
SKIN.colPureBlack = Color(0, 0, 0, 255)
SKIN.colA = Color(70, 70, 70, 255)
SKIN.colB = Color(85, 85, 85, 255)

SKIN.colButton = Color(85, 88, 82, 255)
SKIN.colButtonDepressed = Color(196, 181, 80, 255)
SKIN.colButtonUnpressed = SKIN.colPureWhite
SKIN.colButtonDisabled = SKIN.colA

SKIN.colButtonText = SKIN.colPureWhite
SKIN.colButtonTextDisabled = Color(128, 134, 126, 255)
SKIN.colButtonBorder = Color(7, 4, 12, 255)
SKIN.colButtonBorder2 = Color(85, 88, 82,255)
SKIN.colButtonBorderDisabled = Color(53, 53, 53,255)
SKIN.colButtonBorderDisabled2 = SKIN.colA
SKIN.colButtonBorderDepressed = Color(196, 181, 80, 255)

SKIN.colSysButtonText = Color(216, 222, 211, 255)
SKIN.colSysButtonBorder = SKIN.colB
SKIN.colSysButtonBorder2 = Color(7, 4, 12, 255)

SKIN.colPanelBorder = SKIN.colB
SKIN.colPanelBorder2 = Color(7, 4, 12, 255)

SKIN.colPanelListBorder = SKIN.colB
SKIN.colPanelListBorder2 = Color(7, 4, 12, 255)

SKIN.colVScrollBar = Color(7, 4, 12, 255)
SKIN.colVScrollBar2 = SKIN.colB

SKIN.colMenuBorder = Color(104, 106, 101, 255)
SKIN.colMenuBorder2 = Color(47, 49, 45, 255)

SKIN.colSchemeCheckBox = Color(255, 100, 255, 255)

SKIN.colComboBoxBorder = Color(104, 106, 101, 255)
SKIN.colComboBoxBorder2 = Color(47, 49, 45, 255)

SKIN.colTreeNode = Color(0, 0, 0, 0)
SKIN.colTreeNode2 = Color(196, 181, 80, 255)

SKIN.colTooltip = Color(47, 49, 45, 255)
SKIN.colTooltip2 = Color(104, 106, 101, 255)

SKIN.colTinyButtonDisabled = Color(0, 0, 0, 50)
SKIN.colTinyButton = SKIN.colPureBlack

SKIN.colTinyButtonText = Color(220, 236, 224, 255)
SKIN.colTinyButtonTextHovered = Color(196, 181, 80, 255)

SKIN.colNumSlider = SKIN.colA
SKIN.colNumSlider2 = Color(125, 128, 120, 255)

SKIN.colCheckBox = SKIN.colA
SKIN.colCheckBox2 = Color(7, 4, 12, 255)

SKIN.colMultiChoiceText = Color(30, 100, 200, 255)
SKIN.colMultiChoiceTextHovered = Color(196, 181, 80, 255)

SKIN.colListViewText = Color(230, 236, 234, 255)
SKIN.colListViewTextSelected = Color(196, 181, 80, 255)

SKIN.colListViewLine = Color(0, 0, 0, 0)
SKIN.colListViewLine2 = Color(196, 181, 80, 255)

SKIN.colTabActive = SKIN.colPureWhite
SKIN.colTab = Color(170, 170, 170, 155)
SKIN.colTabText = Color(216, 222, 211, 255)
SKIN.colTabTextActive = Color(196, 181, 80, 255)

SKIN.TreeNodeTextSelected = Color(196, 181, 80, 255)
SKIN.TreeNodeTextHovered = Color(196, 181, 80, 255)
SKIN.TreeNodeText = Color(230, 236, 224, 255)

function SKIN:DrawGenericBackground(x, y, w, h, color)
	draw.RoundedBox(4, x, y, w, h, color)
end

function SKIN:SetDrawColor(col)
	if not col then
		surface.SetDrawColor(255, 0, 255, 255)
		return false
	end
	surface.SetDrawColor(col.r, col.g, col.b, col.a)
	return true
end

function SKIN:DrawTitledBox(x,y,w,h,back,border,title)
	self:SetDrawColor(title)
	surface.DrawRect(x,y+1,w,21)
	surface.DrawRect(x+1, y, w-2,1)
	
	self:SetDrawColor(back)
	surface.DrawRect(x+1,y+22,w-2,h-23)
	
	self:SetDrawColor(border)
	surface.DrawRect(x,y+22,1,h-23) -- Left
	surface.DrawRect(x+1,y+h-1,w-2,1) -- Bottom
	surface.DrawRect(x+w-1,y+22,1,h-23) -- Right
end

function SKIN:DrawBorder(x,y,w,h,border,back,top,left,bottom,right)
	self:SetDrawColor(border)
	surface.DrawRect(x+1, y, w-2, 1)
	surface.DrawRect(x, y+1, 1, h-2)
	surface.DrawRect(x+1, y+h-1, w-2, 1)
	surface.DrawRect(x+w-1, y+1, 1, h-2)
	
	if back then
		self:SetDrawColor(Color((back.r + border.r) * 0.5, (back.g + border.g) * 0.5, (back.b + border.b) * 0.5, (back.a + border.a) * 0.5))
		surface.DrawRect(x+1,y+1,1,1)
		surface.DrawRect(x+w-2,y+1,1,1)
		surface.DrawRect(x+1,y+h-2,1,1)
		surface.DrawRect(x+w-2,y+h-2,1,1)
	end
end

function SKIN:DrawBorderedBox(x,y,w,h,back,border,top,left,bottom,right)
	self:SetDrawColor(back)
	surface.DrawRect(x+1,y+1,w-2,h-2)

	self:DrawBorder(x,y,w,h,border,back,top,left,bottom,right)
end

function SKIN:PaintFrame(panel)
	self:DrawTitledBox(0,0,panel:GetWide(), panel:GetTall(), Color(70,70,70,255), Color(104,106,101, 255), Color(90, 106, 80, 255))
	
	--surface.SetDrawColor(0, 0, 0, 150)
	--surface.DrawRect(0, 22, panel:GetWide(), 1)
end

function SKIN:LayoutFrame(panel)

	panel.lblTitle:SetFont(self.fontFrame)
	
	panel.btnClose:SetPos(panel:GetWide() - 22, 4)
	panel.btnClose:SetSize(18, 18)
	
	panel.lblTitle:SetPos(8, 2)
	panel.lblTitle:SetSize(panel:GetWide() - 25, 20)
end

function SKIN:PaintButton(panel)
	local w, h = panel:GetSize()
	
	-- We have to do text color updates here since scheme button isn't called on hover
	if not panel:GetDisabled() then
		if panel.Hovered or panel.Depressed or panel:GetSelected() then
			panel:SetTextColor(self.colButtonDepressed)
		else
			panel:SetTextColor(self.colButtonUnpressed)
		end
	end
	
	if panel.m_bBackground then
		if panel.m_bIsListViewHeader and panel.m_bIsListViewHeader then
			-- Just draw a background
			surface.SetDrawColor(104, 106, 101, 255)
			surface.DrawRect(0, 0, w, h)
			return
		end
	
		local col = self.colButton
		if panel:GetDisabled() then
			col = self.colButtonDisabled
		end
		surface.SetDrawColor(col.r, col.g, col.b, col.a)
		surface.DrawRect(1, 1, w-2, h-2)
	end
end

function SKIN:PaintOverButton(panel)
	local w, h = panel:GetSize()
	if panel.m_bBorder then
		local col = self.colButtonBorder
		local backColor = self.colButtonBorder2
		
		if (panel:GetDisabled()) then
			col = self.colButtonBorderDisabled
			backColor = self.colButtonBorderDisabled2
		elseif (panel.Depressed || panel:GetSelected()) then
			col = self.colButtonBorderDepressed
		elseif panel.OverrideBorder then
			col = panel.OverrideBorder
		end

		self:DrawBorder(0,0,w,h,col,backColor)
	end
end

function SKIN:SchemeButton(panel)
	panel:SetFont(self.fontButton)
	
	if (panel:GetDisabled()) then
		panel:SetTextColor(self.colButtonTextDisabled)
	else
		panel:SetTextColor(self.colButtonText)
	end
	
	DLabel.ApplySchemeSettings(panel)

end

function SKIN:PaintNoxHorizontalMenu(panel)
end

function SKIN:PaintPanel(panel)
	if panel.m_bPaintBackground then
		local w, h = panel:GetSize()
		self:DrawBorderedBox(0,0,w,h, self.colPanelBorder, self.colPanelBorder2)
	end
end

function SKIN:PaintSysButton(panel)
	if (panel.m_bDrawBackground) then
		self:DrawBorderedBox(1,1,panel:GetWide()-2, panel:GetTall()-2, self.colSysButtonBorder, self.colSysButtonBorder2)
	end
end

function SKIN:SchemeSysButton(panel)
	panel:SetFont("Marlett")
	panel:SetTextColor(self.colSysButtonText)
end

function SKIN:PaintImageButton(panel)
	self:PaintButton(panel)
end

function SKIN:PaintOverImageButton(panel)
	self:PaintOverButton(panel)
end

function SKIN:LayoutImageButton(panel)
	if (panel.m_bBorder) then
		panel.m_Image:SetPos(1, 1)
		panel.m_Image:SetSize(panel:GetWide()-2, panel:GetTall()-2)
	else
		panel.m_Image:SetPos(0, 0)
		panel.m_Image:SetSize(panel:GetWide(), panel:GetTall())
	end
end

function SKIN:PaintPanelList(panel)
	if (panel.m_bBackground) then		
		self:DrawBorderedBox(0,0,panel:GetWide(), panel:GetTall(), self.colPanelListBorder, self.colPanelListBorder2)
	end
end

function SKIN:PaintVScrollBar(panel)
	surface.SetDrawColor(70, 70, 70, 255)
	surface.DrawRect(0, 0, panel:GetWide(), panel:GetTall())
end

function SKIN:LayoutVScrollBar(panel)
	local Wide = panel:GetWide()
	local Scroll = panel:GetScroll() / panel.CanvasSize
	local BarSize = panel:BarScale() * (panel:GetTall() - (Wide * 2))
	local Track = panel:GetTall() - (Wide * 2) - BarSize
	Track = Track + 1
	
	Scroll = Scroll * Track
	
	panel.btnGrip:SetPos(0, Wide + Scroll)
	panel.btnGrip:SetSize(Wide, BarSize)
	
	panel.btnUp:SetPos(0, 0, Wide, Wide)
	panel.btnUp:SetSize(Wide, Wide)
	panel.btnUp.m_scrollbarButton = true
	
	panel.btnDown:SetPos(0, panel:GetTall() - Wide, Wide, Wide)
	panel.btnDown:SetSize(Wide, Wide)
	panel.btnDown.m_scrollbarButton = true
end

function SKIN:PaintScrollBarGrip(panel)
	self:DrawBorderedBox(1,1,panel:GetWide()-2, panel:GetTall()-2, self.colVScrollBar, self.colVScrollBar2)
end

function SKIN:PaintMenu(panel)
	surface.SetDrawColor(47, 49, 45, 255)
	surface.DrawRect(1,1,panel:GetWide()-2,panel:GetTall()-2)
end

function SKIN:PaintOverMenu(panel)
	self:DrawBorder(0,0,panel:GetWide(),panel:GetTall(), self.colMenuBorder, self.colMenuBorder2)
end

function SKIN:LayoutMenu(panel)
	local w = panel:GetMinimumWidth()
	
	for k, pnl in pairs(panel.Panels) do	
		pnl:PerformLayout()
		w = math.max(w, pnl:GetWide())	
	end

	panel:SetWide(w)
	
	local y = 0
	
	for k, pnl in pairs(panel.Panels) do	
		pnl:SetWide(w)
		pnl:SetPos(0, y)
		pnl:InvalidateLayout(true)
		
		y = y + pnl:GetTall()
	end
	
	panel:SetTall(y)
end

function SKIN:PaintMenuOption(panel)
	-- Hovering Color for Text
	if panel.Hovered then	
		panel:SetFGColor(255,255,255,255)
		if (panel.m_bBackground) then
			surface.SetDrawColor(145,134,60,255)
			surface.DrawRect(1, 1, panel:GetWide()-2, panel:GetTall()-2)
		end
	else
		panel:SetFGColor(216,222,211,255)
	end
end

function SKIN:LayoutMenuOption(panel)
	panel:SizeToContents()
	panel:SetWide(panel:GetWide() + 30)
	
	local w = math.max(panel:GetParent():GetWide(), panel:GetWide())
	panel:SetSize(w, 18)
	
	if panel.SubMenuArrow then
		panel.SubMenuArrow:SetSize(panel:GetTall(), panel:GetTall())
		panel.SubMenuArrow:CenterVertical()
		panel.SubMenuArrow:AlignRight()
	end	
end

function SKIN:SchemeMenuOption(panel)
	panel:SetFGColor(216,222,211,255)
end

function SKIN:PaintTextEntry(panel)
	if panel.m_bBackground then
		surface.SetDrawColor(94,94,94,255)
		surface.DrawRect(1, 1, panel:GetWide()-2, panel:GetTall()-2)
	end

	panel:DrawTextEntryText(panel.m_colText, panel.m_colHighlight, panel.m_colCursor)

	if panel.m_bBorder then
		self:DrawBorder(0,0,panel:GetWide(),panel:GetTall(), Color(7,4,12,255), Color(94,94,94,255))
	end	
end

function SKIN:SchemeTextEntry(panel)
	panel:SetTextColor(self.colPureWhite)
	panel:SetHighlightColor(self.colPureWhite)
	panel:SetCursorColor(self.colPureWhite)
end

function SKIN:PaintLabel(panel)
	return false
end

function SKIN:SchemeLabel(panel)
	local col

	if panel.Hovered and panel:GetTextColorHovered() then
		col = panel:GetTextColorHovered()
	else
		col = panel:GetTextColor()
	end

	if col then
		panel:SetFGColor(col.r, col.g, col.b, col.a)
	else
		panel:SetFGColor(200, 200, 200, 255)
	end
end

function SKIN:LayoutLabel(panel)
	panel:ApplySchemeSettings()
	if panel.m_bAutoStretchVertical then
		panel:SizeToContentsY()
	end
end

function SKIN:PaintCategoryHeader(panel)
	surface.SetDrawColor(196,181,80,255)

	local w,h = panel:GetSize()
	local x, y
	y = h * 0.5
	x = y
	
	surface.DrawRect(x - 4, y - 1, 8, 2)
	if not panel:GetParent():GetExpanded() then
		surface.DrawRect(x - 4, y - 4, 8, expanderSize)
	end
end

function SKIN:SchemeCategoryHeader(panel)
	local w,h = panel:GetSize()
	panel:SetTextInset(h + 2)
	panel:SetFont(self.fontCategoryHeader)
end

function SKIN:PaintCollapsibleCategory(panel)
	self:DrawBorderedBox(0,0,panel:GetWide(),panel:GetTall(),Color(43,45,41,255), Color(104,106,101))
end

function SKIN:PaintTab(panel)
	local backCol = Color(70,70,70,255)
	if panel:GetPropertySheet():GetActiveTab() == panel then
		backCol = Color(104,106,101,255)
	end
	self:DrawBorderedBox(0,0,panel:GetWide(),panel:GetTall(),backCol,Color(116,116,116,255), true,true,false,true)
end

function SKIN:SchemeTab(panel)
	panel:SetFont(self.fontTab)
	
	local ExtraInset = 10
	if panel.Image then
		ExtraInset = ExtraInset + panel.Image:GetWide()
	end

	panel:SetTextInset(ExtraInset)
	panel:SizeToContents()
	panel:SetSize(panel:GetWide() + 10, panel:GetTall() + 8)
	
	if panel:GetPropertySheet():GetActiveTab() == panel then
		panel:SetTextColor(self.colTabTextActive)
	else
		panel:SetTextColor(self.colTabText)
	end

	panel.BaseClass.ApplySchemeSettings(panel)		
end

function SKIN:LayoutTab(panel)
	panel:SetTall(22)

	if panel.Image then	
		local Diff = panel:GetTall() - panel.Image:GetTall()
		panel.Image:SetPos(7, Diff * 0.6)
		
		if panel:GetPropertySheet():GetActiveTab() == panel then
			panel.Image:SetImageColor(self.colTabActive)
		else
			panel.Image:SetImageColor(self.colTab)
		end
	end	
end

function SKIN:PaintPropertySheet(panel)
	local ActiveTab = panel:GetActiveTab()
	local Offset = 0
	if ActiveTab then Offset = ActiveTab:GetTall() end
	
	surface.SetDrawColor(104,106,101,255)
	surface.DrawRect(0, Offset, panel:GetWide(), panel:GetTall() - Offset)
end

function SKIN:PaintListViewLine(panel)
	if panel:IsSelected() or panel.Hovered then
		self:DrawBorderedBox(0, 0, panel:GetWide(), panel:GetTall(), self.colListViewLine, self.colListViewLine2)
	end
end

function SKIN:LayoutListViewLabel(panel)
	panel:SetTextInset(10)

	if panel.Line and panel.Line:IsSelected() then
		panel:SetTextColor(self.colListViewTextSelected)	
	else
		panel:SetTextColor(self.colListViewText)	
	end
end

function SKIN:SchemeListViewColumn(panel)
	panel.Header.m_bIsListViewHeader = true
end

function SKIN:PaintForm(panel)
	self:DrawBorderedBox(0,0,panel:GetWide(),panel:GetTall(),Color(43,45,41,255), Color(104,106,101))
end

function SKIN:SchemeForm(panel)
	panel.Label:SetFont("TabLarge")
	panel.Label:SetTextColor(Color(255, 255, 255, 255))
end

function SKIN:LayoutForm(panel)
end

function SKIN:LayoutMultiChoice(panel)
	panel.TextEntry:SetSize(panel:GetWide(), panel:GetTall())
	
	panel.DropButton:SetSize(panel:GetTall(), panel:GetTall())
	panel.DropButton:SetPos(panel:GetWide() - panel:GetTall(), 0)
	
	panel.DropButton:SetZPos(1)
	panel.DropButton:SetDrawBackground(false)
	panel.DropButton:SetDrawBorder(false)
	
	panel.DropButton:SetTextColor(self.colMultiChoiceText)
	panel.DropButton:SetTextColorHovered(self.colMultiChoiceTextHovered)
end

function SKIN:DrawNumberWangIndicatorText(panel, wang, x, y, number, alpha)
	local alpha = math.Clamp(alpha ^ 0.5, 0, 1) * 255
	local col = self.text_dark

	-- Highlight round numbers
	local dec = (wang:GetDecimals() + 1) * 10
	if number / dec == math.ceil(number / dec) then
		col = self.text_highlight
	end

	draw.SimpleText(number, "Default", x, y, Color(col.r, col.g, col.b, alpha))
end

function SKIN:PaintNumberWangIndicator(panel)
	if panel.m_bTop then
		surface.SetMaterial(self.texGradientUp)
	else
		surface.SetMaterial(self.texGradientDown)
	end
	
	surface.SetDrawColor(self.colNumberWangBG)
	surface.DrawTexturedRect(0, 0, panel:GetWide(), panel:GetTall())

	local wang = panel:GetWang()
	local CurNum = math.floor(wang:GetFloatValue())
	local Diff = CurNum - wang:GetFloatValue()

	local Increment = wang:GetTall()
	local Offset = Diff * Increment
	local EndPoint = panel:GetTall()
	local Num = CurNum
	
	if panel.m_bTop then
		local Min = wang:GetMin()
		local Start = panel:GetTall() + Offset
		local End = Increment * -1
		
		CurNum = CurNum + 1
		for y = Start, Increment * -1, End do
			CurNum = CurNum - 1
			if CurNum < Min then break end		
			self:DrawNumberWangIndicatorText(panel, wang, 3, y + 5, CurNum, y / panel:GetTall())
		end
	else
		local Max = wang:GetMax()
		for y = Offset - Increment, panel:GetTall(), Increment do
			self:DrawNumberWangIndicatorText(panel, wang, 3, y + 5, CurNum, 1 - ((y+Increment) / panel:GetTall()))
			CurNum = CurNum + 1
			if CurNum > Max then break end
		end
	end
end

function SKIN:LayoutNumberWangIndicator(panel)
	panel.Height = 200

	local wang = panel:GetWang()
	local x, y = wang:LocalToScreen(0, wang:GetTall())
	
	if panel.m_bTop then
		y = y - panel.Height - wang:GetTall()
	end
	
	panel:SetPos(x, y)
	panel:SetSize(wang:GetWide() - wang.Wanger:GetWide(), panel.Height)
end

function SKIN:PaintCheckBox(panel)
	local w, h = panel:GetSize()
	self:DrawBorderedBox(0, 0, w, h, self.colCheckBox, self.colCheckBox2)
end

function SKIN:SchemeCheckBox(panel)
	panel:SetTextColor(self.colSchemeCheckBox)
	DSysButton.ApplySchemeSettings(panel)
end

function SKIN:PaintSlider(panel)
end

function SKIN:PaintNumSlider(panel)
	local w, h = panel:GetSize()
	self:DrawBorderedBox(2, h * 0.25, w - 4, h * 0.5, self.colNumSlider, self.colNumSlider2)
end

function SKIN:PaintComboBox(panel)
	self:DrawBorderedBox(0,0,panel:GetWide(),panel:GetTall(), self.colComboBoxBorder, self.colComboBoxBorder2)
end

function SKIN:PaintComboBoxItem(panel)
	if panel:GetSelected() then
		surface.SetDrawColor(196,181,80,255)
		local w,h = panel:GetSize()
		surface.DrawRect(0, 0, 2, h)
	elseif panel.Hovered then
		surface.SetDrawColor(196,181,80,255)
	else
		surface.SetDrawColor(217,223,212,255)
	end
end

function SKIN:SchemeComboBoxItem(panel)
	panel:SetTextColor(217, 223, 212, 255)
end

function SKIN:PaintBevel(panel)
	local w, h = panel:GetSize()

	surface.SetDrawColor(255, 255, 255, 255)
	surface.DrawOutlinedRect(0, 0, w-1, h-1)
	
	surface.SetDrawColor(0, 0, 0, 255)
	surface.DrawOutlinedRect(1, 1, w-1, h-1)
end

function SKIN:PaintTree(panel)
	if panel.m_bBackground then
		surface.SetDrawColor(50, 50, 50, 255)
		surface.DrawRect(0,0,panel:GetWide(), panel:GetTall())
	end
end

function SKIN:PaintTinyButton(panel)
	if panel.Hovered then
		panel:SetTextColor(self.colTinyButtonTextHovered)
	else
		panel:SetTextColor(self.colTinyButtonText)
	end

	--w, h = panel:GetSize()
end

function SKIN:SchemeTinyButton(panel)
	panel:SetFont("Default")
	
	if (panel:GetDisabled()) then
		panel:SetTextColor(self.colTinyButtonDisabled)
	else
		panel:SetTextColor(self.colTinyButton)
	end
	
	DLabel.ApplySchemeSettings(panel)
	
	panel:SetFont("DefaultSmall")
end

function SKIN:PaintTreeNodeButton(panel)
	if panel.m_bSelected then
		panel:SetTextColor(self.TreeNodeTextSelected)
		self:DrawBorderedBox(0, 0, panel:GetWide(), panel:GetTall(), self.colTreeNode, self.colTreeNode2)
	elseif panel.Hovered then
		panel:SetTextColor(self.TreeNodeTextHovered)
	else
		panel:SetTextColor(self.TreeNodeText)
	end
	
	if panel:GetParent().m_bExpanded and not panel.m_bSelected then
		-- Expanded
		surface.SetDrawColor(121, 126, 121, 255)
		surface.DrawRect(panel:GetParent():GetIndentSize(), panel:GetTall() - 2, panel:GetWide(), 1)
	end
end

function SKIN:SchemeTreeNodeButton(panel)
	DLabel.ApplySchemeSettings(panel)
end

function SKIN:PaintTooltip(panel)
	DisableClipping(true)
	local w, h = panel:GetSize()
	self:DrawBorderedBox(0, 0, panel:GetWide(),panel:GetTall(), self.colTooltip, self.colTooltip2)
	panel:DrawArrow(0, 0)
	DisableClipping(false)
end

derma.DefineSkin("steam_flat", "Steam Flat - Default", SKIN)

if DTooltip and DTooltip.SetContents then
	DTooltip.SetContents = function(self, panel, bDelete)
		panel:SetParent(self)

		self.Contents = panel
		self.DeleteContentsOnClose = bDelete or false
	
		if self.Contents.SetTextColor then
			self.Contents:SetTextColor(color_white)
			self.Contents:SetFont("DefaultSmall")
		end

		self.Contents:SizeToContents()
		self:InvalidateLayout(true)
		self.Contents:SetVisible(false)
	end
end
