local function MainMenuPaint(self)
	surface.SetDrawColor(0, 0, 0, 180 + math.abs(math.sin(RealTime() * 0.25)) * 20)
	-- TODO: Make this better.

	if GetConVarNumber("nox_hud_nohud") ~= 0 then
		local screenscale = GAMEMODE:GetScreenScale()
		GAMEMODE:DrawDeathNotice(w * 0.95, 16, screenscale)
		GAMEMODE:DrawGameTypeHUD(CurTime(), screenscale)
	end
end

function GM:CreateMainMenu()
	if self.MainMenu and self.MainMenu:Valid() then
		self.MainMenu:SetVisible(true)
		self.MainMenu:MakePopup()
		return
	end

	local screenscale = self:GetScreenScale()

	local background = vgui.Create("DPanel")
	self.MainMenu = background
	background:SetSize(w, h)
	background.Paint = MainMenuPaint

	local y = math.ceil(h * 0.3333)

	-- TODO: Graphical logo?
	surface.SetFont("NoXiousLogoText")
	local texw, texh = surface.GetTextSize("W")
	local logobg = vgui.Create("DPanel", background)
	logobg:SetSize(w, texh + 16 * screenscale)
	logobg:SetPos(0, y)
	local logo = EasyLabel(logobg, self.Name, "NoXiousLogoText", COLOR_LIMEGREEN)
	logo:SetPos(logobg:GetWide() * 0.5 - logo:GetWide() * 0.5, 8 * screenscale)
	y = y + logobg:GetTall() + screenscale * 64

	local gtlab = EasyLabel(background, tostring(self.GameType), "NoXiousLogoSubText", COLOR_WHITE)
	gtlab:SetPos(w * 0.5 - logo:GetWide() * 0.5, y)
	y = y + gtlab:GetTall() + screenscale * 64

	for i, name in ipairs(GAMEMODE.MenuTabs) do
		y = y + (gamemode.Call("CreateMenu"..name, background) or 0) + screenscale * 8
	end

	y = y + 64

	local maplab = EasyLabel(background, "You are playing on "..GetWorldEntity():GetModel(), nil, COLOR_WHITE)
	maplab:SetPos(w * 0.75 - maplab:GetWide(), y)

	background:MakePopup()
end

function GM:CreateMenuHelp(background)
	local button = EasyButton(background, "Help")
	button:SetTooltip("View the in-game help guide. Connects to the NoXiousNet Wiki.")
	button.DoClick = function(btn) NDB.OpenWiki("NoXious") end

	return button:GetTall()
end
