pAspectsIcon = "VGUI/spawnmenu/npc"
pAspectsTooltip = "Change your current profile's Aspects.\nSimply drag the bar of an aspect with your mouse to change it."

function MakepAspects()
	if pAspects then return	end

	local Window = vgui.Create("DPanel")
	Window:SetSize(784, 540)
	Window:SetCursor("pointer")
	pAspects = Window
end

--[[local function AspectTexThink(self)
	local newvalue = self:GetParent():GetValue() * 100
	if self:GetValue() ~= newvalue then
		self:SetValue(newvalue)
	end
end]]

local CurrentDragging
function BuildpAspects()
	pAspects.AspectSliders = {}

	local halfw = pAspects:GetWide() * 0.5

	local dumb = WordBox(pAspects, "You can change a profile's aspects by using your mouse to drag the bars.", "DefaultBold", color_white)
	dumb:SetPos(halfw - dumb:GetWide() * 0.5, pAspects:GetTall() * 0.7 - 8 - dumb:GetTall())

	local quota = vgui.Create("AspectQuota", pAspects)
	quota:SetSize(148, 48)
	quota:SetPos(halfw - quota:GetWide() * 0.5, 8)
	quota.AspectTable = MENUPROFILE

	local cutoff = pAspects:GetTall() * 0.7 - 8
	local slidersize = halfw * 0.5 - 8
	local x = 8
	local y = 64

	for i, tab in ipairs(ASPECTS) do
		local slider = vgui.Create("AspectBar", pAspects)
		slider:SetSize(slidersize, 52)
		slider:SetPos(x, y)
		slider.Aspect = i
		slider.AspectTable = MENUPROFILE
		if ASPECTS[i].Description then
			slider:SetTooltip(ASPECTS[i].Description)
		end

		--[[local lab = EasyLabel(slider, tab.Name):SetPos(4, 4)

		local tex = vgui.Create("DTextEntry", slider)
		tex:SetWide(48)
		tex:SetPos(slider:GetWide() - 52, 4)
		tex:SetEnterAllowed(false)
		tex:SetEditable(false)
		tex:SetValue(slider:GetValue() * 100)
		tex:SetNumeric(true)
		tex.Aspect = i
		tex.Think = AspectTextThink
		slider.TextEntry = tex]]

		table.insert(pAspects.AspectSliders, slider)

		local slidertall = slider:GetTall() + 2
		y = y + slidertall
		if cutoff <= y + slidertall then
			y = 64
			x = x + slidersize + 8
		end
	end

	local summary = vgui.Create("AspectSummary", pAspects)
	summary:SetPos(8, pAspects:GetTall() * 0.7)
	summary:SetSize(pAspects:GetWide() - 16, pAspects:GetTall() * 0.3 - 8)
	summary:RefreshAspects()
	pAspects.AspectSummary = summary
end

local PANEL = {}
function PANEL:Init()
	self.BarHeight = 14
	self.Aspect = 1
end

function PANEL:GetValue()
	return self.AspectTable.Aspects[self.Aspect]
end

function PANEL:Paint()
	derma.SkinHook("Paint", "Panel", self)

	local tab = self.AspectTable

	if not tab or not tab.Aspects then return end

	local telldrag
	if self.Dragging then
		local x, y = self:ScreenToLocal(gui.MousePos())
		tab.Aspects[self.Aspect] = math.min(math.max(math.ceil(((x + 2) / (self:GetWide() - 2)) * 100) * 0.01, 0), 1)
		NormalizeAspects(tab.Aspects, self.Aspect)
	end

	local asp = tab.Aspects[self.Aspect] or 0.5
	local totalbarwid = self:GetWide() - 8
	local barwid = totalbarwid * asp
	local barhei = self.BarHeight
	local bary = self:GetTall() - self.BarHeight - 4

	draw.DrawText(ASPECTS[self.Aspect].Name, "DefaultBold", 4, 4, color_white, TEXT_ALIGN_LEFT)

	surface.SetDrawColor(0, 0, 0, 180)
	surface.DrawRect(4, bary, totalbarwid, barhei)
	surface.SetDrawColor(255 - 255 * asp, 255 * asp, 10, 255)
	surface.DrawRect(4, bary, barwid, barhei)
	surface.SetDrawColor(255, 200, 0, 180)
	surface.DrawOutlinedRect(4, bary, totalbarwid, barhei)
	if 0 < barwid and barwid < 1 then
		surface.SetDrawColor(255, 255, 255, 255)
		surface.DrawLine(4 + barwid, bary, 4 + barwid, bary + barhei)
		surface.DrawRect(2 + barwid, bary + barhei * 0.5 - 2, 4, 4)
	end

	surface.SetFont("DefaultBold")
	local texw, texh = surface.GetTextSize(10000)
	surface.SetDrawColor(60, 60, 60, 255)
	surface.DrawRect(totalbarwid - texw, 4, texw, texh + 4)
	surface.SetDrawColor(110, 90, 10, 255)
	surface.DrawOutlinedRect(totalbarwid - texw, 4, texw, texh + 4)
	draw.SimpleText(tab.Aspects[self.Aspect] * 100, "DefaultBold", (totalbarwid - texw) + texw * 0.5, 6 + texh * 0.5, color_white, TEXT_ALIGN_CENTER, TEXT_ALIGN_CENTER)
end

function PANEL:OnMousePressed(mc)
	local x, y = self:ScreenToLocal(gui.MousePos())
	if 4 <= x and x <= self:GetWide() - 4 and self:GetTall() - self.BarHeight - 4 <= y and y <= self:GetTall() - 4 then
		for _, pa in pairs(pAspects.AspectSliders) do
			pa:MouseCapture(false)
			pa.Dragging = nil
		end
		self.Dragging = true
		self:MouseCapture(true)
	end
end

function PANEL:OnMouseReleased(mc)
	if self.Dragging then
		self.Dragging = nil
		self:MouseCapture(false)
		pAspects.AspectSummary:RefreshAspects()
		pProfiles.AspectSummary:RefreshAspects()
		SaveProfile(MENUPROFILE)
		if MySelf:Team() ~= TEAM_SPECTATE then
			pProfiles.SpawnButton:DoClick(true)
		end
	end
end

function PANEL:Think()
end
vgui.Register("AspectBar", PANEL, "DPanel")
PANEL = nil

local PANEL = {}
function PANEL:GetValue()
	local tab = self.AspectTable

	if not tab or not tab.Aspects then return 0 end

	local current = 0
	for i=1, NUMASPECTS do
		if tab.Aspects[i] then
			current = current + tab.Aspects[i]
		end
	end

	return math.max(0, ASPECTS_MAX - current)
end

function PANEL:Paint()
	derma.SkinHook("Paint", "Panel", self)

	local val = self:GetValue()
	local mul = (ASPECTS_MAX - val) / ASPECTS_MAX
	draw.DrawText(math.ceil(val * 100), "ChatFont", self:GetWide() * 0.5, self:GetTall() * 0.5, Color(255 - mul * 255, mul * 255, 30, 255), TEXT_ALIGN_CENTER)
	draw.DrawText("Points Remaining", "DefaultBold", self:GetWide() * 0.5, 4, color_white, TEXT_ALIGN_CENTER)
end
vgui.Register("AspectQuota", PANEL, "DPanel")
PANEL = nil

local PANEL = {}
function PANEL:Think()
end

function PANEL:Paint()
	derma.SkinHook("Paint", "Panel", self)
end

function PANEL:RefreshAspects()
	if self.ListView and self.ListView:Valid() then
		self.ListView:Remove()
		self.ListView = nil
	end

	local aspects = MENUPROFILE.Aspects

	local pw, ph = self:GetSize()

	local ctrl = vgui.Create("DListView", self)
	self.ListView = ctrl
	ctrl:SetSize(pw - 16, ph - 16)
	ctrl:SetPos(8, 8)
	ctrl:AddColumn("Quality"):SetMinWidth(pw * 0.5)
	ctrl:AddColumn("Value")
	ctrl:AddLine("Maximum health", tostring(GAMEMODE:GetMaximumHealth(aspects[ASPECT_ENDURANCE]))):SetTooltip("Directly depends on Endurance. Can range from 75 to 125.")
	ctrl:AddLine("Maximum stamina", tostring(GAMEMODE:GetMaximumStamina(aspects[ASPECT_WILL]))):SetTooltip("Directly depends on Will. Can range from 30 to 100.")
	ctrl:AddLine("Maximum mana", tostring(GAMEMODE:GetMaximumMana(aspects[ASPECT_MIND]))):SetTooltip("Directly depends on Mind. Can range from 30 to 150.")
	ctrl:AddLine("Stamina regeneration per second", tostring(math.floor(GAMEMODE:GetStaminaRegeneration(aspects[ASPECT_RECOVERY]) * 100) * 0.01)):SetTooltip("Directly depends on Recovery. Can range from 5 to 10.")
	ctrl:AddLine("Casting delay multiplier", tostring(math.floor(GAMEMODE:GetCastingRate(aspects[ASPECT_INTELLIGENCE]) * 100) * 0.01)):SetTooltip("Directly depends on Intelligence. Less is better. Can range from 1.75 to 0.75.")
	ctrl:AddLine("Mana regeneration per second", tostring(math.floor(GAMEMODE:GetManaRegeneration(aspects[ASPECT_SPIRIT]) * 100) * 0.01)):SetTooltip("Directly depends on Spirit. Can range from 0.5 to 4.5.")
	ctrl:AddLine("Mana retained from Obelisks", tostring(math.floor(GAMEMODE:GetObeliskManaRetainer(aspects[ASPECT_SPIRIT]) * 100).."%")):SetTooltip("Directly depends on Spirit. Can range from 25% to 125%")
	ctrl:AddLine("Gun rate of fire", tostring(math.floor(GAMEMODE:GetRateOfFireMultiplier(aspects[ASPECT_INSTINCT]) * 100).."%")):SetTooltip("Directly depends on Instinct. Can range from 75% to 125%.")
	ctrl:AddLine("Gun bullet stray", tostring(math.floor(GAMEMODE:GetRateOfFireMultiplier(aspects[ASPECT_ACCURACY]) * 100).."%")):SetTooltip("Directly depends on Accuracy. Less is better. Can range from 75% to 150%.")
	ctrl:AddLine("Gun mana use", tostring(math.floor(GAMEMODE:GetGunManaMultiplier(aspects[ASPECT_GUNMASTERY]) * 100).."%")):SetTooltip("Directly depends on Gunmastery. Less is better. Can range from 50% to 200%.")
	ctrl:AddLine("Building rate", tostring(math.floor(GAMEMODE:GetBuildingRateMultiplier(aspects[ASPECT_CRAFTSMANSHIP]) * 100).."%")):SetTooltip("Directly depends on Craftsmanship. Can range from 50% to 150%.")
	ctrl:AddLine("Melee damage", tostring(math.floor(GAMEMODE:GetMeleeDamageMultiplier(aspects[ASPECT_MIGHT]) * 100).."%")):SetTooltip("Directly depends on Might. Can range from 75% to 125%.")
	ctrl:AddLine("Jump power", tostring(math.floor(GAMEMODE:GetMeleeDamageMultiplier(aspects[ASPECT_AGILITY]) * JUMPPOWER_DEFAULT))):SetTooltip("Directly depends on Agility. Can range from 288 to 432.")
	ctrl:AddLine("Run speed", tostring(math.floor(GAMEMODE:GetSpeed(aspects[ASPECT_SPEED])))):SetTooltip("Directly depends on Speed. Can range from 200 to 250.")
	ctrl:AddLine("Wall-jump and dodge power", tostring(math.floor(GAMEMODE:GetAgilityMultiplier(aspects[ASPECT_AGILITY]) * 100).."%")):SetTooltip("Directly depends on Agility. Can range from 80% to 120%.")

	if GAMEMODE:GetCanWallJump(aspects[ASPECT_DEXTERITY]) then
		ctrl:AddLine("Can wall-jump", "Yes"):SetTooltip("Requires ".. DEXTERITY_WALLJUMP * 100 .." Dexterity.")
	else
		ctrl:AddLine("Can wall-jump", "No"):SetTooltip("Requires ".. DEXTERITY_WALLJUMP * 100 .." Dexterity.")
	end
	if GAMEMODE:GetCanDodge(aspects[ASPECT_DEXTERITY]) then
		ctrl:AddLine("Can dodge", "Yes"):SetTooltip("Requires ".. DEXTERITY_DODGE * 100 .." Dexterity.")
	else
		ctrl:AddLine("Can dodge", "No"):SetTooltip("Requires ".. DEXTERITY_DODGE * 100 .." Dexterity.")
	end
	if GAMEMODE:GetCanSprint(aspects[ASPECT_DEXTERITY]) then
		ctrl:AddLine("Can sprint", "Yes"):SetTooltip("Requires ".. DEXTERITY_SPRINT * 100 .." Dexterity.")
		ctrl:AddLine("Sprint speed", tostring(math.floor(GAMEMODE:GetSprintSpeed(aspects[ASPECT_SPEED])))):SetTooltip("Directly depends on Speed. Can range from 325 to 400.")
	else
		ctrl:AddLine("Can sprint", "No"):SetTooltip("Requires ".. DEXTERITY_SPRINT * 100 .." Dexterity.")
	end
	if GAMEMODE:GetCanWallRun(aspects[ASPECT_DEXTERITY]) then
		ctrl:AddLine("Can wall-run", "Yes"):SetTooltip("Requires ".. DEXTERITY_WALLRUN * 100 .." Dexterity.")
		ctrl:AddLine("Wall-run speed", tostring(math.floor(GAMEMODE:GetWallRunSpeed(aspects[ASPECT_SPEED])))):SetTooltip("Directly depends on Speed. Can range from 350 to 450.")
	else
		ctrl:AddLine("Can wall-run", "No"):SetTooltip("Requires ".. DEXTERITY_WALLRUN * 100 .." Dexterity.")
	end
	if GAMEMODE:GetCanWallVert(aspects[ASPECT_DEXTERITY]) then
		ctrl:AddLine("Can Wall Vert", "Yes"):SetTooltip("Requires ".. DEXTERITY_WALLVERT * 100 .." Dexterity.")
		ctrl:AddLine("Wall Vert speed", tostring(math.floor(GAMEMODE:GetWallVertSpeed(aspects[ASPECT_SPEED])))):SetTooltip("Directly depends on Speed. Can range from 275 to 350.")
	else
		ctrl:AddLine("Can Wall Vert", "No"):SetTooltip("Requires ".. DEXTERITY_WALLVERT * 100 .." Dexterity.")
	end
end

vgui.Register("AspectSummary", PANEL, "DPanel")
PANEL = nil
