local RememberX, RememberY = ScrW() * 0.5, ScrH() * 0.57
local Scroll = 0

local function MakeProp(btn)
	RunConsoleCommand("CCMakeProp", btn.PropType, btn.MaterialType)
	surface.PlaySound("buttons/button14.wav")
	RememberX, RememberY = gui.MousePos()
	Scroll = pBuilder.PanelList.VBar:GetScroll()
	pBuilder:Remove()
	pBuilder = nil
end

--[[local function neutralpaint(p)
	surface.SetDrawColor(65, 65, 65, 255)
	surface.DrawRect(0, 0, p:GetWide(), p:GetTall())
	surface.SetDrawColor(150, 150, 150, 150)
	surface.DrawOutlinedRect(0, 0, p:GetWide(), p:GetTall())

	return true
end

local function noitempaint(p)
	surface.SetDrawColor(65, 65, 65, 255)
	surface.DrawRect(0, 0, p:GetWide(), p:GetTall())
	surface.SetDrawColor(255, 0, 0, 150)
	surface.DrawOutlinedRect(0, 0, p:GetWide(), p:GetTall())

	return true
end

local function hasitempaint(p)
	surface.SetDrawColor(65, 65, 65, 255)
	surface.DrawRect(0, 0, p:GetWide(), p:GetTall())
	surface.SetDrawColor(20, 255, 20, 150)
	surface.DrawOutlinedRect(0, 0, p:GetWide(), p:GetTall())

	return true
end]]

local function MaterialOnSelect(p, index, value, data)
	RunConsoleCommand("noxbuildingmaterial_"..p.PropName, value)
	p:GetParent().MaterialType = value
	p:GetParent():GetParent().MaterialType = value
end

local function AddBuilding(tab, index, panw)
	local Panel = vgui.Create("DButton")
	Panel:SetText(" ")
	Panel.PropType = index
	Panel.DoClick = MakeProp

	local button = vgui.Create("SpawnIcon", Panel)
	button:SetPos(4, 0)
	button:SetModel(tab.Model)
	button:SetMouseInputEnabled(false)
	--button.PropType = index
	--button.OnMousePressed = MakeProp

	local bsizex, bsizey = button:GetSize()
	local xx, yy = bsizex + 32, 8

	surface.SetFont("noxnetnormal")
	local txt = tab.Name
	local tsizex, tsizey = surface.GetTextSize(txt)
	local label = vgui.Create("DLabel", Panel)
	label:SetSize(tsizex, tsizey)
	label:SetFont("noxnetnormal")
	label:SetText(txt)
	label:SetTextColor(color_white)
	label:SetPos(xx, yy)
	yy = yy + tsizey

	if tab.UsableMaterials then
		local ctrl = vgui.Create("DMultiChoice", Panel)
		ctrl:SetEditable(false)
		ctrl:SetPos(panw - 116, 32 - ctrl:GetTall() * 0.5)
		ctrl.PropName = tab.CleanName
		local desmat = GetConVarString("noxbuildingmaterial_"..tab.CleanName)
		if desmat and desmat ~= "" and table.HasValue(GAMEMODE.ResistanceToString, desmat) then
			ctrl:SetText(desmat)
			ctrl.MaterialType = desmat
			Panel.MaterialType = desmat
		else
			ctrl:SetText("Default")
			ctrl.MaterialType = "Default"
			Panel.MaterialType = "Default"
		end
		ctrl:AddChoice("Default")
		for i, typ in pairs(tab.UsableMaterials) do
			ctrl:AddChoice(GAMEMODE.ResistanceToString[typ])
		end
		ctrl:SetWide(100)
		ctrl.OnSelect = MaterialOnSelect
	end

	local txt = tab.PHealth.." Health"
	surface.SetFont("DefaultSmall")
	local tsizex, tsizey = surface.GetTextSize(txt)
	local label = vgui.Create("DLabel", Panel)
	label:SetSize(tsizex, tsizey)
	label:SetFont("DefaultSmall")
	label:SetText(txt)
	label:SetTextColor(COLOR_LIMEGREEN)
	label:SetPos(xx, yy)
	yy = yy + tsizey

	if tab.ClusterPrevention then
		local txt = "Operating frequency: "..tab.ClusterPrevention
		local tsizex, tsizey = surface.GetTextSize(txt)
		local label = vgui.Create("DLabel", Panel)
		label:SetSize(tsizex, tsizey)
		label:SetFont("DefaultSmall")
		label:SetText(txt)
		label:SetTextColor(COLOR_YELLOW)
		label:SetPos(xx, yy)
		yy = yy + tsizey
	end

	if tab.SolidBase then
		local txt = "Must be placed on solid ground"
		local tsizex, tsizey = surface.GetTextSize(txt)
		local label = vgui.Create("DLabel", Panel)
		label:SetSize(tsizex, tsizey)
		label:SetFont("DefaultSmall")
		label:SetText(txt)
		label:SetTextColor(COLOR_RED)
		label:SetPos(xx, yy)
		yy = yy + tsizey
	end

	if tab.NoWater then
		local txt = "Inoperable in water"
		local tsizex, tsizey = surface.GetTextSize(txt)
		local label = vgui.Create("DLabel", Panel)
		label:SetSize(tsizex, tsizey)
		label:SetFont("DefaultSmall")
		label:SetText(txt)
		label:SetTextColor(COLOR_RED)
		label:SetPos(xx, yy)
		yy = yy + tsizey
	end

	Panel:SetTall(64)
	Panel:SetPos(8, 0)

	return Panel
end

local Category = PROPTYPES[1].Group
local DoCatSwitch
local function CategorySwitch(p, index, value, data)
	RememberX, RememberY = gui.MousePos()
	Category = value
	DoCatSwitch = true
	surface.PlaySound("buttons/button9.wav")
	Scroll = 0
	MakepBuilder()
end

local CategoryTips = {}
CategoryTips["Props"] = "Experiment with different material types to get the best defenses for the right situations."
CategoryTips["Deployables"] = "None of these require Mana in order to function."
CategoryTips["Powered Deployables"] = "These all require Mana from the resource management category to work!"
CategoryTips["Resource Management"] = "Resources are vital to your team's success and are required to power some deployables."
CategoryTips["Auto-Turret"] = "Auto-turrets must be powered by Mana and have a barrel attached in order to work."
CategoryTips["Mountable Turret"] = "These turrets must be powered by Mana, have a barrel attached, and have an operator to work."

function MakepBuilder()
	if pBuilder then
		if DoCatSwitch then
			DoCatSwitch = nil
			pBuilder:Remove()
			pBuilder = nil
		else
			pBuilder:SetVisible(true)
			pBuilder:MakePopup()
			return
		end
	end

	local pw = 800
	local ph = 600

	local Window = vgui.Create("DFrame")
	Window:SetSize(pw, ph)
	Window:Center()
	Window:SetTitle(" ")
	Window:SetVisible(true)
	Window:SetDraggable(false)
	Window:SetDeleteOnClose(false)
	Window:SetCursor("pointer")
	Window:SetKeyboardInputEnabled(false)
	Window:MakePopup()
	pBuilder = Window

	local cpanel = vgui.Create("DPanel", Window)
	local txt = CategoryTips[Category]
	if txt then
		surface.SetFont("Default")
		local tsizex, tsizey = surface.GetTextSize(txt)
		cpanel:SetSize(tsizex + 16, tsizey + 8)
		local label = vgui.Create("DLabel", cpanel)
		label:SetPos(8, cpanel:GetTall() * 0.5 - tsizey * 0.5)
		label:SetSize(tsizex, tsizey)
		label:SetFont("Default")
		label:SetText(txt)
		label:SetTextColor(color_white)
		cpanel:SetVisible(true)
		cpanel:SetMouseInputEnabled(false)
		cpanel:SetKeyboardInputEnabled(false)
		cpanel:SetPos(pw * 0.5 - (tsizex * 0.5 + 8), 40)
	end

	local categories = {}
	local alreadyadded = {}
	for _, tab in ipairs(PROPTYPES) do
		if not alreadyadded[tab.Group] then
			table.insert(categories, tab.Group)
			alreadyadded[tab.Group] = true
		end
	end

	local ctrl = vgui.Create("DMultiChoice", Window)
	ctrl:SetEditable(false)
	ctrl:SetPos(16, 8)
	ctrl:SetText(Category)
	for i, category in ipairs(categories) do
		ctrl:AddChoice(category)
	end
	ctrl:SetWide(170)
	ctrl.OnSelect = CategorySwitch

	local wb = WordBox(Window, "Select a building category")
	wb:SetPos(188, 8)

	--[[local yy = 52
	for i, category in ipairs(categories) do
		local button = vgui.Create("DButton", Window)
		if Category == category then
			button:SetPos(16, yy)
			button:SetFGColorEx(COLOR_YELLOW)
		else
			button:SetPos(8, yy)
		end
		button:SetSize(pw * 0.35, 28)
		button:SetText(category)
		button.Category = category
		button.DoClick = CategorySwitch
		yy = yy + 32
	end]]

	local PanelList = vgui.Create("DPanelList", Window)
	PanelList:EnableVerticalScrollbar()
	PanelList:EnableHorizontal(false)
	local panellistwidth = pw - 32
	PanelList:SetSize(panellistwidth, ph - 250)
	PanelList:SetPos(16, 72)
	PanelList:SetSpacing(2)
	Window.PanelList = PanelList

	local wb = WordBox(Window, "Damage Multipliers")
	wb:SetPos(pw * 0.5 - wb:GetWide() * 0.5, ph - 175)

	local ctrl = vgui.Create("DListView", Window)
	ctrl:AddColumn("Material"):SetMinWidth(128)
	for i, typ in ipairs(DAMAGETYPES) do
		ctrl:AddColumn(typ)
	end
	for x, mat in ipairs(GAMEMODE.ResistanceToString) do
		local tabmul = {}
		for i, typ in ipairs(DAMAGETYPES) do
			table.insert(tabmul, (RESISTANCES[x][i] or 1) * 100 .. "%")
		end
		ctrl:AddLine(mat, unpack(tabmul))
	end
	ctrl:SetSize(pw - 32, 140)
	ctrl:SetPos(16, ph - 148)

	for i, tab in SortedPairsByMemberValue(PROPTYPES, "Name") do
		if not tab.NoCrafter and (tab.Group == Category or not tab.Group) then
			local rightgt = true
			if tab.GameTypes then
				rightgt = false
				for _, gt in pairs(tab.GameTypes) do
					if GAMEMODE.GameType == gt then
						rightgt = true
						break
					end
				end
			end
			if rightgt then
				PanelList:AddItem(AddBuilding(tab, i, panellistwidth))
			end
		end
	end

	--timer.Simple(0, PanelList.VBar.SetScroll, PanelList.VBar, Scroll)

	--gui.SetMousePos(RememberX, RememberY)
end
