pHelpIcon = "gui/info"
pHelpTooltip = "An encyclopedia of the combined knowledge of all players"

function MakepHelp()
	if pHelp then return end

	pHelp = NDB.GetWikiPanel()
end

GM.Wiki = {
	{Name="General",
		{Name="Introduction", Article="NoXious"},
		{Name="Movement",
			{Name="Sprint", Article="Sprint"},
			{Name="Long Jump", Contents="While sprinting, press JUMP. A long jump drains "..STAMINA_LONGJUMP.." stamina. You must have ".. DEXTERITY_SPRINT * 100 .." Dexterity to use sprint. If you try long jumping without enough stamina then you'll jump much shorter!"},
			{Name="Dodge", Contents="Hold STRAFE LEFT or STRAFE RIGHT and press JUMP to dodge. Dodging drains "..STAMINA_DODGE.." stamina. You can also use this to escape being stunned for an increased stamina cost. You must have ".. DEXTERITY_DODGE * 100 .." Dexterity to dodge."},
			{Name="Wall Jump", Contents="If you face a wall and press JUMP while you're in the air, you can perform a wall jump. Wall jumping drains "..STAMINA_WALLJUMP.." stamina. You must have ".. DEXTERITY_WALLJUMP * 100 .." of Dexterity to wall jump."},
			{Name="Wall Reflection", Contents="If you face a wall at an angle and perform a wall jump, you'll also perform a wall reflection which allows control over jump direction."},
			{Name="Wall Run", Contents="While in the air, press FORWARD + FORWARD quickly and hold down FORWARD while you're adjacent to a wall to wall run. Wall running drains "..STAMINA_WALLRUNNING.." stamina per second. You must have ".. DEXTERITY_WALLRUN * 100 .." Dexterity to Wall Run."},
			{Name="Wall Vert", Contents="While facing a wall, press FORWARD + FORWARD quickly and hold down FORWARD to Wall Vert. Wall Verting drains "..STAMINA_WALLVERTING.." stamina per second. You must have ".. DEXTERITY_WALLVERT * 100 .." Dexterity to Wall Vert."},
			{Name="Knockdown Recovery", Contents="Press JUMP while knocked down to quickly get up. If you hit a wall before you get up, you'll be wall slammed so do it quickly!"}
		},
		{Name="New Combat Mechanics",
			{Name="Physical Bullets", Contents="Almost all projectiles, including gun bullets, are physical and take time to travel to their target. This makes dodging and evasion a very essential skill to learn."},
			{Name="Knockdown", Article="Knockdown"},
			{Name="Wall and Ceiling Pin", Contents="If you're knocked down and you hit a wall or ceiling with enough force then you'll be pinned to the surface for a second and then fall down. You are completely helpless until you touch the ground in this state. Hitting the surface itself will also deal damage."}
		},
		{Name="Capture the Flag", Article="Capture_the_flag"},
		{Name="Blitz", Article="Blitz"}
	},
	{Name="Weapons",
		{Name="Melee Weapons",
			{Name="Gladradus", Article="Gladradus"},
			{Name="Frotchet", Article="Frotchet"},
			{Name="Ripdash", Article="Ripdash"},
			{Name="Heater", Article="Heater"}
		},
		{Name="Guns",
			{Name="Zagger", Article="Zagger"},
			{Name="Stigma", Article="Stigma"},
			{Name="Repeater", Article="Repeater"},
			{Name="Nailer", Article="Nailer"},
			{Name="Sweeper", Article="Sweeper"},
		},
		{Name="Building Tools",
			{Name="Builder A-1", Article="Builder_A-1"}
		},
		{Name="Magic Weapons",
			{Name="Apprentice Wand", Article="Apprentice_Wand"},
			{Name="Apprentice Staff", Article="Apprentice_Staff"},
		}
	}
}

do
	local addtab = {Name = "Aspects"}
	for i, tab in SortedPairsByMemberValue(table.Copy(ASPECTS), "Name") do
		addtab[#addtab + 1] = {Name = tab.Name, Article = string.Replace(tab.Name, " ", "_")}
	end
	table.insert(GM.Wiki, addtab)

	local addtab = {Name = "Spells"}
	for i, tab in SortedPairsByMemberValue(table.Copy(Spells), "Name") do
		addtab[#addtab + 1] = {Name = tab.Name, Article = string.Replace(tab.Name, " ", "_")}
	end
	table.insert(GM.Wiki, addtab)
end

function BuildpHelp()
end
