pLoadoutIcon = "VGUI/spawnmenu/swep"
--pLoadoutTooltip = "Change your current profile's loadout, shop for new weapons, or repair your current weapons."
pLoadoutTooltip = "Change your current profile's loadout."

function MakepLoadout()
	if pLoadout then return end

	local Window = vgui.Create("DPanel")
	Window:SetSize(784, 540)
	Window:SetCursor("pointer")
	pLoadout = Window
end

local function EquipInSlot(self)
	MENUPROFILE.Loadout[self.Slot] = self.ID

	for i=1, NUMWEAPONSLOTS do
		if i ~= self.Slot and self.ID == MENUPROFILE.Loadout[i] then
			MENUPROFILE.Loadout[i] = 0
		end
	end

	SaveProfile(MENUPROFILE)

	MySelf:ChatPrint("Use the "..self.Slot.." button on your keyboard to switch to that weapon.")

	if MySelf:Team() ~= TEAM_SPECTATE then
		pProfiles.SpawnButton:DoClick(true)
	end

	self:GetParent():Remove()
end

local function EquipDoClick(self)
	local id = self.ID
	local tab = WEAPONS[id]
	if tab then
		local pw = 620

		local fram = vgui.Create("DFrame")
		fram:SetWide(pw)
		fram:SetTitle("Equip")

		local y = 40
		local ezlab = EasyLabel(fram, "Which slot do you want to equip the "..tab.Name.." in?")
		ezlab:SetPos(pw * 0.5 - ezlab:GetWide() * 0.5, y)
		y = y + ezlab:GetTall() + 8
		local originaly = y

		local spacing = pw / (NUMWEAPONSLOTS + 1)
		for i=1, NUMWEAPONSLOTS do
			y = originaly
			local x = spacing * i

			local weptab
			local mdl
			local name = "Nothing"

			local current = MENUPROFILE.Loadout[i]
			if current then
				local invtab = WEAPONS[current]
				if invtab then
					mdl = invtab.Model
					name = invtab.Name
				end
			end

			local mdlpanel = vgui.Create("DPanel", fram)
			mdlpanel:SetSize(64, 64)
			mdlpanel:SetPos(x - mdlpanel:GetWide() * 0.5, y)
			if mdl then
				local pan2 = vgui.Create("DModelPanel", mdlpanel)
				pan2:SetSize(64, 64)
				pan2:SetModel(mdl)
				if weptab then
					if weptab.LookAt then
						pan2:SetLookAt(weptab.LookAt)
					end
					if weptab.CamPos then
						pan2:SetCamPos(weptab.CamPos)
					end
					if weptab.Tooltip then
						pan2:SetTooltip(weptab.Tooltip)
					end
				end
			end
			y = y + mdlpanel:GetTall() + 8

			local namlab = EasyLabel(fram, name, "noxnetnormal")
			namlab:SetPos(x - namlab:GetWide() * 0.5, y)
			y = y + namlab:GetTall() + 8

			local button = EasyButton(fram, "Slot "..i, 8, 4)
			button:SetPos(x - button:GetWide() * 0.5, y)
			button.ID = id
			button.Slot = i
			button.DoClick = EquipInSlot
			y = y + button:GetTall() + 8
		end

		local cannewbut = EasyButton(fram, "Cancel", 8, 4)
		cannewbut:SetPos(pw * 0.5 - cannewbut:GetWide() * 0.5, y)
		cannewbut.DoClick = function()
			fram:Remove()
		end
		y = y + cannewbut:GetTall()

		fram:SetTall(8 + y)
		fram:Center()
		fram:MakePopup()
	end
end

local blanktable = {}

local function funcCancel() end

function BuildpLoadout()
	--local listw = pLoadout:GetWide() * 0.5 - 16
	local listw = pLoadout:GetWide() - 16

	local wb = WordBox(pLoadout, "Inventory", "DefaultBold")
	wb:SetPos(8 + listw * 0.5 - wb:GetWide() * 0.5, 24)

	local listh = pLoadout:GetTall() - 40 - wb:GetTall()

	local PanelList = vgui.Create("DPanelList", pLoadout)
	PanelList:EnableVerticalScrollbar(true)
	PanelList:SetPos(8, 40 + wb:GetTall())
	PanelList:SetSize(listw, listh)
	pLoadout.List = PanelList
	PanelList.RefreshList = function(me)
		for _, item in pairs(me:GetItems()) do
			me:RemoveItem(item)
		end

		for i, weapontab in ipairs(WEAPONS) do
			local newpanel = vgui.Create("DPanel", PanelList)
			local npwid = PanelList:GetWide() - 16
			newpanel:SetSize(npwid, 72)
			if weapontab.Tooltip then
				newpanel:SetTooltip(weapontab.Tooltip)
			end
			PanelList:AddItem(newpanel)

			local namelab = EasyLabel(newpanel, weapontab.Name, "noxnetnormal", color_white)
			namelab:SetPos(72, 4)

			local mdlpanel = vgui.Create("DPanel", newpanel)
			mdlpanel:SetSize(64, 64)
			mdlpanel:SetPos(4, 4)
			local mdl = weapontab.Model
			if mdl then
				local pan2 = vgui.Create("DModelPanel", mdlpanel)
				pan2:SetSize(64, 64)
				pan2:SetModel(mdl)
				pan2:SetLookAt(weapontab.LookAt)
				pan2:SetCamPos(weapontab.CamPos)
				pan2:SetMouseInputEnabled(false)
			end

			local x = npwid - 4

			if weapontab.Type == TYPE_WEAPON then
				local usebutton = EasyButton(newpanel, "Equip", 8, 4)
				x = x - usebutton:GetWide()
				usebutton:SetPos(x, 4)
				usebutton.ID = i
				usebutton.DoClick = EquipDoClick
				x = x - 4
			end
		end
	end
	PanelList:RefreshList()
end
