pOptionsIcon = "gui/silkicons/wrench"
pOptionsTooltip = "Edit settings for performance and gameplay."

function MakepOptions()
	if pOptions then return end

	local Window = vgui.Create("DPanel")
	Window:SetSize(784, 540)
	Window:SetCursor("pointer")
	pOptions = Window
end

function BuildpOptions()
	local list = vgui.Create("DPanelList", pOptions)
	list:EnableVerticalScrollbar()
	list:EnableHorizontal(false)
	list:SetSize(784 - 16, 540 - 16)
	list:SetPos(8, 8)
	list:SetPadding(8)
	list:SetSpacing(4)

	local check = vgui.Create("DCheckBoxLabel", pOptions)
	check:SetText("Draw motion blur while stunned")
	check:SetConVar("noxious_drawmotionblur_stun")
	check:SizeToContents()
	list:AddItem(check)

	local check = vgui.Create("DCheckBoxLabel", pOptions)
	check:SetText("Draw motion blur while knocked down")
	check:SetConVar("noxious_drawmotionblur_knockdown")
	check:SizeToContents()
	list:AddItem(check)

	local check = vgui.Create("DCheckBoxLabel", pOptions)
	check:SetText("Draw motion blur while dodging")
	check:SetConVar("noxious_drawmotionblur_dodge")
	check:SizeToContents()
	list:AddItem(check)

	local check = vgui.Create("DCheckBoxLabel", pOptions)
	check:SetText("Draw motion blur while sprinting")
	check:SetConVar("noxious_drawmotionblur_sprint")
	check:SizeToContents()
	list:AddItem(check)

	local check = vgui.Create("DCheckBoxLabel", pOptions)
	check:SetText("Draw motion blur while wall running")
	check:SetConVar("noxious_drawmotionblur_wallrun")
	check:SizeToContents()
	list:AddItem(check)

	local check = vgui.Create("DCheckBoxLabel", pOptions)
	check:SetText("Movie HUD - Don't show health, spells selection, etc.")
	check:SetConVar("nox_hud_moviehud")
	check:SizeToContents()
	list:AddItem(check)

	local check = vgui.Create("DCheckBoxLabel", pOptions)
	check:SetText("No HUD - Don't show anything.")
	check:SetConVar("nox_hud_nohud")
	check:SizeToContents()
	list:AddItem(check)

	local check = vgui.Create("DCheckBoxLabel", pOptions)
	check:SetText("Hide the NoXiousNet account box unless the chat is up")
	check:SetConVar("nox_accountbox_hideunlesschatting")
	check:SizeToContents()
	list:AddItem(check)

	local check = vgui.Create("DCheckBoxLabel", pOptions)
	check:SetText("Display 'Press JUMP to get up!' notice")
	check:SetConVar("nox_hud_drawgetup")
	check:SizeToContents()
	list:AddItem(check)

	local check = vgui.Create("DCheckBoxLabel", pOptions)
	check:SetText("Display player hats, auras, etc.")
	check:SetConVar("nox_displayhats")
	check:SizeToContents()
	list:AddItem(check)

	local slider = vgui.Create("DNumSlider", pOptions)
	slider:SetDecimals(2)
	slider:SetMinMax(0, 1)
	slider:SetConVar("nox_forcefieldopacity")
	slider:SetText("Force Field opacity")
	slider:SizeToContents()
	list:AddItem(slider)

	local slider = vgui.Create("DNumSlider", pOptions)
	slider:SetDecimals(0)
	slider:SetMinMax(0, 3)
	slider:SetConVar("_nox_effectquality")
	slider:SetText("Particle density (default: 2)")
	slider.OnValueChanged = function(slid, val)
		RunConsoleCommand("nox_effectquality", val, 1)
	end
	slider:SizeToContents()
	list:AddItem(slider)

	local button = EasyButton(pOptions, "Restore HUD Defaults", 0, 8)
	button.DoClick = GAMEMODE.RestoreHUDDefaults
	list:AddItem(button)

	local slider = vgui.Create("DNumSlider", pOptions)
	slider:SetDecimals(2)
	slider:SetMinMax(0, 1)
	slider:SetConVar("nox_hud_newhealth_x")
	slider:SetText("Health bar X position")
	slider:SizeToContents()
	slider:SetWide(150)
	list:AddItem(slider)

	local slider = vgui.Create("DNumSlider", pOptions)
	slider:SetDecimals(2)
	slider:SetMinMax(0, 1)
	slider:SetConVar("nox_hud_newhealth_y")
	slider:SetText("Health bar Y position")
	slider:SizeToContents()
	slider:SetWide(150)
	list:AddItem(slider)

	local slider = vgui.Create("DNumSlider", pOptions)
	slider:SetDecimals(0)
	slider:SetMinMax(0, 2)
	slider:SetConVar("nox_hud_newhealth_align")
	slider:SetText("Health bar alignment")
	slider:SizeToContents()
	slider:SetWide(150)
	list:AddItem(slider)

	local slider = vgui.Create("DNumSlider", pOptions)
	slider:SetDecimals(2)
	slider:SetMinMax(0, 1)
	slider:SetConVar("nox_hud_newstamina_x")
	slider:SetText("Stamina bar X position")
	slider:SizeToContents()
	slider:SetWide(150)
	list:AddItem(slider)

	local slider = vgui.Create("DNumSlider", pOptions)
	slider:SetDecimals(2)
	slider:SetMinMax(0, 1)
	slider:SetConVar("nox_hud_newstamina_y")
	slider:SetText("Stamina bar Y position")
	slider:SizeToContents()
	slider:SetWide(150)
	list:AddItem(slider)

	local slider = vgui.Create("DNumSlider", pOptions)
	slider:SetDecimals(0)
	slider:SetMinMax(0, 2)
	slider:SetConVar("nox_hud_newstamina_align")
	slider:SetText("Stamina bar alignment")
	slider:SizeToContents()
	slider:SetWide(150)
	list:AddItem(slider)

	local slider = vgui.Create("DNumSlider", pOptions)
	slider:SetDecimals(2)
	slider:SetMinMax(0, 1)
	slider:SetConVar("nox_hud_newmana_x")
	slider:SetText("Mana bar X position")
	slider:SizeToContents()
	slider:SetWide(150)
	list:AddItem(slider)

	local slider = vgui.Create("DNumSlider", pOptions)
	slider:SetDecimals(2)
	slider:SetMinMax(0, 1)
	slider:SetConVar("nox_hud_newmana_y")
	slider:SetText("Mana bar Y position")
	slider:SizeToContents()
	slider:SetWide(150)
	list:AddItem(slider)

	local slider = vgui.Create("DNumSlider", pOptions)
	slider:SetDecimals(0)
	slider:SetMinMax(0, 2)
	slider:SetConVar("nox_hud_newmana_align")
	slider:SetText("Mana bar alignment")
	slider:SizeToContents()
	slider:SetWide(150)
	list:AddItem(slider)

	local slider = vgui.Create("DNumSlider", pOptions)
	slider:SetDecimals(2)
	slider:SetMinMax(0, 1)
	slider:SetConVar("nox_hud_statusbar_x")
	slider:SetText("Status bar X position")
	slider:SizeToContents()
	slider:SetWide(150)
	list:AddItem(slider)

	local slider = vgui.Create("DNumSlider", pOptions)
	slider:SetDecimals(2)
	slider:SetMinMax(0, 1)
	slider:SetConVar("nox_hud_statusbar_y")
	slider:SetText("Status bar Y position")
	slider:SizeToContents()
	slider:SetWide(150)
	list:AddItem(slider)

	local slider = vgui.Create("DNumSlider", pOptions)
	slider:SetDecimals(2)
	slider:SetMinMax(0, 1)
	slider:SetConVar("nox_hud_spellmenu_x")
	slider:SetText("Spell menu X position")
	slider:SizeToContents()
	slider:SetWide(150)
	list:AddItem(slider)

	local slider = vgui.Create("DNumSlider", pOptions)
	slider:SetDecimals(2)
	slider:SetMinMax(0, 1)
	slider:SetConVar("nox_hud_spellmenu_y")
	slider:SetText("Spell menu Y position")
	slider:SizeToContents()
	slider:SetWide(150)
	list:AddItem(slider)

	local check = vgui.Create("DCheckBoxLabel", pOptions)
	check:SetText("Large spell icons")
	check:SetConVar("nox_hud_largespellicons")
	check:SizeToContents()
	list:AddItem(check)

	local slider = vgui.Create("DNumSlider", pOptions)
	slider:SetDecimals(2)
	slider:SetMinMax(0, 1)
	slider:SetConVar("nox_hud_ammo_y")
	slider:SetText("Ammo display Y position")
	slider:SizeToContents()
	slider:SetWide(150)
	list:AddItem(slider)

	local slider = vgui.Create("DNumSlider", pOptions)
	slider:SetDecimals(2)
	slider:SetMinMax(0, 1)
	slider:SetConVar("nox_hud_ammo_x")
	slider:SetText("Ammo display X position")
	slider:SizeToContents()
	slider:SetWide(150)
	list:AddItem(slider)
end
