pProfilesIcon = "VGUI/spawnmenu/save"
pProfilesTooltip = "Create, delete, and load profiles."

function MakepProfiles()
	if pProfiles then return end

	local Window = vgui.Create("DPanel")
	Window:SetSize(784, 540)
	Window:SetCursor("pointer")
	pProfiles = Window
end

function BuildpProfiles()
	local PanelList = vgui.Create("DPanelList", pProfiles)
	PanelList:EnableVerticalScrollbar()
	PanelList:EnableHorizontal(false)
	local panellistwidth = 150
	local halfpanellistwidth = panellistwidth * 0.5
	PanelList:SetSize(panellistwidth, 360)
	PanelList:SetPos(8, 48)
	PanelList:SetSpacing(1)

	local wb = WordBox(pProfiles, "Saved Profiles")
	wb:SetPos(8 + halfpanellistwidth - wb:GetWide() * 0.5, 44 - wb:GetTall())

	local wb2 = WordBox(pProfiles, "Player Model")
	wb2:SetPos(691 - wb2:GetWide() * 0.5, 44 - wb2:GetTall())

	local but = EasyButton(pProfiles, "Spawn using this profile", 8, 4)
	pProfiles.SpawnButton = but
	but:SetWide(panellistwidth)
	local x, y = PanelList:GetPos()
	y = y + PanelList:GetTall() + 4
	but:SetPos(8 + halfpanellistwidth - but:GetWide() * 0.5, y)
	but.DoClick = function(b, fromaspects)
		local tosend = MENUPROFILE.Aspects
		for i=1, NUMASPECTS do
			tosend[i] = math.ceil((tosend[i] or 0) * 100) * 0.01
		end
		for i = NUMASPECTS + 1, NUMASPECTS + NUMWEAPONSLOTS do
			tosend[i] = MENUPROFILE.Loadout[i - NUMASPECTS]
		end

		if MySelf:Team() == TEAM_SPECTATE then
			timer.Simple(0.5, RunConsoleCommand, "changeaspects", table.concat(tosend, " "))
		else
			RunConsoleCommand("changeaspects", table.concat(tosend, " "))
		end
		if not fromaspects then
			RunConsoleCommand("cl_playermodel", MENUPROFILE.Model or "kliener")
			pMain:SetVisible(false)
		end
	end
	but.OldPaint = but.Paint
	but.Paint = function(me)
		if not me.OverrideBorder then
			me.OverrideBorder = Color(100, 60, 20, 255)
		end

		me.OverrideBorder.r = math.sin(RealTime() * 21) * 100 + 155

		me:OldPaint()
	end
	y = y + but:GetTall() + 4

	local but2 = EasyButton(pProfiles, "Create new profile", 8, 4)
	but2:SetTooltip("Create a new profile using the default as a template.")
	but2:SetWide(panellistwidth)
	but2:SetPos(8 + halfpanellistwidth - but2:GetWide() * 0.5, y)
	but2.DoClick = function(me)
		local pw = 400
		local ph = 150

		local fram = vgui.Create("DFrame")
		fram:SetSize(pw, ph)
		fram:Center()
		fram:SetTitle("Create a new profile")
		--fram:SetBackgroundBlur(2)

		local ezlab = EasyLabel(fram, "Enter a name for this profile. Only letters, numbers, underscores, and spaces!", "Default")
		ezlab:SetPos(pw * 0.5 - ezlab:GetWide() * 0.5, 40)

		local tex = vgui.Create("DTextEntry", fram)
		tex:SetWide(pw - 16)
		tex:SetPos(8, 48 + ezlab:GetTall())

		local cannewbut = EasyButton(fram, "Cancel", 8, 4)
		cannewbut:SetPos(pw * 0.5 + 8, ph - cannewbut:GetTall() - 8)
		cannewbut.DoClick = function()
			fram:Remove()
		end

		local newbut = EasyButton(fram, "OK", 8, 4)
		newbut:SetWide(math.max(newbut:GetWide(), cannewbut:GetWide()))
		newbut:SetPos(pw * 0.5 - newbut:GetWide() - 8, ph - newbut:GetTall() - 8)
		newbut.DoClick = function(nb)
			local text = tex:GetValue()
			if string.lower(text) == "default" or string.len(text) <= 1 or string.find(text, "[%c%z%^%$%(%)%%%.%[%]%*%+%-%?]") or file.Exists("noxaspects/"..text..".txt") then
				surface.PlaySound("buttons/button8.wav")
				return
			end

			CreateProfile(text)
			ASPECTFILE = text
			PanelList:Refresh()
			surface.PlaySound("buttons/button3.wav")
			LoadAspects(ASPECTFILE, MENUPROFILE)
			pLoadout.List:RefreshList()
			--pLoadout.ShopList:RefreshList()
			pProfiles.MDLPanel:RefreshCurrentModel()
			fram:Remove()
		end
		tex.OnEnter = function() newbut:DoClick() end

		fram:MakePopup()
	end
	y = y + but2:GetTall() + 4

	local but3 = EasyButton(pProfiles, "Clone this profile", 8, 4)
	but3:SetTooltip("Create a new profile using this profile as a template.")
	but3:SetWide(panellistwidth)
	but3:SetPos(8 + halfpanellistwidth - but3:GetWide() * 0.5, y)
	but3.DoClick = function(me)
		local pw = 400
		local ph = 150

		local fram = vgui.Create("DFrame")
		fram:SetSize(pw, ph)
		fram:Center()
		fram:SetTitle("Clone a profile")
		--fram:SetBackgroundBlur(2)

		local ezlab = EasyLabel(fram, "Enter a name for this profile. Only letters, numbers, underscores, and spaces!", "Default")
		ezlab:SetPos(pw * 0.5 - ezlab:GetWide() * 0.5, 40)

		local tex = vgui.Create("DTextEntry", fram)
		tex:SetWide(pw - 16)
		tex:SetPos(8, 48 + ezlab:GetTall())

		local cannewbut = EasyButton(fram, "Cancel", 8, 4)
		cannewbut:SetPos(pw * 0.5 + 8, ph - cannewbut:GetTall() - 8)
		cannewbut.DoClick = function()
			fram:Remove()
		end

		local newbut = EasyButton(fram, "OK", 8, 4)
		newbut:SetWide(math.max(newbut:GetWide(), cannewbut:GetWide()))
		newbut:SetPos(pw * 0.5 - newbut:GetWide() - 8, ph - newbut:GetTall() - 8)
		newbut.DoClick = function(nb)
			local text = tex:GetValue()
			if string.lower(text) == "default" or string.len(text) <= 1 or string.find(text, "[%c%z%^%$%(%)%%%.%[%]%*%+%-%?]") or file.Exists("noxaspects/"..text..".txt") then
				surface.PlaySound("buttons/button8.wav")
				return
			end

			CreateProfile(text, ASPECTFILE)
			ASPECTFILE = text
			PanelList:Refresh()
			surface.PlaySound("buttons/button3.wav")
			LoadAspects(ASPECTFILE, MENUPROFILE)
			pLoadout.List:RefreshList()
			--pLoadout.ShopList:RefreshList()
			pProfiles.MDLPanel:RefreshCurrentModel()
			fram:Remove()
		end
		tex.OnEnter = function() newbut:DoClick() end

		fram:MakePopup()
	end
	y = y + but3:GetTall() + 4

	local but4 = EasyButton(pProfiles, "Delete current profile", 8, 4)
	but4:SetTooltip("Delete the current profile. default can't be deleted.")
	but4:SetWide(panellistwidth)
	but4:SetPos(8 + halfpanellistwidth - but4:GetWide() * 0.5, y)
	but4.DoClick = function(me)
		if ASPECTFILE == "default" then return end

		local pw = 400
		local ph = 120

		local fram = vgui.Create("DFrame")
		fram:SetSize(pw, ph)
		fram:Center()
		fram:SetTitle("Delete profile")
		--fram:SetBackgroundBlur(2)

		local ezlab = EasyLabel(fram, "Are you sure you want to delete the profile: "..ASPECTFILE.."?", "Default")
		ezlab:SetPos(pw * 0.5 - ezlab:GetWide() * 0.5, 40)

		local cannewbut = EasyButton(fram, "Cancel", 8, 4)
		cannewbut:SetPos(pw * 0.5 + 8, ph - cannewbut:GetTall() - 8)
		cannewbut.DoClick = function()
			fram:Remove()
		end

		local newbut = EasyButton(fram, "OK", 8, 4)
		newbut:SetWide(math.max(newbut:GetWide(), cannewbut:GetWide()))
		newbut:SetPos(pw * 0.5 - newbut:GetWide() - 8, ph - newbut:GetTall() - 8)
		newbut.DoClick = function(nb)
			if string.lower(ASPECTFILE) ~= "default" then
				file.Delete("noxaspects/"..ASPECTFILE..".txt")
				ASPECTFILE = "default"
				PanelList:Refresh()
				LoadAspects(ASPECTFILE, MENUPROFILE)
				pLoadout.List:RefreshList()
				--pLoadout.ShopList:RefreshList()
				pProfiles.MDLPanel:RefreshCurrentModel()
				surface.PlaySound("buttons/button11.wav")
			end
			fram:Remove()
		end

		fram:MakePopup()
	end
	y = y + but4:GetTall() + 4

	local but5 = EasyButton(pProfiles, "Rename this profile", 8, 4)
	but5:SetTooltip("Rename the current profile. default can't be renamed.")
	but5:SetWide(panellistwidth)
	but5:SetPos(8 + halfpanellistwidth - but5:GetWide() * 0.5, y)
	but5.DoClick = function(me)
		local pw = 400
		local ph = 150

		local fram = vgui.Create("DFrame")
		fram:SetSize(pw, ph)
		fram:Center()
		fram:SetTitle("Rename profile "..tostring(ASPECTFILE))
		--fram:SetBackgroundBlur(2)

		local ezlab = EasyLabel(fram, "Rename this profile. Only letters, numbers, underscores, and spaces!", "Default")
		ezlab:SetPos(pw * 0.5 - ezlab:GetWide() * 0.5, 40)

		local tex = vgui.Create("DTextEntry", fram)
		tex:SetWide(pw - 16)
		tex:SetPos(8, 48 + ezlab:GetTall())

		local cannewbut = EasyButton(fram, "Cancel", 8, 4)
		cannewbut:SetPos(pw * 0.5 + 8, ph - cannewbut:GetTall() - 8)
		cannewbut.DoClick = function()
			fram:Remove()
		end

		local newbut = EasyButton(fram, "OK", 8, 4)
		newbut:SetWide(math.max(newbut:GetWide(), cannewbut:GetWide()))
		newbut:SetPos(pw * 0.5 - newbut:GetWide() - 8, ph - newbut:GetTall() - 8)
		newbut.DoClick = function(nb)
			if string.lower(ASPECTFILE) ~= "default" then
				local text = tex:GetValue()
				if string.lower(text) == "default" or string.len(text) <= 1 or string.find(text, "[%c%z%^%$%(%)%%%.%[%]%*%+%-%?]") or file.Exists("noxaspects/"..text..".txt") then
					surface.PlaySound("buttons/button8.wav")
					return
				end

				file.Write("noxaspects/"..text..".txt", file.Read("noxaspects/"..ASPECTFILE..".txt"))
				file.Delete("noxaspects/"..ASPECTFILE..".txt")
				ASPECTFILE = text
				PanelList:Refresh()
				LoadAspects(ASPECTFILE, MENUPROFILE)
				pLoadout.List:RefreshList()
				--pLoadout.ShopList:RefreshList()
				pProfiles.MDLPanel:RefreshCurrentModel()
				surface.PlaySound("buttons/button3.wav")
			end
			fram:Remove()
		end
		tex.OnEnter = function() newbut:DoClick() end

		fram:MakePopup()
	end

	local e

	PanelList.Refresh = function(pl)
		for _, item in pairs(pl:GetItems()) do
			pl:RemoveItem(item)
		end

		for _, nam in pairs(file.Find("noxaspects/*.txt")) do
			local dpanel = vgui.Create("DButton")
			dpanel.FileName = nam
			dpanel.Name = string.sub(nam, 1, -5)
			dpanel:SetText(dpanel.Name)
			if ASPECTFILE == dpanel.Name then
				dpanel:SetFGColor(COLOR_LIMEGREEN)
			end

			dpanel:SetTall(16)
			dpanel:SetPos(8, 0)

			dpanel.DoClick = function(moi)
				if file.Exists("noxaspects/"..moi.FileName) then
					surface.PlaySound("weapons/airboat/airboat_gun_lastshot"..math.random(1,2)..".wav")
					ASPECTFILE = moi.Name
					RunConsoleCommand("noxdefaultaspectprofile", ASPECTFILE)
					PanelList:Refresh()
					LoadProfile(ASPECTFILE, MENUPROFILE)
					pLoadout.List:RefreshList()
					--pLoadout.ShopList:RefreshList()
					pProfiles.MDLPanel:RefreshCurrentModel()
					if MENUPROFILE.Aspects then
						--[[for i, pan in pairs(pAspects.AspectSliders) do
							pan.TextEntry:SetValue(math.ceil((MENUPROFILE.Aspects[i] or 0) * 100))
						end]]
						pAspects.AspectSummary:RefreshAspects()
						pProfiles.AspectSummary:RefreshAspects()
					end
				end
			end

			pl:AddItem(dpanel)
		end

		pl:SortByMember()

		but4:SetDisabled(ASPECTFILE == "default")
		but5:SetDisabled(ASPECTFILE == "default")
	end
	PanelList:Refresh()

	local mdpanel = vgui.Create("DPanel", pProfiles)
	mdpanel:SetSize(104, 104)
	mdpanel:SetPos(598, 48)
	local mdlpanel = vgui.Create("DModelPanel", mdpanel)
	mdlpanel:SetPos(2, 2)
	mdlpanel:SetSize(100, 100)
	mdlpanel:SetAnimated(true)
	mdlpanel:SetCamPos(Vector(0, 90, 72))
	mdlpanel:SetAnimSpeed(1)
	mdlpanel.RefreshCurrentModel = function(mpan)
		mpan:SetModel(player_manager.TranslatePlayerModel(MENUPROFILE.Model or "kliener"))
		mpan:GetEntity():ResetSequence("run_all")
	end
	mdlpanel.LayoutEntity = function(pan, ent)
		if pan.bAnimated then
			pan:RunAnimation()
		end

		ent:SetAngles(Angle(0, RealTime() * 45, 0))
	end
	pProfiles.MDLPanel = mdlpanel
	mdlpanel:RefreshCurrentModel()

	local ModelPanelList = vgui.Create("DPanelList", pProfiles)
	ModelPanelList:EnableVerticalScrollbar()
	ModelPanelList:EnableHorizontal(false)
	ModelPanelList:SetSize(72, 360)
	ModelPanelList:SetPos(704, 48)
	ModelPanelList:SetSpacing(1)

	local function ChangePlayerModel(bt)
		if file.Exists("noxaspects/"..ASPECTFILE..".txt") then
			MENUPROFILE.Model = bt.PlayerModel
			SaveAspects(MENUPROFILE)
			surface.PlaySound("buttons/button24.wav")
			pProfiles.MDLPanel:RefreshCurrentModel()
		end
	end
	for name, mdl in pairs(list.Get("PlayerOptionsModel")) do
		local button = vgui.Create("SpawnIcon")
		button:SetModel(mdl)
		button.PlayerModel = name
		button.MDL = mdl
		button.OnMousePressed = ChangePlayerModel
		ModelPanelList:AddItem(button)
	end

	local summary = vgui.Create("AspectSummary", pProfiles)
	local sx = 16 + panellistwidth
	summary:SetPos(sx, 48)
	summary:SetSize(590 - sx, 360)
	summary:RefreshAspects()
	pProfiles.AspectSummary = summary
end
