GM.CastAfterDelay = 0.75

local function CanCast(pl, spelltab, precast)
	if not spelltab or CurTime() < pl.NextSpell or not pl:IsIdle(not precast) or not pl:Alive() and not spelltab.CanCastWhileDead then return false end

	if spelltab.Mana and pl:GetMana() < spelltab.Mana then
		pl:SendMessage(spelltab.Name.." requires "..spelltab.Mana.." mana to cast.", "COLOR_RED")
		return false
	end

	if spelltab.SkillRequirements then
		for skillid, amount in pairs(spelltab.SkillRequirements) do
			if pl:GetSkill(skillid) < amount then
				pl:SendMessage(spelltab.Name.." requires "..amount.." "..SKILLS[skillid].Name.." to cast.", "COLOR_RED")
				return false
			end
		end
	end

	if spelltab.ItemRequirements then
		for dataname, amount in pairs(spelltab.ItemRequirements) do
			local itemdata = GetItemData(dataname)
			if itemdata and not pl:HasItem(dataname, amount) then
				pl:SendMessage(spelltab.Name.." requires "..util.NameByAmount(itemdata.Name or dataname, amount).." to cast.", "COLOR_RED")
				return false
			end
		end
	end

	if spelltab.CanCast and not spelltab:CanCast(pl) then return false end

	return true
end

function CastSpell(pl, spelltab, skipcheck, nomana, noitems, target, ...)
	if not skipcheck and not CanCast(pl, spelltab) then
		if spelltab.OnFail then spelltab:OnFail(pl, ...) end
		return false
	end

	if spelltab.OnCast and spelltab:OnCast(pl, ...) then return false end

	stat.Start(GAMEMODE.CastAfterDelay)
		pl:StatusWeaponHook("AlterCastRecoveryTime")
	pl.NextSpell = CurTime() + stat.End()

	if not target and spelltab.UsesTarget then
		target = pl:GetSpellTarget()
		if target == pl then target = nil end
	end

	if spelltab.OnCasted and spelltab:OnCasted(pl, target, ...) then return false end

	pl:GlobalHook("PlayerCastedSpell", spelltab, ...)

	if target then
		pl:RemoveStatus("threadoffate", false, true)
	end

	if not nomana and spelltab.Mana then
		pl:SetMana(pl:GetMana() - spelltab.Mana, true)
	end

	if not noitems and spelltab.ItemConsumation then
		for dataname, amount in pairs(spelltab.ItemConsumation) do
			pl:TakeItem(dataname, amount, true)
		end
	end

	return true
end

function PrecastSpell(pl, spelltab)
	if not CanCast(pl, spelltab, true) then return end

	if spelltab.CastTime and 0 < spelltab.CastTime then
		pl:GlobalHook("PlayerPrecastedSpell", spelltab)

		if spelltab.OnPrecast and spelltab:OnPrecast(pl) then return end

		pl.NextSpell = CurTime() + spelltab.CastTime
	else
		CastSpell(pl, spelltab, true)
	end
end
PreCastSpell = PrecastSpell

local function ccCastSpell(pl, command, arguments)
	local spelltab = SPELLS[tostring(table.concat(arguments, "_"))]
	if spelltab then
		PrecastSpell(pl, spelltab)
	end
end
concommand.Add("cast", ccCastSpell)
concommand.Add("spell", ccCastSpell)
concommand.Add("castspell", ccCastSpell)
concommand.Add("spellcast", ccCastSpell)
