local meta = FindMetaTable("Player")
if not meta then return end

function meta:SetRagdoll(ent)
	self:SetDTEntity(0, ent)
end

function meta:GetRagdoll()
	return self:GetDTEntity(0)
end

ExcludedBones = {
	["ValveBiped.Bip01_R_Clavicle"] = true,
	["ValveBiped.Bip01_R_UpperArm"] = true,
	["ValveBiped.Bip01_R_Forearm"] = true,
	["ValveBiped.Bip01_R_Hand"] = true,
	["ValveBiped.Bip01_L_Clavicle"] = true,
	["ValveBiped.Bip01_L_UpperArm"] = true,
	["ValveBiped.Bip01_L_Forearm"] = true,
	["ValveBiped.Bip01_L_Hand"] = true,
	["ValveBiped.Bip01_Neck1"] = true,
	["ValveBiped.Bip01_Head1"] = true,
	["ValveBiped.Bip01_Spine4"] = true,
	["ValveBiped.Bip01_Spine3"] = true,
	["ValveBiped.Bip01_Spine1"] = true,
	["ValveBiped.Bip01_Spine"] = true
}

local ShadowParams = {secondstoarrive = 0.0001, maxangular = 1000, maxangulardamp = 10000, maxspeed = 32000, maxspeeddamp = 1024, dampfactor = 0.5, teleportdistance = 0}
function meta:Think()
	local ent = self:GetRagdoll()
	if not ent:IsValid() then return end

	local ct = CurTime()

	local frametime = ct - (self.LastThink or ct)
	self.LastThink = ct

	local phys = ent:GetPhysicsObject()
	if phys:IsValid() then
		phys:Wake()
	end

	for i = 0, ent:GetPhysicsObjectCount() do
		local bid = ent:TranslatePhysBoneToBone(i)
		if bid and not ExcludedBones[ent:GetBoneName(bid)] then
			local phys = ent:GetPhysicsObjectNum(i)
			if phys and phys:IsValid() then
				local bonepos, boneang = self:GetBonePosition(bid)
				if bonepos then
					ShadowParams.pos = bonepos
					ShadowParams.angle = boneang
					ShadowParams.deltatime = frametime
					phys:ComputeShadowControl(ShadowParams)
				end
			end
		end
	end

	ent:SetPhysicsAttacker(self)
end
