local meta = FindMetaTable("Player")
if not meta then return end

function meta:AttachRagdoll()
	if self:GetRagdoll():IsValid() then self:GetRagdoll():Remove() end

	local ent = ents.Create("prop_ragdoll")
	if ent:IsValid() then
		ent:SetPos(self:GetPos())
		ent:SetAngles(self:GetAngles())
		ent:SetModel(self:GetModel())
		ent:Spawn()
	end

	self:SetRagdoll(ent)
	self:AlignRagdoll()
end

function meta:AlignRagdoll()
	local ent = self:GetRagdoll()
	if ent:IsValid() then
		for i = 0, ent:GetPhysicsObjectCount() do
			local phys = ent:GetPhysicsObjectNum(i)
			if phys and phys:IsValid() then
				local bid = ent:TranslatePhysBoneToBone(i)
				if bid then
					local bonepos, boneang = self:GetBonePosition(bid)
					if bonepos then
						phys:SetPos(bonepos)
						phys:SetAngle(boneang)
					end
				end
			end
		end

		local phys = ent:GetPhysicsObject()
		if phys:IsValid() then
			phys:Wake()
		end
	end
end
