util.PrecacheSound("physics/body/body_medium_break2.wav")
util.PrecacheSound("physics/body/body_medium_break3.wav")
util.PrecacheSound("physics/body/body_medium_break4.wav")

local CLASS = {}

CLASS.Model = Model("models/breen.mdl")
CLASS.Name = "Robert Loggia"

if CLIENT then
	CLASS.Description = "Master of the art of kick-boxing, Robert Loggia is good for beginners learning the art of ragdoll fighting."
	CLASS.Help =
	{
		"Rapid kicking - Mash left mouse AND/OR right mouse.",
		"Acrobatic Lotus - While in the air, alternatly press left and right click over and over."
	}
end

if SERVER then
	function CLASS.Initialize(doll, pl)
		doll.Head = doll:GetPhysicsObjectNum(10)
		doll.LeftLeg = doll:GetPhysicsObjectNum(14)
		doll.RightLeg = doll:GetPhysicsObjectNum(12)
		doll.Phys = doll:GetPhysicsObject()
		doll.NextJump = 0
		doll.Stun = 0
		doll.NextMinuteMaid = 0
	end

	function CLASS.R(doll, pl)
		if pl:KeyDown(IN_FORWARD) then
			
		elseif pl:KeyDown(IN_BACK) then
			
		elseif CurTime() >= doll.NextMinuteMaid then
			if doll.MinuteMaid and doll.MinuteMaid:IsValid() and doll.MinuteMaid.Weld then return end

			doll.NextMinuteMaid = CurTime() + 5
			local ent = ents.Create("robertloggiaminutemaid")
			if ent:IsValid() then
				local armphys = doll:GetPhysicsObjectNum(5)
				ent:SetPos(armphys:GetPos())
				ent:SetAngles(armphys:GetAngles())
				ent:SetOwner(doll)
				ent:Spawn()
				ent.Weld = constraint.Weld(ent, doll, 0, 5, 0)
				doll.MinuteMaid = ent
			end
		end
	end

	function CLASS.KeyPress(key, pl, doll)
		if CurTime() < doll.Stun then return end

		if key == IN_JUMP then
			CLASS.Jump(pl.Ragdoll, pl)
		elseif key == IN_RELOAD then
			CLASS.R(pl.Ragdoll, pl)
		elseif key == IN_ATTACK then
			CLASS.LeftClick(pl.Ragdoll, pl)
		elseif key == IN_ATTACK2 then
			CLASS.RightClick(pl.Ragdoll, pl)
		end
	end

	RIGIDNESS = 6600
	function CLASS.Think(doll, pl)
		local frametime = FrameTime()
		local dollpos = doll:GetPos()
		local posx = dollpos.x


		doll.Phys:ApplyForceCenter(Vector(frametime * -1980 * posx, 0, 0))

		if CurTime() < doll.Stun then return end

		if pl:KeyDown(IN_BACK) then
			CLASS.S(pl.Ragdoll, pl)
		end

		if pl:KeyDown(IN_MOVELEFT) then
			CLASS.A(pl.Ragdoll, pl)
		elseif pl:KeyDown(IN_MOVERIGHT) then
			CLASS.D(pl.Ragdoll, pl)
		end

		pl:SetPos(dollpos + Vector(256, 0, 0))

		if not pl:KeyDown(IN_BACK) and pl:OnGround() then
			local phys = doll.Head

			local pos = phys:GetPos()
			local tr = util.TraceLine({start = pos, endpos = pos + Vector(0, 0, -100), mask=MASK_SOLID_BRUSHONLY})

			if tr.Hit then
				local mul = Vector(0, 0, frametime * 66006 * (1 - tr.Fraction))
				phys:ApplyForceCenter(mul)
				doll.Phys:ApplyForceCenter(mul)
			end

			pl.DoubleJump = nil
		end

		local pos = doll:GetPos()

		pl:SetPos(pos + Vector(1000, 0, 0))



		for i=1, 24 do
			local attach = pl:GetAttachment(i)
			if attach then
				local physnum = doll:GetPhysicsObjectNum(i)
				if physnum:IsValid() then
					physnum:ApplyForceCenter(frametime * RIGIDNESS * (attach.Pos - physnum:GetPos()))
				end
			end
		end

		// Hit detection
		CLASS.HitDetection(doll.LeftLeg, doll, pl, math.random(2, 4), 1, 26)
		CLASS.HitDetection(doll.RightLeg, doll, pl, math.random(2, 4), 1, 26)
	end

	function CLASS.HitDetection(phys, doll, pl, damage, forcescale, radius)
		if phys:GetVelocity():Length() > 100 then
			local physpos = phys:GetPos()
			physpos.x = 0
			for _, ent in pairs(ents.FindInSphere(physpos, radius)) do
				if ent ~= doll and ent:GetClass() == "prop_ragdoll" then
					local headpos = ent.Head:GetPos()
					headpos.x = 0
					if headpos:Distance(physpos) <= 20 then // CONTACT!
						ent.Player:SetHealth(ent.Player:Health() + damage) // Damage

						local newpos = headpos + ent.Player:Health() * (headpos - physpos):Normalize() * 3 * forcescale
						newpos.x = 0

						//ent.Head:SetPos(util.TraceLine({start=headpos, endpos=newpos, mask=COLLISION_GROUP_WORLD}).HitPos) // OMG BYE BYE
						ent.Head:SetPos(newpos)

						phys:ApplyForceCenter((headpos - physpos):Normalize() * -100000) // Recoil

						local effectdata=EffectData()
							effectdata:SetOrigin(headpos)
							effectdata:SetMagnitude(30)
							effectdata:SetScale(5)
							effectdata:SetRadius(5)
						util.Effect("BloodImpact", effectdata)

						ent:EmitSound("physics/body/body_medium_break"..math.random(2,4)..".wav")
					end
				end
			end
		end
	end

	function CLASS.W(doll, pl)
	end

	function CLASS.Jump(doll, pl)
		if not doll:IsValid() then return end

		if doll:GetVelocity():Length() > 800 then return end
		if CurTime() < doll.NextJump then return end

		if pl:OnGround() or not pl.DoubleJump then
			if not pl:OnGround() then
				pl.DoubleJump = true
			end

			if pl.DoubleJump then
				for i=0, doll:GetPhysicsObjectCount() - 1 do
					local phys = doll:GetPhysicsObjectNum(i)
					local vel = phys:GetVelocity()
					phys:SetVelocityInstantaneous(Vector(vel.x, 0, 500))
				end
			else
				for i=0, doll:GetPhysicsObjectCount() - 1 do
					local phys = doll:GetPhysicsObjectNum(i)
					local vel = phys:GetVelocity()
					phys:SetVelocityInstantaneous(Vector(vel.x, vel.y, 500))
				end
			end
			doll.NextJump = CurTime() + 0.25
		end
	end

	function CLASS.S(doll, pl)
		if not doll:IsValid() then return end
	end

	function CLASS.A(doll, pl)
		if not doll:IsValid() then return end

		if pl:OnGround() then
			doll.Phys:ApplyForceCenter(Vector(0, FrameTime() * -66006, 0))
		else
			doll.Phys:ApplyForceCenter(Vector(0, FrameTime() * -26400, 0))
		end
	end

	function CLASS.D(doll, pl)
		if not doll:IsValid() then return end

		if pl:OnGround() then
			doll.Phys:ApplyForceCenter(Vector(0, FrameTime() * 66006, 0))
		else
			doll.Phys:ApplyForceCenter(Vector(0, FrameTime() * 26400, 0))
		end
	end

	function CLASS.LeftClick(doll, pl)
		if not doll:IsValid() then return end

		if doll.MinuteMaid and doll.MinuteMaid:IsValid() then
			doll.MinuteMaid.Weld:Remove()

			doll.MinuteMaid.Weld = nil
			doll.MinuteMaid = nil
		else
			doll.LeftLeg:ApplyForceCenter(Vector(0, math.sin(RealTime() * 10) * 11000, 0))
		end
	end

	function CLASS.RightClick(doll, pl)
		if not doll:IsValid() then return end

		doll.RightLeg:ApplyForceCenter(Vector(0, math.sin(RealTime() * 10) * 11000, 0))
	end
end

RegisterClass("Robert Loggia", CLASS)
